/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/network","vs/base/common/async","electron","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/resources","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/strings","vs/base/common/buffer","fs","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/base/common/arrays","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/remote/common/tunnel","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","vs/base/common/stream","crypto","net","vs/platform/environment/node/argv","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/resourceLoader","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/common/glob","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/product/common/product","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/code/electron-main/protocol","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/mimeTypes","vs/platform/webview/common/webviewManagerService","vs/platform/webview/common/webviewPortMapping","vs/platform/webview/electron-main/webviewPortMappingProvider","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","stream","vs/code/electron-main/main"],J=function(j){for(var e=[],w=0,R=j.length;w<R;w++)e[w]=Q[j[w]];return e};define(Q[99],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=w}),define(Q[52],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(y){return(i,L,g)=>{let E=null,p=null;if(typeof g.value=="function"?(E="value",p=g.value):typeof g.get=="function"&&(E="get",p=g.get),!p)throw new Error("not supported");g[E]=y(p,L)}}e.createDecorator=w;let R=0;function D(){const y=`$memoize${R++}`;let i;const L=function(E,p,h){let m=null,S=null;if(typeof h.value=="function"?(m="value",S=h.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(m="get",S=h.get),!S)throw new Error("not supported");const v=`${y}:${p}`;h[m]=function(...a){return i=this,this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!0,enumerable:!1,writable:!0,value:S.apply(this,a)}),this[v]}};return L.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(g=>{g.indexOf(y)===0&&delete i[g]})},L}e.createMemoizer=D;function b(y,i,L){return D()(y,i,L)}e.memoize=b;function P(y,i,L){return w((g,E)=>{const p=`$debounce$${E}`,h=`$debounce$result$${E}`;return function(...m){this[h]||(this[h]=L?L():void 0),clearTimeout(this[p]),i&&(this[h]=i(this[h],...m),m=[this[h]]),this[p]=setTimeout(()=>{g.apply(this,m),this[h]=L?L():void 0},y)}})}e.debounce=P;function n(y,i,L){return w((g,E)=>{const p=`$throttle$timer$${E}`,h=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,S=`$throttle$pending$${E}`;return function(...v){if(this[h]||(this[h]=L?L():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),i&&(this[h]=i(this[h],...v)),!this[S]){const a=this[m]+y;a<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[h]]),this[h]=L?L():void 0):(this[S]=!0,this[p]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),g.apply(this,[this[h]]),this[h]=L?L():void 0},a-Date.now()))}}})}e.throttle=n}),define(Q[19],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function R(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=R;function D(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=D;function b(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=b;function P(s){if(s instanceof Error){let{name:t,message:r}=s;const o=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:o}}return s}e.transformErrorForSerialization=P;const n="Canceled";function y(s){return s instanceof Error&&s.name===n&&s.message===n}e.isPromiseCanceledError=y;class i extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=i;function L(){const s=new Error(n);return s.name=s.message,s}e.canceled=L;function g(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=g;function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=E;function p(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function m(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=m;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class a extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=a;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function l(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(Q[34],J([0,1,19]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(U,$=0){return U[U.length-(1+$)]}e.tail=R;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=D;function b(U,$,T=(k,M)=>k===M){if(U===$)return!0;if(!U||!$||U.length!==$.length)return!1;for(let k=0,M=U.length;k<M;k++)if(!T(U[k],$[k]))return!1;return!0}e.equals=b;function P(U,$,T){let k=0,M=U.length-1;for(;k<=M;){const O=(k+M)/2|0,_=T(U[O],$);if(_<0)k=O+1;else if(_>0)M=O-1;else return O}return-(k+1)}e.binarySearch=P;function n(U,$){let T=0,k=U.length;if(k===0)return 0;for(;T<k;){const M=Math.floor((T+k)/2);$(U[M])?k=M:T=M+1}return T}e.findFirstInSorted=n;function y(U,$,T){if(U=U|0,U>=$.length)throw new TypeError("invalid index");let k=$[Math.floor($.length*Math.random())],M=[],O=[],_=[];for(let W of $){const z=T(W,k);z<0?M.push(W):z>0?O.push(W):_.push(W)}return U<M.length?y(U,M,T):U<M.length+_.length?_[0]:y(U-(M.length+_.length),O,T)}e.quickSelect=y;function i(U,$){const T=[];let k;for(const M of U.slice(0).sort($))!k||$(k[0],M)!==0?(k=[M],T.push(k)):k.push(M);return T}e.groupBy=i;function L(U,$,T){const k=[];function M(W,z,K){if(!(z===0&&K.length===0)){const Y=k[k.length-1];Y&&Y.start+Y.deleteCount===W?(Y.deleteCount+=z,Y.toInsert.push(...K)):k.push({start:W,deleteCount:z,toInsert:K})}}let O=0,_=0;for(;;){if(O===U.length){M(O,0,$.slice(_));break}if(_===$.length){M(O,U.length-O,[]);break}const W=U[O],z=$[_],K=T(W,z);K===0?(O+=1,_+=1):K<0?(M(O,1,[]),O+=1):K>0&&(M(O,0,[z]),_+=1)}return k}e.sortedDiff=L;function g(U,$,T){const k=L(U,$,T),M=[],O=[];for(const _ of k)M.push(...U.slice(_.start,_.start+_.deleteCount)),O.push(..._.toInsert);return{removed:M,added:O}}e.delta=g;function E(U,$,T){if(T===0)return[];const k=U.slice(0,T).sort($);return h(U,$,k,T,U.length),k}e.top=E;function p(U,$,T,k,M){return T===0?Promise.resolve([]):new Promise((O,_)=>{(async()=>{const W=U.length,z=U.slice(0,T).sort($);for(let K=T,Y=Math.min(T+k,W);K<W;K=Y,Y=Math.min(Y+k,W)){if(K>T&&await new Promise(Z=>setTimeout(Z)),M&&M.isCancellationRequested)throw(0,w.canceled)();h(U,$,z,K,Y)}return z})().then(O,_)})}e.topAsync=p;function h(U,$,T,k,M){for(const O=T.length;k<M;k++){const _=U[k];if($(_,T[O-1])<0){T.pop();const W=n(T,z=>$(_,z)<0);T.splice(W,0,_)}}}function m(U){return U.filter($=>!!$)}e.coalesce=m;function S(U){let $=0;for(let T=0;T<U.length;T++)U[T]&&(U[$]=U[T],$+=1);U.length=$}e.coalesceInPlace=S;function v(U,$,T){U.splice(T,0,U.splice($,1)[0])}e.move=v;function a(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=a;function c(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=c;function l(U,$){if(!$)return U.filter((k,M)=>U.indexOf(k)===M);const T=Object.create(null);return U.filter(k=>{const M=$(k);return T[M]?!1:(T[M]=!0,!0)})}e.distinct=l;function s(U){const $=new Set;return U.filter(T=>$.has(T)?!1:($.add(T),!0))}e.distinctES6=s;function t(U){const $=Object.create(null);return T=>{const k=U(T);return $[k]?!1:($[k]=!0,!0)}}e.uniqueFilter=t;function r(U,$){for(let T=U.length-1;T>=0;T--){const k=U[T];if($(k))return T}return-1}e.lastIndex=r;function o(U,$){return U.length>0?U[0]:$}e.firstOrDefault=o;function u(U,$,T=(k,M)=>k===M){let k=0;for(let M=0,O=Math.min(U.length,$.length);M<O&&T(U[M],$[M]);M++)k++;return k}e.commonPrefixLength=u;function d(U){return[].concat(...U)}e.flatten=d;function f(U,$){let T=typeof $=="number"?U:0;typeof $=="number"?T=U:(T=0,$=U);const k=[];if(T<=$)for(let M=T;M<$;M++)k.push(M);else for(let M=T;M>$;M--)k.push(M);return k}e.range=f;function I(U,$,T){return U.reduce((k,M)=>(k[$(M)]=T?T(M):M,k),Object.create(null))}e.index=I;function A(U,$){return U.push($),()=>F(U,$)}e.insert=A;function F(U,$){const T=U.indexOf($);if(T>-1)return U.splice(T,1),$}e.remove=F;function C(U,$,T){const k=U.slice(0,$),M=U.slice($);return k.concat(T,M)}e.arrayInsert=C;function H(U,$){let T;if(typeof $=="number"){let k=$;T=()=>{const M=Math.sin(k++)*179426549;return M-Math.floor(M)}}else T=Math.random;for(let k=U.length-1;k>0;k-=1){const M=Math.floor(T()*(k+1)),O=U[k];U[k]=U[M],U[M]=O}}e.shuffle=H;function X(U,$){const T=U.indexOf($);T>-1&&(U.splice(T,1),U.unshift($))}e.pushToStart=X;function ne(U,$){const T=U.indexOf($);T>-1&&(U.splice(T,1),U.push($))}e.pushToEnd=ne;function oe(U,$){return Array.isArray(U)?U.map($):$(U)}e.mapArrayOrNot=oe;function V(U){return Array.isArray(U)?U:[U]}e.asArray=V;function N(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=N;function B(U,$){for(const T of U){const k=$(T);if(k!==void 0)return k}}e.mapFind=B}),define(Q[43],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(R){const D=this;let b=!1,P;return function(){return b||(b=!0,P=R.apply(D,arguments)),P}}e.once=w}),define(Q[63],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(R){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=D;const b=Object.freeze([]);function P(){return b}R.empty=P;function*n(s){yield s}R.single=n;function y(s){return s||b}R.from=y;function i(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=i;function L(s){return s[Symbol.iterator]().next().value}R.first=L;function g(s,t){for(const r of s)if(t(r))return!0;return!1}R.some=g;function E(s,t){for(const r of s)if(t(r))return r}R.find=E;function*p(s,t){for(const r of s)t(r)&&(yield r)}R.filter=p;function*h(s,t){for(const r of s)yield t(r)}R.map=h;function*m(...s){for(const t of s)for(const r of t)yield r}R.concat=m;function*S(s){for(const t of s)for(const r of t)yield r}R.concatNested=S;function v(s,t,r){let o=r;for(const u of s)o=t(o,u);return o}R.reduce=v;function*a(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}R.slice=a;function c(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const o=s[Symbol.iterator]();for(let u=0;u<t;u++){const d=o.next();if(d.done)return[r,R.empty()];r.push(d.value)}return[r,{[Symbol.iterator](){return o}}]}R.consume=c;function l(s,t,r=(o,u)=>o===u){const o=s[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const d=o.next(),f=u.next();if(d.done!==f.done)return!1;if(d.done)return!0;if(!r(d.value,f.value))return!1}}R.equals=l})(w=e.Iterable||(e.Iterable={}))}),define(Q[44],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function P(t,r=!1){let o=0,u=t.length,d="",f=0,I=16,A=0;function F(N){let B=0,U=0;for(;B<N;){const $=t.charCodeAt(o);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;o++,B++}return B<N&&(U=-1),U}function C(N){o=N,d="",f=0,I=16,A=0}function H(){const N=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&i(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&i(t.charCodeAt(o)))for(o++;o<t.length&&i(t.charCodeAt(o));)o++;else return A=3,t.substring(N,o);let B=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&i(t.charCodeAt(o))){for(o++;o<t.length&&i(t.charCodeAt(o));)o++;B=o}else A=3;return t.substring(N,B)}function X(){let N="",B=o;for(;;){if(o>=u){N+=t.substring(B,o),A=2;break}const U=t.charCodeAt(o);if(U===34){N+=t.substring(B,o),o++;break}if(U===92){if(N+=t.substring(B,o),o++,o>=u){A=2;break}switch(t.charCodeAt(o++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const T=F(4);T>=0?N+=String.fromCharCode(T):A=4;break;default:A=5}B=o;continue}if(U>=0&&U<=31)if(y(U)){N+=t.substring(B,o),A=2;break}else A=6;o++}return N}function ne(){if(d="",A=0,f=o,o>=u)return f=u,I=17;let N=t.charCodeAt(o);if(n(N)){do o++,d+=String.fromCharCode(N),N=t.charCodeAt(o);while(n(N));return I=15}if(y(N))return o++,d+=String.fromCharCode(N),N===13&&t.charCodeAt(o)===10&&(o++,d+=`
`),I=14;switch(N){case 123:return o++,I=1;case 125:return o++,I=2;case 91:return o++,I=3;case 93:return o++,I=4;case 58:return o++,I=6;case 44:return o++,I=5;case 34:return o++,d=X(),I=10;case 47:const B=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<u&&!y(t.charCodeAt(o));)o++;return d=t.substring(B,o),I=12}if(t.charCodeAt(o+1)===42){o+=2;const U=u-1;let $=!1;for(;o<U;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,A=1),d=t.substring(B,o),I=13}return d+=String.fromCharCode(N),o++,I=16;case 45:if(d+=String.fromCharCode(N),o++,o===u||!i(t.charCodeAt(o)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=H(),I=11;default:for(;o<u&&oe(N);)o++,N=t.charCodeAt(o);if(f!==o){switch(d=t.substring(f,o),d){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return d+=String.fromCharCode(N),o++,I=16}}function oe(N){if(n(N)||y(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let N;do N=ne();while(N>=12&&N<=15);return N}return{setPosition:C,getPosition:()=>o,scan:r?V:ne,getToken:()=>I,getTokenValue:()=>d,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>A}}e.createScanner=P;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function g(t,r){const o=[],u=new Object;let d;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function A(F,C,H,X){f.value=F,f.offset=C,f.length=H,f.type=X,f.colonOffset=void 0,d=f}try{c(t,{onObjectBegin:(F,C)=>{if(r<=F)throw u;d=void 0,I=r>F,o.push("")},onObjectProperty:(F,C,H)=>{if(r<C||(A(F,C,H,"property"),o[o.length-1]=F,r<=C+H))throw u},onObjectEnd:(F,C)=>{if(r<=F)throw u;d=void 0,o.pop()},onArrayBegin:(F,C)=>{if(r<=F)throw u;d=void 0,o.push(0)},onArrayEnd:(F,C)=>{if(r<=F)throw u;d=void 0,o.pop()},onLiteralValue:(F,C,H)=>{if(r<C||(A(F,C,H,s(F)),r<=C+H))throw u},onSeparator:(F,C,H)=>{if(r<=C)throw u;if(F===":"&&d&&d.type==="property")d.colonOffset=C,I=!1,d=void 0;else if(F===","){const X=o[o.length-1];typeof X=="number"?o[o.length-1]=X+1:(I=!0,o[o.length-1]=""),d=void 0}}})}catch(F){if(F!==u)throw F}return{path:o,previousNode:d,isAtPropertyKey:I,matches:F=>{let C=0;for(let H=0;C<F.length&&H<o.length;H++)if(F[C]===o[H]||F[C]==="*")C++;else if(F[C]!=="**")return!1;return C===F.length}}}e.getLocation=g;function E(t,r=[],o=b.DEFAULT){let u=null,d=[];const f=[];function I(F){Array.isArray(d)?d.push(F):u!==null&&(d[u]=F)}return c(t,{onObjectBegin:()=>{const F={};I(F),f.push(d),d=F,u=null},onObjectProperty:F=>{u=F},onObjectEnd:()=>{d=f.pop()},onArrayBegin:()=>{const F=[];I(F),f.push(d),d=F,u=null},onArrayEnd:()=>{d=f.pop()},onLiteralValue:I,onError:(F,C,H)=>{r.push({error:F,offset:C,length:H})}},o),d[0]}e.parse=E;function p(t,r=[],o=b.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(F){u.type==="property"&&(u.length=F-u.offset,u=u.parent)}function f(F){return u.children.push(F),F}c(t,{onObjectBegin:F=>{u=f({type:"object",offset:F,length:-1,parent:u,children:[]})},onObjectProperty:(F,C,H)=>{u=f({type:"property",offset:C,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:F,offset:C,length:H,parent:u})},onObjectEnd:(F,C)=>{u.length=F+C-u.offset,u=u.parent,d(F+C)},onArrayBegin:(F,C)=>{u=f({type:"array",offset:F,length:-1,parent:u,children:[]})},onArrayEnd:(F,C)=>{u.length=F+C-u.offset,u=u.parent,d(F+C)},onLiteralValue:(F,C,H)=>{f({type:s(F),offset:C,length:H,parent:u,value:F}),d(C+H)},onSeparator:(F,C,H)=>{u.type==="property"&&(F===":"?u.colonOffset=C:F===","&&d(C))},onError:(F,C,H)=>{r.push({error:F,offset:C,length:H})}},o);const A=u.children[0];return A&&delete A.parent,A}e.parseTree=p;function h(t,r){if(!!t){let o=t;for(let u of r)if(typeof u=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let d=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===u){o=f.children[1],d=!0;break}if(!d)return}else{const d=u;if(o.type!=="array"||d<0||!Array.isArray(o.children)||d>=o.children.length)return;o=o.children[d]}return o}}e.findNodeAtLocation=h;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=m;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const r=Object.create(null);for(let o of t.children){const u=o.children[1];u&&(r[o.children[0].value]=S(u))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function v(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=v;function a(t,r,o=!1){if(v(t,r,o)){const u=t.children;if(Array.isArray(u))for(let d=0;d<u.length&&u[d].offset<=r;d++){const f=a(u[d],r,o);if(f)return f}return t}}e.findNodeAtOffset=a;function c(t,r,o=b.DEFAULT){const u=P(t,!1);function d(z){return z?()=>z(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(z){return z?K=>z(K,u.getTokenOffset(),u.getTokenLength()):()=>!0}const I=d(r.onObjectBegin),A=f(r.onObjectProperty),F=d(r.onObjectEnd),C=d(r.onArrayBegin),H=d(r.onArrayEnd),X=f(r.onLiteralValue),ne=f(r.onSeparator),oe=d(r.onComment),V=f(r.onError),N=o&&o.disallowComments,B=o&&o.allowTrailingComma;function U(){for(;;){const z=u.scan();switch(u.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:N||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(z){case 12:case 13:N?$(10):oe();break;case 16:$(1);break;case 15:case 14:break;default:return z}}}function $(z,K=[],Y=[]){if(V(z),K.length+Y.length>0){let Z=u.getToken();for(;Z!==17;){if(K.indexOf(Z)!==-1){U();break}else if(Y.indexOf(Z)!==-1)break;Z=U()}}}function T(z){const K=u.getTokenValue();return z?X(K):A(K),U(),!0}function k(){switch(u.getToken()){case 11:let z=0;try{z=JSON.parse(u.getTokenValue()),typeof z!="number"&&($(2),z=0)}catch(K){$(2)}X(z);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return U(),!0}function M(){return u.getToken()!==10?($(3,[],[2,5]),!1):(T(!1),u.getToken()===6?(ne(":"),U(),W()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function O(){I(),U();let z=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(z||$(4,[],[]),ne(","),U(),u.getToken()===2&&B)break}else z&&$(6,[],[]);M()||$(4,[],[2,5]),z=!0}return F(),u.getToken()!==2?$(7,[2],[]):U(),!0}function _(){C(),U();let z=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(z||$(4,[],[]),ne(","),U(),u.getToken()===4&&B)break}else z&&$(6,[],[]);W()||$(4,[],[4,5]),z=!0}return H(),u.getToken()!==4?$(8,[4],[]):U(),!0}function W(){switch(u.getToken()){case 3:return _();case 1:return O();case 10:return T(!0);default:return k()}}return U(),u.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):W()?(u.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=c;function l(t,r){let o=P(t),u=[],d,f=0,I;do switch(I=o.getPosition(),d=o.scan(),d){case 12:case 13:case 17:f!==I&&u.push(t.substring(f,I)),r!==void 0&&u.push(o.getTokenValue().replace(/[^\r\n]/g,r)),f=o.getPosition();break}while(d!==17);return u.join("")}e.stripComments=l;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Q[100],J([0,1,44]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,i,L){let g,E,p,h,m;if(i){for(h=i.offset,m=h+i.length,p=h;p>0&&!n(y,p-1);)p--;let f=m;for(;f<y.length&&!n(y,f);)f++;E=y.substring(p,f),g=b(E,L)}else E=y,g=0,p=0,h=0,m=y.length;const S=P(L,y);let v=!1,a=0,c;L.insertSpaces?c=D(" ",L.tabSize||4):c="	";const l=(0,w.createScanner)(E,!1);let s=!1;function t(){return S+D(c,g+a)}function r(){let f=l.scan();for(v=!1;f===15||f===14;)v=v||f===14,f=l.scan();return s=f===16||l.getTokenError()!==0,f}const o=[];function u(f,I,A){!s&&I<m&&A>h&&y.substring(I,A)!==f&&o.push({offset:I,length:A-I,content:f})}let d=r();if(d!==17){const f=l.getTokenOffset()+p,I=D(c,g);u(I,p,f)}for(;d!==17;){let f=l.getTokenOffset()+l.getTokenLength()+p,I=r(),A="";for(;!v&&(I===12||I===13);){const C=l.getTokenOffset()+p;u(" ",f,C),f=l.getTokenOffset()+l.getTokenLength()+p,A=I===12?t():"",I=r()}if(I===2)d!==1&&(a--,A=t());else if(I===4)d!==3&&(a--,A=t());else{switch(d){case 3:case 1:a++,A=t();break;case 5:case 12:A=t();break;case 13:v?A=t():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(s=!0);break;case 16:s=!0;break}v&&(I===12||I===13)&&(A=t())}const F=l.getTokenOffset()+p;u(A,f,F),d=I}return o}e.format=R;function D(y,i){let L="";for(let g=0;g<i;g++)L+=y;return L}function b(y,i){let L=0,g=0;const E=i.tabSize||4;for(;L<y.length;){const p=y.charAt(L);if(p===" ")g++;else if(p==="	")g+=E;else break;L++}return Math.floor(g/E)}function P(y,i){for(let L=0;L<i.length;L++){const g=i.charAt(L);if(g==="\r")return L+1<i.length&&i.charAt(L+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=P;function n(y,i){return`\r
`.indexOf(y.charAt(i))!==-1}e.isEOL=n}),define(Q[101],J([0,1,44,100]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(i,L,g){return b(i,L,void 0,g)}e.removeProperty=D;function b(i,L,g,E,p){const h=L.slice(),m=[],S=(0,w.parseTree)(i,m);let v,a;for(;h.length>0&&(a=h.pop(),v=(0,w.findNodeAtLocation)(S,h),v===void 0&&g!==void 0);)typeof a=="string"?g={[a]:g}:g=[g];if(v)if(v.type==="object"&&typeof a=="string"&&Array.isArray(v.children)){const c=(0,w.findNodeAtLocation)(v,[a]);if(c!==void 0)if(g===void 0){if(!c.parent)throw new Error("Malformed AST");const l=v.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(l>0){const r=v.children[l-1];s=r.offset+r.length}else s=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return P(i,{offset:s,length:t-s,content:""},E)}else return P(i,{offset:c.offset,length:c.length,content:JSON.stringify(g)},E);else{if(g===void 0)return[];const l=`${JSON.stringify(a)}: ${JSON.stringify(g)}`,s=p?p(v.children.map(r=>r.children[0].value)):v.children.length;let t;if(s>0){const r=v.children[s-1];t={offset:r.offset+r.length,length:0,content:","+l}}else v.children.length===0?t={offset:v.offset+1,length:0,content:l}:t={offset:v.offset+1,length:0,content:l+","};return P(i,t,E)}}else if(v.type==="array"&&typeof a=="number"&&Array.isArray(v.children))if(g!==void 0){const c=`${JSON.stringify(g)}`;let l;if(v.children.length===0||a===0)l={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const s=a===-1||a>v.children.length?v.children.length:a,t=v.children[s-1];l={offset:t.offset+t.length,length:0,content:","+c}}return P(i,l,E)}else{const c=a,l=v.children[c];let s;if(v.children.length===1)s={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const t=v.children[c-1],r=t.offset+t.length,o=v.offset+v.length;s={offset:r,length:o-2-r,content:""}}else s={offset:l.offset,length:v.children[c+1].offset-l.offset,content:""};return P(i,s,E)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${v.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return P(i,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(g)},E)}}e.setProperty=b;function P(i,L,g){let E=n(i,L),p=L.offset,h=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;p>0&&!(0,R.isEOL)(E,p-1);)p--;for(;h<E.length&&!(0,R.isEOL)(E,h);)h++}const m=(0,R.format)(E,{offset:p,length:h-p},g);for(let v=m.length-1;v>=0;v--){const a=m[v];E=n(E,a),p=Math.min(p,a.offset),h=Math.max(h,a.offset+a.length),h+=a.content.length-a.length}const S=i.length-(E.length-h)-p;return[{offset:p,length:S,content:E.substring(p,h)}]}e.withFormatting=P;function n(i,L){return i.substring(0,L.offset)+L.content+i.substring(L.offset+L.length)}e.applyEdit=n;function y(i,L){let g=L.slice(0).sort((p,h)=>{const m=p.offset-h.offset;return m===0?p.length-h.length:m}),E=i.length;for(let p=g.length-1;p>=0;p--){let h=g[p];if(h.offset+h.length<=E)i=n(i,h);else throw new Error("Overlapping edit");E=h.offset}return i}e.applyEdits=y}),define(Q[56],J([0,1,19]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(a){a[a.Unknown=0]="Unknown",a[a.Backspace=1]="Backspace",a[a.Tab=2]="Tab",a[a.Enter=3]="Enter",a[a.Shift=4]="Shift",a[a.Ctrl=5]="Ctrl",a[a.Alt=6]="Alt",a[a.PauseBreak=7]="PauseBreak",a[a.CapsLock=8]="CapsLock",a[a.Escape=9]="Escape",a[a.Space=10]="Space",a[a.PageUp=11]="PageUp",a[a.PageDown=12]="PageDown",a[a.End=13]="End",a[a.Home=14]="Home",a[a.LeftArrow=15]="LeftArrow",a[a.UpArrow=16]="UpArrow",a[a.RightArrow=17]="RightArrow",a[a.DownArrow=18]="DownArrow",a[a.Insert=19]="Insert",a[a.Delete=20]="Delete",a[a.KEY_0=21]="KEY_0",a[a.KEY_1=22]="KEY_1",a[a.KEY_2=23]="KEY_2",a[a.KEY_3=24]="KEY_3",a[a.KEY_4=25]="KEY_4",a[a.KEY_5=26]="KEY_5",a[a.KEY_6=27]="KEY_6",a[a.KEY_7=28]="KEY_7",a[a.KEY_8=29]="KEY_8",a[a.KEY_9=30]="KEY_9",a[a.KEY_A=31]="KEY_A",a[a.KEY_B=32]="KEY_B",a[a.KEY_C=33]="KEY_C",a[a.KEY_D=34]="KEY_D",a[a.KEY_E=35]="KEY_E",a[a.KEY_F=36]="KEY_F",a[a.KEY_G=37]="KEY_G",a[a.KEY_H=38]="KEY_H",a[a.KEY_I=39]="KEY_I",a[a.KEY_J=40]="KEY_J",a[a.KEY_K=41]="KEY_K",a[a.KEY_L=42]="KEY_L",a[a.KEY_M=43]="KEY_M",a[a.KEY_N=44]="KEY_N",a[a.KEY_O=45]="KEY_O",a[a.KEY_P=46]="KEY_P",a[a.KEY_Q=47]="KEY_Q",a[a.KEY_R=48]="KEY_R",a[a.KEY_S=49]="KEY_S",a[a.KEY_T=50]="KEY_T",a[a.KEY_U=51]="KEY_U",a[a.KEY_V=52]="KEY_V",a[a.KEY_W=53]="KEY_W",a[a.KEY_X=54]="KEY_X",a[a.KEY_Y=55]="KEY_Y",a[a.KEY_Z=56]="KEY_Z",a[a.Meta=57]="Meta",a[a.ContextMenu=58]="ContextMenu",a[a.F1=59]="F1",a[a.F2=60]="F2",a[a.F3=61]="F3",a[a.F4=62]="F4",a[a.F5=63]="F5",a[a.F6=64]="F6",a[a.F7=65]="F7",a[a.F8=66]="F8",a[a.F9=67]="F9",a[a.F10=68]="F10",a[a.F11=69]="F11",a[a.F12=70]="F12",a[a.F13=71]="F13",a[a.F14=72]="F14",a[a.F15=73]="F15",a[a.F16=74]="F16",a[a.F17=75]="F17",a[a.F18=76]="F18",a[a.F19=77]="F19",a[a.NumLock=78]="NumLock",a[a.ScrollLock=79]="ScrollLock",a[a.US_SEMICOLON=80]="US_SEMICOLON",a[a.US_EQUAL=81]="US_EQUAL",a[a.US_COMMA=82]="US_COMMA",a[a.US_MINUS=83]="US_MINUS",a[a.US_DOT=84]="US_DOT",a[a.US_SLASH=85]="US_SLASH",a[a.US_BACKTICK=86]="US_BACKTICK",a[a.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",a[a.US_BACKSLASH=88]="US_BACKSLASH",a[a.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",a[a.US_QUOTE=90]="US_QUOTE",a[a.OEM_8=91]="OEM_8",a[a.OEM_102=92]="OEM_102",a[a.NUMPAD_0=93]="NUMPAD_0",a[a.NUMPAD_1=94]="NUMPAD_1",a[a.NUMPAD_2=95]="NUMPAD_2",a[a.NUMPAD_3=96]="NUMPAD_3",a[a.NUMPAD_4=97]="NUMPAD_4",a[a.NUMPAD_5=98]="NUMPAD_5",a[a.NUMPAD_6=99]="NUMPAD_6",a[a.NUMPAD_7=100]="NUMPAD_7",a[a.NUMPAD_8=101]="NUMPAD_8",a[a.NUMPAD_9=102]="NUMPAD_9",a[a.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",a[a.NUMPAD_ADD=104]="NUMPAD_ADD",a[a.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",a[a.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",a[a.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",a[a.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",a[a.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",a[a.ABNT_C1=110]="ABNT_C1",a[a.ABNT_C2=111]="ABNT_C2",a[a.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,l){this._keyCodeToStr[c]=l,this._strToKeyCode[l.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const b=new D,P=new D,n=new D;(function(){function a(c,l,s=l,t=s){b.define(c,l),P.define(c,s),n.define(c,t)}a(0,"unknown"),a(1,"Backspace"),a(2,"Tab"),a(3,"Enter"),a(4,"Shift"),a(5,"Ctrl"),a(6,"Alt"),a(7,"PauseBreak"),a(8,"CapsLock"),a(9,"Escape"),a(10,"Space"),a(11,"PageUp"),a(12,"PageDown"),a(13,"End"),a(14,"Home"),a(15,"LeftArrow","Left"),a(16,"UpArrow","Up"),a(17,"RightArrow","Right"),a(18,"DownArrow","Down"),a(19,"Insert"),a(20,"Delete"),a(21,"0"),a(22,"1"),a(23,"2"),a(24,"3"),a(25,"4"),a(26,"5"),a(27,"6"),a(28,"7"),a(29,"8"),a(30,"9"),a(31,"A"),a(32,"B"),a(33,"C"),a(34,"D"),a(35,"E"),a(36,"F"),a(37,"G"),a(38,"H"),a(39,"I"),a(40,"J"),a(41,"K"),a(42,"L"),a(43,"M"),a(44,"N"),a(45,"O"),a(46,"P"),a(47,"Q"),a(48,"R"),a(49,"S"),a(50,"T"),a(51,"U"),a(52,"V"),a(53,"W"),a(54,"X"),a(55,"Y"),a(56,"Z"),a(57,"Meta"),a(58,"ContextMenu"),a(59,"F1"),a(60,"F2"),a(61,"F3"),a(62,"F4"),a(63,"F5"),a(64,"F6"),a(65,"F7"),a(66,"F8"),a(67,"F9"),a(68,"F10"),a(69,"F11"),a(70,"F12"),a(71,"F13"),a(72,"F14"),a(73,"F15"),a(74,"F16"),a(75,"F17"),a(76,"F18"),a(77,"F19"),a(78,"NumLock"),a(79,"ScrollLock"),a(80,";",";","OEM_1"),a(81,"=","=","OEM_PLUS"),a(82,",",",","OEM_COMMA"),a(83,"-","-","OEM_MINUS"),a(84,".",".","OEM_PERIOD"),a(85,"/","/","OEM_2"),a(86,"`","`","OEM_3"),a(110,"ABNT_C1"),a(111,"ABNT_C2"),a(87,"[","[","OEM_4"),a(88,"\\","\\","OEM_5"),a(89,"]","]","OEM_6"),a(90,"'","'","OEM_7"),a(91,"OEM_8"),a(92,"OEM_102"),a(93,"NumPad0"),a(94,"NumPad1"),a(95,"NumPad2"),a(96,"NumPad3"),a(97,"NumPad4"),a(98,"NumPad5"),a(99,"NumPad6"),a(100,"NumPad7"),a(101,"NumPad8"),a(102,"NumPad9"),a(103,"NumPad_Multiply"),a(104,"NumPad_Add"),a(105,"NumPad_Separator"),a(106,"NumPad_Subtract"),a(107,"NumPad_Decimal"),a(108,"NumPad_Divide")})();var y;(function(a){function c(o){return b.keyCodeToStr(o)}a.toString=c;function l(o){return b.strToKeyCode(o)}a.fromString=l;function s(o){return P.keyCodeToStr(o)}a.toUserSettingsUS=s;function t(o){return n.keyCodeToStr(o)}a.toUserSettingsGeneral=t;function r(o){return P.strToKeyCode(o)||n.strToKeyCode(o)}a.fromUserSettings=r})(y=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl",a[a.KeyCode=255]="KeyCode"})(i||(i={}));var L;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl"})(L=e.KeyMod||(e.KeyMod={}));function g(a,c){const l=(c&65535)<<16>>>0;return(a|l)>>>0}e.KeyChord=g;function E(a,c){if(a===0)return null;const l=(a&65535)>>>0,s=(a&4294901760)>>>16;return s!==0?new m([p(l,c),p(s,c)]):new m([p(l,c)])}e.createKeybinding=E;function p(a,c){const l=!!(a&2048),s=!!(a&256),t=c===2?s:l,r=!!(a&1024),o=!!(a&512),u=c===2?l:s,d=a&255;return new h(t,r,o,u,d)}e.createSimpleKeybinding=p;class h{constructor(c,l,s,t,r){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyCode=r}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",s=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${l}${s}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=h;class m{constructor(c){if(c.length===0)throw(0,w.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let l=0,s=this.parts.length;l<s;l++)l!==0&&(c+=";"),c+=this.parts[l].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(c.parts[l]))return!1;return!0}}e.ChordKeybinding=m;class S{constructor(c,l,s,t,r,o){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=o}}e.ResolvedKeybindingPart=S;class v{}e.ResolvedKeybinding=v}),define(Q[2],J([0,1,43,63]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let b=null;function P(c){b=c}if(e.setDisposableTracker=P,D){const c="__is_disposable_tracked__";b=new class{trackDisposable(l){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[c]||console.log(s)},3e3)}markTracked(l){if(l&&l!==m.None)try{l[c]=!0}catch(s){}}}}function n(c){!b||b.markTracked(c)}function y(c){return b&&b.trackDisposable(c),c}e.trackDisposable=y;class i extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=i;function L(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=L;function g(c){if(R.Iterable.is(c)){let l=[];for(const s of c)if(s){n(s);try{s.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new i(l);return Array.isArray(c)?[]:c}else if(c)return n(c),c.dispose(),c}e.dispose=g;function E(...c){return c.forEach(n),p(()=>g(c))}e.combinedDisposable=E;function p(c){const l=y({dispose:()=>{n(l),c()}});return l}e.toDisposable=p;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new h,y(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var s;this._isDisposed||l===this._value||((s=this._value)===null||s===void 0||s.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,n(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=S;class v{constructor(){this.references=new Map}acquire(l,...s){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...s)},this.references.set(l,t));const{object:r}=t,o=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:r,dispose:o}}}e.ReferenceCollection=v;class a{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=a}),define(Q[76],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(b){this.element=b,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class R{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,P){const n=new w(b);if(this._first===w.Undefined)this._first=n,this._last=n;else if(P){const i=this._last;this._last=n,n.prev=i,i.next=n}else{const i=this._first;this._first=n,n.next=i,i.prev=n}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(n))}}shift(){if(this._first!==w.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==w.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==w.Undefined&&b.next!==w.Undefined){const P=b.prev;P.next=b.next,b.next.prev=P}else b.prev===w.Undefined&&b.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):b.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):b.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==w.Undefined;)yield b.element,b=b.next}}e.LinkedList=R});"use strict";(function(){function j(D){const b=[];typeof D=="number"&&b.push("code/timeOrigin",D);function P(y){b.push(y,Date.now())}function n(){const y=[];for(let i=0;i<b.length;i+=2)y.push({name:b[i],startTime:b[i+1]});return y}return{mark:P,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))b.push({name:P.name,startTime:Math.round(D+P.startTime)});return b}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function w(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=w(R))})(),define(Q[3],J([0,1]),function(j,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let D=!1,b=!1,P=!1,n=!1,y=!1,i=!1,L=!1,g,E=R,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof process!="undefined"?m=process:typeof e.globals.vscode!="undefined"&&(m=e.globals.vscode.process);const S=typeof((w=m==null?void 0:m.versions)===null||w===void 0?void 0:w.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=S&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=m==null?void 0:m.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)h=navigator.userAgent,D=h.indexOf("Windows")>=0,b=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=h.indexOf("Linux")>=0,i=!0,g=navigator.language,E=g;else if(typeof m=="object"){D=m.platform==="win32",b=m.platform==="darwin",P=m.platform==="linux",n=P&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,g=R,E=R;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const d=JSON.parse(u),f=d.availableLanguages["*"];g=d.locale,E=f||R,p=d._translationsConfigFile}catch(d){}y=!0}else console.error("Unable to resolve platform.");var v;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let c=0;b?c=1:D?c=3:P&&(c=2),e.isWindows=D,e.isMacintosh=b,e.isLinux=P,e.isLinuxSnap=n,e.isNative=y,e.isWeb=i,e.isIOS=L,e.platform=c,e.userAgent=h,e.language=E;var l;(function(u){function d(){return e.language}u.value=d;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function I(){return e.language==="en"}u.isDefault=I})(l=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let F=0,C=f.length;F<C;F++){const H=f[F];if(H.id===A.data.vscodeSetImmediateId){f.splice(F,1),H.callback();return}}});let I=0;return A=>{const F=++I;f.push({id:F,callback:A}),e.globals.postMessage({vscodeSetImmediateId:F},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const d=Promise.resolve();return f=>d.then(f)}();var s;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||L?2:D?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(Q[35],J([0,1,3]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof process!="undefined")R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}};else if(typeof w.globals.vscode!="undefined"){const D=w.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(b){return(0,w.setImmediate)(b)}}}else R={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(D){return(0,w.setImmediate)(D)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Q[8],J([0,1,35]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,b=90,P=122,n=46,y=47,i=92,L=58,g=63;class E extends Error{constructor(l,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const o=l.indexOf(".")!==-1?"property":"argument";let u=`The "${l}" ${o} ${r} of type ${s}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function p(c,l){if(typeof c!="string")throw new E(l,"string",c)}function h(c){return c===y||c===i}function m(c){return c===y}function S(c){return c>=R&&c<=b||c>=D&&c<=P}function v(c,l,s,t){let r="",o=0,u=-1,d=0,f=0;for(let I=0;I<=c.length;++I){if(I<c.length)f=c.charCodeAt(I);else{if(t(f))break;f=y}if(t(f)){if(!(u===I-1||d===1))if(d===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const A=r.lastIndexOf(s);A===-1?(r="",o=0):(r=r.slice(0,A),o=r.length-1-r.lastIndexOf(s)),u=I,d=0;continue}else if(r.length!==0){r="",o=0,u=I,d=0;continue}}l&&(r+=r.length>0?`${s}..`:"..",o=2)}else r.length>0?r+=`${s}${c.slice(u+1,I)}`:r=c.slice(u+1,I),o=I-u-1;u=I,d=0}else f===n&&d!==-1?++d:d=-1}return r}function a(c,l){if(l===null||typeof l!="object")throw new E("pathObject","Object",l);const s=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let l="",s="",t=!1;for(let r=c.length-1;r>=-1;r--){let o;if(r>=0){if(o=c[r],p(o,"path"),o.length===0)continue}else l.length===0?o=w.cwd():(o=w.env[`=${l}`]||w.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===i)&&(o=`${l}\\`));const u=o.length;let d=0,f="",I=!1;const A=o.charCodeAt(0);if(u===1)h(A)&&(d=1,I=!0);else if(h(A))if(I=!0,h(o.charCodeAt(1))){let F=2,C=F;for(;F<u&&!h(o.charCodeAt(F));)F++;if(F<u&&F!==C){const H=o.slice(C,F);for(C=F;F<u&&h(o.charCodeAt(F));)F++;if(F<u&&F!==C){for(C=F;F<u&&!h(o.charCodeAt(F));)F++;(F===u||F!==C)&&(f=`\\\\${H}\\${o.slice(C,F)}`,d=F)}}}else d=1;else S(A)&&o.charCodeAt(1)===L&&(f=o.slice(0,2),d=2,u>2&&h(o.charCodeAt(2))&&(I=!0,d=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(s=`${o.slice(d)}\\${s}`,t=I,I&&l.length>0)break}return s=v(s,!t,"\\",h),t?`${l}\\${s}`:`${l}${s}`||"."},normalize(c){p(c,"path");const l=c.length;if(l===0)return".";let s=0,t,r=!1;const o=c.charCodeAt(0);if(l===1)return m(o)?"\\":c;if(h(o))if(r=!0,h(c.charCodeAt(1))){let d=2,f=d;for(;d<l&&!h(c.charCodeAt(d));)d++;if(d<l&&d!==f){const I=c.slice(f,d);for(f=d;d<l&&h(c.charCodeAt(d));)d++;if(d<l&&d!==f){for(f=d;d<l&&!h(c.charCodeAt(d));)d++;if(d===l)return`\\\\${I}\\${c.slice(f)}\\`;d!==f&&(t=`\\\\${I}\\${c.slice(f,d)}`,s=d)}}}else s=1;else S(o)&&c.charCodeAt(1)===L&&(t=c.slice(0,2),s=2,l>2&&h(c.charCodeAt(2))&&(r=!0,s=3));let u=s<l?v(c.slice(s),!r,"\\",h):"";return u.length===0&&!r&&(u="."),u.length>0&&h(c.charCodeAt(l-1))&&(u+="\\"),t===void 0?r?`\\${u}`:u:r?`${t}\\${u}`:`${t}${u}`},isAbsolute(c){p(c,"path");const l=c.length;if(l===0)return!1;const s=c.charCodeAt(0);return h(s)||l>2&&S(s)&&c.charCodeAt(1)===L&&h(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let l,s;for(let o=0;o<c.length;++o){const u=c[o];p(u,"path"),u.length>0&&(l===void 0?l=s=u:l+=`\\${u}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&h(s.charCodeAt(0))){++r;const o=s.length;o>1&&h(s.charCodeAt(1))&&(++r,o>2&&(h(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&h(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(c,l){if(p(c,"from"),p(l,"to"),c===l)return"";const s=e.win32.resolve(c),t=e.win32.resolve(l);if(s===t||(c=s.toLowerCase(),l=t.toLowerCase(),c===l))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===i;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===i;)o--;const u=o-r;let d=0;for(;d<l.length&&l.charCodeAt(d)===i;)d++;let f=l.length;for(;f-1>d&&l.charCodeAt(f-1)===i;)f--;const I=f-d,A=u<I?u:I;let F=-1,C=0;for(;C<A;C++){const X=c.charCodeAt(r+C);if(X!==l.charCodeAt(d+C))break;X===i&&(F=C)}if(C!==A){if(F===-1)return t}else{if(I>A){if(l.charCodeAt(d+C)===i)return t.slice(d+C+1);if(C===2)return t.slice(d+C)}u>A&&(c.charCodeAt(r+C)===i?F=C:C===2&&(F=3)),F===-1&&(F=0)}let H="";for(C=r+F+1;C<=o;++C)(C===o||c.charCodeAt(C)===i)&&(H+=H.length===0?"..":"\\..");return d+=F,H.length>0?`${H}${t.slice(d,f)}`:(t.charCodeAt(d)===i&&++d,t.slice(d,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const l=e.win32.resolve(c);if(l.length<=2)return c;if(l.charCodeAt(0)===i){if(l.charCodeAt(1)===i){const s=l.charCodeAt(2);if(s!==g&&s!==n)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(S(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===i)return`\\\\?\\${l}`;return c},dirname(c){p(c,"path");const l=c.length;if(l===0)return".";let s=-1,t=0;const r=c.charCodeAt(0);if(l===1)return h(r)?c:".";if(h(r)){if(s=t=1,h(c.charCodeAt(1))){let d=2,f=d;for(;d<l&&!h(c.charCodeAt(d));)d++;if(d<l&&d!==f){for(f=d;d<l&&h(c.charCodeAt(d));)d++;if(d<l&&d!==f){for(f=d;d<l&&!h(c.charCodeAt(d));)d++;if(d===l)return c;d!==f&&(s=t=d+1)}}}}else S(r)&&c.charCodeAt(1)===L&&(s=l>2&&h(c.charCodeAt(2))?3:2,t=s);let o=-1,u=!0;for(let d=l-1;d>=t;--d)if(h(c.charCodeAt(d))){if(!u){o=d;break}}else u=!1;if(o===-1){if(s===-1)return".";o=s}return c.slice(0,o)},basename(c,l){l!==void 0&&p(l,"ext"),p(c,"path");let s=0,t=-1,r=!0,o;if(c.length>=2&&S(c.charCodeAt(0))&&c.charCodeAt(1)===L&&(s=2),l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let u=l.length-1,d=-1;for(o=c.length-1;o>=s;--o){const f=c.charCodeAt(o);if(h(f)){if(!r){s=o+1;break}}else d===-1&&(r=!1,d=o+1),u>=0&&(f===l.charCodeAt(u)?--u==-1&&(t=o):(u=-1,t=d))}return s===t?t=d:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=s;--o)if(h(c.charCodeAt(o))){if(!r){s=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){p(c,"path");let l=0,s=-1,t=0,r=-1,o=!0,u=0;c.length>=2&&c.charCodeAt(1)===L&&S(c.charCodeAt(0))&&(l=t=2);for(let d=c.length-1;d>=l;--d){const f=c.charCodeAt(d);if(h(f)){if(!o){t=d+1;break}continue}r===-1&&(o=!1,r=d+1),f===n?s===-1?s=d:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||r===-1||u===0||u===1&&s===r-1&&s===t+1?"":c.slice(s,r)},format:a.bind(null,"\\"),parse(c){p(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.length;let t=0,r=c.charCodeAt(0);if(s===1)return h(r)?(l.root=l.dir=c,l):(l.base=l.name=c,l);if(h(r)){if(t=1,h(c.charCodeAt(1))){let F=2,C=F;for(;F<s&&!h(c.charCodeAt(F));)F++;if(F<s&&F!==C){for(C=F;F<s&&h(c.charCodeAt(F));)F++;if(F<s&&F!==C){for(C=F;F<s&&!h(c.charCodeAt(F));)F++;F===s?t=F:F!==C&&(t=F+1)}}}}else if(S(r)&&c.charCodeAt(1)===L){if(s<=2)return l.root=l.dir=c,l;if(t=2,h(c.charCodeAt(2))){if(s===3)return l.root=l.dir=c,l;t=3}}t>0&&(l.root=c.slice(0,t));let o=-1,u=t,d=-1,f=!0,I=c.length-1,A=0;for(;I>=t;--I){if(r=c.charCodeAt(I),h(r)){if(!f){u=I+1;break}continue}d===-1&&(f=!1,d=I+1),r===n?o===-1?o=I:A!==1&&(A=1):o!==-1&&(A=-1)}return d!==-1&&(o===-1||A===0||A===1&&o===d-1&&o===u+1?l.base=l.name=c.slice(u,d):(l.name=c.slice(u,o),l.base=c.slice(u,d),l.ext=c.slice(o,d))),u>0&&u!==t?l.dir=c.slice(0,u-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let l="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const r=t>=0?c[t]:w.cwd();p(r,"path"),r.length!==0&&(l=`${r}/${l}`,s=r.charCodeAt(0)===y)}return l=v(l,!s,"/",m),s?`/${l}`:l.length>0?l:"."},normalize(c){if(p(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===y,s=c.charCodeAt(c.length-1)===y;return c=v(c,!l,"/",m),c.length===0?l?"/":s?"./":".":(s&&(c+="/"),l?`/${c}`:c)},isAbsolute(c){return p(c,"path"),c.length>0&&c.charCodeAt(0)===y},join(...c){if(c.length===0)return".";let l;for(let s=0;s<c.length;++s){const t=c[s];p(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(c,l){if(p(c,"from"),p(l,"to"),c===l||(c=e.posix.resolve(c),l=e.posix.resolve(l),c===l))return"";const s=1,t=c.length,r=t-s,o=1,u=l.length-o,d=r<u?r:u;let f=-1,I=0;for(;I<d;I++){const F=c.charCodeAt(s+I);if(F!==l.charCodeAt(o+I))break;F===y&&(f=I)}if(I===d)if(u>d){if(l.charCodeAt(o+I)===y)return l.slice(o+I+1);if(I===0)return l.slice(o+I)}else r>d&&(c.charCodeAt(s+I)===y?f=I:I===0&&(f=0));let A="";for(I=s+f+1;I<=t;++I)(I===t||c.charCodeAt(I)===y)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(o+f)}`},toNamespacedPath(c){return c},dirname(c){if(p(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===y;let s=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===y){if(!t){s=r;break}}else t=!1;return s===-1?l?"/":".":l&&s===1?"//":c.slice(0,s)},basename(c,l){l!==void 0&&p(l,"ext"),p(c,"path");let s=0,t=-1,r=!0,o;if(l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let u=l.length-1,d=-1;for(o=c.length-1;o>=0;--o){const f=c.charCodeAt(o);if(f===y){if(!r){s=o+1;break}}else d===-1&&(r=!1,d=o+1),u>=0&&(f===l.charCodeAt(u)?--u==-1&&(t=o):(u=-1,t=d))}return s===t?t=d:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===y){if(!r){s=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){p(c,"path");let l=-1,s=0,t=-1,r=!0,o=0;for(let u=c.length-1;u>=0;--u){const d=c.charCodeAt(u);if(d===y){if(!r){s=u+1;break}continue}t===-1&&(r=!1,t=u+1),d===n?l===-1?l=u:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||t===-1||o===0||o===1&&l===t-1&&l===s+1?"":c.slice(l,t)},format:a.bind(null,"/"),parse(c){p(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.charCodeAt(0)===y;let t;s?(l.root="/",t=1):t=0;let r=-1,o=0,u=-1,d=!0,f=c.length-1,I=0;for(;f>=t;--f){const A=c.charCodeAt(f);if(A===y){if(!d){o=f+1;break}continue}u===-1&&(d=!1,u=f+1),A===n?r===-1?r=f:I!==1&&(I=1):r!==-1&&(I=-1)}if(u!==-1){const A=o===0&&s?1:o;r===-1||I===0||I===1&&r===u-1&&r===o+1?l.base=l.name=c.slice(A,u):(l.name=c.slice(A,r),l.base=c.slice(A,u),l.ext=c.slice(r,u))}return o>0?l.dir=c.slice(0,o-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[77],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var w;(function(n){n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(w=e.ScanCode||(e.ScanCode={}));const R=[],D=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>b[n]||0,toEnum:n=>D[n]||0,toString:n=>R[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class P{constructor(y,i,L,g,E){this.ctrlKey=y,this.shiftKey=i,this.altKey=L,this.metaKey=g,this.scanCode=E}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.scanCode===y.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=P,function(){function n(y,i){R[y]=i,D[i]=y,b[i.toLowerCase()]=y}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let y=0;y<=193;y++)e.IMMUTABLE_CODE_TO_KEY_CODE[y]=-1;for(let y=0;y<=112;y++)e.IMMUTABLE_KEY_CODE_TO_CODE[y]=-1;function n(y,i){e.IMMUTABLE_CODE_TO_KEY_CODE[y]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=y)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Q[102],J([0,1,56,77]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let n=!1,y=!1,i=!1,L=!1,g;do g=!1,/^ctrl(\+|\-)/.test(P)&&(n=!0,P=P.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(P)&&(y=!0,P=P.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(P)&&(i=!0,P=P.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(P)&&(L=!0,P=P.substr("meta-".length),g=!0),/^win(\+|\-)/.test(P)&&(L=!0,P=P.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(P)&&(L=!0,P=P.substr("cmd-".length),g=!0);while(g);let E;const p=P.indexOf(" ");return p>0?(E=P.substring(0,p),P=P.substring(p)):(E=P,P=""),{remains:P,ctrl:n,shift:y,alt:i,meta:L,key:E}}static parseSimpleKeybinding(P){const n=this._readModifiers(P),y=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseKeybinding(P,n){if(!P)return null;const y=[];let i;do[i,P]=this.parseSimpleKeybinding(P),y.push(i);while(P.length>0);return new w.ChordKeybinding(y)}static parseSimpleUserBinding(P){const n=this._readModifiers(P),y=n.key.match(/^\[([^\]]+)\]$/);if(y){const L=y[1],g=R.ScanCodeUtils.lowerCaseToEnum(L);return[new R.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,g),n.remains]}const i=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,i),n.remains]}static parseUserBinding(P){if(!P)return[];const n=[];let y;for(;P.length>0;)[y,P]=this.parseSimpleUserBinding(P),n.push(y);return n}}e.KeybindingParser=D}),define(Q[103],J([0,1,3]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=w.globals.performance&&typeof w.globals.performance.now=="function";class D{constructor(P){this._highResolution=R&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Q[4],J([0,1,19,43,2,76,103]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(v){v.None=()=>D.Disposable.None;function a(V){return(N,B=null,U)=>{let $=!1,T;return T=V(k=>{if(!$)return T?T.dispose():$=!0,N.call(B,k)},null,U),$&&T.dispose(),T}}v.once=a;function c(V,N){return u((B,U=null,$)=>V(T=>B.call(U,N(T)),null,$))}v.map=c;function l(V,N){return u((B,U=null,$)=>V(T=>{N(T),B.call(U,T)},null,$))}v.forEach=l;function s(V,N){return u((B,U=null,$)=>V(T=>N(T)&&B.call(U,T),null,$))}v.filter=s;function t(V){return V}v.signal=t;function r(...V){return(N,B=null,U)=>(0,D.combinedDisposable)(...V.map($=>$(T=>N.call(B,T),null,U)))}v.any=r;function o(V,N,B){let U=B;return c(V,$=>(U=N(U,$),U))}v.reduce=o;function u(V){let N;const B=new E({onFirstListenerAdd(){N=V(B.fire,B)},onLastListenerRemove(){N.dispose()}});return B.event}v.snapshot=u;function d(V,N,B=100,U=!1,$){let T,k,M,O=0;const _=new E({leakWarningThreshold:$,onFirstListenerAdd(){T=V(W=>{O++,k=N(k,W),U&&!M&&(_.fire(k),k=void 0),clearTimeout(M),M=setTimeout(()=>{const z=k;k=void 0,M=void 0,(!U||O>1)&&_.fire(z),O=0},B)})},onLastListenerRemove(){T.dispose()}});return _.event}v.debounce=d;function f(V){const N=new Date().getTime();return c(a(V),B=>new Date().getTime()-N)}v.stopwatch=f;function I(V){let N=!0,B;return s(V,U=>{const $=N||U!==B;return N=!1,B=U,$})}v.latch=I;function A(V,N=!1,B=[]){let U=B.slice(),$=V(M=>{U?U.push(M):k.fire(M)});const T=()=>{U&&U.forEach(M=>k.fire(M)),U=null},k=new E({onFirstListenerAdd(){$||($=V(M=>k.fire(M)))},onFirstListenerDidAdd(){U&&(N?setTimeout(T):T())},onLastListenerRemove(){$&&$.dispose(),$=null}});return k.event}v.buffer=A;class F{constructor(N){this.event=N}map(N){return new F(c(this.event,N))}forEach(N){return new F(l(this.event,N))}filter(N){return new F(s(this.event,N))}reduce(N,B){return new F(o(this.event,N,B))}latch(){return new F(I(this.event))}debounce(N,B=100,U=!1,$){return new F(d(this.event,N,B,U,$))}on(N,B,U){return this.event(N,B,U)}once(N,B,U){return a(this.event)(N,B,U)}}function C(V){return new F(V)}v.chain=C;function H(V,N,B=U=>U){const U=(...M)=>k.fire(B(...M)),$=()=>V.on(N,U),T=()=>V.removeListener(N,U),k=new E({onFirstListenerAdd:$,onLastListenerRemove:T});return k.event}v.fromNodeEventEmitter=H;function X(V,N,B=U=>U){const U=(...M)=>k.fire(B(...M)),$=()=>V.addEventListener(N,U),T=()=>V.removeEventListener(N,U),k=new E({onFirstListenerAdd:$,onLastListenerRemove:T});return k.event}v.fromDOMEventEmitter=X;function ne(V){const N=new E;let B=!1;return V.then(void 0,()=>null).then(()=>{B?N.fire(void 0):setTimeout(()=>N.fire(void 0),0)}),B=!0,N.event}v.fromPromise=ne;function oe(V){return new Promise(N=>a(V)(N))}v.toPromise=oe})(n=e.Event||(e.Event={}));class y{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${y._idPool++}`}start(a){this._stopWatch=new P.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let i=-1;function L(v){const a=i;return i=v,{dispose(){i=a}}}e.setGlobalLeakWarningThreshold=L;class g{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let c=i;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||a<c)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[o,u]of this._stacks)(!t||r<u)&&(t=o,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class E{constructor(a){var c;this._disposed=!1,this._options=a,this._leakageMon=i>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(a,c,l)=>{var s;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[a,c]:a);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const o=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let u;return u={dispose:()=>{o&&o(),u.dispose=E._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof D.DisposableStore?l.add(u):Array.isArray(l)&&l.push(u),u}),this._event}fire(a){var c,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,a]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(r){(0,w.onUnexpectedError)(r)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var a,c,l;(a=this._listeners)===null||a===void 0||a.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class p extends E{constructor(a){super(a);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=p;class h{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const l=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,D.toDisposable)((0,R.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=h;class m{constructor(){this.buffers=[]}wrapEvent(a){return(c,l,s)=>a(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(l,t)):c.call(l,t)},void 0,s)}bufferEvents(a){const c=[];this.buffers.push(c);const l=a();return this.buffers.pop(),c.forEach(s=>s()),l}}e.EventBufferer=m;class S{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(Q[25],J([0,1,4]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(n,y){const i=setTimeout(n.bind(y),0);return{dispose(){clearTimeout(i)}}});var D;(function(n){function y(i){return i===n.None||i===n.Cancelled||i instanceof b?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}n.isCancellationToken=y,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Q[104],J([0,1,4]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(L){const g=this._icons.get(L.id);g?L.description?g.description=L.description:console.error(`Duplicate registration of codicon ${L.id}`):(this._icons.set(L.id,L),this._onDidRegister.fire(L))}get(L){return this._icons.get(L)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function b(i,L){return new P(i,L)}e.registerCodicon=b;class P{constructor(L,g,E){this.id=L,this.definition=g,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function n(i,L){const g=["codicon","codicon-"+i];return L&&g.push("codicon-modifier-"+L),g}e.getClassNamesArray=n;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const L=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(h){if(h instanceof P)return["codicon","codicon-"+h.id];const m=L.exec(h.id);if(!m)return g(P.error);let[,S,v]=m;const a=["codicon","codicon-"+S];return v&&a.push("codicon-modifier-"+v.substr(1)),a}i.asClassNameArray=g;function E(h){return g(h).join(" ")}i.asClassName=E;function p(h){return"."+g(h).join(".")}i.asCSSSelector=p})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnknown=new i("workspace-unknown",{fontCharacter:"\\ebc3"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Q[57],J([0,1,19,2]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(S){const v=S;return v&&[v.on,v.pause,v.resume,v.destroy].every(a=>typeof a=="function")}e.isReadableStream=D;function b(S){const v=S;return v&&D(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean"}e.isReadableBufferedStream=b;function P(S,v){return new n(S,v)}e.newWriteableStream=P;class n{constructor(v,a){this.reducer=v,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){var a;if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof((a=this.options)===null||a===void 0?void 0:a.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(a=>a(v))}emitError(v){this.listeners.error.length===0?(0,w.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(a=>a(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,a){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(v,a){if(!this.state.destroyed){let c;switch(v){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const l=c.indexOf(a);l>=0&&c.splice(l,1)}}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(S,v){const a=[];let c;for(;(c=S.read())!==null;)a.push(c);return v(a)}e.consumeReadable=y;function i(S,v,a){const c=[];let l;for(;(l=S.read())!==null&&c.length<a;)c.push(l);return l===null&&c.length>0?v(c):{read:()=>{if(c.length>0)return c.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return S.read()}}}e.peekReadable=i;function L(S,v){return new Promise((a,c)=>{const l=[];g(S,{onData:s=>{v&&l.push(s)},onError:s=>{v?c(s):a(void 0)},onEnd:()=>{a(v?v(l):void 0)}})})}e.consumeStream=L;function g(S,v){S.on("error",a=>v.onError(a)),S.on("end",()=>v.onEnd()),S.on("data",a=>v.onData(a))}e.listenStream=g;function E(S,v){return new Promise((a,c)=>{const l=new R.DisposableStore,s=[],t=u=>{if(s.push(u),s.length>v)return l.dispose(),S.pause(),a({stream:S,buffer:s,ended:!1})},r=u=>c(u),o=()=>a({stream:S,buffer:s,ended:!0});l.add((0,R.toDisposable)(()=>S.removeListener("error",r))),S.on("error",r),l.add((0,R.toDisposable)(()=>S.removeListener("end",o))),S.on("end",o),l.add((0,R.toDisposable)(()=>S.removeListener("data",t))),S.on("data",t)})}e.peekStream=E;function p(S,v){const a=P(v);return a.end(S),a}e.toStream=p;function h(S){let v=!1;return{read:()=>v?null:(v=!0,S)}}e.toReadable=h;function m(S,v,a){const c=P(a);return g(S,{onData:l=>c.write(v.data(l)),onError:l=>c.error(v.error?v.error(l):l),onEnd:()=>c.end()}),c}e.transform=m}),define(Q[20],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=w;const R=/{(\d+)}/g;function D(q,...te){return te.length===0?q:q.replace(R,function(se,ae){const fe=parseInt(ae,10);return isNaN(fe)||fe<0||fe>=te.length?se:te[fe]})}e.format=D;function b(q){return q.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=b;function P(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function n(q,te){let se=0;const ae=te.charCodeAt(0);for(let fe=q.length-1;fe>=0;fe--)q.charCodeAt(fe)===ae&&se++;return se}e.count=n;function y(q,te,se="\u2026"){return q.length<=te?q:`${q.substr(0,te)}${se}`}e.truncate=y;function i(q,te=" "){const se=L(q,te);return g(se,te)}e.trim=i;function L(q,te){if(!q||!te)return q;const se=te.length;if(se===0||q.length===0)return q;let ae=0;for(;q.indexOf(te,ae)===ae;)ae=ae+se;return q.substring(ae)}e.ltrim=L;function g(q,te){if(!q||!te)return q;const se=te.length,ae=q.length;if(se===0||ae===0)return q;let fe=ae,pe=-1;for(;pe=q.lastIndexOf(te,fe-1),!(pe===-1||pe+se!==fe);){if(pe===0)return"";fe=pe}return q.substring(0,fe)}e.rtrim=g;function E(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function p(q){return q.replace(/\*/g,"")}e.stripWildcards=p;function h(q,te,se={}){if(!q)throw new Error("Cannot create regex from empty string");te||(q=P(q)),se.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ae="";return se.global&&(ae+="g"),se.matchCase||(ae+="i"),se.multiline&&(ae+="m"),se.unicode&&(ae+="u"),new RegExp(q,ae)}e.createRegExp=h;function m(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function S(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function v(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=v;function a(q){return q.split(/\r\n|\r|\n/)}e.splitLines=a;function c(q){for(let te=0,se=q.length;te<se;te++){const ae=q.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function l(q,te=0,se=q.length){for(let ae=te;ae<se;ae++){const fe=q.charCodeAt(ae);if(fe!==32&&fe!==9)return q.substring(te,ae)}return q.substring(te,se)}e.getLeadingWhitespace=l;function s(q,te=q.length-1){for(let se=te;se>=0;se--){const ae=q.charCodeAt(se);if(ae!==32&&ae!==9)return se}return-1}e.lastNonWhitespaceIndex=s;function t(q,te){return q<te?-1:q>te?1:0}e.compare=t;function r(q,te,se=0,ae=q.length,fe=0,pe=te.length){for(;se<ae&&fe<pe;se++,fe++){let Oe=q.charCodeAt(se),We=te.charCodeAt(fe);if(Oe<We)return-1;if(Oe>We)return 1}const Ee=ae-se,Re=pe-fe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstring=r;function o(q,te){return u(q,te,0,q.length,0,te.length)}e.compareIgnoreCase=o;function u(q,te,se=0,ae=q.length,fe=0,pe=te.length){for(;se<ae&&fe<pe;se++,fe++){let Oe=q.charCodeAt(se),We=te.charCodeAt(fe);if(Oe!==We){const Be=Oe-We;if(!(Be===32&&f(We))&&!(Be===-32&&f(Oe)))return d(Oe)&&d(We)?Be:r(q.toLowerCase(),te.toLowerCase(),se,ae,fe,pe)}}const Ee=ae-se,Re=pe-fe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstringIgnoreCase=u;function d(q){return q>=97&&q<=122}e.isLowerAsciiLetter=d;function f(q){return q>=65&&q<=90}e.isUpperAsciiLetter=f;function I(q){return d(q)||f(q)}function A(q,te){return q.length===te.length&&F(q,te)}e.equalsIgnoreCase=A;function F(q,te,se=q.length){for(let ae=0;ae<se;ae++){const fe=q.charCodeAt(ae),pe=te.charCodeAt(ae);if(fe!==pe){if(I(fe)&&I(pe)){const Ee=Math.abs(fe-pe);if(Ee!==0&&Ee!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(pe).toLowerCase())return!1}}return!0}function C(q,te){const se=te.length;return te.length>q.length?!1:F(q,te,se)}e.startsWithIgnoreCase=C;function H(q,te){let se,ae=Math.min(q.length,te.length);for(se=0;se<ae;se++)if(q.charCodeAt(se)!==te.charCodeAt(se))return se;return ae}e.commonPrefixLength=H;function X(q,te){let se,ae=Math.min(q.length,te.length);const fe=q.length-1,pe=te.length-1;for(se=0;se<ae;se++)if(q.charCodeAt(fe-se)!==te.charCodeAt(pe-se))return se;return ae}e.commonSuffixLength=X;function ne(q){return 55296<=q&&q<=56319}e.isHighSurrogate=ne;function oe(q){return 56320<=q&&q<=57343}e.isLowSurrogate=oe;function V(q,te){return(q-55296<<10)+(te-56320)+65536}e.computeCodePoint=V;function N(q,te,se){const ae=q.charCodeAt(se);if(ne(ae)&&se+1<te){const fe=q.charCodeAt(se+1);if(oe(fe))return V(ae,fe)}return ae}e.getNextCodePoint=N;function B(q,te){const se=q.charCodeAt(te-1);if(oe(se)&&te>1){const ae=q.charCodeAt(te-2);if(ne(ae))return V(ae,se)}return se}function U(q,te){const se=Ce.getInstance(),ae=te,fe=q.length,pe=N(q,fe,te);te+=pe>=65536?2:1;let Ee=se.getGraphemeBreakType(pe);for(;te<fe;){const Re=N(q,fe,te),Oe=se.getGraphemeBreakType(Re);if(Ke(Ee,Oe))break;te+=Re>=65536?2:1,Ee=Oe}return te-ae}e.nextCharLength=U;function $(q,te){const se=Ce.getInstance(),ae=te,fe=B(q,te);te-=fe>=65536?2:1;let pe=se.getGraphemeBreakType(fe);for(;te>0;){const Ee=B(q,te),Re=se.getGraphemeBreakType(Ee);if(Ke(Re,pe))break;te-=Ee>=65536?2:1,pe=Re}return ae-te}e.prevCharLength=$;function T(q,te){const se=Ce.getInstance(),ae=q.length,fe=te,pe=N(q,ae,te),Ee=se.getGraphemeBreakType(pe);te+=pe>=65536?2:1;let Re=Ee;for(;te<ae;){const We=N(q,ae,te),Be=se.getGraphemeBreakType(We);if(Ke(Re,Be))break;te+=We>=65536?2:1,Re=Be}const Oe=te;for(te=fe,Re=Ee;te>0;){const We=B(q,te),Be=se.getGraphemeBreakType(We);if(Ke(Be,Re))break;te-=We>=65536?2:1,Re=Be}return[te,Oe]}function k(q,te){return te>0&&oe(q.charCodeAt(te))?T(q,te-1):T(q,te)}e.getCharContainingOffset=k;function M(q){const te=q.length;let se=0,ae=0;for(;ae<te;){const Ee=N(q,te,ae);ae+=Ee>=65536?2:1,Ee<128?se+=1:Ee<2048?se+=2:Ee<65536?se+=3:se+=4}const fe=new Uint8Array(se);ae=0;let pe=0;for(;ae<te;){const Ee=N(q,te,ae);ae+=Ee>=65536?2:1,Ee<128?fe[pe++]=Ee:Ee<2048?(fe[pe++]=192|(Ee&1984)>>>6,fe[pe++]=128|(Ee&63)>>>0):Ee<65536?(fe[pe++]=224|(Ee&61440)>>>12,fe[pe++]=128|(Ee&4032)>>>6,fe[pe++]=128|(Ee&63)>>>0):(fe[pe++]=240|(Ee&1835008)>>>18,fe[pe++]=128|(Ee&258048)>>>12,fe[pe++]=128|(Ee&4032)>>>6,fe[pe++]=128|(Ee&63)>>>0)}return fe}e.encodeUTF8=M;function O(q){const te=q.byteLength,se=[];let ae=0;for(;ae<te;){const fe=q[ae];let pe;if(fe>=240&&ae+3<te?pe=(q[ae++]&7)<<18>>>0|(q[ae++]&63)<<12>>>0|(q[ae++]&63)<<6>>>0|(q[ae++]&63)<<0>>>0:fe>=224&&ae+2<te?pe=(q[ae++]&15)<<12>>>0|(q[ae++]&63)<<6>>>0|(q[ae++]&63)<<0>>>0:fe>=192&&ae+1<te?pe=(q[ae++]&31)<<6>>>0|(q[ae++]&63)<<0>>>0:pe=q[ae++],pe>=0&&pe<=55295||pe>=57344&&pe<=65535)se.push(String.fromCharCode(pe));else if(pe>=65536&&pe<=1114111){const Ee=pe-65536,Re=55296+((Ee&1047552)>>>10),Oe=56320+((Ee&1023)>>>0);se.push(String.fromCharCode(Re)),se.push(String.fromCharCode(Oe))}else se.push(String.fromCharCode(65533))}return se.join("")}e.decodeUTF8=O;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(q){return _.test(q)}e.containsRTL=W;const z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(q){return z.test(q)}e.containsEmoji=K;const Y=/^[\t\n\r\x20-\x7E]*$/;function Z(q){return Y.test(q)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=G;function ee(q){for(let te=0,se=q.length;te<se;te++)if(re(q.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ee;function re(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=re;function ie(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=ie;function ue(q,te){if(q.length<te)return q;const se=/\b/g;let ae=0;for(;se.test(q)&&!(q.length-se.lastIndex<te);)ae=se.lastIndex,se.lastIndex+=1;return q.substring(ae).replace(/^\s/,"")}e.lcut=ue;const ve=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function me(q){return q&&(q=q.replace(ve,""),q=q.replace(de,""),q=q.replace(he,"")),q}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Le(q){return ke(q)?q.substr(1):q}e.stripUTF8BOM=Le;function je(q,te){if(!q||!te||q.length<te.length)return!1;const se=te.length,ae=q.toLowerCase();let fe=0,pe=-1;for(;fe<se;){const Ee=ae.indexOf(te[fe],pe+1);if(Ee<0)return!1;pe=Ee,fe++}return!0}e.fuzzyContains=je;function Fe(q,te=!1){return q?(te&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Fe;function He(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=He;function Ze(q,te=1){if(te===0)return"";let se=-1;do se=q.indexOf(`
`,se+1),te--;while(te>0&&se>=0);return se===-1?q:(q[se-1]==="\r"&&se--,q.substr(0,se))}e.getNLines=Ze;function Ye(q){const te=90-65+1;return q=q%(2*te),q<te?String.fromCharCode(97+q):String.fromCharCode(65+q-te)}e.singleLetterHash=Ye;function nt(q){return Ce.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=nt;function Ke(q,te){return q===0?te!==5&&te!==7:q===2&&te===3?!1:q===4||q===2||q===3||te===4||te===2||te===3?!0:!(q===8&&(te===8||te===9||te===11||te===12)||(q===11||q===9)&&(te===9||te===10)||(q===12||q===10)&&te===10||te===5||te===13||te===7||q===1||q===13&&te===14||q===6&&te===6)}e.breakBetweenGraphemeBreakType=Ke;var rt;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(rt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=st()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const se=this._data,ae=se.length/3;let fe=1;for(;fe<=ae;)if(te<se[3*fe])fe=2*fe;else if(te>se[3*fe+1])fe=2*fe+1;else return se[3*fe+2];return 0}}Ce._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Q[21],J([0,1,20,57]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let n,y;class i{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return D?new i(Buffer.allocUnsafe(d)):new i(new Uint8Array(d))}static wrap(d){return D&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new i(d)}static fromString(d,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&D?new i(Buffer.from(d)):b?(n||(n=new TextEncoder),new i(n.encode(d))):new i(w.encodeUTF8(d))}static concat(d,f){if(typeof f=="undefined"){f=0;for(let F=0,C=d.length;F<C;F++)f+=d[F].byteLength}const I=i.alloc(f);let A=0;for(let F=0,C=d.length;F<C;F++){const H=d[F];I.set(H,A),A+=H.byteLength}return I}toString(){return D?this.buffer.toString():P?(y||(y=new TextDecoder),y.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(d,f){return new i(this.buffer.subarray(d,f))}set(d,f){d instanceof i?this.buffer.set(d.buffer,f):this.buffer.set(d,f)}readUInt32BE(d){return E(this.buffer,d)}writeUInt32BE(d,f){p(this.buffer,d,f)}readUInt32LE(d){return h(this.buffer,d)}writeUInt32LE(d,f){m(this.buffer,d,f)}readUInt8(d){return S(this.buffer,d)}writeUInt8(d,f){v(this.buffer,d,f)}}e.VSBuffer=i;function L(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}e.readUInt16LE=L;function g(u,d,f){u[f+0]=d&255,d=d>>>8,u[f+1]=d&255}e.writeUInt16LE=g;function E(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}e.readUInt32BE=E;function p(u,d,f){u[f+3]=d,d=d>>>8,u[f+2]=d,d=d>>>8,u[f+1]=d,d=d>>>8,u[f]=d}e.writeUInt32BE=p;function h(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}e.readUInt32LE=h;function m(u,d,f){u[f+0]=d&255,d=d>>>8,u[f+1]=d&255,d=d>>>8,u[f+2]=d&255,d=d>>>8,u[f+3]=d&255}e.writeUInt32LE=m;function S(u,d){return u[d]}e.readUInt8=S;function v(u,d,f){u[f]=d}e.writeUInt8=v;function a(u){return R.consumeReadable(u,d=>i.concat(d))}e.readableToBuffer=a;function c(u){return R.toReadable(u)}e.bufferToReadable=c;function l(u){return R.consumeStream(u,d=>i.concat(d))}e.streamToBuffer=l;async function s(u){return u.ended?i.concat(u.buffer):i.concat([...u.buffer,await l(u.stream)])}e.bufferedStreamToBuffer=s;function t(u){return R.toStream(u,d=>i.concat(d))}e.bufferToStream=t;function r(u){return R.transform(u,{data:d=>typeof d=="string"?i.fromString(d):i.wrap(d)},d=>i.concat(d))}e.streamToBufferReadableStream=r;function o(u){return R.newWriteableStream(d=>i.concat(d),u)}e.newWriteableBufferStream=o}),define(Q[78],J([0,1,20]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(v){return D(v,0)}e.hash=R;function D(v,a){switch(typeof v){case"object":return v===null?b(349,a):Array.isArray(v)?y(v,a):i(v,a);case"string":return n(v,a);case"boolean":return P(v,a);case"number":return b(v,a);case"undefined":return b(937,a);default:return b(617,a)}}e.doHash=D;function b(v,a){return(a<<5)-a+v|0}function P(v,a){return b(v?433:863,a)}function n(v,a){a=b(149417,a);for(let c=0,l=v.length;c<l;c++)a=b(v.charCodeAt(c),a);return a}e.stringHash=n;function y(v,a){return a=b(104579,a),v.reduce((c,l)=>D(l,c),a)}function i(v,a){return a=b(181387,a),Object.keys(v).sort().reduce((c,l)=>(c=n(l,c),D(v[l],c)),a)}class L{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=D(a,this._value),this._value}}e.Hasher=L;var g;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function E(v,a,c=32){const l=c-a,s=~((1<<l)-1);return(v<<a|(s&v)>>>l)>>>0}function p(v,a=0,c=v.byteLength,l=0){for(let s=0;s<c;s++)v[a+s]=l}function h(v,a,c="0"){for(;v.length<a;)v=c+v;return v}function m(v,a=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):h((v>>>0).toString(16),a/4)}e.toHexString=m;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const c=a.length;if(c!==0){const l=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=a.charCodeAt(0),o=0);;){let u=r;if(w.isHighSurrogate(r))if(o+1<c){const d=a.charCodeAt(o+1);w.isLowSurrogate(d)?(o++,u=w.computeCodePoint(r,d)):u=65533}else{t=r;break}else w.isLowSurrogate(r)&&(u=65533);if(s=this._push(l,s,u),o++,o<c)r=a.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(a,c,l){return l<128?a[c++]=l:l<2048?(a[c++]=192|(l&1984)>>>6,a[c++]=128|(l&63)>>>0):l<65536?(a[c++]=224|(l&61440)>>>12,a[c++]=128|(l&4032)>>>6,a[c++]=128|(l&63)>>>0):(a[c++]=240|(l&1835008)>>>18,a[c++]=128|(l&258048)>>>12,a[c++]=128|(l&4032)>>>6,a[c++]=128|(l&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=S._bigBlock32,c=this._buffDV;for(let I=0;I<64;I+=4)a.setUint32(I,c.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)a.setUint32(I,E(a.getUint32(I-12,!1)^a.getUint32(I-32,!1)^a.getUint32(I-56,!1)^a.getUint32(I-64,!1),1),!1);let l=this._h0,s=this._h1,t=this._h2,r=this._h3,o=this._h4,u,d,f;for(let I=0;I<80;I++)I<20?(u=s&t|~s&r,d=1518500249):I<40?(u=s^t^r,d=1859775393):I<60?(u=s&t|s&r|t&r,d=2400959708):(u=s^t^r,d=3395469782),f=E(l,5)+u+o+d+a.getUint32(I*4,!1)&4294967295,o=r,r=t,t=E(s,30),s=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(f){return Array.isArray(f)}e.isArray=w;function R(f){return typeof f=="string"}e.isString=R;function D(f){return Array.isArray(f)&&f.every(I=>R(I))}e.isStringArray=D;function b(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=b;function P(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=P;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function y(f){return f===!0||f===!1}e.isBoolean=y;function i(f){return typeof f=="undefined"}e.isUndefined=i;function L(f){return!g(f)}e.isDefined=L;function g(f){return i(f)||f===null}e.isUndefinedOrNull=g;function E(f,I){if(!f)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}e.assertType=E;function p(f){if(g(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=p;function h(...f){const I=[];for(let A=0;A<f.length;A++){const F=f[A];if(g(F))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);I.push(F)}return I}e.assertAllDefined=h;const m=Object.prototype.hasOwnProperty;function S(f){if(!b(f))return!1;for(let I in f)if(m.call(f,I))return!1;return!0}e.isEmptyObject=S;function v(f){return typeof f=="function"}e.isFunction=v;function a(...f){return f.length>0&&f.every(v)}e.areFunctions=a;function c(f,I){const A=Math.min(f.length,I.length);for(let F=0;F<A;F++)l(f[F],I[F])}e.validateConstraints=c;function l(f,I){if(R(I)){if(typeof f!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(v(I)){try{if(f instanceof I)return}catch(A){}if(!g(f)&&f.constructor===I||I.length===1&&I.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function s(f){let I=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)I=I.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return I}e.getAllPropertyNames=s;function t(f){const I=[];for(const A of s(f))typeof f[A]=="function"&&I.push(A);return I}e.getAllMethodNames=t;function r(f,I){const A=C=>function(){const H=Array.prototype.slice.call(arguments,0);return I(C,H)};let F={};for(const C of f)F[C]=A(C);return F}e.createProxyObject=r;function o(f){return f===null?void 0:f}e.withNullAsUndefined=o;function u(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=u;function d(f){return class{constructor(){return new Proxy({},{get(I,A){if(I[A])return I[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=d}),define(Q[29],J([0,1,3,20,8,13]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function y(r,o=D.posix.sep){if(!r)return"";const u=r.length,d=r.charCodeAt(0);if(P(d)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let I=3;const A=I;for(;I<u&&!P(r.charCodeAt(I));I++);if(A!==I&&!P(r.charCodeAt(I+1))){for(I+=1;I<u;I++)if(P(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(S(d)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(P(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=y;function i(r){if(!w.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let u=2;const d=u;for(;u<r.length&&(o=r.charCodeAt(u),o!==92);u++);return!(d===u||(o=r.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=i;const L=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,o=w.isWindows){const u=o?L:g;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||o&&E.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function h(r,o,u){const d=r===o;return!u||d?d:!r||!o?!1:(0,R.equalsIgnoreCase)(r,o)}e.isEqual=h;function m(r,o,u,d=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let I=o.length;return o.charAt(o.length-1)===d&&I--,r.charAt(I)===d}return o.charAt(o.length-1)!==d&&(o+=d),r.indexOf(o)===0}e.isEqualOrParent=m;function S(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=S;function v(r,o){return w.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(o,r)),r=(0,D.normalize)(r),w.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=v;function a(r){const o=(0,D.normalize)(r);return w.isWindows?r.length>3?!1:c(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=a;function c(r){return w.isWindows?S(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(r){return c(r)?r[0]:void 0}e.getDriveLetter=l;function s(r,o,u){return o.length>r.length?-1:r===o?0:(u&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=s;function t(r){const o=r.split(":");let u,d,f;if(o.forEach(I=>{const A=Number(I);(0,b.isNumber)(A)?d===void 0?d=A:f===void 0&&(f=A):u=u?[u,I].join(":"):I}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[45],J([0,1,13]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.keys(h).forEach(S=>{h[S]&&typeof h[S]=="object"?m[S]=R(h[S]):m[S]=h[S]}),m}e.deepClone=R;function D(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const v in S)if(b.call(S,v)){const a=S[v];typeof a=="object"&&!Object.isFrozen(a)&&m.push(a)}}return h}e.deepFreeze=D;const b=Object.prototype.hasOwnProperty;function P(h,m){return n(h,m,new Set)}e.cloneAndChange=P;function n(h,m,S){if((0,w.isUndefinedOrNull)(h))return h;const v=m(h);if(typeof v!="undefined")return v;if((0,w.isArray)(h)){const a=[];for(const c of h)a.push(n(c,m,S));return a}if((0,w.isObject)(h)){if(S.has(h))throw new Error("Cannot clone recursive data-structure");S.add(h);const a={};for(let c in h)b.call(h,c)&&(a[c]=n(h[c],m,S));return S.delete(h),a}return h}function y(h,m,S=!0){return(0,w.isObject)(h)?((0,w.isObject)(m)&&Object.keys(m).forEach(v=>{v in h?S&&((0,w.isObject)(h[v])&&(0,w.isObject)(m[v])?y(h[v],m[v],S):h[v]=m[v]):h[v]=m[v]}),h):m}e.mixin=y;function i(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let S,v;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(S=0;S<h.length;S++)if(!i(h[S],m[S]))return!1}else{const a=[];for(v in h)a.push(v);a.sort();const c=[];for(v in m)c.push(v);if(c.sort(),!i(a,c))return!1;for(S=0;S<a.length;S++)if(!i(h[a[S]],m[a[S]]))return!1}return!0}e.equals=i;function L(h){const m=new Set;return JSON.stringify(h,(S,v)=>{if((0,w.isObject)(v)||Array.isArray(v)){if(m.has(v))return"[Circular]";m.add(v)}return v})}e.safeStringify=L;function g(h,m,S){const v=m(h);return typeof v=="undefined"?S:v}e.getOrDefault=g;function E(h,m){const S=Object.create(null);return!h||!m||Object.keys(m).forEach(a=>{const c=h[a],l=m[a];i(c,l)||(S[a]=l)}),S}e.distinct=E;function p(h,m){const S=m.toLowerCase(),v=Object.keys(h).find(a=>a.toLowerCase()===S);return v?h[v]:h[m]}e.getCaseInsensitive=p}),define(Q[7],J([0,1,3,8]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,b=/^\//,P=/^\/\//;function n(o,u){if(!o.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!b.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,u){return!o&&!u?"file":o}function i(o,u){switch(o){case"https":case"http":case"file":u?u[0]!==g&&(u=g+u):u=g;break}return u}const L="",g="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(u,d,f,I,A,F=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=y(u,F),this.authority=d||L,this.path=i(this.scheme,f||L),this.query=I||L,this.fragment=A||L,n(this,F))}static isUri(u){return u instanceof p?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return c(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:f,path:I,query:A,fragment:F}=u;return d===void 0?d=this.scheme:d===null&&(d=L),f===void 0?f=this.authority:f===null&&(f=L),I===void 0?I=this.path:I===null&&(I=L),A===void 0?A=this.query:A===null&&(A=L),F===void 0?F=this.fragment:F===null&&(F=L),d===this.scheme&&f===this.authority&&I===this.path&&A===this.query&&F===this.fragment?this:new m(d,f,I,A,F)}static parse(u,d=!1){const f=E.exec(u);return f?new m(f[2]||L,r(f[4]||L),r(f[5]||L),r(f[7]||L),r(f[9]||L),d):new m(L,L,L,L,L)}static file(u){let d=L;if(w.isWindows&&(u=u.replace(/\\/g,g)),u[0]===g&&u[1]===g){const f=u.indexOf(g,2);f===-1?(d=u.substring(2),u=g):(d=u.substring(2,f),u=u.substring(f)||g)}return new m("file",d,u,L,L)}static from(u){return new m(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return w.isWindows&&u.scheme==="file"?f=p.file(R.win32.join(c(u,!0),...d)).path:f=R.posix.join(u.path,...d),u.with({path:f})}toString(u=!1){return l(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof p)return u;{const d=new m(u);return d._formatted=u.external,d._fsPath=u._sep===h?u.fsPath:null,d}}else return u}}e.URI=p;const h=w.isWindows?1:void 0;class m extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(u=!1){return u?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=h),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(o,u){let d,f=-1;for(let I=0;I<o.length;I++){const A=o.charCodeAt(I);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||u&&A===47)f!==-1&&(d+=encodeURIComponent(o.substring(f,I)),f=-1),d!==void 0&&(d+=o.charAt(I));else{d===void 0&&(d=o.substr(0,I));const F=S[A];F!==void 0?(f!==-1&&(d+=encodeURIComponent(o.substring(f,I)),f=-1),d+=F):f===-1&&(f=I)}}return f!==-1&&(d+=encodeURIComponent(o.substring(f))),d!==void 0?d:o}function a(o){let u;for(let d=0;d<o.length;d++){const f=o.charCodeAt(d);f===35||f===63?(u===void 0&&(u=o.substr(0,d)),u+=S[f]):u!==void 0&&(u+=o[d])}return u!==void 0?u:o}function c(o,u){let d;return o.authority&&o.path.length>1&&o.scheme==="file"?d=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?u?d=o.path.substr(1):d=o.path[1].toLowerCase()+o.path.substr(2):d=o.path,w.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=c;function l(o,u){const d=u?a:v;let f="",{scheme:I,authority:A,path:F,query:C,fragment:H}=o;if(I&&(f+=I,f+=":"),(A||I==="file")&&(f+=g,f+=g),A){let X=A.indexOf("@");if(X!==-1){const ne=A.substr(0,X);A=A.substr(X+1),X=ne.indexOf(":"),X===-1?f+=d(ne,!1):(f+=d(ne.substr(0,X),!1),f+=":",f+=d(ne.substr(X+1),!1)),f+="@"}A=A.toLowerCase(),X=A.indexOf(":"),X===-1?f+=d(A,!1):(f+=d(A.substr(0,X),!1),f+=A.substr(X))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const X=F.charCodeAt(1);X>=65&&X<=90&&(F=`/${String.fromCharCode(X+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const X=F.charCodeAt(0);X>=65&&X<=90&&(F=`${String.fromCharCode(X+32)}:${F.substr(2)}`)}f+=d(F,!0)}return C&&(f+="?",f+=d(C,!1)),H&&(f+="#",f+=u?H:v(H,!1)),f}function s(o){try{return decodeURIComponent(o)}catch(u){return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,u=>s(u)):o}}),define(Q[105],J([0,1,7]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(i){const L=i;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.isRemoteConsoleLog=R;function D(i){const L=[];let g;try{const E=JSON.parse(i.arguments),p=E[E.length-1];p&&p.__$stack&&(E.pop(),g=p.__$stack),L.push(...E)}catch(E){L.push("Unable to log remote console arguments",i.arguments)}return{args:L,stack:g}}e.parse=D;function b(i){if(typeof i!="string")return b(D(i).stack);const L=i;if(L){const g=P(L),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(E&&E.length===4)return{uri:w.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=b;function P(i){if(!i)return i;const L=i.indexOf(`
`);return L===-1?i:i.substring(0,L)}function n(i,L){const{args:g,stack:E}=D(i),p=typeof g[0]=="string"&&g.length===1;let h=P(E);h&&(h=`(${h.trim()})`);let m=[];if(typeof g[0]=="string"?h&&p?m=[`%c[${L}] %c${g[0]} %c${h}`,y("blue"),y(""),y("grey")]:m=[`%c[${L}] %c${g[0]}`,y("blue"),y(""),...g.slice(1)]:m=[`%c[${L}]%`,y("blue"),...g],h&&!p&&m.push(h),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,m)}e.log=n;function y(i){return`color: ${i}`}}),define(Q[36],J([0,1,7,20]),function(j,e,w,R){"use strict";var D,b;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(l,s,t){let r=l.get(s);return r===void 0&&(r=t,l.set(s,r)),r}e.getOrSet=P;function n(l){const s=[];return l.forEach((t,r)=>{s.push(`${r} => ${t}`)}),`Map(${l.size}) {${s.join(", ")}}`}e.mapToString=n;function y(l){const s=[];return l.forEach(t=>{s.push(t)}),`Set(${l.size}) {${s.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=i;class L{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class g{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var E;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(E||(E={}));class p{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,R.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(s){this._iter=s}static forUris(s=()=>!1){return new m(new p(s))}static forPaths(){return new m(new g)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new L)}clear(){this._root=void 0}set(s,t){const r=this._iter.reset(s);let o;for(this._root||(this._root=new h,this._root.segment=r.value()),o=this._root;;){const d=r.cmp(o.segment);if(d>0)o.left||(o.left=new h,o.left.segment=r.value()),o=o.left;else if(d<0)o.right||(o.right=new h,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new h,o.mid.segment=r.value()),o=o.mid;else break}const u=o.value;return o.value=t,o.key=s,u}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const r=this._iter.reset(s),o=[];let u=this._root;for(;u;){const d=r.cmp(u.segment);if(d>0)o.push([1,u]),u=u.left;else if(d<0)o.push([-1,u]),u=u.right;else if(r.hasNext())r.next(),o.push([0,u]),u=u.mid;else{for(t?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;o.length>0&&u.isEmpty();){let[f,I]=o.pop();switch(f){case 1:I.left=void 0;break;case 0:I.mid=void 0;break;case-1:I.right=void 0;break}u=I}break}}}findSubstr(s){const t=this._iter.reset(s);let r=this._root,o;for(;r;){const u=t.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(t.hasNext())t.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[t,r]of this)s(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=m;class S{constructor(s,t){this[D]="ResourceMap",s instanceof S?(this.map=new Map(s.map),this.toKey=t!=null?t:S.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:S.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[r,o]of this.map)s(o,w.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield w.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[w.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[w.URI.parse(s[0]),s[1]]}}e.ResourceMap=S,S.defaultToKey=l=>l.toString();var v;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class a{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const r=this._map.get(s);if(!!r)return t!==0&&this.touch(r,t),r.value}set(s,t,r=0){let o=this._map.get(s);if(o)o.value=t,r!==0&&this.touch(o,r);else{switch(o={key:s,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(s,o),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const r=this._state;let o=this._head;for(;o;){if(t?s.bind(t)(o.value,o.key,this):s(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const s=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:r.key,done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return o}values(){const s=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:r.value,done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return o}entries(){const s=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:[r.key,r.value],done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return o}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>s;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,r=s.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const r=s.next,o=s.previous;s===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const r=s.next,o=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,r)=>{s.push([r,t])}),s}fromJSON(s){this.clear();for(const[t,r]of s)this.set(t,r)}}e.LinkedMap=a;class c extends a{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(Q[106],J([0,1,21,20,7]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(i){return JSON.stringify(i,n)}e.stringify=b;function P(i){let L=JSON.parse(i);return L=y(L),L}e.parse=P;function n(i,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,R.regExpFlags)(L)}:L}function y(i,L=0){if(!i||L>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof w.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=y(i[g],L+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=y(i[g],L+1))}return i}e.revive=y}),define(Q[9],J([0,1,7,3]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.vscodeWebviewResource="vscode-webview-resource",n.extension="extension",n.vscodeFileResource="vscode-file"})(D=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,i,L){this._hosts[y]=i,this._ports[y]=L}setConnectionToken(y,i){this._connectionTokens[y]=i}rewrite(y){if(this._delegate)return this._delegate(y);const i=y.authority;let L=this._hosts[i];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const g=this._ports[i],E=this._connectionTokens[i];let p=`path=${encodeURIComponent(y.path)}`;return typeof E=="string"&&(p+=`&tkn=${encodeURIComponent(E)}`),w.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${L}:${g}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new b;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,i,L){const g=this.toUri(y,i);return g.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(g):R.isNative&&(L||R.isPreferringBrowserCodeLoad)&&g.scheme===D.file?g.with({scheme:D.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(y,i){const L=this.toUri(y,i);return L.scheme===D.vscodeFileResource?L.with({scheme:D.file,authority:L.authority!==this.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,i){return w.URI.isUri(y)?y:w.URI.parse(i.toUrl(y))}}e.FileAccess=new P}),define(Q[64],J([0,1,36]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new w.LRUCache(1e4);function D(i){return y(i,"NFC",R)}e.normalizeNFC=D;const b=new w.LRUCache(1e4);function P(i){return y(i,"NFD",b)}e.normalizeNFD=P;const n=/[^\u0000-\u0080]/;function y(i,L,g){if(!e.canNormalize||!i)return i;const E=g.get(i);if(E)return E;let p;return n.test(i)?p=i.normalize(L):p=i,g.set(i,p),p}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(L){return P(L).replace(i,"")}}else return function(i){return i}}()}),define(Q[15],J([0,1,29,8,7,20,9,3]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(p){return(0,D.uriToFsPath)(p,!0)}e.originalFSPath=y;class i{constructor(h){this._ignorePathCasing=h}compare(h,m,S=!1){return h===m?0:(0,b.compare)(this.getComparisonKey(h,S),this.getComparisonKey(m,S))}isEqual(h,m,S=!1){return h===m?!0:!h||!m?!1:this.getComparisonKey(h,S)===this.getComparisonKey(m,S)}getComparisonKey(h,m=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,m,S=!1){if(h.scheme===m.scheme){if(h.scheme===P.Schemas.file)return w.isEqualOrParent(y(h),y(m),this._ignorePathCasing(h))&&h.query===m.query&&(S||h.fragment===m.fragment);if((0,e.isEqualAuthority)(h.authority,m.authority))return w.isEqualOrParent(h.path,m.path,this._ignorePathCasing(h),"/")&&h.query===m.query&&(S||h.fragment===m.fragment)}return!1}joinPath(h,...m){return D.URI.joinPath(h,...m)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let m;return h.scheme===P.Schemas.file?m=D.URI.file(R.dirname(y(h))).path:(m=R.posix.dirname(h.path),h.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),m="/")),h.with({path:m})}normalizePath(h){if(!h.path.length)return h;let m;return h.scheme===P.Schemas.file?m=D.URI.file(R.normalize(y(h))).path:m=R.posix.normalize(h.path),h.with({path:m})}relativePath(h,m){if(!(h.scheme!==m.scheme||!(0,e.isEqualAuthority)(h.authority,m.authority))){if(h.scheme===P.Schemas.file){const a=R.relative(y(h),y(m));return n.isWindows?w.toSlashes(a):a}let S=h.path||"/",v=m.path||"/";if(this._ignorePathCasing(h)){let a=0;for(const c=Math.min(S.length,v.length);a<c&&!(S.charCodeAt(a)!==v.charCodeAt(a)&&S.charAt(a).toLowerCase()!==v.charAt(a).toLowerCase());a++);S=v.substr(0,a)+S.substr(a)}return R.posix.relative(S,v)}}resolvePath(h,m){if(h.scheme===P.Schemas.file){const S=D.URI.file(R.resolve(y(h),m));return h.with({authority:S.authority,path:S.path})}return m.indexOf("/")===-1&&(m=w.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),h.with({path:R.posix.resolve(h.path,m)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,m){return h===m||(0,b.equalsIgnoreCase)(h,m)}hasTrailingPathSeparator(h,m=R.sep){if(h.scheme===P.Schemas.file){const S=y(h);return S.length>w.getRoot(S).length&&S[S.length-1]===m}else{const S=h.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,m=R.sep){return(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,m=R.sep){let S=!1;if(h.scheme===P.Schemas.file){const v=y(h);S=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===m}else{m="/";const v=h.path;S=v.length===1&&v.charCodeAt(v.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(h,m)?h.with({path:h.path+"/"}):h}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(p=>p.scheme===P.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new i(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(p,h){const m=[];for(let S=0;S<p.length;S++){const v=h(p[S]);p.some((a,c)=>c===S?!1:(0,e.isEqualOrParent)(v,h(a)))||m.push(p[S])}return m}e.distinctParents=L;var g;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(m){const S=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[l,s]=c.split(":");l&&s&&S.set(l,s)});const a=m.path.substring(0,m.path.indexOf(";"));return a&&S.set(p.META_DATA_MIME,a),S}p.parseMetaData=h})(g=e.DataUri||(e.DataUri={}));function E(p,h,m){if(h){let S=p.path;return S&&S[0]!==R.posix.sep&&(S=R.posix.sep+S),p.with({scheme:m,authority:h,path:S})}return p.with({scheme:m})}e.toLocalResource=E}),define(Q[10],J([0,1,25,19,4,2,76,15]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(T){return!!T&&typeof T.then=="function"}e.isThenable=y;function i(T){const k=new w.CancellationTokenSource,M=T(k.token),O=new Promise((_,W)=>{k.token.onCancellationRequested(()=>{W((0,R.canceled)())}),Promise.resolve(M).then(z=>{k.dispose(),_(z)},z=>{k.dispose(),W(z)})});return new class{cancel(){k.cancel()}then(_,W){return O.then(_,W)}catch(_){return this.then(void 0,_)}finally(_){return O.finally(_)}}}e.createCancelablePromise=i;function L(T,k,M){return Promise.race([T,new Promise(O=>k.onCancellationRequested(()=>O(M)))])}e.raceCancellation=L;async function g(T){let k=-1;const M=T.map((_,W)=>_.then(z=>(k=W,z))),O=await Promise.race(M);return T.forEach((_,W)=>{W!==k&&_.cancel()}),O}e.raceCancellablePromises=g;function E(T,k,M){let O;const _=setTimeout(()=>{O==null||O(void 0),M==null||M()},k);return Promise.race([T.finally(()=>clearTimeout(_)),new Promise(W=>O=W)])}e.raceTimeout=E;function p(T){return new Promise((k,M)=>{const O=T();y(O)?O.then(k,M):k(O)})}e.asPromise=p;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(M,M).then(O)})}return new Promise((M,O)=>{this.queuedPromise.then(M,O)})}return this.activePromise=k(),new Promise((M,O)=>{this.activePromise.then(_=>{this.activePromise=null,M(_)},_=>{this.activePromise=null,O(_)})})}}e.Throttler=h;class m{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}e.Sequencer=m;class S{constructor(){this.promiseMap=new Map}queue(k,M){var O;const W=((O=this.promiseMap.get(k))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(k)===W&&this.promiseMap.delete(k)});return this.promiseMap.set(k,W),W}}e.SequencerByKey=S;class v{constructor(k){this.defaultDelay=k,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,M=this.defaultDelay){return this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,_)=>{this.doResolve=O,this.doReject=_}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=v;class a{constructor(k){this.delayer=new v(k),this.throttler=new h}trigger(k,M){return this.delayer.trigger(()=>this.throttler.queue(k),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class c{constructor(){this._isOpen=!1,this._promise=new Promise((k,M)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class l extends c{constructor(k){super();this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(T,k){return k?new Promise((M,O)=>{const _=setTimeout(M,T);k.onCancellationRequested(()=>{clearTimeout(_),O((0,R.canceled)())})}):i(M=>s(T,M))}e.timeout=s;function t(T,k=0){const M=setTimeout(T,k);return(0,b.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function r(T){return T.then(void 0,k=>{})}e.ignoreErrors=r;function o(T){const k=[];let M=0;const O=T.length;function _(){return M<O?T[M++]():null}function W(z){z!=null&&k.push(z);const K=_();return K?K.then(W):Promise.resolve(k)}return Promise.resolve(null).then(W)}e.sequence=o;function u(T,k=O=>!!O,M=null){let O=0;const _=T.length,W=()=>{if(O>=_)return Promise.resolve(M);const z=T[O++];return Promise.resolve(z()).then(Y=>k(Y)?Promise.resolve(Y):W())};return W()}e.first=u;function d(T,k=O=>!!O,M=null){if(T.length===0)return Promise.resolve(M);let O=T.length;const _=()=>{var W,z;O=-1;for(const K of T)(z=(W=K).cancel)===null||z===void 0||z.call(W)};return new Promise((W,z)=>{for(const K of T)K.then(Y=>{--O>=0&&k(Y)?(_(),W(Y)):O===0&&W(M)}).catch(Y=>{--O>=0&&(_(),z(Y))})})}e.firstParallel=d;class f{constructor(k){this._size=0,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(k){return this._size++,new Promise((M,O)=>{this.outstandingPromises.push({factory:k,c:M,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const M=k.factory();M.then(k.c,k.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class I extends f{constructor(){super(1)}}e.Queue=I;class A{constructor(){this.queues=new Map}queueFor(k,M=n.extUri){const O=M.getComparisonKey(k);let _=this.queues.get(O);return _||(_=new I,D.Event.once(_.onFinished)(()=>{_==null||_.dispose(),this.queues.delete(O)}),this.queues.set(O,_)),_}dispose(){this.queues.forEach(k=>k.dispose()),this.queues.clear()}}e.ResourceQueue=A;class F{constructor(k,M){this._token=-1,typeof k=="function"&&typeof M=="number"&&this.setIfNotSet(k,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},M)}setIfNotSet(k,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},M))}}e.TimeoutTimer=F;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(k,M){this.cancel(),this._token=setInterval(()=>{k()},M)}}e.IntervalTimer=C;class H{constructor(k,M){this.timeoutToken=-1,this.runner=k,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class X extends H{constructor(k,M){super(k,M);this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner&&this.runner(k)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const T=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=k=>{const M=setTimeout(()=>k(T));let O=!1;return{dispose(){O||(O=!0,clearTimeout(M))}}}}else e.runWhenIdle=(T,k)=>{const M=requestIdleCallback(T,typeof k=="number"?{timeout:k}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(M))}}}}();class ne{constructor(k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ne;async function oe(T,k,M){let O;for(let _=0;_<M;_++)try{return await T()}catch(W){O=W,await s(k)}throw O}e.retry=oe;class V{hasPending(k){return this._pending?typeof k=="number"?this._pending.taskId===k:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var k;(k=this._pending)===null||k===void 0||k.cancel()}setPending(k,M,O){return this._pending={taskId:k,cancel:()=>O==null?void 0:O(),promise:M},M.then(()=>this.donePending(k),()=>this.donePending(k)),M}donePending(k){this._pending&&k===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const k=this._next;this._next=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}setNext(k){if(this._next)this._next.run=k;else{let M,O;const _=new Promise((W,z)=>{M=W,O=z});this._next={run:k,promise:_,promiseResolve:M,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=V;class N{constructor(k){this.interval=k,this.lastIncrementTime=0,this.value=0}increment(){const k=Date.now();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((k,M)=>{this.completeCallback=k,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(k){return new Promise(M=>{this.completeCallback(k),this.resolved=!0,M()})}error(k){return new Promise(M=>{this.errorCallback(k),this.rejected=!0,M()})}cancel(){new Promise(k=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,k()})}}e.DeferredPromise=B;class U extends D.Emitter{async fireAsync(k,M,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,k]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[_,W]=this._asyncDeliveryQueue.shift(),z=[],K=Object.assign(Object.assign({},W),{waitUntil:Y=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");O&&(Y=O(Y,typeof _=="function"?_:_[0])),z.push(Y)}});try{typeof _=="function"?_.call(void 0,K):_[0].call(_[1],K)}catch(Y){(0,R.onUnexpectedError)(Y);continue}Object.freeze(z),await $.settled(z).catch(Y=>(0,R.onUnexpectedError)(Y))}}}}e.AsyncEmitter=U;var $;(function(T){async function k(W){return typeof Promise.allSettled=="function"?M(W):O(W)}T.allSettled=k;async function M(W){return Promise.allSettled(W)}async function O(W){return Promise.all(W.map(z=>z.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function _(W){let z;const K=await Promise.all(W.map(Y=>Y.then(Z=>Z,Z=>{z||(z=Z)})));if(typeof z!="undefined")throw z;return K}T.settled=_})($=e.Promises||(e.Promises={}))}),define(Q[79],J([0,1,20,29,8,36,10]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const y="**",i="/",L="[/\\\\]",g="[^/\\\\]",E=/\//g;function p(M){switch(M){case 0:return"";case 1:return`${g}*?`;default:return`(?:${L}|${g}+${L}|${L}${g}+)*?`}}function h(M,O){if(!M)return[];const _=[];let W=!1,z=!1,K="";for(const Y of M){switch(Y){case O:if(!W&&!z){_.push(K),K="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":z=!0;break;case"]":z=!1;break}K+=Y}return K&&_.push(K),_}e.splitGlobAware=h;function m(M){if(!M)return"";let O="";const _=h(M,i);if(_.every(W=>W===y))O=".*";else{let W=!1;_.forEach((z,K)=>{if(z===y){W||(O+=p(2),W=!0);return}let Y=!1,Z="",G=!1,ee="";for(const re of z){if(re!=="}"&&Y){Z+=re;continue}if(G&&(re!=="]"||!ee)){let ie;re==="-"?ie=re:(re==="^"||re==="!")&&!ee?ie="^":re===i?ie="":ie=w.escapeRegExpCharacters(re),ee+=ie;continue}switch(re){case"{":Y=!0;continue;case"[":G=!0;continue;case"}":O+=`(?:${h(Z,",").map(ve=>m(ve)).join("|")})`,Y=!1,Z="";break;case"]":O+="["+ee+"]",G=!1,ee="";break;case"?":O+=g;continue;case"*":O+=p(1);continue;default:O+=w.escapeRegExpCharacters(re)}}K<_.length-1&&(_[K+1]!==y||K+2<_.length)&&(O+=L),W=!1})}return O}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),r=function(){return!1},o=function(){return null};function u(M,O){if(!M)return o;let _;typeof M!="string"?_=M.pattern:_=M,_=_.trim();const W=`${_}_${!!O.trimForExclusions}`;let z=t.get(W);if(z)return d(z,M);let K;if(S.test(_)){const Y=_.substr(4);z=function(Z,G){return typeof Z=="string"&&Z.endsWith(Y)?_:null}}else(K=v.exec(f(_,O)))?z=I(K[1],_):(O.trimForExclusions?c:a).test(_)?z=A(_,O):(K=l.exec(f(_,O)))?z=F(K[1].substr(1),_,!0):(K=s.exec(f(_,O)))?z=F(K[1],_,!1):z=C(_);return t.set(W,z),d(z,M)}function d(M,O){return typeof O=="string"?M:function(_,W){return R.isEqualOrParent(_,O.base)?M(D.relative(O.base,_),W):null}}function f(M,O){return O.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function I(M,O){const _=`/${M}`,W=`\\${M}`,z=function(Y,Z){return typeof Y!="string"?null:Z?Z===M?O:null:Y===M||Y.endsWith(_)||Y.endsWith(W)?O:null},K=[M];return z.basenames=K,z.patterns=[O],z.allBasenames=K,z}function A(M,O){const _=k(M.slice(1,-1).split(",").map(Z=>u(Z,O)).filter(Z=>Z!==o),M),W=_.length;if(!W)return o;if(W===1)return _[0];const z=function(Z,G){for(let ee=0,re=_.length;ee<re;ee++)if(_[ee](Z,G))return M;return null},K=_.find(Z=>!!Z.allBasenames);K&&(z.allBasenames=K.allBasenames);const Y=_.reduce((Z,G)=>G.allPaths?Z.concat(G.allPaths):Z,[]);return Y.length&&(z.allPaths=Y),z}function F(M,O,_){const W=D.sep===D.posix.sep,z=W?M:M.replace(E,D.sep),K=D.sep+z,Y=D.posix.sep+M,Z=_?function(G,ee){return typeof G=="string"&&(G===z||G.endsWith(K)||!W&&(G===M||G.endsWith(Y)))?O:null}:function(G,ee){return typeof G=="string"&&(G===z||!W&&G===M)?O:null};return Z.allPaths=[(_?"*/":"./")+M],Z}function C(M){try{const O=new RegExp(`^${m(M)}$`);return function(_){return O.lastIndex=0,typeof _=="string"&&O.test(_)?M:null}}catch(O){return o}}function H(M,O,_){return!M||typeof O!="string"?!1:X(M)(O,void 0,_)}e.match=H;function X(M,O={}){if(!M)return r;if(typeof M=="string"||N(M)){const _=u(M,O);if(_===o)return r;const W=function(z,K){return!!_(z,K)};return _.allBasenames&&(W.allBasenames=_.allBasenames),_.allPaths&&(W.allPaths=_.allPaths),W}return $(M,O)}e.parse=X;function ne(M){if(!!M){let O;return _=>(O||(O=(M()||Promise.resolve([])).then(W=>W?V(W):{})),O.then(W=>!!W[_]))}}e.hasSiblingPromiseFn=ne;function oe(M){if(!!M){let O;return _=>{if(!O){const W=M();O=W?V(W):{}}return!!O[_]}}}e.hasSiblingFn=oe;function V(M){const O={};for(const _ of M)O[_]=!0;return O}function N(M){const O=M;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=N;function B(M){return M.allBasenames||[]}e.getBasenameTerms=B;function U(M){return M.allPaths||[]}e.getPathTerms=U;function $(M,O){const _=k(Object.getOwnPropertyNames(M).map(Z=>T(Z,M[Z],O)).filter(Z=>Z!==o)),W=_.length;if(!W)return o;if(!_.some(Z=>!!Z.requiresSiblings)){if(W===1)return _[0];const Z=function(re,ie){for(let ue=0,ve=_.length;ue<ve;ue++){const de=_[ue](re,ie);if(de)return de}return null},G=_.find(re=>!!re.allBasenames);G&&(Z.allBasenames=G.allBasenames);const ee=_.reduce((re,ie)=>ie.allPaths?re.concat(ie.allPaths):re,[]);return ee.length&&(Z.allPaths=ee),Z}const z=function(Z,G,ee){let re;for(let ie=0,ue=_.length;ie<ue;ie++){const ve=_[ie];ve.requiresSiblings&&ee&&(G||(G=D.basename(Z)),re||(re=G.substr(0,G.length-D.extname(Z).length)));const de=ve(Z,G,re,ee);if(de)return de}return null},K=_.find(Z=>!!Z.allBasenames);K&&(z.allBasenames=K.allBasenames);const Y=_.reduce((Z,G)=>G.allPaths?Z.concat(G.allPaths):Z,[]);return Y.length&&(z.allPaths=Y),z}function T(M,O,_){if(O===!1)return o;const W=u(M,_);if(W===o)return o;if(typeof O=="boolean")return W;if(O){const z=O.when;if(typeof z=="string"){const K=(Y,Z,G,ee)=>{if(!ee||!W(Y,Z))return null;const re=z.replace("$(basename)",G),ie=ee(re);return(0,P.isThenable)(ie)?ie.then(ue=>ue?M:null):ie?M:null};return K.requiresSiblings=!0,K}}return W}function k(M,O){const _=M.filter(Z=>!!Z.basenames);if(_.length<2)return M;const W=_.reduce((Z,G)=>{const ee=G.basenames;return ee?Z.concat(ee):Z},[]);let z;if(O){z=[];for(let Z=0,G=W.length;Z<G;Z++)z.push(O)}else z=_.reduce((Z,G)=>{const ee=G.patterns;return ee?Z.concat(ee):Z},[]);const K=function(Z,G){if(typeof Z!="string")return null;if(!G){let re;for(re=Z.length;re>0;re--){const ie=Z.charCodeAt(re-1);if(ie===47||ie===92)break}G=Z.substr(re)}const ee=W.indexOf(G);return ee!==-1?z[ee]:null};K.basenames=W,K.patterns=z,K.allBasenames=W;const Y=M.filter(Z=>!Z.basenames);return Y.push(K),Y}}),define(Q[39],J([0,1,7,8,20,9,3,15,29]),function(j,e,w,R,D,b,P,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(u,d,f){if(typeof u=="string"&&(u=w.URI.file(u)),f){const A=f.getWorkspaceFolder(u);if(A){const F=f.getWorkspace().folders.length>1;let C;if((0,n.isEqual)(A.uri,u)?C="":C=(0,n.relativePath)(A.uri,u),F){const H=A.name?A.name:(0,n.basename)(A.uri);C=C?H+" \u2022 "+C:H}return C}}if(u.scheme!==b.Schemas.file&&u.scheme!==b.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(u.fsPath))return(0,R.normalize)(g(u.fsPath));let I=(0,R.normalize)(u.fsPath);return!P.isWindows&&(d==null?void 0:d.userHome)&&(I=p(I,d.userHome.fsPath)),I}e.getPathLabel=i;function L(u){if(!!u){typeof u=="string"&&(u=w.URI.file(u));const d=(0,n.basename)(u)||(u.scheme===b.Schemas.file?u.fsPath:u.path);return P.isWindows&&(0,y.isRootOrDriveLetter)(d)?g(d):d}}e.getBaseLabel=L;function g(u){return(0,y.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=g;let E=Object.create(null);function p(u,d){if(P.isWindows||!u||!d)return u;let f=E.original===d?E.normalized:void 0;return f||(f=`${(0,D.rtrim)(d,R.posix.sep)}${R.posix.sep}`,E={original:d,normalized:f}),(P.isLinux?u.startsWith(f):(0,D.startsWithIgnoreCase)(u,f))&&(u=`~/${u.substr(f.length)}`),u}e.tildify=p;function h(u,d){return u.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=h;const m="\u2026",S="\\\\",v="~";function a(u,d=R.sep){const f=new Array(u.length);let I=!1;for(let A=0;A<u.length;A++){let F=u[A];if(F===""){f[A]=`.${d}`;continue}if(!F){f[A]=F;continue}I=!0;let C="";F.indexOf(S)===0?(C=F.substr(0,F.indexOf(S)+S.length),F=F.substr(F.indexOf(S)+S.length)):F.indexOf(d)===0?(C=F.substr(0,F.indexOf(d)+d.length),F=F.substr(F.indexOf(d)+d.length)):F.indexOf(v)===0&&(C=F.substr(0,F.indexOf(v)+v.length),F=F.substr(F.indexOf(v)+v.length));const H=F.split(d);for(let X=1;I&&X<=H.length;X++)for(let ne=H.length-X;I&&ne>=0;ne--){I=!1;let oe=H.slice(ne,ne+X).join(d);for(let V=0;!I&&V<u.length;V++)if(V!==A&&u[V]&&u[V].indexOf(oe)>-1){const N=ne+X===H.length,B=ne>0&&u[V].indexOf(d)>-1?d+oe:oe,U=u[V].endsWith(B);I=!N||U}if(!I){let V="";(H[0].endsWith(":")||C!=="")&&(ne===1&&(ne=0,X++,oe=H[0]+d+oe),ne>0&&(V=H[0]+d),V=C+V),ne>0&&(V=V+m+d),V=V+oe,ne+X<H.length&&(V=V+d+m),f[A]=V}}I&&(f[A]=F)}return f}e.shorten=a;var c;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function l(u,d=Object.create(null)){const f=[];let I=!1,A="";for(const F of u)if(F==="$"||I&&F==="{")A&&f.push({value:A,type:c.TEXT}),A="",I=!0;else if(F==="}"&&I){const C=d[A];if(typeof C=="string")C.length&&f.push({value:C,type:c.VARIABLE});else if(C){const H=f[f.length-1];(!H||H.type!==c.SEPARATOR)&&f.push({value:C.label,type:c.SEPARATOR})}A="",I=!1}else A+=F;return A&&!I&&f.push({value:A,type:c.TEXT}),f.filter((F,C)=>{if(F.type===c.SEPARATOR){const H=f[C-1],X=f[C+1];return[H,X].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(F=>F.value).join("")}e.template=l;function s(u,d){return P.isMacintosh||d?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):u.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(u,d){return P.isMacintosh||d?u.replace(/\(&&\w\)|&&/g,""):P.isWindows?u.replace(/&&|&/g,f=>f==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(u){const d=u.indexOf("/")!==-1?R.posix:R.win32,f=d.basename(u),I=d.dirname(u);return f.length?{name:f,parentPath:I}:{name:I,parentPath:""}}e.splitName=o}),define(Q[107],J([0,1,8,20,79,9,15]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let n=[],y=[],i=[];function L(l,s=!1){const t=g(l);n.push(t),t.userConfigured?i.push(t):y.push(t),s&&!t.userConfigured&&n.forEach(r=>{r.mime===t.mime||r.userConfigured||(t.extension&&r.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&r.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&r.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&r.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=L;function g(l){return{id:l.id,mime:l.mime,filename:l.filename,extension:l.extension,filepattern:l.filepattern,firstline:l.firstline,userConfigured:l.userConfigured,filenameLowercase:l.filename?l.filename.toLowerCase():void 0,extensionLowercase:l.extension?l.extension.toLowerCase():void 0,filepatternLowercase:l.filepattern?l.filepattern.toLowerCase():void 0,filepatternOnPath:l.filepattern?l.filepattern.indexOf(w.posix.sep)>=0:!1}}function E(l){l?(n=n.filter(s=>!s.userConfigured),i=[]):(n=[],y=[],i=[])}e.clearTextMimes=E;function p(l,s){let t;if(l)switch(l.scheme){case b.Schemas.file:t=l.fsPath;break;case b.Schemas.data:t=P.DataUri.parseMetaData(l).get(P.DataUri.META_DATA_LABEL);break;default:t=l.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const r=(0,w.basename)(t),o=h(t,r,i);if(o)return[o,e.MIME_TEXT];const u=h(t,r,y);if(u)return[u,e.MIME_TEXT];if(s){const d=m(s);if(d)return[d,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=p;function h(l,s,t){let r=null,o=null,u=null;for(let d=t.length-1;d>=0;d--){const f=t[d];if(s===f.filenameLowercase){r=f;break}if(f.filepattern&&(!o||f.filepattern.length>o.filepattern.length)){const I=f.filepatternOnPath?l:s;(0,D.match)(f.filepatternLowercase,I)&&(o=f)}f.extension&&(!u||f.extension.length>u.extension.length)&&s.endsWith(f.extensionLowercase)&&(u=f)}return r?r.mime:o?o.mime:u?u.mime:null}function m(l){if((0,R.startsWithUTF8BOM)(l)&&(l=l.substr(1)),l.length>0)for(let s=n.length-1;s>=0;s--){const t=n[s];if(!!t.firstline){const r=l.match(t.firstline);if(r&&r.length>0)return t.mime}}return null}function S(l){return l?typeof l=="string"?l===e.MIME_BINARY||l===e.MIME_TEXT||l===e.MIME_UNKNOWN:l.length===1&&S(l[0]):!0}e.isUnspecific=S;const v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(l){const s=(0,w.extname)(l);return v[s.toLowerCase()]}e.getMediaMime=a;function c(l){for(const s in v)if(v[s]===l)return s}e.getExtensionForMimeType=c}),define(Q[30],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return w.test(y)}e.isUUID=R;const D=new Uint8Array(16),b=[];for(let y=0;y<256;y++)b.push(y.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(y){for(let i=0;i<y.length;i++)y[i]=Math.floor(Math.random()*256);return y};function n(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,i="";return i+=b[D[y++]],i+=b[D[y++]],i+=b[D[y++]],i+=b[D[y++]],i+="-",i+=b[D[y++]],i+=b[D[y++]],i+="-",i+=b[D[y++]],i+=b[D[y++]],i+="-",i+=b[D[y++]],i+=b[D[y++]],i+="-",i+=b[D[y++]],i+=b[D[y++]],i+=b[D[y++]],i+=b[D[y++]],i+=b[D[y++]],i+=b[D[y++]],i}e.generateUuid=n}),define(Q[108],J([0,1,22,58,43]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(P,n){if(await new Promise((L,g)=>{const E=w.createReadStream(P),p=R.createHash("sha1");E.pipe(p);const h=(0,D.once)((m,S)=>{E.removeAllListeners(),p.removeAllListeners(),m?g(m):L(S)});E.once("error",h),E.once("end",h),p.once("error",h),p.once("data",m=>h(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=b}),define(Q[80],J([0,1,234]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(b="utf8"){this.stringDecoder=new w.StringDecoder(b),this.remaining=null}write(b){const P=[],n=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(n.length<1)return P;let y=0,i,L=y;for(;L<n.length;)if(i=n.charCodeAt(L),i===13||i===10){if(P.push(n.substring(y,L)),L++,L<n.length){const g=i;i=n.charCodeAt(L),(g===13&&i===10||g===10&&i===13)&&L++}y=L}else L++;return this.remaining=y<n.length?n.substr(y):null,P}end(){return this.remaining}}e.LineDecoder=R}),define(Q[109],J([0,1,27]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const y=n.replace(/\-/g,":").toLowerCase();return!R.has(y)}function b(){return new Promise(async(n,y)=>{const i=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await P())}catch(L){y(L)}finally{clearTimeout(i)}})}e.getMac=b;function P(){return new Promise((n,y)=>{try{const i=(0,w.networkInterfaces)();for(const[,L]of Object.entries(i))for(const g of L)if(D(g.mac))return n(g.mac);y("Unable to retrieve mac address (unexpected format)")}catch(i){y(i)}})}}),define(Q[65],J([0,1,19,30,27,36,109]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(L){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(L)}value(){if(this._value===void 0){let L=0,g=0;const E=(0,D.networkInterfaces)();for(let p in E)if(Object.prototype.hasOwnProperty.call(E,p))for(const{mac:h,internal:m}of E[p])m||(g+=1,this._isVirtualMachineMacAdress(h.toUpperCase())&&(L+=1));this._value=g>0?L/g:0}return this._value}};let n;async function y(){return n||(n=(async()=>await i()||R.generateUuid())()),n}e.getMachineId=y;async function i(){try{const L=await new Promise((E,p)=>{j(["crypto"],E,p)}),g=await(0,P.getMac)();return L.createHash("sha256").update(g,"utf8").digest("hex")}catch(L){w.onUnexpectedError(L);return}}}),define(Q[23],J([0,1,22,27,8,10,3,29,30,64,15,7]),function(j,e,w,R,D,b,P,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function p(B,U=E.UNLINK){if((0,n.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return U===E.UNLINK?m(B):h(B)}e.rimraf=p;async function h(B){try{const U=(0,D.join)((0,R.tmpdir)(),(0,y.generateUuid)());try{await w.promises.rename(B,U)}catch($){return m(B)}m(U).catch($=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function m(B){return w.promises.rmdir(B,{recursive:!0,maxRetries:3})}function S(B){if((0,n.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(B,{recursive:!0})}e.rimrafSync=S;async function v(B,U){return l(await(U?a(B):w.promises.readdir(B)))}e.readdir=v;async function a(B){try{return await w.promises.readdir(B,{withFileTypes:!0})}catch(T){console.warn("[node.js fs] readdir with filetypes failed with error: ",T)}const U=[],$=await v(B);for(const T of $){let k=!1,M=!1,O=!1;try{const _=await w.promises.lstat((0,D.join)(B,T));k=_.isFile(),M=_.isDirectory(),O=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}U.push({name:T,isFile:()=>k,isDirectory:()=>M,isSymbolicLink:()=>O})}return U}function c(B){return l(w.readdirSync(B))}e.readdirSync=c;function l(B){return B.map(U=>typeof U=="string"?P.isMacintosh?(0,i.normalizeNFC)(U):U:(U.name=P.isMacintosh?(0,i.normalizeNFC)(U.name):U.name,U))}async function s(B){const U=await v(B),$=[];for(const T of U)await r.existsDirectory((0,D.join)(B,T))&&$.push(T);return $}e.readDirsInDir=s;function t(B,U=1e3){return new Promise($=>{let T=!1;const k=setInterval(()=>{T||(T=!0,w.access(B,M=>{T=!1,M&&(clearInterval(k),$(void 0))}))},U)})}e.whenDeleted=t;var r;(function(B){async function U(k){let M;try{if(M=await w.promises.lstat(k),!M.isSymbolicLink())return{stat:M}}catch(O){}try{return{stat:await w.promises.stat(k),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(P.isWindows&&O.code==="EACCES")try{return{stat:await w.promises.stat(await w.promises.readlink(k)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw _}throw O}}B.stat=U;async function $(k){try{const{stat:M,symbolicLink:O}=await B.stat(k);return M.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(M){}return!1}B.existsFile=$;async function T(k){try{const{stat:M,symbolicLink:O}=await B.stat(k);return M.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(M){}return!1}B.existsDirectory=T})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new b.ResourceQueue;function u(B,U,$){return o.queueFor(g.URI.file(B),L.extUriBiasedIgnorePathCase).queue(()=>{const T=A($);return new Promise((k,M)=>f(B,U,T,O=>O?M(O):k()))})}e.writeFile=u;let d=!0;function f(B,U,$,T){if(!d)return w.writeFile(B,U,{mode:$.mode,flag:$.flag},T);w.open(B,$.flag,$.mode,(k,M)=>{if(k)return T(k);w.writeFile(M,U,O=>{if(O)return w.close(M,()=>T(O));w.fdatasync(M,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),d=!1),w.close(M,W=>T(W))))})})}function I(B,U,$){const T=A($);if(!d)return w.writeFileSync(B,U,{mode:T.mode,flag:T.flag});const k=w.openSync(B,T.flag,T.mode);try{w.writeFileSync(k,U);try{w.fdatasyncSync(k)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),d=!1}}finally{w.closeSync(k)}}e.writeFileSync=I;function A(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function F(B,U){if(B!==U){async function $(T){try{const k=await w.promises.lstat(T);if(k.isDirectory()||k.isSymbolicLink())return;const M=await w.promises.open(T,"a");try{await M.utimes(k.atime,new Date)}finally{await M.close()}}catch(k){}}try{await w.promises.rename(B,U),await $(U)}catch(T){if(B.toLowerCase()!==U.toLowerCase()&&T.code==="EXDEV"||B.endsWith("."))await C(B,U,{preserveSymlinks:!1}),await p(B,E.MOVE),await $(U);else throw T}}}e.move=F;async function C(B,U,$){return X(B,U,{root:{source:B,target:U},options:$,handledSourcePaths:new Set})}e.copy=C;const H=511;async function X(B,U,$){if(!$.handledSourcePaths.has(B)){$.handledSourcePaths.add(B);const{stat:T,symbolicLink:k}=await r.stat(B);if(k){if($.options.preserveSymlinks)try{return await V(B,U,$)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(k.dangling)return}return T.isDirectory()?ne(B,U,T.mode&H,$):oe(B,U,T.mode&H)}}async function ne(B,U,$,T){await w.promises.mkdir(U,{recursive:!0,mode:$});const k=await v(B);for(const M of k)await X((0,D.join)(B,M),(0,D.join)(U,M),T)}async function oe(B,U,$){await w.promises.copyFile(B,U),await w.promises.chmod(U,$)}async function V(B,U,$){let T=await w.promises.readlink(B);(0,n.isEqualOrParent)(T,$.root.source,!P.isLinux)&&(T=(0,D.join)($.root.target,T.substr($.root.source.length+1))),await w.promises.symlink(T,U)}async function N(B){try{return await w.promises.access(B),!0}catch(U){return!1}}e.exists=N}),define(Q[110],J([0,1,22,111,20,8,23]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(g){const E=(0,b.dirname)(g);if(g===E)return g;const p=((0,b.basename)(g)||g).toLowerCase();try{const m=(0,P.readdirSync)(E).filter(S=>S.toLowerCase()===p);if(m.length===1){const S=n(E);if(S)return(0,b.join)(S,m[0])}else if(m.length>1){const S=m.indexOf(p);if(S>=0){const v=n(E);if(v)return(0,b.join)(v,m[S])}}}catch(h){}return null}e.realcaseSync=n;async function y(g){try{return await(0,R.promisify)(w.realpath)(g)}catch(E){const p=L(g);return await w.promises.access(p,w.constants.R_OK),p}}e.realpath=y;function i(g){try{return w.realpathSync(g)}catch(E){const p=L(g);return w.accessSync(p,w.constants.R_OK),p}}e.realpathSync=i;function L(g){return(0,D.rtrim)((0,b.normalize)(g),b.sep)}}),define(Q[112],J([0,1,59]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function R(){const y=1025;return y+Math.floor((65535-y)*Math.random())}e.randomPort=R;function D(y,i,L){let g=!1;return new Promise(E=>{const p=setTimeout(()=>{if(!g)return g=!0,E(0)},L);b(y,i,h=>{if(!g)return g=!0,clearTimeout(p),E(h)})})}e.findFreePort=D;function b(y,i,L){if(i===0)return L(0);const g=new w.Socket;g.once("connect",()=>(n(g),b(y+1,i-1,L))),g.once("data",()=>{}),g.once("error",E=>(n(g),E.code!=="ECONNREFUSED"?b(y+1,i-1,L):L(y))),g.connect(y,"127.0.0.1")}function P(y,i,L){let g=!1,E,p=1;const h=w.createServer({pauseOnConnect:!0});function m(S,v){g||(g=!0,h.removeAllListeners(),h.close(),E&&clearTimeout(E),v(S))}return new Promise(S=>{E=setTimeout(()=>{m(0,S)},L),h.on("listening",()=>{m(y,S)}),h.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&p<i?(y++,p++,h.listen(y,"127.0.0.1")):m(0,S)}),h.on("close",()=>{m(0,S)}),h.listen(y,"127.0.0.1")})}e.findFreePortFaster=P;function n(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(i){console.error(i)}}});var Ae=this&&this.__await||function(j){return this instanceof Ae?(this.v=j,this):new Ae(j)},gt=this&&this.__asyncGenerator||function(j,e,w){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=w.apply(j,e||[]),D,b=[];return D={},P("next"),P("throw"),P("return"),D[Symbol.asyncIterator]=function(){return this},D;function P(E){R[E]&&(D[E]=function(p){return new Promise(function(h,m){b.push([E,p,h,m])>1||n(E,p)})})}function n(E,p){try{y(R[E](p))}catch(h){g(b[0][3],h)}}function y(E){E.value instanceof Ae?Promise.resolve(E.value.v).then(i,L):g(b[0][2],E)}function i(E){n("next",E)}function L(E){n("throw",E)}function g(E,p){E(p),b.shift(),b.length&&n(b[0][0],b[0][1])}},mt=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],w;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),w={},R("next"),R("throw"),R("return"),w[Symbol.asyncIterator]=function(){return this},w);function R(b){w[b]=j[b]&&function(P){return new Promise(function(n,y){P=j[b](P),D(n,y,P.done,P.value)})}}function D(b,P,n,y){Promise.resolve(y).then(function(i){b({value:i,done:n})},P)}};define(Q[113],J([0,1,23,27,8]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,P=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var y;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(y||(y={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=1:L=0;class g{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:l=!1}={}){return l?i===0?process.env["ProgramFiles(x86)"]||null:L===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:l=!1,findPreview:s=!1}={}){const t=E({useAlternateBitness:l});if(!t)return null;const r=D.join(t,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(r))return null;let o=-1,u=null;for(const I of await w.readdir(r)){let A=-1;if(s){const C=I.indexOf("-");if(C<0)continue;const H=I.substring(0,C);if(!b.test(H)||I.substring(C+1)!=="preview")continue;A=parseInt(H,10)}else{if(!b.test(I))continue;A=parseInt(I,10)}if(!(A<=o)){const F=D.join(r,I,"pwsh.exe");!await w.SymlinkSupport.existsFile(F)||(u=F,o=A)}}if(!u)return null;const d=t.includes("x86")?" (x86)":"",f=s?" Preview":"";return new g(u,`PowerShell${f}${d}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=l?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const o of await w.readdir(s))if(t.test(o)){const u=D.join(s,o,"pwsh.exe");return new g(u,r)}return null}function m(){const l=D.join(R.homedir(),".dotnet","tools","pwsh.exe");return new g(l,".NET Core PowerShell Global Tool")}function S(){const l=D.join(process.env.windir,i===1&&L!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(l,"Windows PowerShell",!0)}function v(){return gt(this,arguments,function*(){let s=yield Ae(p());s&&(yield yield Ae(s)),s=yield Ae(p({useAlternateBitness:!0})),s&&(yield yield Ae(s)),s=yield Ae(h()),s&&(yield yield Ae(s)),s=m(),s&&(yield yield Ae(s)),s=yield Ae(p({findPreview:!0})),s&&(yield yield Ae(s)),s=yield Ae(h({findPreview:!0})),s&&(yield yield Ae(s)),s=yield Ae(p({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Ae(s)),s=S(),s&&(yield yield Ae(s))})}function a(){return gt(this,arguments,function*(){var s,t;try{for(var r=mt(v()),o;o=yield Ae(r.next()),!o.done;){const u=o.value;(yield Ae(u.exists()))&&(yield yield Ae(u))}}catch(u){s={error:u}}finally{try{o&&!o.done&&(t=r.return)&&(yield Ae(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=a;async function c(){var l,s;try{for(var t=mt(a()),r;r=await t.next(),!r.done;)return r.value}catch(o){l={error:o}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(Q[81],J([0,1,46,9]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((n,y)=>{let i;const L=new Map;function g(h,m,S,v,a){const c=L.get(m);if(h===P||c){const l={name:E(S),cmd:S,pid:h,ppid:m,load:v,mem:a};L.set(h,l),h===P&&(i=l),c&&(c.children||(c.children=[]),c.children.push(l),c.children.length>1&&(c.children=c.children.sort((s,t)=>s.pid-t.pid)))}}function E(h){const m=/--disable-blink-features=Auxclick/,S=/\\watcher\\win32\\CodeHelper\.exe/,v=/--crashes-directory/,a=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(S.exec(h))return"watcherService ";if(v.exec(h))return"electron-crash-reporter";if(a.exec(h))return"winpty-process";if(c.exec(h))return"console-window-host (Windows internal process)";let s=l.exec(h);if(s&&s.length===2)return s[1]==="renderer"?m.exec(h)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(h),s&&(r+=s+" ");while(s);return r&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${r}`:h}if(process.platform==="win32"){const h=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,S)=>{j(["windows-process-tree"],m,S)}).then(m=>{m.getProcessList(P,S=>{m.getProcessCpuUsage(S,v=>{const a=new Map;v.forEach(c=>{const l=h(c.commandLine||"");a.set(c.pid,{name:E(l),cmd:l,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),i=a.get(P),i?(a.forEach(c=>{const l=a.get(c.ppid);l&&(l.children||(l.children=[]),l.children.push(c))}),a.forEach(c=>{c.children&&(c.children=c.children.sort((l,s)=>l.pid-s.pid))}),n(i)):y(new Error(`Root process ${P} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{function p(){let h=[i];const m=[];for(;h.length;){const v=h.shift();v&&(m.push(v.pid),v.children&&(h=h.concat(v.children)))}let S=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);S+=" "+m.join(" "),(0,w.exec)(S,{},(v,a,c)=>{if(v||c)y(v||new Error(c.toString()));else{const l=a.toString().split(`
`);for(let s=0;s<m.length;s++){const t=L.get(m[s]);t.load=parseFloat(l[s])}if(!i){y(new Error(`Root process ${P} not found`));return}n(i)}})}(0,w.exec)("which ps",{},(h,m,S)=>{if(h||S)if(process.platform!=="linux")y(h||new Error(S.toString()));else{const v=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,w.exec)(v,{},(a,c,l)=>{a||l?y(a||new Error(l.toString())):(b(c,g),p())})}else{const v=m.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${v} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,l,s)=>{c||s&&!s.includes("screen size is bogus")?y(c||new Error(s.toString())):(b(l,g),process.platform==="linux"?p():i?n(i):y(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function b(P,n){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=P.toString().split(`
`);for(const L of i){const g=y.exec(L.trim());g&&g.length===6&&n(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(Q[114],J([0,1,8,22,3,64,2,23]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(g,E,p){return L({path:g,isDirectory:!1},E,p)}e.watchFile=y;function i(g,E,p){return L({path:g,isDirectory:!0},E,p)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function L(g,E,p){const h=(0,w.basename)(g.path),m=new Map;let S=!1,v=[(0,P.toDisposable)(()=>{m.forEach(a=>(0,P.dispose)(a)),m.clear()})];try{const a=(0,R.watch)(g.path);v.push((0,P.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const c=new Set;g.isDirectory&&(0,n.readdir)(g.path).then(l=>l.forEach(s=>c.add(s))),a.on("error",(l,s)=>{S||p(`Failed to watch ${g.path} for changes using fs.watch() (${l}, ${s})`)}),a.on("change",(l,s)=>{if(!S){let t="";if(s&&(t=s.toString(),D.isMacintosh&&(t=(0,b.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const r=g.isDirectory?(0,w.join)(g.path,t):g.path;if(g.isDirectory)if(l==="rename"){const o=m.get(r);o&&(0,P.dispose)(o);const u=setTimeout(async()=>{m.delete(r);const d=await(0,n.exists)(r);if(!S){let f;d?c.has(t)?f="changed":(f="added",c.add(t)):(c.delete(t),f="deleted"),E(f,r)}},e.CHANGE_BUFFER_DELAY);m.set(r,(0,P.toDisposable)(()=>clearTimeout(u)))}else{let o;c.has(t)?o="changed":(o="added",c.add(t)),E(o,r)}else if(l==="rename"||t!==h){const o=setTimeout(async()=>{const u=await(0,n.exists)(r);S||(u?(E("changed",r),v=[L(g,E,p)]):E("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,P.dispose)(v),v=[(0,P.toDisposable)(()=>clearTimeout(o))]}else E("changed",r)}}})}catch(a){(0,n.exists)(g.path).then(c=>{c&&!S&&p(`Failed to watch ${g.path} for changes using fs.watch() (${a.toString()})`)})}return(0,P.toDisposable)(()=>{S=!0,v=(0,P.dispose)(v)})}}),define(Q[115],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[116],J([0,1,11,115,13]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){w.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(n,y,i,L,g)=>{const E=P(n,L,i);E.popup({window:(0,D.withNullAsUndefined)(w.BrowserWindow.fromWebContents(n.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{E&&n.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,y)}})})}e.registerContextMenuListener=b;function P(n,y,i){const L=new w.Menu;return i.forEach(g=>{let E;g.type==="separator"?E=new w.MenuItem({type:g.type}):Array.isArray(g.submenu)?E=new w.MenuItem({submenu:P(n,y,g.submenu),label:g.label}):E=new w.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(p,h,m)=>n.sender.send(y,g.id,m)}),L.append(E)}),L}}),define(Q[33],J([0,1,4,2,10,25,19,21,34,13,106,20]),function(j,e,w,R,D,b,P,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function p(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function m(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(S||(S={}));class v{constructor(k){this.buffer=k,this.pos=0}read(k){const M=this.buffer.slice(this.pos,this.pos+k);return this.pos+=M.byteLength,M}}class a{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var c;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(c||(c={}));function l(T){const k=n.VSBuffer.alloc(4);return k.writeUInt32BE(T,0),k}function s(T){return T.read(4).readUInt32BE(0)}function t(T){const k=n.VSBuffer.alloc(1);return k.writeUInt8(T,0),k}const r={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},o=typeof Buffer!="undefined";function u(T,k){if(typeof k=="undefined")T.write(r.Undefined);else if(typeof k=="string"){const M=n.VSBuffer.fromString(k);T.write(r.String),T.write(l(M.byteLength)),T.write(M)}else if(o&&Buffer.isBuffer(k)){const M=n.VSBuffer.wrap(k);T.write(r.Buffer),T.write(l(M.byteLength)),T.write(M)}else if(k instanceof n.VSBuffer)T.write(r.VSBuffer),T.write(l(k.byteLength)),T.write(k);else if(Array.isArray(k)){T.write(r.Array),T.write(l(k.length));for(const M of k)u(T,M)}else{const M=n.VSBuffer.fromString(JSON.stringify(k));T.write(r.Object),T.write(l(M.byteLength)),T.write(M)}}function d(T){switch(T.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return T.read(s(T)).toString();case c.Buffer:return T.read(s(T)).buffer;case c.VSBuffer:return T.read(s(T));case c.Array:{const M=s(T),O=[];for(let _=0;_<M;_++)O.push(d(T));return O}case c.Object:return JSON.parse(T.read(s(T)).toString())}}class f{constructor(k,M,O=null,_=1e3){this.protocol=k,this.ctx=M,this.logger=O,this.timeoutDelay=_,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(k,M){this.channels.set(k,M),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const M=this.send([k.type]);this.logger&&this.logger.logOutgoing(M,0,1,m(k.type));return}case 201:case 202:case 204:case 203:{const M=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(M,k.id,1,m(k.type),k.data);return}}}send(k,M=void 0){const O=new a;return u(O,k),u(O,M),this.sendBuffer(O.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(M){return 0}}onRawMessage(k){const M=new v(k),O=d(M),_=d(M),W=O[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,O[1],1,`${p(W)}: ${O[2]}.${O[3]}`,_),this.onPromise({type:W,id:O[1],channelName:O[2],name:O[3],arg:_});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,O[1],1,`${p(W)}: ${O[2]}.${O[3]}`,_),this.onEventListen({type:W,id:O[1],channelName:O[2],name:O[3],arg:_});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,O[1],1,`${p(W)}`),this.disposeActiveRequest({type:W,id:O[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,O[1],1,`${p(W)}`),this.disposeActiveRequest({type:W,id:O[1]})}}onPromise(k){const M=this.channels.get(k.channelName);if(!M){this.collectPendingRequest(k);return}const O=new b.CancellationTokenSource;let _;try{_=M.call(this.ctx,k.name,k.arg,O.token)}catch(K){_=Promise.reject(K)}const W=k.id;_.then(K=>{this.sendResponse({id:W,data:K,type:201}),this.activeRequests.delete(k.id)},K=>{K instanceof Error?this.sendResponse({id:W,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:W,data:K,type:203}),this.activeRequests.delete(k.id)});const z=(0,R.toDisposable)(()=>O.cancel());this.activeRequests.set(k.id,z)}onEventListen(k){const M=this.channels.get(k.channelName);if(!M){this.collectPendingRequest(k);return}const O=k.id,W=M.listen(this.ctx,k.name,k.arg)(z=>this.sendResponse({id:O,data:z,type:204}));this.activeRequests.set(k.id,W)}disposeActiveRequest(k){const M=this.activeRequests.get(k.id);M&&(M.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let M=this.pendingRequests.get(k.channelName);M||(M=[],this.pendingRequests.set(k.channelName,M));const O=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:k,timeoutTimer:O})}flushPendingRequests(k){const M=this.pendingRequests.get(k);if(M){for(const O of M)switch(clearTimeout(O.timeoutTimer),O.request.type){case 100:this.onPromise(O.request);break;case 102:this.onEventListen(O.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var I;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(k,M=null){this.protocol=k,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(O=>this.onBuffer(O)),this.logger=M}getChannel(k){const M=this;return{call(O,_,W){return M.isDisposed?Promise.reject(P.canceled()):M.requestPromise(k,O,_,W)},listen(O,_){return M.isDisposed?Promise.reject(P.canceled()):M.requestEvent(k,O,_)}}}requestPromise(k,M,O,_=b.CancellationToken.None){const W=this.lastRequestId++,K={id:W,type:100,channelName:k,name:M,arg:O};if(_.isCancellationRequested)return Promise.reject(P.canceled());let Y;return new Promise((G,ee)=>{if(_.isCancellationRequested)return ee(P.canceled());const re=()=>{const de=he=>{switch(he.type){case 201:this.handlers.delete(W),G(he.data);break;case 202:this.handlers.delete(W);const me=new Error(he.data.message);me.stack=he.data.stack,me.name=he.data.name,ee(me);break;case 203:this.handlers.delete(W),ee(he.data);break}};this.handlers.set(W,de),this.sendRequest(K)};let ie=null;this.state===S.Idle?re():(ie=(0,D.createCancelablePromise)(de=>this.whenInitialized()),ie.then(()=>{ie=null,re()}));const ue=()=>{ie?(ie.cancel(),ie=null):this.sendRequest({id:W,type:101}),ee(P.canceled())},ve=_.onCancellationRequested(ue);Y=(0,R.combinedDisposable)((0,R.toDisposable)(ue),ve),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(k,M,O){const _=this.lastRequestId++,z={id:_,type:102,channelName:k,name:M,arg:O};let K=null;const Y=new w.Emitter({onFirstListenerAdd:()=>{K=(0,D.createCancelablePromise)(G=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(Y),this.sendRequest(z)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(Y),this.sendRequest({id:_,type:103}))}}),Z=G=>Y.fire(G.data);return this.handlers.set(_,Z),Y.event}sendRequest(k){switch(k.type){case 100:case 102:{const M=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(M,k.id,0,`${p(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const M=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(M,k.id,0,p(k.type));return}}}send(k,M=void 0){const O=new a;return u(O,k),u(O,M),this.sendBuffer(O.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(M){return 0}}onBuffer(k){const M=new v(k),O=d(M),_=d(M),W=O[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,m(W)),this.onResponse({type:O[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,O[1],0,m(W),_),this.onResponse({type:O[0],id:O[1],data:_})}}onResponse(k){if(k.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(k.id);M&&M(k)}whenInitialized(){return this.state===S.Idle?Promise.resolve():w.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class F{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:M,onDidClientDisconnect:O})=>{w.Event.once(M.onMessage)(W=>{const z=new v(W),K=d(z),Y=new f(M,K),Z=new A(M);this.channels.forEach((ee,re)=>Y.registerChannel(re,ee));const G={channelServer:Y,channelClient:Z,ctx:K};this._connections.add(G),this._onDidAddConnection.fire(G),O(()=>{Y.dispose(),Z.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)})})})}get connections(){const k=[];return this._connections.forEach(M=>k.push(M)),k}getChannel(k,M){const O=this;return{call(_,W,z){let K;if((0,i.isFunction)(M)){let Z=(0,y.getRandomElement)(O.connections.filter(M));K=Z?Promise.resolve(Z):w.Event.toPromise(w.Event.filter(O.onDidAddConnection,M))}else K=M.routeCall(O,_,W);const Y=K.then(Z=>Z.channelClient.getChannel(k));return H(Y).call(_,W,z)},listen(_,W){if((0,i.isFunction)(M))return O.getMulticastEvent(k,M,_,W);const z=M.routeEvent(O,_,W).then(K=>K.channelClient.getChannel(k));return H(z).listen(_,W)}}}getMulticastEvent(k,M,O,_){const W=this;let z=new R.DisposableStore;const K=new w.Emitter({onFirstListenerAdd:()=>{z=new R.DisposableStore;const Y=new w.EventMultiplexer,Z=new Map,G=re=>{const ue=re.channelClient.getChannel(k).listen(O,_),ve=Y.add(ue);Z.set(re,ve)},ee=re=>{const ie=Z.get(re);!ie||(ie.dispose(),Z.delete(re))};W.connections.filter(M).forEach(G),w.Event.filter(W.onDidAddConnection,M)(G,void 0,z),W.onDidRemoveConnection(ee,void 0,z),Y.event(K.fire,K,z),z.add(Y)},onLastListenerRemove:()=>{z.dispose()}});return K.event}registerChannel(k,M){this.channels.set(k,M),this._connections.forEach(O=>{O.channelServer.registerChannel(k,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class C{constructor(k,M,O=null){const _=new a;u(_,M),k.send(_.buffer),this.channelClient=new A(k,O),this.channelServer=new f(k,M,O)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,M){this.channelServer.registerChannel(k,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function H(T){return{call(k,M,O){return T.then(_=>_.call(k,M,O))},listen(k,M){const O=new w.Relay;return T.then(_=>O.input=_.listen(k,M)),O.event}}}e.getDelayedChannel=H;function X(T){let k=!1;return{call(M,O,_){return k?T.call(M,O,_):(0,D.timeout)(0).then(()=>k=!0).then(()=>T.call(M,O,_))},listen(M,O){if(k)return T.listen(M,O);const _=new w.Relay;return(0,D.timeout)(0).then(()=>k=!0).then(()=>_.input=T.listen(M,O)),_.event}}}e.getNextTickChannel=X;class ne{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const M of k.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await w.Event.toPromise(k.onDidAddConnection),await this.route(k)}}e.StaticRouter=ne;var oe;(function(T){function k(_,W){const z=_,K=W&&W.disableMarshalling,Y=new Map;for(const Z in z)O(Z)&&Y.set(Z,w.Event.buffer(z[Z],!0));return new class{listen(Z,G){const ee=Y.get(G);if(ee)return ee;throw new Error(`Event not found: ${G}`)}call(Z,G,ee){const re=z[G];if(typeof re=="function"){if(!K&&Array.isArray(ee))for(let ie=0;ie<ee.length;ie++)ee[ie]=(0,L.revive)(ee[ie]);return re.apply(z,ee)}throw new Error(`Method not found: ${G}`)}}}T.fromService=k;function M(_,W){const z=W&&W.disableMarshalling;return new Proxy({},{get(K,Y){var Z;if(typeof Y=="string")return((Z=W==null?void 0:W.properties)===null||Z===void 0?void 0:Z.has(Y))?W.properties.get(Y):O(Y)?_.listen(Y):async function(...G){let ee;W&&!(0,i.isUndefinedOrNull)(W.context)?ee=[W.context,...G]:ee=G;const re=await _.call(Y,ee);return z?re:(0,L.revive)(re)};throw new Error(`Property not found: ${String(Y)}`)}})}T.toService=M;function O(_){return _[0]==="o"&&_[1]==="n"&&g.isUpperAsciiLetter(_.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let k=T.toString();if(k!=="[object Object]")return k}return T}function B(T){return Array.isArray(T)?T.map(N):N(T)}function U(T,k,M,O,_,W,z){z=B(z);const K=V[_],Y=K[O%K.length];let Z=[`%c[${T}]%c[${String(k).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(O).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(W)?(Z=Z.concat(z),Z.push(")")):Z.push(z),console.log.apply(console,Z)}e.logWithColors=U;class ${constructor(k,M){this._outgoingPrefix=k,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,M,O,_,W){this._totalOutgoing+=k,U(this._outgoingPrefix,this._totalOutgoing,k,M,O,_,W)}logIncoming(k,M,O,_,W){this._totalIncoming+=k,U(this._incomingPrefix,this._totalIncoming,k,M,O,_,W)}}e.IPCLogger=$}),define(Q[117],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(D,b){this.sender=D,this.onMessage=b}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Q[118],J([0,1,4,33,21]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(y){this.port=y,this.onMessage=w.Event.fromDOMEventEmitter(this.port,"message",i=>D.VSBuffer.wrap(i.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class P extends R.IPCClient{constructor(y,i){const L=new b(y);super(L,i);this.protocol=L}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Q[82],J([0,1,4,33,2,21,3,35]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function i(){return y||(y=b.VSBuffer.alloc(0)),y}class L{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}let d=b.VSBuffer.alloc(o),f=0,I=0;for(;o>0;){const A=this._chunks[I];if(A.byteLength>o){const F=A.slice(0,o);d.set(F,f),f+=o,u&&(this._chunks[I]=A.slice(o),this._totalLength-=o),o-=o}else d.set(A,f),f+=A.byteLength,u?(this._chunks.shift(),this._totalLength-=A.byteLength):I++,o-=A.byteLength}return d}}e.ChunkStream=L;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(o,u,d,f){this.type=o,this.id=u,this.ack=d,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends D.Disposable{constructor(o){super();this._onMessage=this._register(new w.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new L,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const d=this._state.messageType,f=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(d,f,I,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=b.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._writeSoon(u,o.data)}}_bufferAdd(o,u){const d=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,d}_bufferTake(){const o=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends D.Disposable{constructor(o){super();this._onMessage=new w.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new p(1,0,0,o))}}e.Protocol=S;class v extends R.IPCClient{constructor(o,u,d=null){super(o,u,d);this.protocol=o}static fromSocket(o,u){return new v(new S(o),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new w.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class c{constructor(o){this.data=o,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],u=0,d=this._first;for(;d;)o[u++]=d.data,d=d.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new c(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let d=0;for(let f=0;f<s._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=u&&d++;return 1-d/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,u=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new p(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const u=new p(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let u=0,d=o.length;u<d;u++)this._socketWriter.write(o[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const u=this._outgoingUnackMsg.toArray();for(let d=0,f=u.length;d<f;d++)this._socketWriter.write(u[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new p(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(o){const u=new p(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(Q[119],J([0,1,11,4,33,117,2,21]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function y(L,g){const E=R.Event.fromNodeEventEmitter(w.ipcMain,g,(h,m)=>({event:h,message:m})),p=R.Event.filter(E,({event:h})=>h.sender.id===L);return R.Event.map(p,({message:h})=>h&&n.VSBuffer.wrap(h))}class i extends D.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const g=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:E})=>E);return R.Event.map(g,E=>{const p=E.id,h=i.Clients.get(p);h&&h.dispose();const m=new R.Emitter;i.Clients.set(p,(0,P.toDisposable)(()=>m.fire()));const S=y(p,"vscode:message"),v=R.Event.any(R.Event.signal(y(p,"vscode:disconnect")),m.event);return{protocol:new b.Protocol(E,S),onDidClientDisconnect:v}})}}e.Server=i,i.Clients=new Map}),define(Q[83],J([0,1,11,4,30,118]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends b.Client{constructor(i,L){super({addEventListener:(g,E)=>i.addListener(g,E),removeEventListener:(g,E)=>i.removeListener(g,E),postMessage:g=>i.postMessage(g),start:()=>i.start(),close:()=>i.close()},L)}}e.Client=P;async function n(y){if(y.isDestroyed()||y.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=(0,D.generateUuid)();y.webContents.send("vscode:createMessageChannel",i);const L=R.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(E,p)=>({nonce:p,port:E.ports[0]})),{port:g}=await R.Event.toPromise(R.Event.once(R.Event.filter(L,E=>E.nonce===i)));return g}e.connect=n}),define(Q[84],J([0,1,2,4,10,13]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var n;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(n||(n={}));class y extends w.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var E,p;(E=g.changed)===null||E===void 0||E.forEach((h,m)=>this.accept(m,h)),(p=g.deleted)===null||p===void 0||p.forEach(h=>this.accept(h,void 0))}accept(g,E){if(this.state!==n.Closed){let p=!1;(0,b.isUndefinedOrNull)(E)?p=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),p=!0),p&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const p=this.cache.get(g);return(0,b.isUndefinedOrNull)(p)?E:p}getBoolean(g,E){const p=this.get(g);return(0,b.isUndefinedOrNull)(p)?E:p==="true"}getNumber(g,E){const p=this.get(g);return(0,b.isUndefinedOrNull)(p)?E:parseInt(p,10)}async set(g,E){if(this.state!==n.Closed){if((0,b.isUndefinedOrNull)(E))return this.delete(g);const p=String(E);if(this.cache.get(g)!==p)return this.cache.set(g,p),this.pendingInserts.set(g,p),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==n.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,p)=>this.items.set(p,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(Q[120],J([0,1,22,4,10,36,8,23]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(g,E=Object.create(null)){this.path=g,this.options=E,this.name=(0,P.basename)(this.path),this.logger=new i(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const g=await this.whenConnected,E=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(h=>E.set(h.key,h.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(g){const E=await this.whenConnected;return this.doUpdateItems(E,g)}doUpdateItems(g,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,b.mapToString)(E.insert):"0"}), delete(${E.delete?(0,b.setToString)(E.delete):"0"})`),this.transaction(g,()=>{const p=E.insert,h=E.delete;if(p&&p.size>0){const m=[];m.push([]);let S=0;p.forEach((v,a)=>{let c=m[S];c.length>y.MAX_HOST_PARAMETERS&&(S++,c=[],m.push(c)),c.push(a,v)}),m.forEach(v=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(v.length/2).fill("(?,?)").join(",")}`,a=>a.run(v),()=>{const a=[];let c=0;return p.forEach((l,s)=>{a.push(s),c+=l.length}),`Keys: ${a.join(", ")} Length: ${c}`})})}if(h&&h.size){const m=[];m.push([]);let S=0;h.forEach(v=>{let a=m[S];a.length>y.MAX_HOST_PARAMETERS&&(S++,a=[],m.push(a)),a.push(v)}),m.forEach(v=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(v.length).fill("?").join(",")})`,a=>a.run(v),()=>{const a=[];return h.forEach(c=>{a.push(c)}),`Keys: ${a.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,g)}doClose(g,E){return new Promise((p,h)=>{g.db.close(m=>(m&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${m}`),this.path===y.IN_MEMORY_PATH?p():!g.isErroneous&&!g.isInMemory?this.backup().then(p,S=>(this.logger.error(`[storage ${this.name}] backup(): ${S}`),p())):typeof E=="function"?w.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(S=>{const v=()=>this.doClose(S,void 0);return this.doUpdateItems(S,{insert:E()}).then(()=>v(),a=>(v(),Promise.reject(a)))})).then(p,h):h(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,n.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const E=await this.whenConnected,p=await this.get(E,g?"PRAGMA integrity_check":"PRAGMA quick_check"),h=g?p.integrity_check:p.quick_check;return E.isErroneous?`${h} (last error: ${E.lastError})`:E.isInMemory?`${h} (in-memory!)`:h}async connect(g,E=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${E})`);try{return await this.doConnect(g)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&E)return await(0,D.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await w.promises.unlink(g);try{await w.promises.rename(this.toBackupPath(g),g)}catch(h){}return await this.doConnect(g)}catch(h){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${h}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(g,E){g.isErroneous=!0,g.lastError=E,this.logger.error(E)}doConnect(g){return new Promise((E,p)=>{new Promise((h,m)=>{j(["vscode-sqlite3"],h,m)}).then(h=>{const m={db:new(this.logger.isTracing?h.verbose().Database:h.Database)(g,S=>S?m.db?m.db.close(()=>p(S)):p(S):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(m),v=>m.db.close(()=>p(v)))),isInMemory:g===y.IN_MEMORY_PATH};m.db.on("error",S=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${S}`)),this.logger.isTracing&&m.db.on("trace",S=>this.logger.trace(`[storage ${this.name}] Trace (event): ${S}`))},p)})}exec(g,E){return new Promise((p,h)=>{g.db.exec(E,m=>m?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${m}`),h(m)):p())})}get(g,E){return new Promise((p,h)=>{g.db.get(E,(m,S)=>m?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${m}`),h(m)):p(S))})}all(g,E){return new Promise((p,h)=>{g.db.all(E,(m,S)=>m?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${m}`),h(m)):p(S))})}transaction(g,E){return new Promise((p,h)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),E(),g.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${m}`),h(m)):p())})})}prepare(g,E,p,h){const m=g.db.prepare(E),S=v=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${v} (${E}). Details: ${h()}`)};m.on("error",S),p(m),m.finalize(v=>{v&&S(v),m.removeListener("error",S)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class i{constructor(g){g&&typeof g.logTrace=="function"&&process.env[i.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}i.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[121],J([14,12]),function(j,e){return j.create("vs/base/common/date",e)}),define(Q[122],J([0,1,121]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,b=D*24,P=b*7,n=b*30,y=b*365;function i(g,E){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,w.localize)(0,null,i(new Date().getTime()+p*1e3,!1));if(p<30)return(0,w.localize)(1,null);let h;return p<R?(h=p,E?h===1?(0,w.localize)(2,null,h):(0,w.localize)(3,null,h):h===1?(0,w.localize)(4,null,h):(0,w.localize)(5,null,h)):p<D?(h=Math.floor(p/R),E?h===1?(0,w.localize)(6,null,h):(0,w.localize)(7,null,h):h===1?(0,w.localize)(8,null,h):(0,w.localize)(9,null,h)):p<b?(h=Math.floor(p/D),E?h===1?(0,w.localize)(10,null,h):(0,w.localize)(11,null,h):h===1?(0,w.localize)(12,null,h):(0,w.localize)(13,null,h)):p<P?(h=Math.floor(p/b),E?h===1?(0,w.localize)(14,null,h):(0,w.localize)(15,null,h):h===1?(0,w.localize)(16,null,h):(0,w.localize)(17,null,h)):p<n?(h=Math.floor(p/P),E?h===1?(0,w.localize)(18,null,h):(0,w.localize)(19,null,h):h===1?(0,w.localize)(20,null,h):(0,w.localize)(21,null,h)):p<y?(h=Math.floor(p/n),E?h===1?(0,w.localize)(22,null,h):(0,w.localize)(23,null,h):h===1?(0,w.localize)(24,null,h):(0,w.localize)(25,null,h)):(h=Math.floor(p/y),E?h===1?(0,w.localize)(26,null,h):(0,w.localize)(27,null,h):h===1?(0,w.localize)(28,null,h):(0,w.localize)(29,null,h))}e.fromNow=i;function L(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(Q[123],J([14,12]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Q[66],J([0,1,123,13,34]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(i,L){return L&&(i.stack||i.stacktrace)?w.localize(0,null,n(i),P(i.stack)||P(i.stacktrace)):n(i)}function P(i){return Array.isArray(i)?i.join(`
`):i}function n(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?w.localize(1,null,i.message):i.message||w.localize(2,null)}function y(i=null,L=!1){if(!i)return w.localize(3,null);if(Array.isArray(i)){const g=D.coalesce(i),E=y(g[0],L);return g.length>1?w.localize(4,null,E,g.length):E}if(R.isString(i))return i;if(i.detail){const g=i.detail;if(g.error)return b(g.error,L);if(g.exception)return b(g.exception,L)}return i.stack?b(i,L):i.message?i.message:w.localize(5,null)}e.toErrorMessage=y}),define(Q[124],J([14,12]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Q[125],J([0,1,124]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(P,n,y=n){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=n,this.modifierLabels[3]=y}toLabel(P,n,y){if(n.length===0)return null;const i=[];for(let L=0,g=n.length;L<g;L++){const E=n[L],p=y(E);if(p===null)return null;i[L]=D(E,p,this.modifierLabels[P])}return i.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(b,P,n){if(P===null)return"";const y=[];return b.ctrlKey&&y.push(n.ctrlKey),b.shiftKey&&y.push(n.shiftKey),b.altKey&&y.push(n.altKey),b.metaKey&&y.push(n.metaKey),P!==""&&y.push(P),y.join(n.separator)}}),define(Q[126],J([14,12]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Q[85],J([0,1,8,22,23,46,126,35,13,45,29,3,80,9]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(s,t){if(g.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const o=b.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(u=>{o.once("error",d=>{u({success:!1,error:d})}),o.once("exit",(d,f)=>{u(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(g.isLinux||g.isMacintosh)try{const r=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(o=>{b.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(u,d,f)=>{o(u?{success:!1,error:u}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function S(s=n.env){return s.comspec||"cmd.exe"}e.getWindowsShell=S;class v{constructor(t,r,o,u){if(r!==void 0&&o!==void 0&&u!==void 0)this.cmd=t,this.args=r,this.shell=o,this.options=u;else{const d=t;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(n.env).forEach(f=>{d[f]=n.env[f]}),Object.keys(this.options.env).forEach(f=>{d[f]=this.options.env[f]}),this.options.env=d}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(w.sep);return r!==-1&&(t=t.substring(r+1)),v.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(n.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(r=>{let o,u;const d=new Promise((f,I)=>{o=f,u=I});if(r){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=b.exec(f,this.options,(I,A,F)=>{this.childProcess=null;const C=I;C&&C.killed?u({killed:this.terminateRequested,stdout:A.toString(),stderr:F.toString()}):this.handleExec(o,t,I,A,F)})}else{let f=null;const I=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,o,t,u);const F={terminated:this.terminateRequested};y.isNumber(A)&&(F.cmdCode=A),o(F)};if(this.shell&&g.isWindows){const A=i.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let F=!1,C=!1;const H=[];let X=this.ensureQuotes(this.cmd);H.push(X.value),F=X.quoted,this.args&&this.args.forEach(oe=>{X=this.ensureQuotes(oe),H.push(X.value),C=C&&X.quoted});const ne=["/s","/c"];F?C?ne.push('"'+H.join(" ")+'"'):H.length>1?ne.push('"'+H[0]+'" '+H.slice(1).join(" ")):ne.push('"'+H[0]+'"'):ne.push(H.join(" ")),f=b.spawn(S(),ne,A)}else this.cmd&&(f=b.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(y.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",A=>{this.childProcess=null,u({terminated:this.terminateRequested,error:A})}),f.pid&&(this.childProcess.on("close",I),this.handleSpawn(f,o,t,u,!0)))}return d})}handleClose(t,r,o,u){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const r=b.spawn(S(),["/s","/c"]);r.on("error",o=>t(!0)),r.on("exit",o=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class a extends v{constructor(t,r,o,u){super(t,r,o,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,o,u,d){[u,d].forEach((f,I)=>{const A=new E.LineDecoder;A.write(f).forEach(H=>{r({line:H,source:I===0?0:1})});const C=A.end();C&&r({line:C,source:I===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,r,o,u,d){const f=new E.LineDecoder,I=new E.LineDecoder;t.stdout.on("data",A=>{f.write(A).forEach(C=>o({line:C,source:0}))}),t.stderr.on("data",A=>{I.write(A).forEach(C=>o({line:C,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=I}handleClose(t,r,o,u){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&o({line:d,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&o({line:f,source:1})}}e.LineProcess=a;function c(s){let t=[],r=!1;const o=function(u){if(r){t.push(u);return}(!s.send(u,f=>{if(f&&console.error(f),r=!1,t.length>0){const I=t.slice(0);t=[],I.forEach(A=>o(A))}})||g.isWindows)&&(r=!0)};return{send:o}}e.createQueuedSender=c;var l;(function(s){async function t(r,o,u){if(w.isAbsolute(r))return r;if(o===void 0&&(o=n.cwd()),w.dirname(r)!=="."||(u===void 0&&y.isString(n.env.PATH)&&(u=n.env.PATH.split(w.delimiter)),u===void 0||u.length===0))return w.join(o,r);async function f(I){return await D.exists(I)?!(await R.promises.stat(I)).isDirectory():!1}for(let I of u){let A;if(w.isAbsolute(I)?A=w.join(I,r):A=w.join(o,I,r),await f(A))return A;let F=A+".com";if(await f(F)||(F=A+".exe",await f(F)))return F}return w.join(o,r)}s.findExecutable=t})(l=e.win32||(e.win32={}))}),define(Q[127],J([0,1,27,3,113,85]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(p,h){return p===3?R.isWindows?g():b.getWindowsShell(h):i(p,h)}e.getSystemShell=P;function n(p,h){return p===3?R.isWindows?E(h):b.getWindowsShell(h):i(p,h)}e.getSystemShellSync=n;let y=null;function i(p,h){if(R.isLinux&&p===1||R.isMacintosh&&p===2)return"/bin/bash";if(!y){let m;if(R.isWindows)m="/bin/bash";else{if(m=h.SHELL,!m)try{m=w.userInfo().shell}catch(S){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}y=m}return y}let L=null;async function g(){return L||(L=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),L}function E(p){if(L)return L;const h=R.isWindows&&parseFloat(w.release())>=10,m=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${p.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?S:b.getWindowsShell(p)}}),define(Q[86],J([0,1,46,2,10,45,4,85,33,105,25,19,21,3]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(v){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch(c){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",a=>E.VSBuffer.wrap(Buffer.from(a,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=h;class m{constructor(v,a){this.modulePath=v,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new D.Delayer(c),this.child=null,this._client=null}getChannel(v){const a=this;return{call(c,l,s){return a.requestPromise(v,c,l,s)},listen(c,l){return a.requestEvent(v,c,l)}}}requestPromise(v,a,c,l=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),t=(0,D.createCancelablePromise)(u=>s.call(a,c,u)),r=l.onCancellationRequested(()=>t.cancel()),o=(0,R.toDisposable)(()=>t.cancel());return this.activeRequests.add(o),t.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(v,a,c){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let l;const s=new P.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(v).listen(a,c)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(a.env=Object.assign(Object.assign({},a.env),this.options.env)),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d))),p.isMacintosh&&a.env&&delete a.env.DYLD_LIBRARY_PATH,this.child=(0,w.fork)(this.modulePath,v,a);const c=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",d=>d)(d=>{if((0,i.isRemoteConsoleLog)(d)){(0,i.log)(d,`IPC Library: ${this.options.serverName}`);return}c.fire(E.VSBuffer.wrap(Buffer.from(d,"base64")))});const s=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=d=>this.child&&this.child.connected&&s.send(d.buffer.toString("base64")),r=c.event,o={send:t,onMessage:r};this._client=new y.ChannelClient(o);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",d=>console.warn('IPC "'+this.options.serverName+'" errored with '+d)),this.child.on("exit",(d,f)=>{process.removeListener("exit",u),this.activeRequests.forEach(I=>(0,R.dispose)(I)),this.activeRequests.clear(),d!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+d+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:d,signal:f})})}return this._client}getCachedChannel(v){let a=this.channels.get(v);return a||(a=this.client.getChannel(v),this.channels.set(v,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Q[128],J([14,12]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Q[129],J([14,12]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[130],J([14,12]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[131],J([14,12]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Q[132],J([14,12]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Q[133],J([14,12]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[134],J([14,12]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[135],J([14,12]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Q[136],J([14,12]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Q[137],J([14,12]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Q[138],J([14,12]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[139],J([14,12]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[140],J([14,12]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[141],J([14,12]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Q[142],J([14,12]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[143],J([14,12]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[144],J([14,12]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Q[145],J([14,12]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[146],J([14,12]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[147],J([14,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[148],J([14,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[149],J([0,1,4,2]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(n,y,i){switch(y){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(n,y,i){switch(y){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class b extends R.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,y,i){this.channel.call("attach",[n,y,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,y){this.channel.call("terminate",[n,y])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,y,i){return this.channel.call("openExtensionDevelopmentHostWindow",[n,y,i])}}e.ExtensionHostDebugChannelClient=b});var le=this&&this.__decorate||function(j,e,w,R){var D=arguments.length,b=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,w):R,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(j,e,w,R);else for(var n=j.length-1;n>=0;n--)(P=j[n])&&(b=(D<3?P(b):D>3?P(e,w,b):P(e,w))||b);return D>3&&b&&Object.defineProperty(e,w,b),b};define(Q[150],J([0,1,8,15,52,122,9,7,35]),function(j,e,w,R,D,b,P,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class i{constructor(h,m,S){this._args=h,this.paths=m,this.productService=S}get appRoot(){return(0,w.dirname)(P.FileAccess.asFileUri("",j).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,w.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,w.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,w.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(n.URI.file((0,w.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=y.env.VSCODE_PORTABLE;return h?n.URI.file((0,w.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,w.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,w.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,w.resolve)(h):(0,w.normalize)((0,w.join)(P.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,w.resolve)(h):(0,w.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,w.resolve)(h);const m=y.env.VSCODE_EXTENSIONS;if(m)return m;const S=y.env.VSCODE_PORTABLE;return S?(0,w.join)(S,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?n.URI.parse(m):n.URI.file((0,w.normalize)(m)))}get extensionDevelopmentKind(){var h;return(h=this.args.extensionDevelopmentKind)===null||h===void 0?void 0:h.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?n.URI.parse(h):n.URI.file((0,w.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!y.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,w.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}le([D.memoize],i.prototype,"appRoot",null),le([D.memoize],i.prototype,"userHome",null),le([D.memoize],i.prototype,"userDataPath",null),le([D.memoize],i.prototype,"appSettingsHome",null),le([D.memoize],i.prototype,"tmpDir",null),le([D.memoize],i.prototype,"userRoamingDataHome",null),le([D.memoize],i.prototype,"settingsResource",null),le([D.memoize],i.prototype,"userDataSyncHome",null),le([D.memoize],i.prototype,"userDataSyncLogResource",null),le([D.memoize],i.prototype,"sync",null),le([D.memoize],i.prototype,"machineSettingsResource",null),le([D.memoize],i.prototype,"globalStorageHome",null),le([D.memoize],i.prototype,"workspaceStorageHome",null),le([D.memoize],i.prototype,"keybindingsResource",null),le([D.memoize],i.prototype,"keyboardLayoutResource",null),le([D.memoize],i.prototype,"argvResource",null),le([D.memoize],i.prototype,"snippetsHome",null),le([D.memoize],i.prototype,"isExtensionDevelopment",null),le([D.memoize],i.prototype,"untitledWorkspacesHome",null),le([D.memoize],i.prototype,"installSourcePath",null),le([D.memoize],i.prototype,"builtinExtensionsPath",null),le([D.memoize],i.prototype,"extensionsPath",null),le([D.memoize],i.prototype,"extensionDevelopmentLocationURI",null),le([D.memoize],i.prototype,"extensionDevelopmentKind",null),le([D.memoize],i.prototype,"extensionTestsLocationURI",null),le([D.memoize],i.prototype,"debugExtensionHost",null),le([D.memoize],i.prototype,"serviceMachineIdResource",null),le([D.memoize],i.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=i;function L(p,h){return E(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId)}e.parseExtensionHostPort=L;function g(p,h){return E(p["inspect-search"],p["inspect-brk-search"],5876,h)}e.parseSearchPort=g;function E(p,h,m,S,v){const c=Number(h||p)||(S?null:m),l=c?Boolean(!!h):!1;return{port:c,break:l,debugId:v}}}),define(Q[60],J([0,1,235,131,3]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(h,m,S=P){const v={},a=[],c=[];for(let r in m){const o=m[r];o.alias&&(v[r]=o.alias),o.type==="string"||o.type==="string[]"?(a.push(r),o.deprecates&&a.push(o.deprecates)):o.type==="boolean"&&(c.push(r),o.deprecates&&c.push(o.deprecates))}const l=w(h,{string:a,boolean:c,alias:v}),s={},t=l;s._=l._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const o=m[r];o.alias&&delete t[o.alias];let u=t[r];o.deprecates&&t.hasOwnProperty(o.deprecates)&&(u||(u=t[o.deprecates]),delete t[o.deprecates]),typeof u!="undefined"&&(o.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):o.type==="string"&&Array.isArray(u)&&(u=u.pop(),S.onMultipleValues(r,u)),s[r]=u),delete t[r]}for(let r in t)S.onUnknownOption(r);return s}e.parseArgs=n;function y(h,m){let S="";return m.args&&(Array.isArray(m.args)?S=` <${m.args.join("> <")}>`:S=` <${m.args}>`),m.alias?`-${m.alias} --${h}${S}`:`--${h}${S}`}function i(h,m){let S=0,v=[];for(const s in h){const t=h[s],r=y(s,t);S=Math.max(S,r.length),v.push([r,t.description])}let a=S+2+1;if(m-a<25)return v.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=m-a-1,l=[];for(const s of v){let t=s[0],r=g(s[1],c),o=L(a-t.length-2);l.push("  "+t+o+r[0]);for(let u=1;u<r.length;u++)l.push(L(a)+r[u])}return l}e.formatOptions=i;function L(h){return" ".repeat(h)}function g(h,m){let S=[];for(;h.length;){let v=h.length<m?h.length:h.lastIndexOf(" ",m),a=h.slice(0,v).trim();h=h.slice(v),S.push(a)}return S}function E(h,m,S,v,a=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${h} ${S}`];l.push(""),l.push(`${(0,R.localize)(32,null)}: ${m} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),l.push(""),a&&(D.isWindows?l.push((0,R.localize)(35,null,m)):l.push((0,R.localize)(36,null,m)),l.push(""));const s={};for(const t in v){const r=v[t];if(r.description&&r.cat){let o=s[r.cat];o||(s[r.cat]=o={}),o[t]=r}}for(let t in s){const r=t;let o=s[r];o&&(l.push(b[r]),l.push(...i(o,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=E;function p(h,m){return`${h||(0,R.localize)(37,null)}
${m||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Q[151],J([0,1,60,59,149]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,y,i){return y==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(n,y,i)}async openExtensionDevelopmentHostWindow(n,y,i){const L=(0,w.parseArgs)(n,w.OPTIONS);L.debugRenderer=i;const g=L.extensionDevelopmentPath;if(!g)return{};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:L,userEnv:Object.keys(y).length>0?y:void 0});if(!i)return{};const p=E.win;if(!p)return{};const h=p.webContents.debugger;let m=h.isAttached()?Infinity:0;const S=(0,R.createServer)(v=>{m++==0&&h.attach();let a=!1;const c=t=>{a||v.write(JSON.stringify(t)+"\0")},l=(t,r,o,u)=>c({method:r,params:o,sessionId:u});p.on("close",()=>{h.removeListener("message",l),v.end(),a=!0}),h.addListener("message",l);let s=Buffer.alloc(0);v.on("data",t=>{s=Buffer.concat([s,t]);for(let r=s.indexOf(0);r!==-1;r=s.indexOf(0)){let o;try{const u=s.slice(0,r).toString("utf8");s=s.slice(r+1),o=JSON.parse(u)}catch(u){console.error("error reading cdp line",u)}h.sendCommand(o.method,o.params,o.sessionId).then(u=>c({id:o.id,sessionId:o.sessionId,result:u})).catch(u=>c({id:o.id,sessionId:o.sessionId,error:{code:0,message:u.message}}))}}),v.on("error",t=>{console.error("error on cdp pipe:",t)}),v.on("close",()=>{a=!0,--m==0&&h.detach()})});return await new Promise(v=>S.listen(0,v)),p.on("close",()=>S.close()),{rendererDebugPort:S.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function j(e,w,R){function D(P){return e.resolve(b(P))}function b(P){const n=process.env.VSCODE_PORTABLE;if(n)return e.join(n,"user-data");const y=P["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(L,"AppData","Roaming")}break;case"darwin":i=e.join(w.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,R)}return{getUserDataPath:D}}if(typeof define=="function")define(Q[152],J([0,236,27,9,15]),function(e,w,R,D,b){const P=b.dirname(D.FileAccess.asFileUri("",e)),n=e.__$__nodeRequire(b.joinPath(P,"package.json").fsPath);return j(w,R,n.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),R=require("os");module.exports=j(w,R,e.name)}else throw new Error("Unknown context")}(),define(Q[153],J([0,1,27,152,150]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends D.AbstractNativeEnvironmentService{constructor(n,y){super(n,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,R.getUserDataPath)(n)},y)}}e.NativeEnvironmentService=b}),define(Q[154],J([0,1,22,27,8]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(P){const n=(0,D.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return w.writeFileSync(n,""),P&&console.log(`Marker file for --wait created: ${n}`),n}catch(y){P&&console.error(`Failed to create marker file for --wait: ${y}`);return}}e.createWaitMarkerFile=b}),define(Q[155],J([0,1,134]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function D(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=D;function b(g){if(!D(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=b;function P(g){if(!g)return null;let E=g.majorBase,p=g.majorMustEqual,h=g.minorBase,m=g.minorMustEqual,S=g.patchBase,v=g.patchMustEqual;return g.hasCaret&&(E===0||(m=!1),v=!1),{majorBase:E,majorMustEqual:p,minorBase:h,minorMustEqual:m,patchBase:S,patchMustEqual:v,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=P;function n(g,E){let p;typeof g=="string"?p=P(b(g)):p=g;let h;if(typeof E=="string"?h=P(b(E)):h=E,!p||!h)return!1;let m=p.majorBase,S=p.minorBase,v=p.patchBase,a=h.majorBase,c=h.minorBase,l=h.patchBase,s=h.majorMustEqual,t=h.minorMustEqual,r=h.patchMustEqual;return h.isMinimum?m>a?!0:m<a?!1:S>c?!0:S<c?!1:v>=l:(m===1&&a===0&&(!s||!t||!r)&&(a=1,c=0,l=0,s=!0,t=!1,r=!1),m<a?!1:m>a?!s:S<c?!1:S>c?!t:v<l?!1:v>l?!r:!0)}e.isValidVersion=n;function y(g,E,p){return E.isBuiltin||typeof E.main=="undefined"?!0:L(g,E.engines.vscode,p)}e.isValidExtensionVersion=y;function i(g,E){return g==="*"||L(E,g)}e.isEngineValid=i;function L(g,E,p=[]){let h=P(b(E));if(!h)return p.push(w.localize(0,null,E)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return p.push(w.localize(1,null,E)),!1}else if(!h.majorMustEqual)return p.push(w.localize(2,null,E)),!1;return n(g,h)?!0:(p.push(w.localize(3,null,g,E)),!1)}e.isVersionValid=L}),define(Q[156],J([0,1,33,86,2,9]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends D.Disposable{constructor(y,i,L,g){super();this.folders=y,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[157],J([0,1,33,86,2,9]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends D.Disposable{constructor(y,i,L,g,E={}){super();this.folders=y,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(b.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(y.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[158],J([0,1,46,80,79,9]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(y,i,L,g,E){this.watchedFolder=y,this.eventCallback=L,this.logCallback=g,this.verboseLogging=E,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(p=>D.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=w.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,y);const i=new R.LineDecoder;this.handle.stdout.on("data",L=>{const g=[];i.write(L).forEach(E=>{const p=E.split("|");if(p.length===2){const h=Number(p[0]),m=p[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(S=>S(m))){this.verboseLogging&&this.log(m);return}g.push({type:P.changeTypeMap[h],path:m})}else this.log(p[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",L=>this.onError(L)),this.handle.stderr.on("data",L=>this.onError(L)),this.handle.on("exit",(L,g)=>this.onExit(L,g))}onError(y){this.error("process error: "+y.toString())}onExit(y,i){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${i})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(Q[159],J([0,1,158,8,20]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(n,y,i,L){this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=L,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(Q[67],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(b,P=[],n=!1){this.ctor=b,this.staticArguments=P,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=w;const R=(D,...b)=>new w(D,b);e.createSyncDescriptor=R}),define(Q[160],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=w;class R{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let P of this._nodes.values())P.outgoing.size===0&&b.push(P);return b}insertEdge(b,P){const n=this.lookupOrInsertNode(b),y=this.lookupOrInsertNode(P);n.outgoing.set(this._hashFn(P),y),y.incoming.set(this._hashFn(b),n)}removeNode(b){const P=this._hashFn(b);this._nodes.delete(P);for(let n of this._nodes.values())n.outgoing.delete(P),n.incoming.delete(P)}lookupOrInsertNode(b){const P=this._hashFn(b);let n=this._nodes.get(P);return n||(n=new w(b),this._nodes.set(P,n)),n}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[P,n]of this._nodes)b.push(`${P}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return b.join(`
`)}}e.Graph=R}),define(Q[5],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function y(i){return i[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=y})(w=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(n,y,i,L){y[w.DI_TARGET]===y?y[w.DI_DEPENDENCIES].push({id:n,index:i,optional:L}):(y[w.DI_DEPENDENCIES]=[{id:n,index:i,optional:L}],y[w.DI_TARGET]=y)}function D(n){if(w.serviceIds.has(n))return w.serviceIds.get(n);const y=function(i,L,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,i,g,!1)};return y.toString=()=>n,w.serviceIds.set(n,y),y}e.createDecorator=D;function b(n){return n}e.refineServiceDecorator=b;function P(n){return function(y,i,L){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(n,y,L,!0)}}e.optional=P}),define(Q[68],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R}),define(Q[87],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService");class R{constructor(b){this.machineId=b}encryption(){return new Promise((b,P)=>j(["vscode-encrypt"],b,P))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(P){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(P){return b}}}e.EncryptionMainService=R}),define(Q[47],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[161],J([0,1,133,5,9]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=b;var P;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var n;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var i;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class L extends Error{constructor(E,p){super(E);this.code=p}}e.ExtensionManagementError=L,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Q[162],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Q[163],J([0,1,20,5]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class P{constructor(L){this.value=L,this._lower=L.toLowerCase()}static equals(L,g){if(typeof L=="undefined"||L===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof L=="string"||typeof g=="string"){let E=typeof L=="string"?L:L.value,p=typeof g=="string"?g:g.value;return w.equalsIgnoreCase(E,p)}return L._lower===g._lower}static toKey(L){return typeof L=="string"?L.toLowerCase():L._lower}}e.ExtensionIdentifier=P;function n(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=n;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[164],J([0,1,20,163]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(p,h){return p.uuid&&h.uuid?p.uuid===h.uuid:p.id===h.id?!0:(0,w.compareIgnoreCase)(p.id,h.id)===0}e.areSameExtensions=D;class b{constructor(h,m){this.version=m,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof b?D(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=b;function P(p,h){return`${p}.${h}`}e.getExtensionId=P;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function y(p,h){return n(P(p,h))}e.getGalleryExtensionId=y;function i(p,h){const m=[],S=v=>{for(const a of m)if(a.some(c=>D(h(c),h(v))))return a;return null};for(const v of p){const a=S(v);a?a.push(v):m.push([v])}return m}e.groupByExtension=i;function L(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function g(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(p){const h=new Set;for(const m of p)m.malicious&&h.add(m.id.id);return h}e.getMaliciousExtensionsSet=E}),define(Q[16],J([0,1,136,8,7,5,20,13,36]),function(j,e,w,R,D,b,P,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function i(V){return V.create===!0}e.isFileOpenForWriteOptions=i;var L;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var g;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function p(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=p;function h(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function m(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=m;var S;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(N,B){super(N);this.code=B}}e.FileSystemProviderError=v;function a(V,N){const B=new v(V.toString(),N);return l(B,N),B}e.createFileSystemProviderError=a;function c(V){return V||a((0,w.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function l(V,N){return V.name=N?`${N} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function s(V){if(!V)return S.Unknown;if(V instanceof v)return V.code;const N=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!N)return S.Unknown;switch(N[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=s;function t(V){if(V instanceof I)return V.fileOperationResult;switch(s(V)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(N,B,U){this.resource=N,this.operation=B,this.target=U}isOperation(N){return this.operation===N}}e.FileOperationEvent=o;var u;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(N,B){this.ignorePathCasing=B,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=N;for(const U of N)switch(U.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(N,...B){return this.doContains(N,{includeChildren:!1},...B)}affects(N,...B){return this.doContains(N,{includeChildren:!0},...B)}doContains(N,B,...U){var $,T,k,M,O,_;if(!N)return!1;const W=U.length>0;return!!((!W||U.includes(1))&&((($=this.added)===null||$===void 0?void 0:$.get(N))||B.includeChildren&&((T=this.added)===null||T===void 0?void 0:T.findSuperstr(N)))||(!W||U.includes(0))&&(((k=this.updated)===null||k===void 0?void 0:k.get(N))||B.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr(N)))||(!W||U.includes(2))&&(((O=this.deleted)===null||O===void 0?void 0:O.findSubstr(N))||B.includeChildren&&((_=this.deleted)===null||_===void 0?void 0:_.findSuperstr(N))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(N){const B=[],U=N===1?this.added:N===0?this.updated:this.deleted;if(U)for(const[,$]of U)B.push($);return B}filter(N){return new d(this.changes.filter(B=>N(B)),this.ignorePathCasing)}}e.FileChangesEvent=d;function f(V,N,B){return!V||!N||V===N||N.length>V.length?!1:(N.charAt(N.length-1)!==R.sep&&(N+=R.sep),B?(0,P.startsWithIgnoreCase)(V,N):V.indexOf(N)===0)}e.isParent=f;class I extends Error{constructor(N,B,U){super(N);this.fileOperationResult=B,this.options=U}static isFileOperationError(N){return N instanceof Error&&!(0,n.isUndefinedOrNull)(N.fileOperationResult)}}e.FileOperationError=I;var A;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function C(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=C;async function H(V,N){if(!N.canHandleResource(D.URI.from({scheme:V.scheme})))return new Promise(B=>{const U=N.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===V.scheme&&$.added&&(U.dispose(),B())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize(N){return(0,n.isNumber)(N)||(N=0),N<X.KB?(0,w.localize)(1,null,N.toFixed(0)):N<X.MB?(0,w.localize)(2,null,(N/X.KB).toFixed(2)):N<X.GB?(0,w.localize)(3,null,(N/X.MB).toFixed(2)):N<X.TB?(0,w.localize)(4,null,(N/X.GB).toFixed(2)):(0,w.localize)(5,null,(N/X.TB).toFixed(2))}}e.ByteSize=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;var ne;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function oe(V){return{maxFileSize:V===0?300*X.MB:16*X.GB,maxHeapSize:V===0?700*X.MB:2*700*X.MB}}e.getPlatformLimits=oe}),define(Q[53],J([0,1,237,132,16,60]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(E,p){const h={onUnknownOption:S=>{console.warn((0,R.localize)(0,null,S))},onMultipleValues:(S,v)=>{console.warn((0,R.localize)(1,null,S,v))}},m=(0,b.parseArgs)(E,b.OPTIONS,p?h:void 0);return m.goto&&m._.forEach(S=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,R.localize)(2,null))),m["max-memory"]&&w(parseInt(m["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(E){const p=E.findIndex(h=>!/^-/.test(h));if(p>-1)return[...E.slice(0,p),...E.slice(p+1)]}function y(E){let[,...p]=E;process.env.VSCODE_DEV&&(p=n(p)||[]);const h=!g(process.env);return P(p,h)}e.parseMainProcessArgv=y;function i(E){const[,,...p]=E;return P(p,!0)}e.parseCLIProcessArgv=i;function L(E,...p){const h=E.indexOf("--");return h===-1?E.push(...p):E.splice(h,0,...p),E}e.addArg=L;function g(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(Q[69],J([0,1,46,30,3,53,66,127]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(g,E,p){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(p)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(p)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=L(g)),i)}e.resolveShellEnv=y;let i;async function L(g){const E=new Promise(async(p,h)=>{const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const v=(0,R.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(v+"(.*)"+v),c=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),l=`'${process.execPath}' -p '"${v}" + JSON.stringify(process.env) + "${v}"'`;g.trace("getUnixShellEnvironment#env",c),g.trace("getUnixShellEnvironment#spawn",l);const s=await(0,n.getSystemShell)(D.platform,c);g.trace("getUnixShellEnvironment#shell",s);const t=(0,w.spawn)(s,["-ilc",l],{detached:!0,stdio:["ignore","pipe",process.stderr],env:c}),r=[];t.on("error",()=>p({})),t.stdout.on("data",o=>r.push(o)),t.on("close",o=>{if(o!==0)return h(new Error("Failed to get environment"));const u=Buffer.concat(r).toString("utf8");g.trace("getUnixShellEnvironment#raw",u);const d=a.exec(u),f=d?d[1]:"{}";try{const I=JSON.parse(f);m?I.ELECTRON_RUN_AS_NODE=m:delete I.ELECTRON_RUN_AS_NODE,S?I.ELECTRON_NO_ATTACH_CONSOLE=S:delete I.ELECTRON_NO_ATTACH_CONSOLE,delete I.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",I),p(I)}catch(I){g.error("getUnixShellEnvironment#error",I),h(I)}})});try{return await E}catch(p){return g.error("getUnixShellEnvironment#error",(0,P.toErrorMessage)(p)),{}}}}),define(Q[88],J([0,1,137,21,16,19]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(L,g,E,p,h,m){let S;try{await n(L,g,E,p,h,m)}catch(v){S=v}finally{S&&h.errorTransformer&&(S=h.errorTransformer(S)),typeof S!="undefined"&&E.error(S),E.end()}}e.readFileIntoStream=P;async function n(L,g,E,p,h,m){y(m);const S=await L.open(g,{create:!1});try{y(m);let v=0,a=0,c=h&&typeof h.length=="number"?h.length:void 0,l=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof c=="number"?c:h.bufferSize)),s=h&&typeof h.position=="number"?h.position:0,t=0;do a=await L.read(S,s,l.buffer,t,l.byteLength-t),s+=a,t+=a,v+=a,typeof c=="number"&&(c-=a),t===l.byteLength&&(await E.write(p(l)),l=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof c=="number"?c:h.bufferSize)),t=0);while(a>0&&(typeof c!="number"||c>0)&&y(m)&&i(v,h));if(t>0){let r=t;typeof c=="number"&&(r=Math.min(t,c)),E.write(p(l.slice(0,r)))}}catch(v){throw(0,D.ensureFileSystemProviderError)(v)}finally{await L.close(S)}}function y(L){if(L.isCancellationRequested)throw(0,b.canceled)();return!0}function i(L,g){if(g==null?void 0:g.limits){if(typeof g.limits.memory=="number"&&L>g.limits.memory)throw(0,D.createFileSystemProviderError)((0,w.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&L>g.limits.size)throw(0,D.createFileSystemProviderError)((0,w.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[89],J([0,1,7,16,3]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(y){return y.map(i=>({type:i.type,resource:w.URI.file(i.path)}))}e.toFileChanges=b;function P(y){const i=new n;for(const L of y)i.processEvent(L);return i.normalize()}e.normalizeFileChanges=P;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const L=this.mapPathToChange.get(i.path);if(L){const g=L.type,E=i.type;g===1&&E===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(L),1)):g===2&&E===1?L.type=0:g===1&&E===0||(L.type=E)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],L=[];return this.normalized.filter(g=>g.type!==2?(i.push(g),!1):!0).sort((g,E)=>g.path.length-E.path.length).filter(g=>L.some(E=>(0,R.isParent)(g.path,E,!D.isLinux))?!1:(L.push(g.path),!0)).concat(i)}}}),define(Q[165],J([0,1,89,2,23,110,114,10,8]),function(j,e,w,R,D,b,P,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends R.Disposable{constructor(g,E,p,h){super();this.path=g,this.onDidFilesChange=E,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:E}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(E)try{p=await(0,b.realpath)(p)}catch(h){if(this.onError(h),E.dangling)return}g.isDirectory()?this._register((0,P.watchFolder)(p,(h,m)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,y.join)(this.path,(0,y.basename)(m))})},h=>this.onError(h))):this._register((0,P.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,w.normalizeFileChanges)(E);this.verboseLogging&&p.forEach(h=>{this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(Q[70],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...D){this._entries=new Map;for(let[b,P]of D)this.set(b,P)}set(D,b){const P=this._entries.get(D);return this._entries.set(D,b),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=w}),define(Q[166],J([0,1,19,160,67,5,70,10]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class i extends Error{constructor(h){super("cyclic dependency between services");this.message=h.toString()}}class L{constructor(h=new P.ServiceCollection,m=!1,S){this._activeInstantiations=new Set,this._services=h,this._strict=m,this._parent=S,this._services.set(b.IInstantiationService,this)}createChild(h){return new L(h,this._strict,this)}invokeFunction(h,...m){let S=E.traceInvocation(h),v=!1;try{return h({get:(c,l)=>{if(v)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,S);if(!s&&l!==b.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...m)}finally{v=!0,S.stop()}}createInstance(h,...m){let S,v;return h instanceof D.SyncDescriptor?(S=E.traceCreation(h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(m),S)):(S=E.traceCreation(h),v=this._createInstance(h,m,S)),S.stop(),v}_createInstance(h,m=[],S){let v=b._util.getServiceDependencies(h).sort((l,s)=>l.index-s.index),a=[];for(const l of v){let s=this._getOrCreateServiceInstance(l.id,S);if(!s&&this._strict&&!l.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`);a.push(s)}let c=v.length>0?v[0].index:m.length;if(m.length!==c){console.warn(`[createInstance] First service dependency of ${h.name} at position ${c+1} conflicts with ${m.length} static arguments`);let l=c-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,c)}return new h(...[...m,...a])}_setServiceInstance(h,m){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,m);else if(this._parent)this._parent._setServiceInstance(h,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let m=this._services.get(h);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):m}_getOrCreateServiceInstance(h,m){let S=this._getServiceInstanceOrDescriptor(h);return S instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,S,m.branch(h,!0)):(m.branch(h,!1),S)}_safeCreateAndCacheServiceInstance(h,m,S){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,m,S)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,m,S){const v=new R.Graph(l=>l.id.toString());let a=0;const c=[{id:h,desc:m,_trace:S}];for(;c.length;){const l=c.pop();if(v.lookupOrInsertNode(l),a++>1e3)throw new i(v);for(let s of b._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${h} depends on ${s.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:s.id,desc:t,_trace:l._trace.branch(s.id,!0)};v.insertEdge(l,r),c.push(r)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new i(v);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,m,S=[],v,a){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(m,S,v,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,m,S,v,a);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(h,m=[],S,v){if(S){const a=new n.IdleValue(()=>this._createInstance(h,m,v));return new Proxy(Object.create(null),{get(c,l){if(l in c)return c[l];let s=a.value,t=s[l];return typeof t!="function"||(t=t.bind(s),c[l]=t),t},set(c,l,s){return a.value[l]=s,!0}})}else return this._createInstance(h,m,v)}}e.InstantiationService=L;var g;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(g||(g={}));class E{constructor(h,m){this.type=h,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return y?new E(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(h){return y?new E(0,h.name):E._None}branch(h,m){let S=new E(2,h.toString());return this._dep.push([h,m,S]),S}stop(){let h=Date.now()-this._start;E._totals+=h;let m=!1;function S(a,c){let l=[],s=new Array(a+1).join("	");for(const[t,r,o]of c._dep)if(r&&o){m=!0,l.push(`${s}CREATES -> ${t}`);let u=S(a+1,o);u&&l.push(u)}else l.push(`${s}uses -> ${t}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(h>2||m)&&console.log(v.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Q[167],J([0,1,19,125,56]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends D.ResolvedKeybinding{constructor(n,y){super();if(y.length===0)throw(0,w.illegalArgument)("parts");this._os=n,this._parts=y}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=b}),define(Q[168],J([0,1,56,167]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends R.BaseResolvedKeybinding{constructor(P,n){super(n,P.parts)}_keyCodeToUILabel(P){if(this._os===2)switch(P){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(P)}_getLabel(P){return P.isDuplicateModifierCase()?"":this._keyCodeToUILabel(P.keyCode)}_getAriaLabel(P){return P.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(P.keyCode)}_keyCodeToElectronAccelerator(P){if(P>=93&&P<=108)return null;switch(P){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return w.KeyCodeUtils.toString(P)}_getElectronAccelerator(P){return P.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(P.keyCode)}_getUserSettingsLabel(P){if(P.isDuplicateModifierCase())return"";const n=w.KeyCodeUtils.toUserSettingsUS(P.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(P){return D.getDispatchStr(P)}static getDispatchStr(P){if(P.isModifierKey())return null;let n="";return P.ctrlKey&&(n+="ctrl+"),P.shiftKey&&(n+="shift+"),P.altKey&&(n+="alt+"),P.metaKey&&(n+="meta+"),n+=w.KeyCodeUtils.toString(P.keyCode),n}_getSingleModifierDispatchPart(P){return P.keyCode===5&&!P.shiftKey&&!P.altKey&&!P.metaKey?"ctrl":P.keyCode===4&&!P.ctrlKey&&!P.altKey&&!P.metaKey?"shift":P.keyCode===6&&!P.ctrlKey&&!P.shiftKey&&!P.metaKey?"alt":P.keyCode===57&&!P.ctrlKey&&!P.shiftKey&&!P.altKey?"meta":null}}e.USLayoutResolvedKeybinding=D}),define(Q[169],J([0,1,10]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(D,b){if(D.length===0)return Promise.resolve(!1);const P=[];let n=!1;for(let y of D){if(y===!0)return Promise.resolve(!0);(0,w.isThenable)(y)&&P.push(y.then(i=>{i&&(n=!0)},i=>{b(i),n=!0}))}return w.Promises.settled(P).then(()=>n)}e.handleVetos=R}),define(Q[6],J([0,1,5,2,3,4,66]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function n(){return new Date().toISOString()}var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class i extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class L extends i{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(y.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let r=0;r<s.length;r++){let o=s[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}t+=(r>0?" ":"")+o}return t}}e.AbstractMessageLogger=L;class g extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!D.isWindows}trace(s,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}debug(s,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}info(s,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}warn(s,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,s,...t):console.warn(`[main ${n()}]`,s,...t))}error(s,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}critical(s,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class E extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends i{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,P.toErrorMessage)(s,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class h extends i{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=h;class m extends R.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=m;class S{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(s){}getLevel(){return y.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=S;function v(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const s=a(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function a(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function c(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c});var x=this&&this.__param||function(j,e){return function(w,R){e(w,R,j)}};define(Q[170],J([0,1,4,2,9,7,47,11,6,36,3,15]),function(j,e,w,R,D,b,P,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileProtocolHandler=void 0;let E=class extends R.Disposable{constructor(h,m){super();this.logService=m,this.validRoots=i.TernarySearchTree.forUris(()=>!L.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]);const{defaultSession:S}=n.session;this.validRoots.set(b.URI.file(h.appRoot),!0),this.validRoots.set(b.URI.file(h.extensionsPath),!0),this.validRoots.set(h.globalStorageHome,!0),this.validRoots.set(h.workspaceStorageHome,!0),S.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(v,a)=>this.handleResourceRequest(v,a)),S.protocol.interceptFileProtocol(D.Schemas.file,(v,a)=>this.handleFileRequest(v,a)),this._register((0,R.toDisposable)(()=>{S.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),S.protocol.uninterceptProtocol(D.Schemas.file)}))}injectWindowsMainService(h){this._register(h.onDidSignalReadyWindow(m=>{var S,v;if(((S=m.config)===null||S===void 0?void 0:S.extensionDevelopmentPath)||((v=m.config)===null||v===void 0?void 0:v.extensionTestsPath)){const a=new R.DisposableStore;if(a.add(w.Event.any(m.onDidClose,m.onDidDestroy)(()=>a.dispose())),m.config.extensionDevelopmentPath)for(const c of m.config.extensionDevelopmentPath)a.add(this.addValidRoot(b.URI.file(c)));m.config.extensionTestsPath&&a.add(this.addValidRoot(b.URI.file(m.config.extensionTestsPath)))}}))}addValidRoot(h){return this.validRoots.get(h)?R.Disposable.None:(this.validRoots.set(h,!0),(0,R.toDisposable)(()=>this.validRoots.delete(h)))}async handleFileRequest(h,m){const S=b.URI.parse(h.url);return L.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${h.url})`),m({error:-3})):this.validRoots.findSubstr(S)?m({path:S.fsPath}):this.validExtensions.has((0,g.extname)(S))?m({path:S.fsPath}):(this.logService.error(`${D.Schemas.file}: Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${h.url})`),m({error:-3}))}async handleResourceRequest(h,m){const S=b.URI.parse(h.url),v=D.FileAccess.asFileUri(S);return this.validRoots.findSubstr(v)?m({path:v.fsPath}):this.validExtensions.has((0,g.extname)(v))?m({path:v.fsPath}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),m({error:-3}))}};E=le([x(0,P.INativeEnvironmentService),x(1,y.ILogService)],E),e.FileProtocolHandler=E}),define(Q[171],J([0,1,135,172,2,16,4,15,36,34,6,21,57,10,25,9,88,63]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends D.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s});const t=new D.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,D.dispose)(t)})}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){s.push(t)}}),!this.provider.has(l)&&await p.Promises.settled(s)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,s){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return v.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,n.isAbsolutePath)(l))throw new b.FileOperationError((0,w.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,w.localize)(1,null,l.toString()),t}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s)||(0,b.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,b.hasOpenReadWriteCloseCapability)(s)||(0,b.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(t){throw(0,b.toFileSystemProviderErrorCode)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,w.localize)(2,null,this.resourceForError(l)),1):(0,b.ensureFileSystemProviderError)(t)}}async doResolveFile(l,s){const t=await this.withProvider(l),r=this.isPathCaseSensitive(t),o=s==null?void 0:s.resolveTo,u=s==null?void 0:s.resolveSingleChildDescendants,d=s==null?void 0:s.resolveMetadata,f=await t.stat(l);let I;return this.toFileStat(t,l,f,void 0,!!d,(A,F)=>(I||(I=y.TernarySearchTree.forUris(()=>!r),I.set(l,!0),(0,i.isNonEmptyArray)(o)&&o.forEach(C=>I.set(C,!0))),Boolean(I.findSuperstr(A.resource)||I.get(A.resource))?!0:A.isDirectory&&u?F===1:!1))}async toFileStat(l,s,t,r,o,u){const{providerExtUri:d}=this.getExtUri(l),f={resource:s,name:d.basename(s),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,b.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&u(f,r)){try{const I=await l.readdir(s),A=await p.Promises.settled(I.map(async([F,C])=>{try{const H=d.joinPath(s,F),X=o?await l.stat(H):{type:C};return await this.toFileStat(l,H,X,I.length,o,u)}catch(H){return this.logService.trace(H),null}}));f.children=(0,i.coalesce)(A)}catch(I){this.logService.trace(I),f.children=[]}return f}return f}async resolveAll(l){return p.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch(t){return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(t){return t}return!0}async doValidateCreateFile(l,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(l))throw new b.FileOperationError((0,w.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const r=await this.writeFile(l,s);return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,r)),r}async writeFile(l,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:o}=this.getExtUri(r);try{await this.validateWriteFile(r,l,t)||await this.mkdirp(r,o.dirname(l));let d;if((0,b.hasReadWriteCapability)(r)&&!(s instanceof g.VSBuffer))if((0,E.isReadableStream)(s)){const f=await(0,E.peekStream)(s,3);f.ended?d=g.VSBuffer.concat(f.buffer):d=f}else d=(0,E.peekReadable)(s,f=>g.VSBuffer.concat(f),3);else d=s;!(0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)&&d instanceof g.VSBuffer?await this.doWriteUnbuffered(r,l,t,d):await this.doWriteBuffered(r,l,t,d instanceof g.VSBuffer?(0,g.bufferToReadable)(d):d)}catch(u){throw new b.FileOperationError((0,w.localize)(4,null,this.resourceForError(l),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,w.localize)(5,null,this.resourceForError(s)));let o;try{o=await l.stat(s)}catch(u){return}if((o.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,w.localize)(6,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,b.etag)({mtime:t.mtime,size:o.size}))throw new b.FileOperationError((0,w.localize)(7,null),3,t);return o}async readFile(l,s){const t=await this.withReadProvider(l);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,l,s):this.doReadFile(t,l,s)}async doReadFileAtomic(l,s,t){return new Promise((r,o)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(l,s,t);r(u)}catch(u){o(u)}})})}async doReadFile(l,s,t){const r=await this.doReadFileStream(l,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,g.streamToBuffer)(r.value)})}async readFileStream(l,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,s)}async doReadFileStream(l,s,t){const r=new h.CancellationTokenSource,o=this.validateReadFile(s,t).then(d=>d,d=>{throw r.cancel(),d});let u;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await o,!((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasFileReadStreamCapability)(l))||(0,b.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(l,s,t):(0,b.hasFileReadStreamCapability)(l)?u=this.readFileStreamed(l,s,r.token,t):u=this.readFileBuffered(l,s,r.token,t);const d=await o;return Object.assign(Object.assign({},d),{value:u})}catch(d){throw u&&await(0,E.consumeStream)(u),new b.FileOperationError((0,w.localize)(8,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(d).toString()),(0,b.toFileOperationResult)(d),t)}}readFileStreamed(l,s,t,r=Object.create(null)){const o=l.readFileStream(s,r,t);return(0,E.transform)(o,{data:u=>u instanceof g.VSBuffer?u:g.VSBuffer.wrap(u),error:u=>new b.FileOperationError((0,w.localize)(9,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),r)},u=>g.VSBuffer.concat(u))}readFileBuffered(l,s,t,r=Object.create(null)){const o=(0,g.newWriteableBufferStream)();return(0,S.readFileIntoStream)(l,s,o,u=>u,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new b.FileOperationError((0,w.localize)(10,null,this.resourceForError(s),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),r)}),t),o}readFileUnbuffered(l,s,t){const r=(0,E.newWriteableStream)(o=>g.VSBuffer.concat(o));return(async()=>{try{let o=await l.readFile(s);t&&typeof t.position=="number"&&(o=o.slice(t.position)),t&&typeof t.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(s,o.byteLength,t),r.end(g.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async validateReadFile(l,s){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError((0,w.localize)(11,null,this.resourceForError(l)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==b.ETAG_DISABLED&&s.etag===t.etag)throw new b.FileOperationError((0,w.localize)(12,null),2,s);return this.validateReadFileLimits(l,t.size,s),t}validateReadFileLimits(l,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError((0,w.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,s,t){return this.doCanMoveCopy(l,s,"move",t)}async canCopy(l,s,t){return this.doCanMoveCopy(l,s,"copy",t)}async doCanMoveCopy(l,s,t,r){if(l.toString()!==s.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(o,l,u,s,t,r)}catch(o){return o}return!0}async move(l,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(r,l,o,s,"move",!!t),d=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,u==="move"?2:3,d)),d}async copy(l,s,t){const r=await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(r,l,o,s,"copy",!!t),d=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,u==="copy"?3:2,d)),d}async doMoveCopy(l,s,t,r,o,u){if(s.toString()===r.toString())return o;const{exists:d,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,s,t,r,o,u);if(d&&!f&&u&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),o==="copy"){if(l===t&&(0,b.hasFileFolderCopyCapability)(l))await l.copy(s,r,{overwrite:u});else{const I=await this.resolve(s);I.isDirectory?await this.doCopyFolder(l,I,t,r):await this.doCopyFile(l,s,t,r)}return o}else return l===t?(await l.rename(s,r,{overwrite:u}),o):(await this.doMoveCopy(l,s,t,r,"copy",u),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,t,r){if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,s,t,r);if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,s,t,r);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,s,t,r);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,s,t,r)}async doCopyFolder(l,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await p.Promises.settled(s.children.map(async o=>{const u=this.getExtUri(t).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(l,await this.resolve(o.resource),t,u):this.doCopyFile(l,o.resource,t,u)}))}async doValidateMoveCopy(l,s,t,r,o,u){let d=!1;if(l===t){const{providerExtUri:I,isPathCaseSensitive:A}=this.getExtUri(l);if(A||(d=I.isEqual(s,r)),d&&o==="copy")throw new Error((0,w.localize)(14,null,this.resourceForError(s),this.resourceForError(r)));if(!d&&I.isEqualOrParent(r,s))throw new Error((0,w.localize)(15,null,this.resourceForError(s),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!d){if(!u)throw new b.FileOperationError((0,w.localize)(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(l===t){const{providerExtUri:I}=this.getExtUri(l);if(I.isEqualOrParent(s,r))throw new Error((0,w.localize)(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:d}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(l,0,t)),t}async mkdirp(l,s){const t=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(s,r.dirname(s));)try{if(((await l.stat(s)).type&b.FileType.Directory)==0)throw new Error((0,w.localize)(18,null,this.resourceForError(s)));break}catch(o){if((0,b.toFileSystemProviderErrorCode)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(r.basename(s)),s=r.dirname(s)}for(let o=t.length-1;o>=0;o--){s=r.joinPath(s,t[o]);try{await l.mkdir(s)}catch(u){if((0,b.toFileSystemProviderErrorCode)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(t){return t}return!0}async doValidateDelete(l,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,w.localize)(19,null,this.resourceForError(l)));const o=await this.exists(l);if(!o)throw new b.FileOperationError((0,w.localize)(20,null,this.resourceForError(l)),1);if(!!!(s==null?void 0:s.recursive)&&o){const d=await this.resolve(l);if(d.isDirectory&&Array.isArray(d.children)&&d.children.length>0)throw new Error((0,w.localize)(21,null,this.resourceForError(l)))}return t}async del(l,s){const t=await this.doValidateDelete(l,s),r=!!(s==null?void 0:s.useTrash),o=!!(s==null?void 0:s.recursive);await t.delete(l,{recursive:o,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(l,1))}watch(l,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(l,s).then(o=>{t?(0,D.dispose)(o):r=()=>(0,D.dispose)(o)},o=>this.logService.error(o)),(0,D.toDisposable)(()=>r())}async doWatch(l,s){const t=await this.withProvider(l),r=this.toWatchKey(t,l,s),o=this.activeWatchers.get(r)||{count:0,disposable:t.watch(l,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,o),o.count+=1,(0,D.toDisposable)(()=>{o.count--,o.count===0&&((0,D.dispose)(o.disposable),this.activeWatchers.delete(r))})}toWatchKey(l,s,t){const{providerExtUri:r}=this.getExtUri(l);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,D.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{var o;const u=await l.open(s,{create:!0,unlock:(o=t==null?void 0:t.unlock)!==null&&o!==void 0?o:!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,u,r):await this.doWriteReadableBufferedQueued(l,u,r)}catch(d){throw(0,b.ensureFileSystemProviderError)(d)}finally{await l.close(u)}})}async doWriteStreamBufferedQueued(l,s,t){let r=0,o;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,s,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise(async(u,d)=>{(0,E.listenStream)(o,{onData:async f=>{o.pause();try{await this.doWriteBuffer(l,s,f,f.byteLength,r,0)}catch(I){return d(I)}r+=f.byteLength,setTimeout(()=>o.resume())},onError:f=>d(f),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(l,s,t){let r=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(l,s,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(l,s,t,r,o,u){let d=0;for(;d<r;)d+=await l.write(s,o+d,t.buffer,u+d,r-d)}async doWriteUnbuffered(l,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,t,r))}async doWriteUnbufferedQueued(l,s,t,r){var o;let u;r instanceof g.VSBuffer?u=r:(0,E.isReadableStream)(r)?u=await(0,g.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?u=await(0,g.bufferedStreamToBuffer)(r):u=(0,g.readableToBuffer)(r),await l.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:(o=t==null?void 0:t.unlock)!==null&&o!==void 0?o:!1})}async doPipeBuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,t,r))}async doPipeBufferedQueued(l,s,t,r){let o,u;try{o=await l.open(s,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const d=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,I=0,A=0;do A=await l.read(o,f,d.buffer,I,d.byteLength-I),await this.doWriteBuffer(t,u,d,A,f,I),f+=A,I+=A,I===d.byteLength&&(I=0);while(A>0)}catch(d){throw(0,b.ensureFileSystemProviderError)(d)}finally{await p.Promises.settled([typeof o=="number"?l.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,t,r))}async doPipeUnbufferedQueued(l,s,t,r){return t.writeFile(r,await l.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,t,r))}async doPipeUnbufferedToBufferedQueued(l,s,t,r){const o=await t.open(r,{create:!0,unlock:!1});try{const u=await l.readFile(s);await this.doWriteBuffer(t,o,g.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,b.ensureFileSystemProviderError)(u)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(l,s,t,r){const o=await(0,g.streamToBuffer)(this.readFileBuffered(l,s,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,o)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new b.FileOperationError((0,w.localize)(22,null,this.resourceForError(s)),6);return l}resourceForError(l){return l.scheme===m.Schemas.file?l.fsPath:l.toString(!0)}};a=le([x(0,L.ILogService)],a),e.FileService=a}),define(Q[173],J([0,1,22,111,2,16,4,3,23,8,15,29,10,6,138,89,157,159,156,165,57,88,34,21]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class o extends D.Disposable{constructor(d,f){var I;super();this.logService=d,this.options=f,this.BUFFER_SIZE=((I=this.options)===null||I===void 0?void 0:I.bufferSize)||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,n.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(d){try{const{stat:f,symbolicLink:I}=await y.SymlinkSupport.stat(this.toFilePath(d));return{type:this.toType(f,I),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(d){try{const f=await(0,y.readdir)(this.toFilePath(d),{withFileTypes:!0}),I=[];return await Promise.all(f.map(async A=>{try{let F;A.isSymbolicLink()?F=(await this.stat((0,L.joinPath)(d,A.name))).type:F=this.toType(A),I.push([A.name,F])}catch(F){this.logService.trace(F)}})),I}catch(f){throw this.toFileSystemProviderError(f)}}toType(d,f){let I;return(f==null?void 0:f.dangling)?I=b.FileType.Unknown:d.isFile()?I=b.FileType.File:d.isDirectory()?I=b.FileType.Directory:I=b.FileType.Unknown,f&&(I|=b.FileType.SymbolicLink),I}async readFile(d){try{const f=this.toFilePath(d);return await w.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(d,f,I){const A=(0,l.newWriteableStream)(F=>r.VSBuffer.concat(F.map(C=>r.VSBuffer.wrap(C))).buffer);return(0,s.readFileIntoStream)(this,d,A,F=>F.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),I),A}async writeFile(d,f,I){let A;try{const F=this.toFilePath(d);if(!I.create||!I.overwrite){if(await(0,y.exists)(F)){if(!I.overwrite)throw(0,b.createFileSystemProviderError)((0,h.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!I.create)throw(0,b.createFileSystemProviderError)((0,h.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(d,{create:!0,unlock:I.unlock}),await this.write(A,0,f,0,f.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(d,F)}finally{typeof A=="number"&&await this.close(A)}}async open(d,f){try{const I=this.toFilePath(d);if((0,b.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:C}=await y.SymlinkSupport.stat(I);C.mode&128||await w.promises.chmod(I,C.mode|128)}catch(C){this.logService.trace(C)}let A;if((0,b.isFileOpenForWriteOptions)(f)){if(n.isWindows)try{await w.promises.truncate(I,0),A="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}A||(A="w")}else A="r";const F=await(0,R.promisify)(w.open)(I,A);return this.mapHandleToPos.set(F,0),(0,b.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(F,d),F}catch(I){throw(0,b.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(d,I):this.toFileSystemProviderError(I)}}async close(d){try{if(this.mapHandleToPos.delete(d),this.writeHandles.delete(d)&&this.canFlush)try{await(0,R.promisify)(w.fdatasync)(d)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,R.promisify)(w.close)(d)}catch(f){throw this.toFileSystemProviderError(f)}}async read(d,f,I,A,F){const C=this.normalizePos(d,f);let H=null;try{const X=await(0,R.promisify)(w.read)(d,I,A,F,C);return typeof X=="number"?H=X:H=X.bytesRead,H}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(d,C,H)}}normalizePos(d,f){return f===this.mapHandleToPos.get(d)?null:f}updatePos(d,f,I){const A=this.mapHandleToPos.get(d);typeof A=="number"&&(typeof f=="number"||(typeof I=="number"?this.mapHandleToPos.set(d,A+I):this.mapHandleToPos.delete(d)))}async write(d,f,I,A,F){return(0,E.retry)(()=>this.doWrite(d,f,I,A,F),100,3)}async doWrite(d,f,I,A,F){const C=this.normalizePos(d,f);let H=null;try{const X=await(0,R.promisify)(w.write)(d,I,A,F,C);return typeof X=="number"?H=X:H=X.bytesWritten,H}catch(X){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(d),X)}finally{this.updatePos(d,C,H)}}async mkdir(d){try{await w.promises.mkdir(this.toFilePath(d))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(d,f){try{const I=this.toFilePath(d);await this.doDelete(I,f)}catch(I){throw this.toFileSystemProviderError(I)}}async doDelete(d,f){f.recursive?await(0,y.rimraf)(d,y.RimRafMode.MOVE):await w.promises.unlink(d)}async rename(d,f,I){const A=this.toFilePath(d),F=this.toFilePath(f);if(A!==F)try{await this.validateTargetDeleted(d,f,"move",I.overwrite),await(0,y.move)(A,F)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,h.localize)(2,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(F)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(d,f,I){const A=this.toFilePath(d),F=this.toFilePath(f);if(A!==F)try{await this.validateTargetDeleted(d,f,"copy",I.overwrite),await(0,y.copy)(A,F,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,h.localize)(3,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(F)),C.toString()))),this.toFileSystemProviderError(C)}}async validateTargetDeleted(d,f,I,A){const F=this.toFilePath(d),C=this.toFilePath(f);let H=!1;if(!!(this.capabilities&1024)||(H=(0,g.isEqual)(F,C,!0)),H&&I==="copy")throw(0,b.createFileSystemProviderError)((0,h.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!H&&await(0,y.exists)(C)){if(!A)throw(0,b.createFileSystemProviderError)((0,h.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(d,f){return f.recursive?this.watchRecursive(d,f.excludes):this.watchNonRecursive(d)}watchRecursive(d,f){const I={path:this.toFilePath(d),excludes:f},A=(0,t.insert)(this.recursiveFoldersToWatch,I);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var d,f,I;if(this.recursiveWatcher instanceof a.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,F;((f=(d=this.options)===null||d===void 0?void 0:d.watcher)===null||f===void 0?void 0:f.usePolling)?(A=S.FileWatcher,F=(I=this.options)===null||I===void 0?void 0:I.watcher):this.recursiveFoldersToWatch.length===1?n.isWindows?A=v.FileWatcher:A=S.FileWatcher:A=a.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,C=>this._onDidChangeFile.fire((0,m.toFileChanges)(C)),C=>{C.type==="error"&&this._onDidWatchErrorOccur.fire(C.message),this.logService[C.type](C.message)},this.logService.getLevel()===p.LogLevel.Trace,F),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(d){const f=new c.FileWatcher(this.toFilePath(d),A=>this._onDidChangeFile.fire((0,m.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===p.LogLevel.Trace),I=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,D.combinedDisposable)(f,I)}toFilePath(d){return(0,i.normalize)(d.fsPath)}toFileSystemProviderError(d){if(d instanceof b.FileSystemProviderError)return d;let f;switch(d.code){case"ENOENT":f=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=b.FileSystemProviderErrorCode.NoPermissions;break;default:f=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(d,f)}async toFileSystemProviderWriteError(d,f){let I=this.toFileSystemProviderError(f);if(d&&I.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:A}=await y.SymlinkSupport.stat(this.toFilePath(d));A.mode&128||(I=(0,b.createFileSystemProviderError)(f,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(A){this.logService.trace(A)}return I}dispose(){super.dispose(),(0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,D.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=o}),define(Q[90],J([0,1,6]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(b,P){switch(P){case w.LogLevel.Trace:return b.trace;case w.LogLevel.Debug:return b.debug;case w.LogLevel.Info:return b.info;case w.LogLevel.Warning:return b.warn;case w.LogLevel.Error:return b.error;case w.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class D extends w.AbstractLogger{constructor(P=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(P){this._logger=P;for(const{level:n,args:y}of this.buffer)R(P,n).apply(P,y);this.buffer=[]}_log(P,...n){this._logger?R(this._logger,P).apply(this._logger,n):this.getLevel()<=P&&this.buffer.push({level:P,args:n})}trace(P,...n){this._log(w.LogLevel.Trace,P,...n)}debug(P,...n){this._log(w.LogLevel.Debug,P,...n)}info(P,...n){this._log(w.LogLevel.Info,P,...n)}warn(P,...n){this._log(w.LogLevel.Warning,P,...n)}error(P,...n){this._log(w.LogLevel.Error,P,...n)}critical(P,...n){this._log(w.LogLevel.Critical,P,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Q[174],J([0,1,6,16,10,21,15,2,5,90]),function(j,e,w,R,D,b,P,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const L=5*R.ByteSize.MB;let g=class extends w.AbstractLogger{constructor(h,m,S,v){super();this.name=h,this.resource=m,this.fileService=v,this.backupIndex=1,this.setLevel(S),this.queue=this._register(new D.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=w.LogLevel.Trace&&this._log(w.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=w.LogLevel.Debug&&this._log(w.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=w.LogLevel.Info&&this._log(w.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=w.LogLevel.Warning&&this._log(w.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=w.LogLevel.Error){const h=arguments[0];if(h instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=h.stack,this._log(w.LogLevel.Error,this.format(m))}else this._log(w.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=w.LogLevel.Critical&&this._log(w.LogLevel.Critical,this.format(arguments))}flush(){}log(h,m){this._log(h,this.format(m))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(h){if(h.fileOperationResult!==3)throw h}}_log(h,m){this.queue.queue(async()=>{await this.initializePromise;let S=await this.loadContent();S.length>L&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(S)),S=""),S+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(h)}] ${m}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(S))})}getCurrentTimestamp(){const h=v=>v<10?`0${v}`:v,m=v=>v<10?`00${v}`:v<100?`0${v}`:v,S=new Date;return`${S.getFullYear()}-${h(S.getMonth()+1)}-${h(S.getDate())} ${h(S.getHours())}:${h(S.getMinutes())}:${h(S.getSeconds())}.${m(S.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,P.joinPath)((0,P.dirname)(this.resource),`${(0,P.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(h){return""}}stringifyLogLevel(h){switch(h){case w.LogLevel.Critical:return"critical";case w.LogLevel.Debug:return"debug";case w.LogLevel.Error:return"error";case w.LogLevel.Info:return"info";case w.LogLevel.Trace:return"trace";case w.LogLevel.Warning:return"warning"}return""}format(h){let m="";for(let S=0;S<h.length;S++){let v=h[S];if(typeof v=="object")try{v=JSON.stringify(v)}catch(a){}m+=(S>0?" ":"")+v}return m}};g=le([x(3,R.IFileService)],g),e.FileLogger=g;let E=class extends n.Disposable{constructor(h,m,S){super();this.logService=h,this.instantiationService=m,this.fileService=S,this.loggers=new Map,this._register(h.onDidChangeLogLevel(v=>this.loggers.forEach(a=>a.setLevel(v))))}createLogger(h){let m=this.loggers.get(h.toString());return m||(m=new i.BufferLogService(this.logService.getLevel()),this.loggers.set(h.toString(),m),(0,R.whenProviderRegistered)(h,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(g,(0,P.basename)(h),h,this.logService.getLevel()))),m}dispose(){this.loggers.forEach(h=>h.dispose()),this.loggers.clear(),super.dispose()}};E=le([x(0,w.ILogService),x(1,y.IInstantiationService),x(2,R.IFileService)],E),e.FileLoggerService=E}),define(Q[175],J([0,1,6,4,7]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(E){this.service=E,this.onDidChangeLogLevel=R.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(E,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=b;class P{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){P.setLevel(this.channel,E)}static setLevel(E,p){return E.call("setLevel",p)}}e.LogLevelChannelClient=P;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,p){throw new Error(`Event not found: ${p}`)}async call(E,p,h){switch(p){case"createLogger":this.createLogger(D.URI.revive(h[0]),h[1]);return;case"log":return this.log(D.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(E,p){this.loggers.set(E.toString(),this.loggerService.createLogger(E,p))}consoleLog(E,p){let h=console.log;switch(E){case w.LogLevel.Error:h=console.error;break;case w.LogLevel.Warning:h=console.warn;break;case w.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(E,p){const h=this.loggers.get(E.toString());if(!h)throw new Error("Create the logger before logging");for(const[m,S]of p)switch(m){case w.LogLevel.Trace:h.trace(S);break;case w.LogLevel.Debug:h.debug(S);break;case w.LogLevel.Info:h.info(S);break;case w.LogLevel.Warning:h.warn(S);break;case w.LogLevel.Error:h.error(S);break;case w.LogLevel.Critical:h.critical(S);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class y{constructor(E){this.channel=E}createConsoleMainLogger(){return new w.AdapterLogger({log:(E,p)=>{this.channel.call("consoleLog",[E,p])}})}createLogger(E,p){return new i(this.channel,E,p)}}e.LoggerChannelClient=y;class i extends w.AbstractMessageLogger{constructor(E,p,h){super(h==null?void 0:h.always);this.channel=E,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[p,h]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(E,p){this._log([[E,p]])}_log(E){this.isLoggerCreated?this.channel.call("log",[this.file,E]):this.buffer.push(...E)}}class L extends w.LogService{constructor(E,p){super(p);this.parent=E,this._register(E.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=L}),define(Q[91],J([0,1,6,16]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(y,i,L,g){try{const E=await new Promise((p,h)=>{j(["spdlog"],p,h)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(y,i,L,g)}catch(E){console.error(E)}return null}function b(y,i,L,g){return j.__$__nodeRequire("spdlog").createRotatingLogger(y,i,L,g)}e.createRotatingLogger=b;function P(y,i,L){switch(i){case w.LogLevel.Trace:y.trace(L);break;case w.LogLevel.Debug:y.debug(L);break;case w.LogLevel.Info:y.info(L);break;case w.LogLevel.Warning:y.warn(L);break;case w.LogLevel.Error:y.error(L);break;case w.LogLevel.Critical:y.critical(L);break;default:throw new Error("Invalid log level")}}class n extends w.AbstractMessageLogger{constructor(i,L,g,E){super();this.name=i,this.filepath=L,this.rotating=g,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const i=this.rotating?6:1,L=30/i*R.ByteSize.MB;return D(this.name,this.filepath,L,i).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:E,message:p}of this.buffer)P(this._logger,E,p);this.buffer=[]}})}log(i,L){this._logger?P(this._logger,i,L):this.getLevel()<=i&&this.buffer.push({level:i,message:L})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Q[176],J([0,1,6,2,15,9,174,91,16,30]),function(j,e,w,R,D,b,P,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let L=class extends R.Disposable{constructor(E,p){super();this.logService=E,this.fileService=p,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(E.onDidChangeLogLevel(h=>this.logLevelChangeableLoggers.forEach(m=>m.setLevel(h))))}createLogger(E,p){var h;let m=this.loggers.get(E.toString());return m||(E.scheme===b.Schemas.file?(m=new n.SpdLogLogger((p==null?void 0:p.name)||(0,i.generateUuid)(),E.fsPath,!(p==null?void 0:p.donotRotate),this.logService.getLevel()),(p==null?void 0:p.donotUseFormatters)&&m.clearFormatters()):m=new P.FileLogger((h=p==null?void 0:p.name)!==null&&h!==void 0?h:(0,D.basename)(E),E,this.logService.getLevel(),this.fileService),this.loggers.set(E.toString(),m),(p==null?void 0:p.always)?m.setLevel(w.LogLevel.Trace):this.logLevelChangeableLoggers.push(m)),m}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(E=>E.dispose()),this.loggers.clear(),super.dispose()}};L=le([x(0,w.ILogService),x(1,y.IFileService)],L),e.LoggerService=L}),define(Q[177],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function R(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function b(P){return!w(P)&&!R(P)&&!D(P)}e.isMenubarMenuItemAction=b}),define(Q[92],J([0,1,9,3,35,15]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(R.isWeb||typeof j=="undefined"||typeof j.__$__nodeRequire!="function")P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.55.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const n=(0,b.dirname)(w.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,b.joinPath)(n,"product.json").fsPath);const y=j.__$__nodeRequire((0,b.joinPath)(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:y.version})}e.default=P}),define(Q[17],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService")}),define(Q[178],J([0,1,58,6,17]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(n,y){this.productService=n,this.logService=y,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,y){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(y);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",y),!1;const[,L,g]=i;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const p=Buffer.from(decodeURIComponent(g),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",y),!1;const h=p.slice(0,6),m=p.readUIntBE(0,6),S=Date.now()-m;if(S<0||S>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",y),!1;const v=p.slice(6),a=w.createVerify("SHA256");a.write(h),a.write(Buffer.from(L)),a.end();for(let c=0;c<E.length;c++){let l=E[c];if(l!==null){if(typeof l=="string")try{l=w.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),E[c]=l}catch(s){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${n}:`,s),E[c]=null;continue}if(a.verify(l,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",y),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",y),!1}};b=le([x(0,D.IProductService),x(1,R.ILogService)],b),e.ExtensionUrlTrustService=b}),define(Q[37],J([0,1,13,99]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,n){R.ok(w.isString(P)),R.ok(w.isObject(n)),R.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,n)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Q[179],J([0,1,37,4]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class b{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,i){this.schemasById[D(y)]=i,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new b;w.Registry.add(e.Extensions.JSONContribution,P)}),define(Q[48],J([0,1,129,4,37,13,179]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=D.Registry.as(P.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,a=!0){this.registerConfigurations([v],a)}registerConfigurations(v,a=!0){const c=[];v.forEach(l=>{c.push(...this.validateAndRegisterProperties(l,a)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(v){const a=[],c=l=>{if(l.properties)for(const s in l.properties)a.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,l.properties[s]);l.allOf&&l.allOf.forEach(s=>c(s))};for(const l of v){c(l);const s=this.configurationContributors.indexOf(l);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(v){const a=[],c=[];for(const l of v)for(const s in l)if(a.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),l[s]);const t={type:"object",default:this.defaultValues[s],description:w.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(g(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=l[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(v){const a=[];for(const c of v)for(const l in c)if(a.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const a of v)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(v,a=!0,c=3){c=b.isUndefinedOrNull(v.scope)?c:v.scope;let l=[],s=v.properties;if(s)for(let r in s){if(a&&h(r)){delete s[r];continue}const o=s[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:o.scope=b.isUndefinedOrNull(o.scope)?c:o.scope,s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),l.push(r)}let t=v.allOf;if(t)for(let r of t)l.push(...this.validateAndRegisterProperties(r,a,c));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const a=c=>{let l=c.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let s=c.allOf;s&&s.forEach(a)};a(v)}updateSchema(v,a){switch(e.allSettings.properties[v]=a,a.scope){case 1:e.applicationSettings.properties[v]=a;break;case 2:e.machineSettings.properties[v]=a;break;case 6:e.machineOverridableSettings.properties[v]=a;break;case 3:e.windowSettings.properties[v]=a;break;case 4:e.resourceSettings.properties[v]=a;break;case 5:e.resourceSettings.properties[v]=a,this.resourceLanguageSettingsSchema.properties[v]=a;break}}removeFromSchema(v,a){switch(delete e.allSettings.properties[v],a.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const a=`[${v}]`,c={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,c),e.allSettings.properties[a]=c,e.applicationSettings.properties[a]=c,e.machineSettings.properties[a]=c,e.machineOverridableSettings.properties[a]=c,e.windowSettings.properties[a]=c,e.resourceSettings.properties[a]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,a){let c=this.defaultValues[v];b.isUndefined(c)&&(c=a.default),b.isUndefined(c)&&(c=E(a.type)),a.default=c}}const L="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(L);function g(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=g;function E(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const p=new i;D.Registry.add(e.Extensions.Configuration,p);function h(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?w.localize(5,null,S):p.getConfigurationProperties()[S]!==void 0?w.localize(6,null,S):null:w.localize(4,null)}e.validateProperty=h;function m(){const S=[],v=p.getConfigurationProperties();for(const a of Object.keys(v))S.push([a,v[a].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=m}),define(Q[24],J([0,1,45,13,7,37,5,48]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=y;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function L(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=L;function g(r,o){const u=o?r?o.keys.filter(H=>r.keys.indexOf(H)===-1):[...o.keys]:[],d=r?o?r.keys.filter(H=>o.keys.indexOf(H)===-1):[...r.keys]:[],f=[];if(o&&r){for(const H of r.keys)if(o.keys.indexOf(H)!==-1){const X=v(r.contents,H),ne=v(o.contents,H);w.equals(X,ne)||f.push(H)}}const I=[],A=H=>{const X={};for(const ne of H)for(const oe of ne.identifiers)X[s(oe)]=ne;return X},F=o?A(o.overrides):{},C=r?A(r.overrides):{};if(Object.keys(F).length)for(const H of u){const X=F[H];X&&I.push([(0,n.overrideIdentifierFromKey)(H),X.keys])}if(Object.keys(C).length)for(const H of d){const X=C[H];X&&I.push([(0,n.overrideIdentifierFromKey)(H),X.keys])}if(Object.keys(F).length&&Object.keys(C).length)for(const H of f){const X=C[H],ne=F[H];if(X&&ne){const oe=g({contents:X.contents,keys:X.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});I.push([(0,n.overrideIdentifierFromKey)(H),[...oe.added,...oe.removed,...oe.updated]])}}return{added:u,removed:d,updated:f,overrides:I}}e.compare=g;function E(r,o){const u=[];for(const d of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(d)){const f={};for(const I in r[d])f[I]=r[d][I];u.push({identifiers:[(0,n.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(f),contents:p(f,o)})}return u}e.toOverrides=E;function p(r,o){const u=Object.create(null);for(let d in r)h(u,d,r[d],o);return u}e.toValuesTree=p;function h(r,o,u,d){const f=o.split("."),I=f.pop();let A=r;for(let F=0;F<f.length;F++){let C=f[F],H=A[C];switch(typeof H){case"undefined":H=A[C]=Object.create(null);break;case"object":break;default:d(`Ignoring ${o} as ${f.slice(0,F+1).join(".")} is ${JSON.stringify(H)}`);return}A=H}if(typeof A=="object"&&A!==null)try{A[I]=u}catch(F){d(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(A)}`)}else d(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=h;function m(r,o){const u=o.split(".");S(r,u)}e.removeFromValueTree=m;function S(r,o){const u=o.shift();if(o.length===0){delete r[u];return}if(Object.keys(r).indexOf(u)!==-1){const d=r[u];typeof d=="object"&&!Array.isArray(d)&&(S(d,o),Object.keys(d).length===0&&delete r[u])}}function v(r,o,u){function d(A,F){let C=A;for(const H of F){if(typeof C!="object"||C===null)return;C=C[H]}return C}const f=o.split("."),I=d(r,f);return typeof I=="undefined"?u:I}e.getConfigurationValue=v;function a(r,o,u){Object.keys(o).forEach(d=>{d!=="__proto__"&&(d in r?R.isObject(r[d])&&R.isObject(o[d])?a(r[d],o[d],u):u&&(r[d]=o[d]):r[d]=o[d])})}e.merge=a;function c(){const r=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function l(){const r=Object.create(null),o=b.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let u in o){let d=o[u].default;h(r,u,d,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=l;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,o,u){const d=r.inspect(o),f=r.inspect(u);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:d.defaultValue}e.getMigratedSettingValue=t}),define(Q[180],J([0,1,44,36,34,13,45,7,48,24,37,2,4]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const u of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let d=this.contents[u],f=r[u];f&&(typeof d=="object"&&typeof f=="object"?(d=P.deepClone(d),this.mergeContents(d,f)):d=f),o[u]=d}return new p(o,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),o=P.deepClone(this.overrides),u=[...this.keys];for(const d of t){this.mergeContents(r,d.contents);for(const f of d.overrides){const[I]=o.filter(A=>D.equals(A.identifiers,f.identifiers));I?this.mergeContents(I.contents,f.contents):o.push(P.deepClone(f))}for(const f of d.keys)u.indexOf(f)===-1&&u.push(f)}return new p(r,u,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&b.isObject(t[o])&&b.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=P.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),o=[];for(const u of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(u)&&o.push({identifiers:[(0,y.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,i.toValuesTree)(t[u],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,r,o)}}e.DefaultConfigurationModel=h;class m{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get errors(){return this._parseErrors}parseContent(t){if(!b.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new p(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},o=null,u=[],d=[],f=[];function I(F){Array.isArray(u)?u.push(F):o&&(u[o]=F)}let A={onObjectBegin:()=>{let F={};I(F),d.push(u),u=F,o=null},onObjectProperty:F=>{o=F},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{let F=[];I(F),d.push(u),u=F,o=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:I,onError:(F,C,H)=>{f.push({error:F,offset:C,length:H})}};if(t)try{w.visit(t,A),r=u[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return r}doParseRaw(t){if(this._scopes){const d=L.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,d,!0,this._scopes)}const r=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),o=Object.keys(t),u=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:r,keys:o,overrides:u}}filterByScope(t,r,o,u){const d={};for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&o)d[f]=this.filterByScope(t[f],r,!1,u);else{const I=this.getScope(f,r);(I===void 0||u.indexOf(I)!==-1)&&(d[f]=t[f])}return d}getScope(t,r){const o=r[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=m;class S extends g.Disposable{constructor(t,r,o,u){super();this.userSettingsResource=t,this.scopes=r,this.fileService=u,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new p}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=S;class v{constructor(t,r,o=new p,u=new p,d=new R.ResourceMap,f=new p,I=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=d,this._memoryConfiguration=f,this._memoryConfigurationByResource=I,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let u;o.resource?(u=this._memoryConfigurationByResource.get(o.resource),u||(u=new p,this._memoryConfigurationByResource.set(o.resource,u))):u=this._memoryConfiguration,r===void 0?u.removeValue(t):u.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const u=this.getConsolidateConfigurationModel(r,o),d=this.getFolderConfigurationModelForResource(r.resource,o),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,I=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),F=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),C=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=d?r.overrideIdentifier?d.freeze().override(r.overrideIdentifier).getValue(t):d.freeze().getValue(t):void 0,ne=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),oe=u.getValue(t),V=D.distinct(D.flatten(u.overrides.map(N=>N.identifiers))).filter(N=>u.getOverrideValue(t,N)!==void 0);return{defaultValue:I,userValue:A,userLocalValue:F,userRemoteValue:C,workspaceValue:H,workspaceFolderValue:X,memoryValue:ne,value:oe,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:d==null?void 0:d.freeze().getValue(t),override:r.overrideIdentifier?d==null?void 0:d.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(u=>y.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const d=(0,y.overrideIdentifierFromKey)(u),f=this._defaultConfiguration.getKeysForOverrideIdentifier(d),I=t.getKeysForOverrideIdentifier(d),A=[...I.filter(F=>f.indexOf(F)===-1),...f.filter(F=>I.indexOf(F)===-1),...f.filter(F=>!P.equals(this._defaultConfiguration.override(d).getValue(F),t.override(d).getValue(F)))];return[d,A]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:d}=(0,i.compare)(this.localUserConfiguration,t),f=[...r,...o,...u];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:d}=(0,i.compare)(this.remoteUserConfiguration,t);let f=[...r,...o,...u];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:u,overrides:d}=(0,i.compare)(this.workspaceConfiguration,t);let f=[...r,...o,...u];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:d}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:u,updated:d,removed:f,overrides:I}=(0,i.compare)(o,r);let A=[...u,...d,...f];return(A.length||!o)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:I}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:d,overrides:f}=(0,i.compare)(r,void 0);return{keys:[...o,...u,...d],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const u=r.getFolder(t);u&&(o=this.getFolderConsolidatedConfiguration(u.uri)||o);const d=this._memoryConfigurationByResource.get(t);d&&(o=o.merge(d))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(r=o.merge(u),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:u,keys:d}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:u,keys:d}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),d=t.folders.reduce((f,I)=>(f.set(n.URI.revive(I[0]),this.parseConfigurationModel(I[1])),f),new R.ResourceMap);return new v(r,o,new p,u,d,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const u of s)u.keys.forEach(d=>t.add(d)),u.overrides.forEach(([d,f])=>{const I=(0,R.getOrSet)(r,d,new Set);f.forEach(A=>I.add(A))});const o=[];return r.forEach((u,d)=>o.push([d,[...u.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=a;class c{constructor(t,r,o,u){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=u,this._previousConfiguration=void 0;const d=new Set;t.keys.forEach(I=>d.add(I)),t.overrides.forEach(([,I])=>I.forEach(A=>d.add(A))),this.affectedKeys=[...d.values()];const f=new p;this.affectedKeys.forEach(I=>f.setValue(I,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,d=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(u,d)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,i.toValuesTree)({[r]:!0},()=>{}),u;for(;typeof o=="object"&&(u=Object.keys(o)[0]);){if(t=t[u],!t)return!1;o=o[u]}return!0}}e.ConfigurationChangeEvent=c;class l extends c{constructor(t,r,o,u){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=l}),define(Q[181],J([0,1,37,48,2,24,180,4,10,15]),function(j,e,w,R,D,b,P,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class L extends D.Disposable{constructor(E,p){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,p){const h=typeof E=="string"?E:void 0,m=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,m,void 0)}updateValue(E,p,h,m){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(h,p,1)}onDidDefaultConfigurationChange(E){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,E);this.trigger(h,p,6)}trigger(E,p,h){const m=new P.ConfigurationChangeEvent(E,{data:p},this.configuration);m.source=h,m.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=L}),define(Q[182],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var R;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,n=R.Unknown,y){super(P);this._message=P,this._code=n,this._detail=y,this.isHandled=n===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Q[183],J([0,1,82,30,2,21,4,182,19,10,25]),function(j,e,w,R,D,b,P,n,y,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var E;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function p(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(_){const W=new L.CancellationTokenSource;return setTimeout(()=>W.cancel(),_),W.token}function m(_,W){if(_.isCancellationRequested||W.isCancellationRequested)return L.CancellationToken.Cancelled;const z=new L.CancellationTokenSource;return _.onCancellationRequested(()=>z.cancel()),W.onCancellationRequested(()=>z.cancel()),z.token}class S{constructor(W){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((z,K)=>{this._resolvePromise=z,this._rejectPromise=K}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function v(_,W){const z=new S(W);return z.registerDisposable(_.onControlMessage(K=>{const Y=JSON.parse(K.toString()),Z=$(Y);Z?z.reject(Z):z.resolve(Y)})),z.promise}function a(_,W,z,K,Y,Z){const G=new S(Z);return W.connect(z,K,Y,(ee,re)=>{G.didTimeout?(ee&&_.error(ee),re==null||re.dispose()):ee||!re?G.reject(ee):G.resolve(re)}),G.promise}function c(_,W){const z=new S(W);return _.then(K=>{z.didTimeout||z.resolve(K)},K=>{z.didTimeout||z.reject(K)}),z.promise}async function l(_,W,z,K){const Y=M(_,W);_.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await a(_.logService,_.socketFactory,_.host,_.port,`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,K)}catch(ie){throw _.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),_.logService.error(ie),ie}_.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let G,ee;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(Z,null),G=_.reconnectionProtocol,ee=!1):(G=new w.PersistentProtocol(Z,null),ee=!0),_.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:_.connectionToken||"00000000000000000000"};G.sendControl(b.VSBuffer.fromString(JSON.stringify(re)));try{const ie=await v(G,m(K,h(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}_.logService.trace(`${Y} 4/6. received SignRequest control message.`);const ue=await c(_.signService.sign(ie.data),K),ve={type:"connectionType",commit:_.commit,signedData:ue,desiredConnectionType:W};return z&&(ve.args=z),_.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(b.VSBuffer.fromString(JSON.stringify(ve))),{protocol:G,ownsProtocol:ee}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(_.logService.error(`${Y} the handshake timed out. Error:`),_.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${Y} received error control message when negotiating connection. Error:`),_.logService.error(ie)),ee&&U(G),ie}}async function s(_,W,z,K){const Y=Date.now(),Z=M(_,W),{protocol:G,ownsProtocol:ee}=await l(_,W,z,K),re=new S(K);return re.registerDisposable(G.onControlMessage(ie=>{const ue=JSON.parse(ie.toString()),ve=$(ue);ve?(_.logService.error(`${Z} received error control message when negotiating connection. Error:`),_.logService.error(ve),ee&&U(G),re.reject(ve)):(_.reconnectionProtocol&&_.reconnectionProtocol.endAcceptReconnection(),_.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${O(Y)}!`),re.resolve({protocol:G,firstMessage:ue}))})),re.promise}async function t(_,W){const{protocol:z}=await s(_,1,void 0,W);return{protocol:z}}async function r(_,W,z){const{protocol:K,firstMessage:Y}=await s(_,2,W,z),Z=Y&&Y.debugPort;return{protocol:K,debugPort:Z}}async function o(_,W,z){const K=Date.now(),Y=M(_,3),{protocol:Z}=await l(_,3,W,z);return _.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${O(K)}!`),Z}async function u(_,W,z){const{host:K,port:Y,connectionToken:Z}=await _.addressProvider.getAddress();return{commit:_.commit,host:K,port:Y,connectionToken:Z,reconnectionToken:W,reconnectionProtocol:z,socketFactory:_.socketFactory,signService:_.signService,logService:_.logService}}async function d(_,W,z){try{const K=(0,R.generateUuid)(),Y=await u(_,K,null),{protocol:Z}=await t(Y,L.CancellationToken.None);return new N(_,W,z,K,Z)}catch(K){throw _.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),_.logService.error(K),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=d;async function f(_,W){try{const z=(0,R.generateUuid)(),K=await u(_,z,null),{protocol:Y,debugPort:Z}=await r(K,W,L.CancellationToken.None);return new B(_,W,z,Y,Z)}catch(z){throw _.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),_.logService.error(z),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentExtensionHost=f;async function I(_,W){const z=await u(_,(0,R.generateUuid)(),null);return await o(z,{port:W},L.CancellationToken.None)}e.connectRemoteAgentTunnel=I;function A(_){return(0,i.createCancelablePromise)(W=>new Promise((z,K)=>{const Y=setTimeout(z,_*1e3);W.onCancellationRequested(()=>{clearTimeout(Y),z()})}))}var F;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class C{constructor(W,z){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=C;class H{constructor(W,z,K,Y){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.durationSeconds=K,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class X{constructor(W,z,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=X;class ne{constructor(W,z,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=K,this.type=4}}e.ConnectionGainEvent=ne;class oe{constructor(W,z,K,Y){this.reconnectionToken=W,this.millisSinceLastIncomingData=z,this.attempt=K,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class V extends D.Disposable{constructor(W,z,K,Y){super();this._connectionType=W,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=z,this.reconnectionToken=K,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(()=>this._beginReconnecting())),this._register(Y.onSocketTimeout(()=>this._beginReconnecting())),V._instances.push(this),V._permanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(W,z,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=z,this._permanentFailureHandled=K,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!V._permanentFailure){const W=k(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30],K=Date.now();let Y=-1;do{Y++;const Z=Y<z.length?z[Y]:z[z.length-1];try{if(Z>0){const ee=A(Z);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,ee)),this._options.logService.info(`${W} waiting for ${Z} seconds before reconnecting...`);try{await ee}catch(re){}}if(V._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1)),this._options.logService.info(`${W} resolving connection...`);const G=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(g)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(Date.now()-K>108e5){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,y.isPromiseCanceledError)(G)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,n.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Y+1,!1);break}}while(!V._permanentFailure)}}_gotoPermanentFailure(W,z,K){this._onDidStateChange.fire(new oe(this.reconnectionToken,W,z,K)),U(this.protocol)}}V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class N extends V{constructor(W,z,K,Y,Z){super(1,W,Y,Z);this.client=this._register(new w.Client(Z,{remoteAuthority:z,clientId:K},W.ipcLogger))}async _reconnect(W,z){await t(W,z)}}e.ManagementPersistentConnection=N;class B extends V{constructor(W,z,K,Y,Z){super(2,W,K,Y);this._startArguments=z,this.debugPort=Z}async _reconnect(W,z){await r(W,this._startArguments,z)}}e.ExtensionHostPersistentConnection=B;function U(_){try{_.acceptDisconnect();const W=_.getSocket();_.dispose(),W.dispose()}catch(W){(0,y.onUnexpectedError)(W)}}function $(_){if(_&&_.type==="error"){const W=new Error(`Connection error: ${_.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function T(_,W){for(;_.length<W;)_+=" ";return _}function k(_,W,z){return`[remote-connection][${T(p(_),13)}][${W.substr(0,5)}\u2026][${z?"reconnect":"initial"}]`}function M(_,W){return`${k(W,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.host}:${_.port}]`}function O(_){return`${Date.now()-_} ms`}}),define(Q[71],J([0,1,9]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function R(b){return b.scheme===w.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=R;function D(b){if(!!b){const P=b.indexOf("+");return P<0?b:b.substr(0,P)}}e.getRemoteName=D}),define(Q[54],J([0,1,4,3,5,6]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var P;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!p)return{address:p[1],port:+p[2]}}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=i;function L(E,p){return p?p!==1&&E<1024:!R.isWindows&&E<1024}e.isPortPrivileged=L;let g=class{constructor(p){this.logService=p,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(p,h){return this._tunnelProvider=p,p?(this._canElevate=h.elevation,this._canMakePublic=h.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const h=[],m=Array.from(this._tunnels.values());for(let S of m){const v=Array.from(S.values());for(let a of v){const c=await a.value;c&&h.push(c)}}p(h)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:h}of p.values())await h.then(m=>m==null?void 0:m.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,h,m,S,v=!1,a=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${m} on local port ${S}.`),!!p){h||(h="localhost");const c=this.retainOrCreateTunnel(p,h,m,S,v,a);return c?c.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==h||l.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemotePort} `);const h=this._tunnels.get(p.tunnelRemoteHost);if(h){const m=h.get(p.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,m))}}}}async tryDisposeTunnel(p,h,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${h}.`);const S=m.value.then(async v=>{v&&(await v.dispose(!0),this._onTunnelClosed.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(h),S}}async closeTunnel(p,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h} `);const m=this._tunnels.get(p);if(m&&m.has(h)){const S=m.get(h);S.refcount=0,await this.tryDisposeTunnel(p,h,S)}}addTunnelToMap(p,h,m){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(h,{refcount:1,value:m})}async removeEmptyTunnelFromMap(p,h){const m=this._tunnels.get(p);m&&(await m.get(h)||m.delete(h),m.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,h){let m=[p];y(p)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):i(p)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const S=m.map(v=>this._tunnels.get(v));for(const v of S){const a=v==null?void 0:v.get(h);if(a)return a}}canTunnel(p){return!!n(p)}createWithProvider(p,h,m,S,v,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${m} on local port ${S}.`);const l={elevationRequired:v?L(S===void 0?m:S):!1},s={remoteAddress:{host:h,port:m},localAddressPort:S,public:a},t=p.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(h,m,t),t}};g=le([x(0,b.ILogService)],g),e.AbstractTunnelService=g}),define(Q[40],J([0,1,141,5,48,37,21]),function(j,e,w,R,D,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function y(g){return g.res.statusCode===204}async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return y(g)?null:(await(0,P.streamToBuffer)(g.stream)).toString()}e.asText=i;async function L(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(y(g))return null;const p=(await(0,P.streamToBuffer)(g.stream)).toString();try{return JSON.parse(p)}catch(h){throw h.message+=`:
`+p,h}}e.asJson=L,b.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,w.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,w.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,w.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,w.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,w.localize)(4,null),(0,w.localize)(5,null),(0,w.localize)(6,null)],default:"override",description:(0,w.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,w.localize)(8,null)}}})}),define(Q[184],J([0,1,185,13]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,n){return P.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:P.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function b(P,n,y={}){const i=(0,w.parse)(P),L=y.proxyUrl||D(i,n);if(!L)return null;const g=(0,w.parse)(L);if(!/^https?:$/.test(g.protocol||""))return null;const E={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,R.isBoolean)(y.strictSSL)?y.strictSSL:!0};return i.protocol==="http:"?new(await new Promise((p,h)=>{j(["http-proxy-agent"],p,h)}))(E):new(await new Promise((p,h)=>{j(["https-proxy-agent"],p,h)}))(E)}e.getProxyAgent=b}),define(Q[186],J([0,1,30,21]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(b,P,n){let y=n&&n.get("storage.serviceMachineId",0)||null;if(y)return y;try{const L=(await P.readFile(b.serviceMachineIdResource)).value.toString();y=(0,w.isUUID)(L)?L:null}catch(i){y=null}if(!y){y=(0,w.generateUuid)();try{await P.writeFile(b.serviceMachineIdResource,R.VSBuffer.fromString(y))}catch(i){}}return n&&n.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=D}),define(Q[72],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[187],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{vsda(){return new Promise((D,b)=>j(["vsda"],D,b))}async sign(D){try{const b=await this.vsda(),P=new b.signer;if(P)return P.sign(D)}catch(b){}return D}}e.SignService=w}),define(Q[38],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,w.createDecorator)("stateService")}),define(Q[18],J([0,1,11,6,38,4,5,169,3,2,10,13,35]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var p;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var h;(function(S){S[S.Starting=1]="Starting",S[S.Ready=2]="Ready",S[S.AfterWindowOpen=3]="AfterWindowOpen"})(h=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class et extends i.Disposable{constructor(v,a){super();this.logService=v,this.stateService=a,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(et.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(et.QUIT_FROM_RESTART_MARKER)}registerListeners(){const v=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};w.app.addListener("before-quit",v);const a=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",a),w.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",v),w.app.removeListener("window-all-closed",a),w.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const v=[];return this._onWillShutdown.fire({join(a){v.push(a)}}),this.pendingWillShutdownPromise=L.Promises.settled(v).then(()=>{},a=>this.logService.error(a)),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==v){this.logService.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const a=this.phaseWhen.get(this._phase);a&&(a.open(),this.phaseWhen.delete(this._phase))}}async when(v){if(!(v<=this._phase)){let a=this.phaseWhen.get(v);a||(a=new L.Barrier,this.phaseWhen.set(v,a)),await a.wait()}}registerWindow(v){const a=new i.DisposableStore;this.windowCounter++,a.add(v.onWillLoad(l=>this._onWillLoadWindow.fire({window:v,workspace:l.workspace})));const c=(0,g.assertIsDefined)(v.win);c.on("close",l=>{const s=v.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),l.preventDefault(),this.unload(v,1).then(t=>{if(t){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(v),v.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,a.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(v,a){await this.unload(v,3)||v.reload(a)}async unload(v,a){if(!v.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${v.id}`);const c=this._quitRequested?2:a;let l=await this.onBeforeUnloadWindowInRenderer(v,c);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(v,c),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${v.id})`),await this.onWillUnloadWindowInRenderer(v,c),!1))}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(v,a){return new Promise(c=>{const l=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${l}`,t=`vscode:cancel${l}`;w.ipcMain.once(s,()=>{c(!1)}),w.ipcMain.once(t,()=>{c(!0)}),v.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:t,reason:a})})}onBeforeUnloadWindowInMain(v,a){const c=[];return this._onBeforeUnloadWindow.fire({reason:a,window:v,veto(l){c.push(l)}}),(0,n.handleVetos)(c,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(v,a){return new Promise(c=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(s,()=>c()),v.send("vscode:onWillUnload",{replyChannel:s,reason:a})})}quit(v){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${v}`),v&&this.stateService.setItem(et.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(a=>{this.pendingQuitPromiseResolve=a,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}relaunch(v){this.logService.trace("Lifecycle#relaunch()");const a=process.argv.slice(1);if((v==null?void 0:v.addArgs)&&a.push(...v.addArgs),v==null?void 0:v.removeArgs)for(const l of v.removeArgs){const s=a.indexOf(l);s>=0&&a.splice(s,1)}let c=!1;w.app.once("quit",()=>{if(!c){this.stateService.setItem(et.QUIT_FROM_RESTART_MARKER,!0);try{if(y.isWindows){const l=(0,E.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:a})}}),this.quit().then(l=>c=l)}async kill(v){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const a of w.BrowserWindow.getAllWindows())if(a&&!a.isDestroyed()){let c;a.webContents&&!a.webContents.isDestroyed()?c=new Promise(l=>a.once("closed",l)):c=Promise.resolve(),a.destroy(),await c}})()]),w.app.exit(v)}};m.QUIT_FROM_RESTART_MARKER="quit.from.restart",m=le([x(0,R.ILogService),x(1,D.IStateService)],m),e.LifecycleMainService=m}),define(Q[188],J([0,1,5,4,2,18]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,w.createDecorator)("keyboardLayoutMainService");let P=class extends D.Disposable{constructor(i){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,i.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const i=await new Promise((L,g)=>{j(["native-keymap"],L,g)});this._keyboardLayoutData=n(i),i.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(i),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=le([x(0,b.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function n(y){const i=y.getKeyMap(),L=y.getCurrentKeyboardLayout();return{keyboardMapping:i,keyboardLayoutInfo:L}}}),define(Q[189],J([0,1,8,22,47,23,13,6]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class y{constructor(g,E){this.dbPath=g,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=R.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await R.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,E){const p=this.database[g];return(0,P.isUndefinedOrNull)(p)?E:p}setItem(g,E){if((0,P.isUndefinedOrNull)(E))return this.removeItem(g);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[g]===E||(this.database[g]=E,this.saveSync())}removeItem(g){(0,P.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,b.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(E){this.onError(E)}}}e.FileStorage=y;let i=class pt{constructor(g,E){this.fileStorage=new y(w.join(g.userDataPath,pt.STATE_FILE),p=>E.error(p))}init(){return this.fileStorage.init()}getItem(g,E){return this.fileStorage.getItem(g,E)}setItem(g,E){this.fileStorage.setItem(g,E)}removeItem(g){this.fileStorage.removeItem(g)}};i.STATE_FILE="storage.json",i=le([x(0,D.INativeEnvironmentService),x(1,n.ILogService)],i),e.StateService=i}),define(Q[93],J([0,1,5,4,2,13,84,10]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var i;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var L;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(L=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class E extends D.Disposable{constructor(S={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,v){v===y?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:v,target:this.getKeyTargets(S)[v]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,v,a){var c;return(c=this.getStorage(v))===null||c===void 0?void 0:c.get(S,a)}getBoolean(S,v,a){var c;return(c=this.getStorage(v))===null||c===void 0?void 0:c.getBoolean(S,a)}getNumber(S,v,a){var c;return(c=this.getStorage(v))===null||c===void 0?void 0:c.getNumber(S,a)}store(S,v,a,c){if((0,b.isUndefinedOrNull)(v)){this.remove(S,a);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(S,a,c),(l=this.getStorage(a))===null||l===void 0||l.set(S,v)})}remove(S,v){this.withPausedEmitters(()=>{var a;this.updateKeyTarget(S,v,void 0),(a=this.getStorage(v))===null||a===void 0||a.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,v){const a=[],c=this.getKeyTargets(S);for(const l of Object.keys(c))c[l]===v&&a.push(l);return a}updateKeyTarget(S,v,a){var c,l;const s=this.getKeyTargets(v);typeof a=="number"?s[S]!==a&&(s[S]=a,(c=this.getStorage(v))===null||c===void 0||c.set(y,JSON.stringify(s))):typeof s[S]=="number"&&(delete s[S],(l=this.getStorage(v))===null||l===void 0||l.set(y,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const v=this.get(y,S);if(v)try{return JSON.parse(v)}catch(a){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(){var S,v,a,c;this._onWillSaveState.fire({reason:i.NONE}),await n.Promises.settled([(v=(S=this.getStorage(0))===null||S===void 0?void 0:S.whenFlushed())!==null&&v!==void 0?v:Promise.resolve(),(c=(a=this.getStorage(1))===null||a===void 0?void 0:a.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var S,v,a,c,l,s;const t=(v=(S=this.getStorage(0))===null||S===void 0?void 0:S.items)!==null&&v!==void 0?v:new Map,r=(c=(a=this.getStorage(1))===null||a===void 0?void 0:a.items)!==null&&c!==void 0?c:new Map;return h(t,r,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends E{constructor(){super();this.globalStorage=new P.Storage(new P.InMemoryStorageDatabase),this.workspaceStorage=new P.Storage(new P.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=p;async function h(m,S,v,a){const c=d=>{try{return JSON.parse(d)}catch(f){return d}},l=new Map,s=new Map;m.forEach((d,f)=>{l.set(f,d),s.set(f,c(d))});const t=new Map,r=new Map;S.forEach((d,f)=>{t.set(f,d),r.set(f,c(d))}),console.group(`Storage: Global (path: ${v})`);let o=[];l.forEach((d,f)=>{o.push({key:f,value:d})}),console.table(o),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${a})`);let u=[];t.forEach((d,f)=>{u.push({key:f,value:d})}),console.table(u),console.groupEnd(),console.log(r)}e.logStorage=h}),define(Q[190],J([0,1,3,35,30,7]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function P(y,i,L,g,E,p,h,m,S){const v=Object.create(null);v["common.machineId"]=p,v.sessionID=(0,D.generateUuid)()+Date.now(),v.commitHash=g,v.version=E,v["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,w.PlatformToString)(w.platform),v["common.nodePlatform"]=R.platform,v["common.nodeArch"]=L,v["common.product"]=S||"desktop";const a=n(h||[]);a&&(v["common.msftInternal"]=a);let c=0;const l=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(v["common.snap"]="true");try{const s=await y.readFile(b.URI.file(m));v["common.source"]=s.value.toString().slice(0,30)}catch(s){}return v}e.resolveCommonProperties=P;function n(y){const i=R.env.USERDNSDOMAIN;if(!i)return!1;const L=i.toLowerCase();return y.some(g=>L===g)}}),define(Q[31],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[191],J([0,1,27,65,68,22,8,44,81,17,3,7,31,63,9,16,23]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(t,r){const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,d=new Map,f=2e4;function I(C,H,X,ne){const oe=H.substring(C.length+1);return new Promise(async V=>{var N,B,U;let $;try{$=await(0,S.readdir)(H,{withFileTypes:!0})}catch(M){V();return}if(ne.count>=f){ne.count+=$.length,ne.maxReached=!0,V();return}let T=$.length;if(T===0){V();return}let k=$;ne.count+$.length>f&&(ne.maxReached=!0,T=f-ne.count,k=$.slice(0,T)),ne.count+=$.length;for(const M of k)if(M.isDirectory()){if(X.includes(M.name)||await I(C,(0,P.join)(H,M.name),X,ne),--T==0){V();return}}else{const O=M.name.lastIndexOf(".");if(O>=0){const _=M.name.substring(O+1);_&&u.set(_,((N=u.get(_))!==null&&N!==void 0?N:0)+1)}for(const _ of o)((B=_.relativePathPattern)===null||B===void 0?void 0:B.test(oe))!==!1&&_.filePattern.test(M.name)&&d.set(_.tag,((U=d.get(_.tag))!==null&&U!==void 0?U:0)+1);if(--T==0){V();return}}})}const A={count:0,maxReached:!1};await I(t,t,r,A);const F=await l(t);return{configFiles:a(d),fileTypes:a(u),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:F}}e.collectWorkspaceStats=v;function a(t){return[...p.Iterable.map(t.entries(),([r,o])=>({name:r,count:o}))].sort((r,o)=>o.count-r.count)}function c(){const t={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},r=w.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=c;function l(t){let r=new Map,o=(0,P.join)(t,".vscode","launch.json");return new Promise((u,d)=>{(0,b.exists)(o,f=>{if(f)(0,b.readFile)(o,(I,A)=>{if(I)return u([]);const F=[],C=(0,n.parse)(A.toString(),F);if(F.length)return console.log(`Unable to parse ${o}`),u([]);if((0,n.getNodeType)(C)==="object"&&C.configurations)for(const H of C.configurations){const X=H.type;X&&(r.has(X)?r.set(X,r.get(X)+1):r.set(X,1))}return u(a(r))});else return u([])})})}e.collectLaunchConfigs=l;let s=class{constructor(r,o){this.telemetryService=r,this.productService=o}formatMachineInfo(r){const o=[];return o.push(`OS Version:       ${r.os}`),o.push(`CPUs:             ${r.cpus}`),o.push(`Memory (System):  ${r.memory}`),o.push(`VM:               ${r.vmHint}`),o.join(`
`)}formatEnvironment(r){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const u=w.cpus();return u&&u.length>0&&o.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),o.push(`Memory (System):  ${(w.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),L.isWindows||o.push(`Load (avg):       ${w.loadavg().map(d=>Math.round(d)).join(", ")}`),o.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${r.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(r,o){return Promise.all([(0,y.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async u=>{let[d,f]=u,I=this.formatProcessList(r,d);return o.forEach(A=>{if((0,D.isRemoteDiagnosticError)(A))I+=`
${A.errorMessage}`,f+=`
${A.errorMessage}`;else if(I+=`

Remote: ${A.hostName}`,A.processes&&(I+=`
${this.formatProcessList(r,A.processes)}`),A.workspaceMetadata){f+=`
|  Remote: ${A.hostName}`;for(const F of Object.keys(A.workspaceMetadata)){const C=A.workspaceMetadata[F];let H=`${C.fileCount} files`;C.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${F}): ${H}`,f+=this.formatWorkspaceStats(C)}}}),{processInfo:I,workspaceInfo:f}})}async getSystemInfo(r,o){const{memory:u,vmHint:d,os:f,cpus:I}=c(),A={os:f,memory:u,cpus:I,vmHint:d,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:o};return L.isWindows||(A.load=`${w.loadavg().map(F=>Math.round(F)).join(", ")}`),L.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(r,o){const u=[];return(0,y.listProcesses)(r.mainPID).then(async d=>(u.push(""),u.push(this.formatEnvironment(r)),u.push(""),u.push(this.formatProcessList(r,d)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(r))),o.forEach(f=>{if((0,D.isRemoteDiagnosticError)(f))u.push(`
${f.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${f.hostName}`),u.push(this.formatMachineInfo(f.machineInfo)),f.processes&&u.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const I of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[I];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),u.push(`Folder (${I}): ${F}`),u.push(this.formatWorkspaceStats(A))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(r){const o=[],u=60;let d=0;const f=(C,H)=>{const X=` ${C}(${H})`;d+X.length>u?(o.push(I),I="|                 ",d=I.length):d+=X.length,I+=X};let I="|      File types:";const A=10;let F=r.fileTypes.length>A?A:r.fileTypes.length;for(let C=0;C<F;C++){const H=r.fileTypes[C];f(H.name,H.count)}if(o.push(I),r.configFiles.length>=0&&(I="|      Conf files:",d=0,r.configFiles.forEach(C=>{f(C.name,C.count)}),o.push(I)),r.launchConfigFiles.length>0){let C="|      Launch Configs:";r.launchConfigFiles.forEach(H=>{C+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),o.push(C)}return o.join(`
`)}expandGPUFeatures(r){const o=Math.max(...Object.keys(r).map(u=>u.length));return Object.keys(r).map(u=>`${u}:  ${" ".repeat(o-u.length)}  ${r[u]}`).join(`
                  `)}formatWorkspaceMetadata(r){const o=[],u=[];return r.windows.forEach(d=>{d.folderURIs.length===0||!!d.remoteAuthority||(o.push(`|  Window (${d.title})`),d.folderURIs.forEach(f=>{const I=g.URI.revive(f);if(I.scheme===h.Schemas.file){const A=I.fsPath;u.push(v(A,["node_modules",".git"]).then(F=>{let C=`${F.fileCount} files`;F.maxFilesReached&&(C=`more than ${C}`),o.push(`|    Folder (${(0,P.basename)(A)}): ${C}`),o.push(this.formatWorkspaceStats(F))}).catch(F=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${F.toString()})`)}))}else o.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(d=>o.join(`
`)).catch(d=>`Unable to collect workspace stats: ${d}`)}formatProcessList(r,o){const u=new Map;r.windows.forEach(f=>u.set(f.pid,f.title));const d=[];return d.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(r.mainPID,u,d,o,0),d.join(`
`)}formatProcessItem(r,o,u,d,f){const I=f===0;let A;I?A=d.pid===r?`${this.productService.applicationName} main`:"remote agent":(A=`${"  ".repeat(f)} ${d.name}`,d.name==="window"&&(A=`${A} (${o.get(d.pid)})`));const F=process.platform==="win32"?d.mem:w.totalmem()*(d.mem/100);u.push(`${d.load.toFixed(0).padStart(5," ")}	${(F/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${d.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(d.children)&&d.children.forEach(C=>this.formatProcessItem(r,o,u,C,f+1))}async reportWorkspaceStats(r){for(const{uri:o}of r.folders){const u=g.URI.revive(o);if(u.scheme===h.Schemas.file){const d=u.fsPath;try{const f=await v(d,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),f.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),f.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})})}catch(f){}}}}};s=le([x(0,E.ITelemetryService),x(1,i.IProductService)],s),e.DiagnosticsService=s}),define(Q[192],J([0,1,19,161,164,45,31,40,155,47,25,6,16,7,17,93,186,5,15]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(c||(c={}));function l(...k){return String(k.reduce((M,O)=>M|O,0))}var s;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class d{constructor(M=u){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,O=this.state.pageSize){return new d(Object.assign(Object.assign({},this.state),{pageNumber:M,pageSize:O}))}withFilter(M,...O){const _=[...this.state.criteria,...O.length?O.map(W=>({filterType:M,value:W})):[{filterType:M}]];return new d(Object.assign(Object.assign({},this.state),{criteria:_}))}withSortBy(M){return new d(Object.assign(Object.assign({},this.state),{sortBy:M}))}withSortOrder(M){return new d(Object.assign(Object.assign({},this.state),{sortOrder:M}))}withFlags(...M){return new d(Object.assign(Object.assign({},this.state),{flags:M.reduce((O,_)=>O|_,0)}))}withAssetTypes(...M){return new d(Object.assign(Object.assign({},this.state),{assetTypes:M}))}get raw(){const{criteria:M,pageNumber:O,pageSize:_,sortBy:W,sortOrder:z,flags:K,assetTypes:Y}=this.state;return{filters:[{criteria:M,pageNumber:O,pageSize:_,sortBy:W,sortOrder:z}],assetTypes:Y,flags:K}}get searchText(){const M=this.state.criteria.filter(O=>O.filterType===s.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(k,M){const O=(k||[]).filter(_=>_.statisticName===M)[0];return O?O.value:0}function I(k){const M="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(_=>_.assetType.indexOf(M)===0).reduce((_,W)=>{const z=H(k,W.assetType);return z&&_.push([W.assetType.substring(M.length),z]),_},[])}function A(k){if(k.properties){const M=k.properties.filter(W=>W.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),_=M.filter(W=>O.test(W.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return H(k,t.Repository)}function F(k){return{uri:`${k.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${k.fallbackAssetUri}/${t.VSIX}`}}function C(k){const M=H(k,t.Icon);if(M)return M;const O=R.DefaultIconPath;return{uri:O,fallbackUri:O}}function H(k,M){return k.files.filter(_=>_.assetType===M)[0]?{uri:`${k.assetUri}/${M}`,fallbackUri:`${k.fallbackAssetUri}/${M}`}:null}function X(k,M){const O=k.properties?k.properties.filter(W=>W.key===M):[],_=O.length>0&&O[0].value;return _?_.split(",").map(W=>(0,D.adoptToGalleryExtensionId)(W)):[]}function ne(k){const M=k.properties?k.properties.filter(O=>O.key===r.Engine):[];return M.length>0&&M[0].value||""}function oe(k){const M=k.properties?k.properties.filter(_=>_.key===r.LocalizedLanguages):[],O=M.length>0&&M[0].value||"";return O?O.split(","):[]}function V(k){return k.indexOf("preview")!==-1}function N(k){const M=k.properties?k.properties.find(O=>O.key===r.WebExtension):void 0;return!!M&&M.value==="true"}function B(k){return k.files.some(M=>M.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,a.joinPath)(p.URI.parse(k.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function U(k,M,O,_,W){const z={manifest:H(M,t.Manifest),readme:H(M,t.Details),changelog:H(M,t.Changelog),license:H(M,t.License),repository:A(M),download:F(M),icon:C(M),coreTranslations:I(M)};return{identifier:{id:(0,D.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:M.version,date:M.lastUpdated,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:f(k.statistics,"install"),rating:f(k.statistics,"averagerating"),ratingCount:f(k.statistics,"ratingcount"),assetUri:p.URI.parse(M.assetUri),webResource:B(M),assetTypes:M.files.map(({assetType:K})=>K),assets:z,properties:{dependencies:X(M,r.Dependency),extensionPack:X(M,r.ExtensionPack),engine:ne(M),localizedLanguages:oe(M),webExtension:N(M)},telemetryData:{index:(_.pageNumber-1)*_.pageSize+O,searchText:_.searchText,querySource:W},preview:V(k.flags)}}let $=class{constructor(M,O,_,W,z,K,Y){this.requestService=M,this.logService=O,this.environmentService=_,this.telemetryService=W,this.fileService=z,this.productService=K;const Z=K.extensionsGallery;this.extensionsGalleryUrl=Z&&Z.serviceUrl,this.extensionsControlUrl=Z&&Z.controlUrl,this.commonHeadersPromise=T(K.version,this.environmentService,this.fileService,Y)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,O){const _=[];let{total:W,firstPage:z,getPage:K}=await this.query({names:M,pageSize:M.length},O);_.push(...z);for(let Y=1;_.length<W&&(z=await K(Y,O),z.length);Y++)_.push(...z);return _}async getCompatibleExtension(M,O){const _=await this.getCompatibleExtensionByEngine(M,O);return(_==null?void 0:_.properties.webExtension)?_.webResource?_:null:_}async getCompatibleExtensionByEngine(M,O){const _=(0,R.isIExtensionIdentifier)(M)?null:M;if(_&&_.properties.engine&&(0,y.isEngineValid)(_.properties.engine,this.productService.version))return _;const{id:W,uuid:z}=_?_.identifier:M;let K=new d().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");z?K=K.withFilter(s.ExtensionId,z):K=K.withFilter(s.ExtensionName,W);const{galleryExtensions:Y}=await this.queryGallery(K,L.CancellationToken.None),[Z]=Y;if(!Z||!Z.versions.length)return null;if(O){const ee=Z.versions.filter(re=>re.version===O)[0];if(ee){const re=U(Z,ee,0,K);if(re.properties.engine&&(0,y.isEngineValid)(re.properties.engine,this.productService.version))return re}return null}const G=await this.getLastValidExtensionVersion(Z,Z.versions);return G?U(Z,G,0,K):null}async query(M,O){const _=L.CancellationToken.isCancellationToken(M)?{}:M,W=L.CancellationToken.isCancellationToken(M)?M:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=_.text||"";const K=(0,b.getOrDefault)(_,ie=>ie.pageSize,50);let Y=new d().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,K).withFilter(s.Target,"Microsoft.VisualStudio.Code");z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ue,ve)=>(Y=Y.withFilter(s.Category,ve||ue),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,ue,ve)=>(Y=Y.withFilter(s.Tag,ve||ue),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(s.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),Y=Y.withFilter(s.SearchText,z)),Y=Y.withSortBy(0)):_.ids?Y=Y.withFilter(s.ExtensionId,..._.ids):_.names?Y=Y.withFilter(s.ExtensionName,..._.names):Y=Y.withSortBy(4),typeof _.sortBy=="number"&&(Y=Y.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(Y=Y.withSortOrder(_.sortOrder));const{galleryExtensions:Z,total:G}=await this.queryGallery(Y,W),ee=Z.map((ie,ue)=>U(ie,ie.versions[0],ue,Y,_.source)),re=async(ie,ue)=>{if(ue.isCancellationRequested)throw(0,w.canceled)();const ve=Y.withPage(ie+1),{galleryExtensions:de}=await this.queryGallery(ve,ue);return de.map((he,me)=>U(he,he.versions[0],me,ve,_.source))};return{firstPage:ee,total:G,pageSize:Y.pageSize,getPage:re}}async queryGallery(M,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,c.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,l(c.Unpublished));const _=await this.commonHeadersPromise,W=JSON.stringify(M.raw),z=Object.assign(Object.assign({},_),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),K=new Date().getTime();let Y,Z,G=0;try{if(Y=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:z},O),Y.res.statusCode&&Y.res.statusCode>=400&&Y.res.statusCode<500)return{galleryExtensions:[],total:G};const ee=await(0,n.asJson)(Y);if(ee){const re=ee.results[0],ie=re.extensions,ue=re.resultMetadata&&re.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return G=ue&&ue.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:ie,total:G}}return{galleryExtensions:[],total:G}}catch(ee){throw Z=ee,ee}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},M.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-K,success:!!Y&&(0,n.isSuccess)(Y),responseBodySize:Y==null?void 0:Y.res.headers["Content-Length"],statusCode:Y?String(Y.res.statusCode):void 0,errorCode:Z?(0,w.isPromiseCanceledError)(Z)?"canceled":(0,w.getErrorMessage)(Z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(G)}))}}async reportStatistic(M,O,_,W){if(!!this.isEnabled()){const z=await this.commonHeadersPromise,K=Object.assign(Object.assign({},z),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${M}/extensions/${O}/${_}/stats?statType=${W}`),headers:K},L.CancellationToken.None)}catch(Y){}}}async download(M,O,_){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const W=(0,D.getGalleryExtensionTelemetryData)(M),z=new Date().getTime(),K=ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ee})),Y=_===1?"install":_===2?"update":"",Z=Y?{uri:`${M.assets.download.uri}&${Y}=true`,fallbackUri:`${M.assets.download.fallbackUri}?${Y}=true`}:M.assets.download,G=await this.getAsset(Z);await this.fileService.writeFile(O,G.stream),K(new Date().getTime()-z)}async getReadme(M,O){if(M.assets.readme){const _=await this.getAsset(M.assets.readme,{},O);return await(0,n.asText)(_)||""}return""}async getManifest(M,O){if(M.assets.manifest){const _=await this.getAsset(M.assets.manifest,{},O),W=await(0,n.asText)(_);return W?JSON.parse(W):null}return null}async getCoreTranslation(M,O){const _=M.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(_){const W=await this.getAsset(_[1]),z=await(0,n.asText)(W);return z?JSON.parse(z):null}return null}async getChangelog(M,O){if(M.assets.changelog){const _=await this.getAsset(M.assets.changelog,{},O);return await(0,n.asText)(_)||""}return""}async getAllVersions(M,O){let _=new d().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");M.identifier.uuid?_=_.withFilter(s.ExtensionId,M.identifier.uuid):_=_.withFilter(s.ExtensionName,M.identifier.id);const W=[],{galleryExtensions:z}=await this.queryGallery(_,L.CancellationToken.None);return z.length&&(O?await Promise.all(z[0].versions.map(async K=>{let Y;try{Y=await this.getEngine(K)}catch(Z){}Y&&(0,y.isEngineValid)(Y,this.productService.version)&&W.push({version:K.version,date:K.lastUpdated})})):W.push(...z[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),W}async getAsset(M,O={},_=L.CancellationToken.None){const W=await this.commonHeadersPromise,z={type:"GET"},K=Object.assign(Object.assign({},W),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),z),{headers:K});const Y=M.uri,Z=M.fallbackUri,G=Object.assign(Object.assign({},O),{url:Y});try{const ee=await this.requestService.request(G,_);if(ee.res.statusCode===200)return ee;const re=await(0,n.asText)(ee);throw new Error(`Expected 200, got back ${ee.res.statusCode} instead.

${re}`)}catch(ee){if((0,w.isPromiseCanceledError)(ee))throw ee;const re=(0,w.getErrorMessage)(ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Y,message:re});const ie=Object.assign(Object.assign({},O),{url:Z});return this.requestService.request(ie,_)}}async getLastValidExtensionVersion(M,O){const _=this.getLastValidExtensionVersionFromProperties(M,O);return _||this.getLastValidExtensionVersionRecursively(M,O)}getLastValidExtensionVersionFromProperties(M,O){for(const _ of O){const W=ne(_);if(!W)return null;if((0,y.isEngineValid)(W,this.productService.version))return _}return null}async getEngine(M){const O=ne(M);if(O)return O;const _=H(M,t.Manifest);if(!_)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},z=await this.getAsset(_,{headers:W}),K=await(0,n.asJson)(z);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(M,O){if(!O.length)return null;const _=O[0],W=await this.getEngine(_);return(0,y.isEngineValid)(W,this.productService.version)?(_.properties=_.properties||[],_.properties.push({key:r.Engine,value:W}),_):this.getLastValidExtensionVersionRecursively(M,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await(0,n.asJson)(M),_=new Map;if(O)for(const W of O.malicious){const z=_.get(W)||{id:{id:W},malicious:!0,slow:!1};z.malicious=!0,_.set(W,z)}return[..._.values()]}};$=le([x(0,n.IRequestService),x(1,g.ILogService),x(2,i.IEnvironmentService),x(3,P.ITelemetryService),x(4,E.IFileService),x(5,h.IProductService),x(6,(0,v.optional)(m.IStorageService))],$),e.ExtensionGalleryService=$;async function T(k,M,O,_){const W={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},z=await(0,S.getServiceMachineId)(M,O,_);return W["X-Market-User-Id"]=z,W}e.resolveMarketplaceHeaders=T}),define(Q[193],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(b){this.appender=b}listen(b,P){throw new Error(`Event not found: ${P}`)}call(b,P,{eventName:n,data:y}){return this.appender.log(n,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class R{constructor(b){this.channel=b}log(b,P){return this.channel.call("log",{eventName:b,data:P}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Q[194],J([0,1,92,142,20,5,24,48,2,45,37]),function(j,e,w,R,D,b,P,n,y,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(h,m){this._configurationService=m,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const v=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})}))}setExperimentProperty(h,m){this._experimentProperties[h]=m}setEnabled(h){this._enabled=h}_updateUserOptIn(){var h;const m=(h=this._configurationService)===null||h===void 0?void 0:h.getValue(E);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let m=h.sessionID,S=h["common.instanceId"],v=h["common.machineId"],a=h["common.firstSessionDate"],c=h["common.msftInternal"];return{sessionId:m,instanceId:S,machineId:v,firstSessionDate:a,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(h,m,S){return this.isOptedIn?this._commonProperties.then(v=>{m=(0,i.mixin)(m,v),m=(0,i.mixin)(m,this._experimentProperties),m=(0,i.cloneAndChange)(m,a=>{if(typeof a=="string")return this._cleanupInfo(a,S)}),this._appender.log(h,m)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(h,m,S){return this.publicLog(h,m,S)}publicLogError(h,m){return this.sendErrorTelemetry?this.publicLog(h,m,!0):Promise.resolve(void 0)}publicLogError2(h,m){return this.publicLogError(h,m)}_cleanupInfo(h,m){let S=h;if(m){const v=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(h);if(!t)break;v.push([t.index,s.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(S="";;){const s=c.exec(h);if(!s)break;!a.test(s[0])&&v.every(([t,r])=>s.index<t||s.index>=r)&&(S+=h.substring(l,s.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}l<h.length&&(S+=h.substr(l))}for(let v of this._cleanupPatterns)S=S.replace(v,"");return S}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=le([x(1,(0,b.optional)(P.IConfigurationService))],g),e.TelemetryService=g;const E="telemetry";L.Registry.as(n.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,R.localize)(2,null,w.default.privacyStatementUrl):(0,R.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[94],J([0,1,24,45,13,10]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,m){return Promise.resolve(void 0)}publicLog2(h,m){return this.publicLog(h,m)}publicLogError(h,m){return Promise.resolve(void 0)}publicLogError2(h,m){return this.publicLogError(h,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(m,S,v){}async publicLogError(m,S,v){}}e.NullEndpointTelemetryService=P;function n(...h){return{log:(m,S)=>h.forEach(v=>v.log(m,S)),flush:()=>b.Promises.settled(h.map(m=>m.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(h,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(S.source),configurationKeys:E(S.sourceConfig)})})}e.configurationTelemetry=y;function i(h){const m=Object.create(null),S=Object.create(null),v=Object.create(null);g(h,v);for(let a in v){a=a.length>150?a.substr(a.length-149):a;const c=v[a];typeof c=="number"?S[a]=c:typeof c=="boolean"?S[a]=c?1:0:typeof c=="string"?m[a]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(m[a]=c)}return{properties:m,measurements:S}}e.validateTelemetryData=i;function L(h){if(!h)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{h.indexOf(`${v}+`)===0&&(m=v)}),m}e.cleanRemoteAuthority=L;function g(h,m,S=0,v){if(!!h)for(let a of Object.getOwnPropertyNames(h)){const c=h[a],l=v?v+a:a;Array.isArray(c)?m[l]=(0,R.safeStringify)(c):c instanceof Date?m[l]=c.toISOString():(0,D.isObject)(c)?S<2?g(c,m,S+1,l+"."):m[l]=(0,R.safeStringify)(c):m[l]=c}}function E(h){if(!h)return[];const m=[];return p(m,"",h),m}function p(h,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(v=>p(h,m?`${m}.${v}`:v,S[v])):h.push(m)}}),define(Q[195],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Q[196],J([0,1,5,2,37,4,195,104]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var y;(function(S){function v(a){return a&&typeof a=="object"&&typeof a.id=="string"}S.isThemeColor=v})(y=e.ThemeColor||(e.ThemeColor={}));function i(S){return{id:S}}e.themeColorFromId=i;var L;(function(S){function v(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}S.isThemeIcon=v;const a=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=a.exec(t);if(!!r){let[,o]=r;return{id:o}}}S.fromString=c;function l(t,r){let o=t.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),r&&(o=`${o}~${r}`),{id:o}}S.modify=l;function s(t,r){var o,u;return t.id===r.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((u=r.color)===null||u===void 0?void 0:u.id)}S.isEqual=s,S.asClassNameArray=n.CSSIcon.asClassNameArray,S.asClassName=n.CSSIcon.asClassName,S.asCSSSelector=n.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function g(S){switch(S){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,R.toDisposable)(()=>{const a=this.themingParticipants.indexOf(v);this.themingParticipants.splice(a,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new E;D.Registry.add(e.Extensions.ThemingContribution,p);function h(S){return p.onColorThemeChange(S)}e.registerThemingParticipant=h;class m extends R.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(a=>this.onThemeChange(a)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,a){let c=this.theme.getColor(v);return c&&a&&(c=a(c,this.theme)),c?c.toString():null}}e.Themable=m}),define(Q[73],J([0,1,3,11,38,5]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",n="#1E1E1E",y="#000000",i="theme",L="themeBackground";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let g=class{constructor(p){this.stateService=p,R.ipcMain.on("vscode:changeColorTheme",(h,m,S)=>{typeof S=="string"&&this.storeBackgroundColor(JSON.parse(S))})}storeBackgroundColor(p){this.stateService.setItem(i,p.baseTheme),this.stateService.setItem(L,p.background)}getBackgroundColor(){if((w.isWindows||w.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme)return y;let p=this.stateService.getItem(L,null);if(!p){let h;(w.isWindows||w.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateService.getItem(i,"vs-dark").split(" ")[0],p=h==="hc-black"?y:h==="vs"?P:n}return w.isMacintosh&&p.toUpperCase()===n&&(p="#171717"),p}};g=le([x(0,D.IStateService)],g),e.ThemeMainService=g}),define(Q[41],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(R=e.StateType||(e.StateType={}));var D;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,P)=>({type:"idle",updateType:b,error:P}),CheckingForUpdates:b=>({type:"checking for updates",context:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Q[197],J([0,1,37,48,143,3]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[198],J([0,1,4,41]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,y){switch(y){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${y}`)}call(n,y,i){switch(y){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${y}`)}}e.UpdateChannel=D;class b{constructor(n){this.channel=n,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(y=>this.state=y),this.channel.call("_getInitialState").then(y=>this.state=y)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(Q[95],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Q[199],J([0,1,7]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(n){this.handler=n}listen(n,y){throw new Error(`Event not found: ${y}`)}call(n,y,i){switch(y){case"handleURL":return this.handler.handleURL(w.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${y}`)}}e.URLHandlerChannel=R;class D{constructor(n){this.channel=n}handleURL(n,y){return this.channel.call("handleURL",[n.toJSON(),y])}}e.URLHandlerChannelClient=D;class b{constructor(n){this.next=n}async routeCall(n,y,i,L){if(y!=="handleURL")throw new Error(`Call not found: ${y}`);if(i){const g=w.URI.revive(i);if(g&&g.query){const E=/\bwindowId=(\d+)/.exec(g.query);if(E){const p=E[1],h=new RegExp(`window:${p}`),m=n.connections.find(S=>h.test(S.ctx));if(m)return m}}}return this.next.routeCall(n,y,i,L)}routeEvent(n,y){throw new Error(`Event not found: ${y}`)}}e.URLHandlerRouter=b}),define(Q[200],J([0,1,7,10,2,17]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,L){const g=[...this.handlers.values()];return(0,R.first)(g.map(E=>()=>E.handleURL(i,L)),void 0,!1).then(E=>E||!1)}registerHandler(i){return this.handlers.add(i),(0,D.toDisposable)(()=>this.handlers.delete(i))}}e.AbstractURLService=P;let n=class extends P{constructor(i){super();this.productService=i}create(i){let{authority:L,path:g,query:E,fragment:p}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return L&&g&&g.indexOf("/")!==0&&(g=`/${g}`),w.URI.from({scheme:this.productService.urlProtocol,authority:L,path:g,query:E,fragment:p})}};n=le([x(0,b.IProductService)],n),e.NativeURLService=n}),define(Q[201],J([0,1,4,11,7,2,3,10]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function y(L){try{return D.URI.parse(L)}catch(g){return null}}class i{constructor(g,E,p,h,m){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=g,P.isWindows){const a=h.isBuilt?[]:[`"${h.appRoot}"`];a.push("--open-url","--"),R.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,a)}const S=w.Event.map(w.Event.fromNodeEventEmitter(R.app,"open-url",(a,c)=>({event:a,url:c})),({event:a,url:c})=>(a.preventDefault(),c));this.disposables.add(S(a=>{const c=y(a);!c||this.urlService.open(c,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?this.flush():w.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||g.push(E);g.length!==0&&(this.uris=g,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=i}),define(Q[202],J([0,1,107,8]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWebviewContentMimeType=void 0;const D=new Map([[".svg","image/svg+xml"],[".txt","text/plain"],[".css","text/css"],[".js","application/javascript"],[".json","application/json"],[".html","text/html"],[".htm","text/html"],[".xhtml","application/xhtml+xml"],[".oft","font/otf"],[".xml","application/xml"]]);function b(P){const n=(0,R.extname)(P.fsPath).toLowerCase();return D.get(n)||(0,w.getMediaMime)(P.fsPath)||w.MIME_UNKNOWN}e.getWebviewContentMimeType=b}),define(Q[74],J([0,1,29,9,8,7,16,202]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.loadLocalResource=e.readFileStream=e.WebviewFileReadResponse=e.WebviewResourceResponse=e.webviewPartitionId=void 0,e.webviewPartitionId="webview";var y;(function(m){let S;(function(c){c[c.Success=0]="Success",c[c.Failed=1]="Failed",c[c.AccessDenied=2]="AccessDenied",c[c.NotModified=3]="NotModified"})(S=m.Type||(m.Type={}));class v{constructor(l,s,t){this.stream=l,this.etag=s,this.mimeType=t,this.type=S.Success}}m.StreamSuccess=v,m.Failed={type:S.Failed},m.AccessDenied={type:S.AccessDenied};class a{constructor(l){this.mimeType=l,this.type=S.NotModified}}m.NotModified=a})(y=e.WebviewResourceResponse||(e.WebviewResourceResponse={}));var i;(function(m){let S;(function(a){a[a.Success=0]="Success",a[a.NotModified=1]="NotModified"})(S=m.Type||(m.Type={}));class v{constructor(c,l){this.stream=c,this.etag=l,this.type=S.Success}}m.StreamSuccess=v,m.NotModified={type:S.NotModified}})(i=e.WebviewFileReadResponse||(e.WebviewFileReadResponse={}));async function L(m,S,v){try{const a=await m.readFileStream(S,{etag:v});return new i.StreamSuccess(a.value,a.etag)}catch(a){if(a instanceof P.FileOperationError&&a.fileOperationResult===2)return i.NotModified;throw a}}e.readFileStream=L;async function g(m,S,v,a,c,l,s){l.debug(`loadLocalResource - being. requestUri=${m}`);let t=E(m,v.roots);if(l.debug(`loadLocalResource - found resource to load. requestUri=${m}, resourceToLoad=${t}`),!t)return y.AccessDenied;const r=(0,n.getWebviewContentMimeType)(m);if(v.rewriteUri&&(t=v.rewriteUri(t)),t.scheme===R.Schemas.http||t.scheme===R.Schemas.https){const o={};S&&(o["If-None-Match"]=S);const u=await c.request({url:t.toString(!0),headers:o},s);switch(l.debug(`loadLocalResource - Loaded over http(s). requestUri=${m}, response=${u.res.statusCode}`),u.res.statusCode){case 200:return new y.StreamSuccess(u.stream,u.res.headers.etag,r);case 304:return new y.NotModified(r);default:return y.Failed}}try{const o=await a.readFileStream(t,S);switch(l.debug(`loadLocalResource - Loaded using fileReader. requestUri=${m}`),o.type){case i.Type.Success:return new y.StreamSuccess(o.stream,o.etag,r);case i.Type.NotModified:return new y.NotModified(r);default:return l.error("loadLocalResource - Unknown file read response"),y.Failed}}catch(o){return l.debug(`loadLocalResource - Error using fileReader. requestUri=${m}`),console.log(o),y.Failed}}e.loadLocalResource=g;function E(m,S){const v=p(m);for(const a of S)if(h(a,v))return v}function p(m){return m.scheme===R.Schemas.vscodeWebviewResource?b.URI.parse(encodeURIComponent(m.path).replace(/%2F/gi,"/").replace(/^\/([a-z0-9\-]+)(\/{1,2})/i,(v,a,c)=>c.length===1?`${a}:///`:`${a}://`)).with({query:m.query,fragment:m.fragment}):m}function h(m,S){let v=m.fsPath+(m.fsPath.endsWith(D.sep)?"":D.sep),a=S.fsPath;return(0,w.isUNC)(m.fsPath)&&(0,w.isUNC)(S.fsPath)&&(v=v.toLowerCase(),a=a.toLowerCase()),a.startsWith(v)}}),define(Q[203],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Q[204],J([0,1,9,7,54]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingManager=void 0;class b{constructor(n,y,i){this._getExtensionLocation=n,this._getMappings=y,this.tunnelService=i,this._tunnels=new Map}async getRedirect(n,y){const i=R.URI.parse(y),L=(0,D.extractLocalHostUriMetaDataForPortMapping)(i);if(!!L){for(const g of this._getMappings())if(g.webviewPort===L.port){const E=this._getExtensionLocation();if(E&&E.scheme===w.Schemas.vscodeRemote){const p=n&&await this.getOrCreateTunnel(n,g.extensionHostPort);if(p)return p.tunnelLocalPort===g.webviewPort?void 0:encodeURI(i.with({authority:`127.0.0.1:${p.tunnelLocalPort}`}).toString(!0))}if(g.webviewPort!==g.extensionHostPort)return encodeURI(i.with({authority:`${L.address}:${g.extensionHostPort}`}).toString(!0))}}}async dispose(){for(const n of this._tunnels.values())await n.dispose();this._tunnels.clear()}async getOrCreateTunnel(n,y){const i=this._tunnels.get(y);if(i)return i;const L=await this.tunnelService.openTunnel({getAddress:async()=>n},void 0,y);return L&&this._tunnels.set(y,L),L}}e.WebviewPortMappingManager=b}),define(Q[205],J([0,1,11,2,9,7,54,74,204]),function(j,e,w,R,D,b,P,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingProvider=void 0;let i=class extends R.Disposable{constructor(g){super();this._tunnelService=g,this._webviewData=new Map,w.session.fromPartition(n.webviewPartitionId).webRequest.onBeforeRequest({urls:["*://localhost:*/*","*://127.0.0.1:*/*","*://0.0.0.0:*/*"]},async(p,h)=>{let m;try{if(p.lastCommittedOrigin)m=b.URI.parse(p.lastCommittedOrigin).authority;else if(typeof p.webContentsId=="number"){const a=w.webContents.fromId(p.webContentsId),c=b.URI.parse(a.getURL());c.scheme===D.Schemas.vscodeWebview&&(m=c.authority)}}catch(a){return h({})}if(!m)return h({});const S=this._webviewData.get(m);if(!S)return h({});const v=await S.manager.getRedirect(S.metadata.resolvedAuthority,p.url);return h(v?{redirectURL:v}:{})})}async registerWebview(g,E){const p=new y.WebviewPortMappingManager(()=>{var h;return(h=this._webviewData.get(g))===null||h===void 0?void 0:h.metadata.extensionLocation},()=>{var h;return((h=this._webviewData.get(g))===null||h===void 0?void 0:h.metadata.mappings)||[]},this._tunnelService);this._webviewData.set(g,{metadata:E,manager:p})}unregisterWebview(g){const E=this._webviewData.get(g);E&&(E.manager.dispose(),this._webviewData.delete(g))}async updateWebviewMetadata(g,E){const p=this._webviewData.get(g);p&&this._webviewData.set(g,Object.assign(Object.assign({},p),E))}};i=le([x(0,P.ITunnelService)],i),e.WebviewPortMappingProvider=i}),define(Q[61],J([0,1,3]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(i){return!!i.workspaceUri}e.isWorkspaceToOpen=R;function D(i){return!!i.folderUri}e.isFolderToOpen=D;function b(i){return!!i.fileUri}e.isFileToOpen=b;function P(i){const L=n(i),g=i.getValue("window.menuBarVisibility");return g==="default"||L==="native"&&g==="compact"||w.isMacintosh&&w.isNative?"classic":g}e.getMenuBarVisibility=P;function n(i){if(w.isWeb)return"custom";const L=i.getValue("window");if(L){if(w.isMacintosh&&L.nativeTabs===!0||w.isMacintosh&&L.nativeFullScreen===!1)return"native";const p=L.titleBarStyle;if(p==="native"||p==="custom")return p}return w.isLinux?"native":"custom"}e.getTitleBarStyle=n;function y(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=y}),define(Q[32],J([0,1,5]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var R;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));const D=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=D;var b;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var P;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService")}),define(Q[206],J([0,1,11,238,21,25,2,9,57,7,16,6,40,74,32]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;let m=class yt extends P.Disposable{constructor(v,a,c,l){super();this.fileService=v,this.logService=a,this.requestService=c,this.windowsMainService=l,this.webviewMetadata=new Map,this.requestIdPool=1,this.pendingResourceReads=new Map;const s=w.session.fromPartition(p.webviewPartitionId),t=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t),s.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t);const r=this.handleWebviewResourceRequest.bind(this);w.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),s.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),this._register((0,P.toDisposable)(()=>{w.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),s.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),w.protocol.unregisterProtocol(n.Schemas.vscodeWebview),s.protocol.unregisterProtocol(n.Schemas.vscodeWebview)}))}streamToNodeReadable(v){return new class extends R.Readable{constructor(){super(...arguments);this.listening=!1}_read(a){this.listening||(this.listening=!0,(0,y.listenStream)(v,{onData:c=>{try{this.push(c.buffer)||v.pause()}catch(l){this.emit(l)}},onError:c=>{this.emit("error",c)},onEnd:()=>{try{this.push(null)}catch(c){this.emit(c)}}})),v.resume()}_destroy(a,c){v.destroy(),c(null)}}}async registerWebview(v,a){this.webviewMetadata.set(v,a)}unregisterWebview(v){this.webviewMetadata.delete(v)}async updateWebviewMetadata(v,a){const c=this.webviewMetadata.get(v);c&&this.webviewMetadata.set(v,Object.assign(Object.assign({},c),a))}async handleWebviewRequest(v,a){try{const c=i.URI.parse(v.url),l=yt.validWebviewFilePaths.get(c.path);if(typeof l=="string"){const s=c.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${l}`:`vs/workbench/contrib/webview/browser/pre/${l}`,t=n.FileAccess.asFileUri(s,j);return a(decodeURIComponent(t.fsPath))}}catch(c){}a({error:-10})}async handleWebviewResourceRequest(v,a){try{const c=i.URI.parse(v.url),l=v.headers["If-None-Match"],s=c.authority,t=this.webviewMetadata.get(s);if(t){let r;t.remoteConnectionData&&(r=d=>{var f;if(t.remoteConnectionData&&(d.scheme===n.Schemas.vscodeRemote||((f=t.extensionLocation)===null||f===void 0?void 0:f.scheme)===n.Schemas.vscodeRemote)){let I=t.remoteConnectionData.host;return I&&I.indexOf(":")!==-1&&(I=`[${I}]`),i.URI.parse(`http://${I}:${t.remoteConnectionData.port}`).with({path:"/vscode-remote-resource",query:`tkn=${t.remoteConnectionData.connectionToken}&path=${encodeURIComponent(d.path)}`})}return d});const o={readFileStream:async(d,f)=>{var I;if(d.scheme===n.Schemas.file)return(0,p.readFileStream)(this.fileService,d,f);const A=this.windowsMainService.getWindowById(t.windowId);if(!A)throw new L.FileOperationError("Could not find window for resource",1);const F=this.requestIdPool++,C=new Promise(X=>{this.pendingResourceReads.set(F,{resolve:X})});A.send(`vscode:loadWebviewResource-${s}`,F,c,f);const H=await C;switch(H.response){case"access-denied":throw new L.FileOperationError("Could not read file",6);case"not-found":throw new L.FileOperationError("Could not read file",1);case"not-modified":return p.WebviewFileReadResponse.NotModified;default:return new p.WebviewFileReadResponse.StreamSuccess((0,D.bufferToStream)(H.response),(I=H.responseDetails)===null||I===void 0?void 0:I.etag)}}},u=await(0,p.loadLocalResource)(c,l,{extensionLocation:t.extensionLocation,roots:t.localResourceRoots,remoteConnectionData:t.remoteConnectionData,rewriteUri:r},o,this.requestService,this.logService,b.CancellationToken.None);switch(u.type){case p.WebviewResourceResponse.Type.Success:{const d=u.etag?{ETag:u.etag,"Cache-Control":"no-cache"}:{},f=v.headers["If-None-Match"];return f&&u.etag===f?a({statusCode:304,data:void 0,headers:Object.assign({"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"},d)}):a({statusCode:200,data:this.streamToNodeReadable(u.stream),headers:Object.assign({"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"},d)})}case p.WebviewResourceResponse.Type.NotModified:return a({statusCode:304,data:void 0,headers:{"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"}});case p.WebviewResourceResponse.Type.AccessDenied:return console.error("Webview: Cannot load resource outside of protocol root"),a({data:void 0,statusCode:401})}}}catch(c){}return a({data:void 0,statusCode:404})}didLoadResource(v,a,c){const l=this.pendingResourceReads.get(v);if(!l)throw new Error("Unknown request");this.pendingResourceReads.delete(v),l.resolve({response:a,responseDetails:c})}};m.validWebviewFilePaths=new Map([["/index.html","index.html"],["/electron-browser/index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"]]),m=le([x(0,L.IFileService),x(1,g.ILogService),x(2,E.IRequestService),x(3,h.IWindowsMainService)],m),e.WebviewProtocolProvider=m}),define(Q[207],J([0,1,11,2,7,16,6,54,40,74,205,206,32]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let p=class extends R.Disposable{constructor(m,S,v,a,c){super();this.windowsMainService=c,this.protocolProvider=this._register(new g.WebviewProtocolProvider(m,S,v,c)),this.portMappingProvider=this._register(new L.WebviewPortMappingProvider(a));const l=w.session.fromPartition(i.webviewPartitionId);l.setPermissionRequestHandler((s,t,r)=>r(t==="clipboard-read")),l.setPermissionCheckHandler((s,t)=>t==="clipboard-read")}async registerWebview(m,S,v){const a=v.extensionLocation?D.URI.from(v.extensionLocation):void 0;this.protocolProvider.registerWebview(m,Object.assign(Object.assign({},v),{windowId:S,extensionLocation:a,localResourceRoots:v.localResourceRoots.map(c=>D.URI.from(c))})),this.portMappingProvider.registerWebview(m,{extensionLocation:a,mappings:v.portMappings,resolvedAuthority:v.remoteConnectionData})}async unregisterWebview(m){this.protocolProvider.unregisterWebview(m),this.portMappingProvider.unregisterWebview(m)}async updateWebviewMetadata(m,S){var v;const a=S.extensionLocation?D.URI.from(S.extensionLocation):void 0;this.protocolProvider.updateWebviewMetadata(m,Object.assign(Object.assign({},S),{extensionLocation:a,localResourceRoots:(v=S.localResourceRoots)===null||v===void 0?void 0:v.map(c=>D.URI.from(c))})),this.portMappingProvider.updateWebviewMetadata(m,Object.assign(Object.assign({},S),{extensionLocation:a}))}async setIgnoreMenuShortcuts(m,S){let v;if(typeof m.windowId=="number"){const{windowId:a}=m,c=this.windowsMainService.getWindowById(a);if(!(c==null?void 0:c.win))throw new Error(`Invalid windowId: ${a}`);v=c.win.webContents}else{const{webContentsId:a}=m;if(v=w.webContents.fromId(a),!v)throw new Error(`Invalid webContentsId: ${a}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(S)}async didLoadResource(m,S,v){this.protocolProvider.didLoadResource(m,S,v)}};p=le([x(0,b.IFileService),x(1,P.ILogService),x(2,y.IRequestService),x(3,n.ITunnelService),x(4,E.IWindowsMainService)],p),e.WebviewMainService=p}),define(Q[208],J([0,1,4,2,10]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends R.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:y,getActiveWindowId:i}){super();this.disposables=this._register(new R.DisposableStore),w.Event.latch(w.Event.any(n,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>i()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(Q[209],J([0,1,7,15,5,36]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var P;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const p=E;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function y(E){const p=E;return!!(p&&typeof p=="object"&&w.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=y;class i{constructor(p,h,m,S){this._id=p,this._configuration=m,this._ignorePathCasing=S,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class L{constructor(p,h){this.raw=h,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function g(E){return new L({uri:E,index:0,name:(0,R.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=g}),define(Q[28],J([0,1,5,146,209,7,3,8,15,101,44,9,39,29,71]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(B){return(typeof B=="string"?(0,n.extname)(B):(0,y.extname)(B))===m}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function v(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function a(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=a;function c(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=c;function l(B){const U=B;return typeof(U==null?void 0:U.id)=="string"&&b.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function s(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(B){const U=B;return typeof(U==null?void 0:U.id)=="string"&&b.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function r(B){const U=B;if(U==null?void 0:U.uri)return{id:U.id,uri:b.URI.revive(U.uri)};const $=B;if($==null?void 0:$.configPath)return{id:$.id,configPath:b.URI.revive($.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=r;function o(B,U){return y.extUriBiasedIgnorePathCase.isEqualOrParent(B,U.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function u(B){return d(B)||f(B)}e.isStoredWorkspaceFolder=u;function d(B){const U=B;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=d;function f(B){const U=B;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=f;function I(B,U,$,T,k=!P.isWindows,M){if(B.scheme!==T.scheme)return{name:$,uri:B.toString(!0)};let O=U?void 0:M.relativePath(T,B);if(O!==void 0)O.length===0?O=".":P.isWindows&&B.scheme===g.Schemas.file&&!k&&(O=O.replace(/\//g,"\\"));else if(B.scheme===g.Schemas.file)O=B.fsPath,P.isWindows&&(O=(0,E.normalizeDriveLetter)(O),k&&(O=(0,p.toSlashes)(O)));else{if(!M.isEqualAuthority(B.authority,T.authority))return{name:$,uri:B.toString(!0)};O=B.path}return{name:$,path:O}}e.getStoredWorkspaceFolder=I;function A(B,U,$){let T=[],k=new Set;const M=$.dirname(U);for(let O of B){let _=null;if(d(O))O.path&&(_=$.resolvePath(M,O.path));else if(f(O))try{_=b.URI.parse(O.uri),_.path[0]!=="/"&&(_=_.with({path:"/"+_.path}))}catch(W){console.warn(W)}if(_){let W=$.getComparisonKey(_);if(!k.has(W)){k.add(W);const z=O.name||$.basenameOrAuthority(_);T.push(new D.WorkspaceFolder({uri:_,name:z,index:T.length},O))}}}return T}e.toWorkspaceFolders=A;function F(B,U,$,T,k){let M=C(U,B);const O=k.dirname(U),_=k.dirname(T),W=[],z=H(M.folders);for(const G of M.folders){const ee=d(G)?k.resolvePath(O,G.path):b.URI.parse(G.uri);let re;$?re=!1:re=!d(G)||(0,n.isAbsolute)(G.path),W.push(I(ee,re,G.name,_,z,k))}const K={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},Y=i.setProperty(B,["folders"],W,K);let Z=i.applyEdits(B,Y);return M.remoteAuthority===(0,h.getRemoteAuthority)(T)&&(Z=i.applyEdits(Z,i.removeProperty(Z,["remoteAuthority"],K))),Z}e.rewriteWorkspaceFileForNewLocation=F;function C(B,U){let $=L.parse(U);if($&&Array.isArray($.folders))$.folders=$.folders.filter(T=>u(T));else throw new Error(`${B} looks like an invalid workspace file.`);return $}function H(B){return P.isWindows?B.some(U=>d(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function X(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function ne(B){return typeof B.folderUri=="string"}function oe(B){return typeof B.fileUri=="string"}function V(B,U){const $={workspaces:[],files:[]};if(B){const T=function(M,O){for(let _=0;_<M.length;_++)try{O(M[_],_)}catch(W){U.warn(`Error restoring recent entry ${JSON.stringify(M[_])}: ${W.toString()}. Skip entry.`)}},k=B;if(Array.isArray(k.entries))T(k.entries,M=>{const O=M.label,_=M.remoteAuthority;X(M)?$.workspaces.push({label:O,remoteAuthority:_,workspace:{id:M.workspace.id,configPath:b.URI.parse(M.workspace.configPath)}}):ne(M)?$.workspaces.push({label:O,remoteAuthority:_,folderUri:b.URI.parse(M.folderUri)}):oe(M)&&$.files.push({label:O,remoteAuthority:_,fileUri:b.URI.parse(M.fileUri)})});else{const M=B;Array.isArray(M.workspaces3)&&T(M.workspaces3,(O,_)=>{const W=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[_]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?$.workspaces.push({label:W,workspace:{id:O.id,configPath:b.URI.parse(O.configURIPath)}}):typeof O=="string"&&$.workspaces.push({label:W,folderUri:b.URI.parse(O)})}),Array.isArray(M.files2)&&T(M.files2,(O,_)=>{const W=Array.isArray(M.fileLabels)&&M.fileLabels[_]||void 0;typeof O=="string"&&$.files.push({label:W,fileUri:b.URI.parse(O)})})}}return $}e.restoreRecentlyOpened=V;function N(B){const U={entries:[]};for(const $ of B.workspaces)a($)?U.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):U.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of B.files)U.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return U}e.toStoreData=N}),define(Q[49],J([0,1,5,28]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService");function D(b){const P=b;return P&&(0,R.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=D}),define(Q[50],J([0,1,5,11,10,38,3,8,64,23,13,130,28,39,2,78]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let S=class ut{constructor(a){this.stateService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),c)}pickFolder(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,title:(0,g.localize)(1,null)}),c)}pickFile(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:(0,g.localize)(2,null)}),c)}pickWorkspace(a,c){const l=(0,g.localize)(3,null),s=(0,p.mnemonicButtonLabel)((0,g.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:l,filters:t,buttonLabel:s}),c)}async doPick(a,c){const l={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};l.defaultPath=a.defaultPath||this.stateService.getItem(ut.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(l.properties=void 0,a.pickFiles&&a.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),P.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=c||R.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,(0,L.withNullAsUndefined)(s));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ut.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(a){if(a){let c=this.windowDialogQueues.get(a.id);return c||(c=new D.Queue,this.windowDialogQueues.set(a.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(a,c){return this.getWindowDialogQueue(c).queue(async()=>c?R.dialog.showMessageBox(c,a):R.dialog.showMessageBox(a))}async showSaveDialog(a,c){const l=this.acquireFileDialogLock(a,c);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showSaveDialog(c,a):s=await R.dialog.showSaveDialog(a),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,h.dispose)(l)}}normalizePath(a){return a&&P.isMacintosh&&(a=(0,y.normalizeNFC)(a)),a}normalizePaths(a){return a.map(c=>this.normalizePath(c))}async showOpenDialog(a,c){a.defaultPath&&(await(0,i.exists)(a.defaultPath)||(a.defaultPath=void 0));const l=this.acquireFileDialogLock(a,c);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showOpenDialog(c,a):s=await R.dialog.showOpenDialog(a),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,h.dispose)(l)}}acquireFileDialogLock(a,c){if(!c)return h.Disposable.None;let l=this.windowFileDialogLocks.get(c.id);l||(l=new Set,this.windowFileDialogLocks.set(c.id,l));const s=(0,m.hash)(a);if(!l.has(s))return l.add(s),(0,h.toDisposable)(()=>{l==null||l.delete(s),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=le([x(0,b.IStateService)],S),e.DialogMainService=S}),define(Q[210],J([0,1,4,2,28]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends R.Disposable{constructor(n,y){super();this.logService=n,this.storageMainService=y,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,y)=>(n?n.push(y):n=[y],n),b.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const y=new Map,i=new Set;return n.forEach(L=>{const g=this.storageMainService.globalStorage.get(L.key);typeof g=="string"?y.set(L.key,g):i.add(L.key)}),{changed:Array.from(y.entries()),deleted:Array.from(i.values())}}listen(n,y){switch(y){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${y}`)}async call(n,y,i){const L=(0,D.reviveIdentifier)(i.workspace),g=await this.withStorageInitialized(L);switch(y){case"getItems":return Array.from(g.items.entries());case"updateItems":{const E=i;if(E.insert)for(const[p,h]of E.insert)g.set(p,h);E.delete&&E.delete.forEach(p=>g.delete(p));break}case"close":{if(L)return g.close();break}default:throw new Error(`Call not found: ${y}`)}}async withStorageInitialized(n){const y=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await y.init()}catch(i){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${i}`)}return y}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[211],J([0,1,22,23,4,2,6,120,84,8,93,31,30,28]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class h extends b.Disposable{constructor(a){super();this.logService=a,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new y.Storage(new y.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const a=await this.doCreate();this.storage.dispose(),this.storage=a,this._register(a.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(a);const c=a.getBoolean(L.IS_NEW_KEY);c===void 0?a.set(L.IS_NEW_KEY,!0):c&&a.set(L.IS_NEW_KEY,!1)}catch(a){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${a}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===P.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this.storage.items}get(a,c){return this.storage.get(a,c)}set(a,c){return this.storage.set(a,c)}delete(a){return this.storage.delete(a)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class m extends h{constructor(a,c,l){super(c);this.options=a,this.environmentService=l}async doCreate(){let a;return this.options.useInMemoryStorage?a=n.SQLiteStorageDatabase.IN_MEMORY_PATH:a=(0,i.join)(this.environmentService.globalStorageHome.fsPath,m.STORAGE_NAME),new y.Storage(new n.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}))}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(g.instanceStorageKey,void 0)===void 0&&a.set(g.instanceStorageKey,(0,E.generateUuid)()),a.get(g.firstSessionDateStorageKey,void 0)===void 0&&a.set(g.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();a.set(g.lastSessionDateStorageKey,typeof s=="undefined"?null:s),a.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=m,m.STORAGE_NAME="state.vscdb";class S extends h{constructor(a,c,l,s){super(l);this.workspace=a,this.options=c,this.environmentService=s}async doCreate(){const{storageFilePath:a,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new y.Storage(new n.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}),{hint:c?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:n.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,i.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,i.join)(a,S.WORKSPACE_STORAGE_NAME);return await(0,R.exists)(a)?{storageFilePath:c,wasCreated:!1}:(await w.promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let c;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const l=(0,i.join)(a,S.WORKSPACE_META_NAME);await(0,R.exists)(l)||await(0,R.writeFile)(l,JSON.stringify(c,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=S,S.WORKSPACE_STORAGE_NAME="state.vscdb",S.WORKSPACE_META_NAME="workspace.json"}),define(Q[96],J([0,1,43,2,47,5,18,6,211]),function(j,e,w,R,D,b,P,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let i=class extends R.Disposable{constructor(g,E,p){super();this.logService=g,this.environmentService=E,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)g.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new y.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new y.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let E=this.mapWorkspaceToStorage.get(g.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),E=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,E),(0,w.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),E}};i=le([x(0,n.ILogService),x(1,D.IEnvironmentService),x(2,P.ILifecycleMainService)],i),e.StorageMainService=i}),define(Q[97],J([0,1,7,28,15]),function(j,e,w,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(y,i,L){for(const E of y){const p=E.openedWorkspace;if((0,R.isWorkspaceIdentifier)(p)){const h=L(p);if(h){if(h.folders.some(m=>D.extUriBiasedIgnorePathCase.isEqualOrParent(i,m.uri)))return E}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(i,p.configPath))return E}}const g=y.filter(E=>(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(i,E.openedWorkspace.uri));if(g.length)return g.sort((E,p)=>-(E.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function P(y,i){for(const L of y)if((0,R.isWorkspaceIdentifier)(L.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.configPath,i)||(0,R.isSingleFolderWorkspaceIdentifier)(L.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.uri,i))return L}e.findWindowOnWorkspaceOrFolder=P;function n(y,i){var L,g;const E=p=>i.some(h=>D.extUriBiasedIgnorePathCase.isEqual(w.URI.file(h),w.URI.file(p)));for(const p of y)if((g=(L=p.config)===null||L===void 0?void 0:L.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(h=>E(h)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(Q[212],J([0,1,11,2,3,15,7,24,18,6,38,32,28]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class ht extends R.Disposable{constructor(c,l,s,t,r){super();this.windowsMainService=c,this.stateService=l,this.lifecycleMainService=s,this.logService=t,this.configurationService=r,this._state=h(this.stateService.getItem(ht.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const s=S(c);this.stateService.setItem(ht.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const l=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(s=>{var t;const r=(0,E.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=s.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,o=(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&s.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(s.folderUri,c.openedWorkspace.uri);(r||o)&&(s.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}}toWindowState(c){return{workspace:(0,E.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const l=this.doGetNewWindowState(c),s=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((s==null?void 0:s.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(s==null?void 0:s.restoreFullscreen)),t&&D.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(c){const l=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const d=c.workspace;if((0,E.isWorkspaceIdentifier)(d)){const I=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===d.id).map(A=>A.uiState);if(I.length)return I[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(d)){const I=this.state.openedWindows.filter(A=>A.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(A.folderUri,d.uri)).map(A=>A.uiState);if(I.length)return I[0]}else if(c.backupPath){const I=this.state.openedWindows.filter(A=>A.backupPath===c.backupPath).map(A=>A.uiState);if(I.length)return I[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let s;const t=w.screen.getAllDisplays();if(t.length===1)s=t[0];else{if(D.isMacintosh){const d=w.screen.getCursorScreenPoint();s=w.screen.getDisplayNearestPoint(d)}!s&&l&&(s=w.screen.getDisplayMatching(l.getBounds())),s||(s=w.screen.getPrimaryDisplay()||t[0])}let r=(0,g.defaultWindowState)();r.x=Math.round(s.bounds.x+s.bounds.width/2-r.width/2),r.y=Math.round(s.bounds.y+s.bounds.height/2-r.height/2);const o=this.configurationService.getValue("window");let u=!0;if(o==null?void 0:o.newWindowDimensions){if(o.newWindowDimensions==="maximized")r.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")r.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&l){const d=l.serializeWindowState();d.mode===3?r.mode=3:r=d,u=r.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const l=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;l.some(s=>s.x===c.x||s.y===c.y);)c.x+=30,c.y+=30;return c}};p.windowsStateStorageKey="windowsState",p=le([x(0,g.IWindowsMainService),x(1,L.IStateService),x(2,y.ILifecycleMainService),x(3,i.ILogService),x(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function h(a){const c={openedWindows:[]},l=a||{openedWindows:[]};return l.lastActiveWindow&&(c.lastActiveWindow=m(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=m(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(c.openedWindows=l.openedWindows.map(s=>m(s))),c}e.restoreWindowsState=h;function m(a){const c={uiState:a.uiState};return a.backupPath&&(c.backupPath=a.backupPath),a.remoteAuthority&&(c.remoteAuthority=a.remoteAuthority),a.folder&&(c.folderUri=P.URI.parse(a.folder)),a.workspaceIdentifier&&(c.workspace={id:a.workspaceIdentifier.id,configPath:P.URI.parse(a.workspaceIdentifier.configURIPath)}),c}function S(a){return{lastActiveWindow:a.lastActiveWindow&&v(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&v(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(c=>v(c))}}e.getWindowsStateStoreData=S;function v(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(Q[55],J([0,1,58,59,213,4,33,8,27,30,2,21,82,19,3]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(I){this.socket=I,this._errorListener=A=>{if(A){if(A.code==="EPIPE")return;(0,p.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const A=F=>I(g.VSBuffer.wrap(F));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(I){return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(I){return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(I){if(!this.socket.destroyed)try{this.socket.write(I.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,p.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,p.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((I,A)=>{if(this.socket.bufferSize===0){I();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),I()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=m;var S;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var v;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(v||(v={}));class a extends L.Disposable{constructor(I,A,F,C){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=I,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=C,A?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),(0,p.onUnexpectedError)(H),this._onClose.fire()}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),F&&(this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),(0,p.onUnexpectedError)(H),this._onClose.fire()}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._totalOutgoingDataBytes+=I.byteLength,this._zlibDeflate?(this._zlibDeflate.write(I.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(g.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(I,!1)}_write(I,A){let F=2;I.byteLength<126?F+=0:I.byteLength<2**16?F+=2:F+=8;const C=g.VSBuffer.alloc(F);if(A?C.writeUInt8(194,0):C.writeUInt8(130,0),I.byteLength<126)C.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){C.writeUInt8(126,1);let H=1;C.writeUInt8(I.byteLength>>>8&255,++H),C.writeUInt8(I.byteLength>>>0&255,++H)}else{C.writeUInt8(127,1);let H=1;C.writeUInt8(0,++H),C.writeUInt8(0,++H),C.writeUInt8(0,++H),C.writeUInt8(0,++H),C.writeUInt8(I.byteLength>>>24&255,++H),C.writeUInt8(I.byteLength>>>16&255,++H),C.writeUInt8(I.byteLength>>>8&255,++H),C.writeUInt8(I.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=C.byteLength+I.byteLength,this.socket.write(g.VSBuffer.concat([C,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._totalIncomingWireBytes+=I.byteLength,this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),C=(A.readUInt8(0)&128)>>>7,H=A.readUInt8(1),X=(H&128)>>>7,ne=H&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=C,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),F=A.readUInt8(1),C=(F&128)>>>7;let H=F&127,X=1;H===126?H=A.readUInt8(++X)*2**8+A.readUInt8(++X):H===127&&(H=A.readUInt8(++X)*0+A.readUInt8(++X)*0+A.readUInt8(++X)*0+A.readUInt8(++X)*0+A.readUInt8(++X)*2**24+A.readUInt8(++X)*2**16+A.readUInt8(++X)*2**8+A.readUInt8(++X));let ne=0;C&&(ne=A.readUInt8(++X)*2**24+A.readUInt8(++X)*2**16+A.readUInt8(++X)*2**8+A.readUInt8(++X)),this._state.state=3,this._state.readLen=H,this._state.mask=ne}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);c(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const F=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=F.length,this._onData.fire(g.VSBuffer.wrap(F))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=a;function c(f,I){if(I!==0){let A=f.byteLength>>>2;for(let oe=0;oe<A;oe++){const V=f.readUInt32BE(oe*4);f.writeUInt32BE(V^I,oe*4)}let F=A*4,C=f.byteLength-F;const H=I>>>24&255,X=I>>>16&255,ne=I>>>8&255;C>=1&&f.writeUInt8(f.readUInt8(F)^H,F),C>=2&&f.writeUInt8(f.readUInt8(F+1)^X,F+1),C>=3&&f.writeUInt8(f.readUInt8(F+2)^ne,F+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const f=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):I=(0,n.join)((0,y.tmpdir)(),`vscode-ipc-${f}.sock`),r(I),I}e.createRandomIPCHandle=s;function t(f,I,A){const F=(0,w.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${I}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${A}-${I}.sock`):C=(0,n.join)(f,`${A}-${I}.sock`),r(C),C}e.createStaticIPCHandle=t;function r(f){const I=l[h.platform];typeof I=="number"&&f.length>=I&&console.warn(`WARNING: IPC handle "${f}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends P.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const A=b.Event.fromNodeEventEmitter(I,"connection");return b.Event.map(A,F=>({protocol:new E.Protocol(new m(F)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(f){return new Promise((I,A)=>{const F=(0,R.createServer)();F.on("error",A),F.listen(f,()=>{F.removeListener("error",A),I(new o(F))})})}e.serve=u;function d(f,I){return new Promise((A,F)=>{const C=(0,R.createConnection)(f,()=>{C.removeListener("error",F),A(E.Client.fromSocket(new m(C),I))});C.once("error",F)})}e.connect=d}),define(Q[214],J([0,1,55]),function(j,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(g){this.driver=g}listen(g,E){throw new Error("No event found")}call(g,E,p){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(p);case"reloadWindow":return this.driver.reloadWindow(p);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(p[0],p[1]);case"click":return this.driver.click(p[0],p[1],p[2],p[3]);case"doubleClick":return this.driver.doubleClick(p[0],p[1]);case"setValue":return this.driver.setValue(p[0],p[1],p[2]);case"getTitle":return this.driver.getTitle(p[0]);case"isActiveElement":return this.driver.isActiveElement(p[0],p[1]);case"getElements":return this.driver.getElements(p[0],p[1],p[2]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1],p[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p[0],p[1]);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1],p[2])}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=R;class D{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,E){return this.channel.call("dispatchKeybinding",[g,E])}click(g,E,p,h){return this.channel.call("click",[g,E,p,h])}doubleClick(g,E){return this.channel.call("doubleClick",[g,E])}setValue(g,E,p){return this.channel.call("setValue",[g,E,p])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,E){return this.channel.call("isActiveElement",[g,E])}getElements(g,E,p){return this.channel.call("getElements",[g,E,p])}getElementXY(g,E,p,h){return this.channel.call("getElementXY",[g,E,p,h])}typeInEditor(g,E,p){return this.channel.call("typeInEditor",[g,E,p])}getTerminalBuffer(g,E){return this.channel.call("getTerminalBuffer",[g,E])}writeInTerminal(g,E,p){return this.channel.call("writeInTerminal",[g,E,p])}}e.DriverChannelClient=D;class b{constructor(g){this.registry=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,p){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(p);case"reloadWindowDriver":return this.registry.reloadWindowDriver(p)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=b;class P{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=P;class n{constructor(g){this.driver=g}listen(g,E){throw new Error(`No event found: ${E}`)}call(g,E,p){switch(E){case"click":return this.driver.click(p[0],p[1],p[2]);case"doubleClick":return this.driver.doubleClick(p);case"setValue":return this.driver.setValue(p[0],p[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(p);case"getElements":return this.driver.getElements(p[0],p[1]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1])}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=n;class y{constructor(g){this.channel=g}click(g,E,p){return this.channel.call("click",[g,E,p])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,E){return this.channel.call("setValue",[g,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,E){return this.channel.call("getElements",[g,E])}getElementXY(g,E,p){return this.channel.call("getElementXY",[g,E,p])}typeInEditor(g,E){return this.channel.call("typeInEditor",[g,E])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,E){return this.channel.call("writeInTerminal",[g,E])}}e.WindowDriverChannelClient=y;async function i(L){const g=await(0,w.connect)(L,"driverClient"),E=g.getChannel("driver"),p=new D(E);return{client:g,driver:p}}e.connect=i}),define(Q[26],J([0,1,8,52,5,47,153,55]),function(j,e,w,R,D,b,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,D.refineServiceDecorator)(b.IEnvironmentService);class y extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,w.join)(this.userDataPath,"clp")}get backupHome(){return(0,w.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,w.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}}le([R.memoize],y.prototype,"cachedLanguagesPath",null),le([R.memoize],y.prototype,"backupHome",null),le([R.memoize],y.prototype,"backupWorkspacesPath",null),le([R.memoize],y.prototype,"mainIPCHandle",null),le([R.memoize],y.prototype,"sandbox",null),le([R.memoize],y.prototype,"driverVerbose",null),le([R.memoize],y.prototype,"disableUpdates",null),le([R.memoize],y.prototype,"disableKeytar",null),le([R.memoize],y.prototype,"nodeCachedDataDir",null),e.EnvironmentMainService=y}),define(Q[215],J([0,1,22,58,8,3,23,49,26,24,16,6,28,7,29,9,15]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(c,l,s){this.configurationService=l,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=S.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,h.isEqual)(t,r,!b.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await w.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let l=[];try{Array.isArray(c.rootURIWorkspaces)&&(l=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let s=[];try{Array.isArray(c.folderURIWorkspaces)&&(s=c.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==L.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===L.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const l=this.configurationService.getValue();return((c=l==null?void 0:l.files)===null||c===void 0?void 0:c.hotExit)||L.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,l){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const s=this.getBackupPath(c.workspace.id);return l&&this.moveBackupFolderSync(s,l),s}moveBackupFolderSync(c,l){if(w.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),w.existsSync(l))try{w.renameSync(l,c)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(c){const l=c.id,s=this.workspaces.findIndex(t=>t.workspace.id===l);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(l=>this.backupUriComparer.isEqual(c,l))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const l=this.folders.findIndex(s=>this.backupUriComparer.isEqual(c,s));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(c,l){const s=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:l}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(c){const l=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(c){return(0,D.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const l=new Set,s=[];for(let t of c){const r=t.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!l.has(r.id)){l.add(r.id);const o=this.getBackupPath(r.id);await this.doHasBackups(o)?r.configPath.scheme!==m.Schemas.file||await(0,P.exists)(r.configPath.fsPath)?s.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return s}async validateFolders(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const r=this.backupUriComparer.getComparisonKey(t);if(!s.has(r)){s.add(r);const o=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(o)?t.scheme!==m.Schemas.file||await(0,P.exists)(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const r=t.backupFolder;if(typeof r!="string")return[];if(!s.has(r)){s.add(r);const o=this.getBackupPath(r);await this.doHasBackups(o)?l.push(t):await this.deleteStaleBackup(o)}}return l}async deleteStaleBackup(c){try{await(0,P.exists)(c)&&await(0,P.rimraf)(c,P.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{await w.promises.rename(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{w.renameSync(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const c=[];for(const l of this.workspaces)await this.hasBackups(l)&&c.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&c.push(l);return c}hasBackups(c){let l;return p.URI.isUri(c)?l=this.getBackupPath(this.getFolderHash(c)):(0,n.isWorkspaceBackupInfo)(c)?l=this.getBackupPath(c.workspace.id):l=c.backupFolder,this.doHasBackups(l)}async doHasBackups(c){try{const l=await(0,P.readdir)(c);for(const s of l)try{if((await(0,P.readdir)((0,D.join)(c,s))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,P.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let l;return c.scheme===m.Schemas.file?l=b.isLinux?c.fsPath:c.fsPath.toLowerCase():l=c.toString().toLowerCase(),(0,R.createHash)("md5").update(l).digest("hex")}};v=le([x(0,y.IEnvironmentMainService),x(1,i.IConfigurationService),x(2,g.ILogService)],v),e.BackupMainService=v}),define(Q[42],J([0,1,4,32,11,18,3,26,50,23,7,31,5,27,65,6,8,17,52,2]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let l=class it extends c.Disposable{constructor(t,r,o,u,d,f,I,A){super();this.sharedProcess=t,this.windowsMainService=r,this.dialogMainService=o,this.lifecycleMainService=u,this.environmentMainService=d,this.telemetryService=f,this.logService=I,this.productService=A,this.onDidOpenWindow=w.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidMaximizeWindow=w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(F,C)=>C.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidUnmaximizeWindow=w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(F,C)=>C.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidBlurWindow=w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(F,C)=>C.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusWindow=w.Event.any(w.Event.map(w.Event.filter(w.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),w.Event.filter(w.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(F,C)=>C.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidResumeOS=w.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new w.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new w.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=w.Event.debounce(w.Event.any(w.Event.filter(w.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(F,C,H)=>H),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),w.Event.fromNodeEventEmitter(D.screen,"display-added"),w.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(r=>{var o,u;return{id:r.id,workspace:r.openedWorkspace,title:(u=(o=r.win)===null||o===void 0?void 0:o.getTitle())!==null&&u!==void 0?u:"",filename:r.getRepresentedFilename(),dirty:r.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const r=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(r)return r.id}openWindow(t,r,o){return Array.isArray(r)?this.doOpenWindow(t,r,o):this.doOpenEmptyWindow(t,r)}async doOpenWindow(t,r,o=Object.create(null)){r.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:r,cli:this.environmentMainService.args,forceNewWindow:o.forceNewWindow,forceReuseWindow:o.forceReuseWindow,preferNewWindow:o.preferNewWindow,diffMode:o.diffMode,addMode:o.addMode,gotoLineMode:o.gotoLineMode,noRecentEntry:o.noRecentEntry,waitMarkerFileURI:o.waitMarkerFileURI,remoteAuthority:o.remoteAuthority||void 0})}async doOpenEmptyWindow(t,r){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},r)}async toggleFullScreen(t){const r=this.windowById(t);r&&r.toggleFullScreen()}async handleTitleDoubleClick(t){const r=this.windowById(t);r&&r.handleTitleDoubleClick()}async isMaximized(t){const r=this.windowById(t);return(r==null?void 0:r.win)?r.win.isMaximized():!1}async maximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.maximize()}async unmaximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.unmaximize()}async minimizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.minimize()}async focusWindow(t,r){var o;r&&typeof r.windowId=="number"&&(t=r.windowId);const u=this.windowById(t);u&&u.focus({force:(o=r==null?void 0:r.force)!==null&&o!==void 0?o:!1})}async setMinimumSize(t,r,o){const u=this.windowById(t);if(u==null?void 0:u.win){const[d,f]=u.win.getSize(),[I,A]=u.win.getMinimumSize(),[F,C]=[r!=null?r:I,o!=null?o:A],[H,X]=[Math.max(d,F),Math.max(f,C)];(I!==F||A!==C)&&u.win.setMinimumSize(F,C),(d!==H||f!==X)&&u.win.setSize(H,X)}}async showMessageBox(t,r){return this.dialogMainService.showMessageBox(r,this.toBrowserWindow(t))}async showSaveDialog(t,r){return this.dialogMainService.showSaveDialog(r,this.toBrowserWindow(t))}async showOpenDialog(t,r){return this.dialogMainService.showOpenDialog(r,this.toBrowserWindow(t))}toBrowserWindow(t){const r=this.windowById(t);if(r==null?void 0:r.win)return r.win}async pickFileFolderAndOpen(t,r){const o=await this.dialogMainService.pickFileFolder(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFileFolder",r.telemetryExtraData),this.doOpenPicked(await Promise.all(o.map(async u=>await i.SymlinkSupport.existsDirectory(u)?{folderUri:L.URI.file(u)}:{fileUri:L.URI.file(u)})),r,t))}async pickFolderAndOpen(t,r){const o=await this.dialogMainService.pickFolder(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFolder",r.telemetryExtraData),this.doOpenPicked(o.map(u=>({folderUri:L.URI.file(u)})),r,t))}async pickFileAndOpen(t,r){const o=await this.dialogMainService.pickFile(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFile",r.telemetryExtraData),this.doOpenPicked(o.map(u=>({fileUri:L.URI.file(u)})),r,t))}async pickWorkspaceAndOpen(t,r){const o=await this.dialogMainService.pickWorkspace(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openWorkspace",r.telemetryExtraData),this.doOpenPicked(o.map(u=>({workspaceUri:L.URI.file(u)})),r,t))}doOpenPicked(t,r,o){this.windowsMainService.open({context:3,contextWindowId:o,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:r.forceNewWindow})}sendPickerTelemetry(t,r,o){const u=t?t.length:0;this.telemetryService.publicLog(r,Object.assign(Object.assign({},o),{outcome:u?"success":"canceled",numberOfPaths:u}))}async showItemInFolder(t,r){D.shell.showItemInFolder(r)}async setRepresentedFilename(t,r){const o=this.windowById(t);o&&o.setRepresentedFilename(r)}async setDocumentEdited(t,r){const o=this.windowById(t);o&&o.setDocumentEdited(r)}async openExternal(t,r){return P.isLinuxSnap?this.safeSnapOpenExternal(r):D.shell.openExternal(r),!0}safeSnapOpenExternal(t){const r=process.env.GDK_PIXBUF_MODULE_FILE,o=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=r,process.env.GDK_PIXBUF_MODULEDIR=o}async moveItemToTrash(t,r){return D.shell.moveItemToTrash(r)}async isAdmin(){let t;return P.isWindows?t=(await new Promise((r,o)=>{j(["native-is-elevated"],r,o)}))():t=process.getuid()===0,t}async writeElevated(t,r,o,u){const d=await new Promise((f,I)=>{j(["sudo-prompt"],f,I)});return new Promise((f,I)=>{const A=[`"${this.cliPath}"`];(u==null?void 0:u.unlock)&&A.push("--file-chmod"),A.push("--file-write",`"${r.fsPath}"`,`"${o.fsPath}"`);const F={name:this.productService.nameLong.replace("-",""),icns:P.isMacintosh&&this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};d.exec(A.join(" "),F,(C,H,X)=>{H&&this.logService.trace(`[sudo-prompt] received stdout: ${H}`),X&&this.logService.trace(`[sudo-prompt] received stderr: ${X}`),C?I(C):f(void 0)})})}get cliPath(){return P.isWindows?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):P.isLinux?this.environmentMainService.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,S.join)(this.environmentMainService.appRoot,"bin","code"):(0,S.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,p.totalmem)(),freemem:(0,p.freemem)(),loadavg:(0,p.loadavg)()}}async getOSProperties(){return{arch:(0,p.arch)(),platform:(0,p.platform)(),release:(0,p.release)(),type:(0,p.type)(),cpus:(0,p.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async killProcess(t,r,o){process.kill(r,o)}async readClipboardText(t,r){return D.clipboard.readText(r)}async writeClipboardText(t,r,o){return D.clipboard.writeText(r,o)}async readClipboardFindText(t){return D.clipboard.readFindText()}async writeClipboardFindText(t,r){return D.clipboard.writeFindText(r)}async writeClipboardBuffer(t,r,o,u){return D.clipboard.writeBuffer(r,Buffer.from(o),u)}async readClipboardBuffer(t,r){return D.clipboard.readBuffer(r)}async hasClipboard(t,r,o){return D.clipboard.has(r,o)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,r){const o=this.windowById(t);o&&o.updateTouchBar(r)}async notifyReady(t){const r=this.windowById(t);r&&r.setReady()}async relaunch(t,r){return this.lifecycleMainService.relaunch(r)}async reload(t,r){const o=this.windowById(t);if(o)return this.lifecycleMainService.reload(o,(r==null?void 0:r.disableExtensions)!==void 0?{_:[],"disable-extensions":r==null?void 0:r.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,r){const o=this.windowById(r);if(o==null?void 0:o.win)return o.win.close()}async quit(t){const r=this.windowsMainService.getLastActiveWindow();(r==null?void 0:r.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&r.win?r.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,r){await this.lifecycleMainService.kill(r)}async resolveProxy(t,r){var o,u;const d=this.windowById(t),f=(u=(o=d==null?void 0:d.win)===null||o===void 0?void 0:o.webContents)===null||u===void 0?void 0:u.session;if(f)return f.resolveProxy(r)}async openDevTools(t,r){const o=this.windowById(t);(o==null?void 0:o.win)&&o.win.webContents.openDevTools(r)}async toggleDevTools(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.webContents.toggleDevTools()}async sendInputEvent(t,r){const o=this.windowById(t);(o==null?void 0:o.win)&&(r.type==="mouseDown"||r.type==="mouseUp")&&o.win.webContents.sendInputEvent(r)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,r,o,u){if(!!P.isWindows){const d=await new Promise((f,I)=>{j(["vscode-windows-registry"],f,I)});try{return d.GetStringRegKey(r,o,u)}catch(f){return}}}async getPassword(t,r,o){const u=await this.withKeytar(),d=await u.getPassword(r,o);if(d)try{let{content:f,hasNextChunk:I}=JSON.parse(d);if(!f||!I)return d;let A=1;for(;I;){const F=await u.getPassword(r,`${o}-${A}`),C=JSON.parse(F);f+=C.content,I=C.hasNextChunk}return f}catch(f){return d}return d}async setPassword(t,r,o,u){const d=await this.withKeytar();if(P.isWindows&&u.length>it.MAX_PASSWORD_LENGTH){let f=0,I=0,A=!0;for(;A;){const F=u.substring(f,f+it.PASSWORD_CHUNK_SIZE);f+=it.PASSWORD_CHUNK_SIZE,A=u.length-f>0;const C={content:F,hasNextChunk:A};await d.setPassword(r,I?`${o}-${I}`:o,JSON.stringify(C)),I++}}else await d.setPassword(r,o,u);this._onDidChangePassword.fire({service:r,account:o})}async deletePassword(t,r,o){const d=await(await this.withKeytar()).deletePassword(r,o);return d&&this._onDidChangePassword.fire({service:r,account:o}),d}async findPassword(t,r){return(await this.withKeytar()).findPassword(r)}async findCredentials(t,r){return(await this.withKeytar()).findCredentials(r)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,r)=>{j(["keytar"],t,r)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};l.MAX_PASSWORD_LENGTH=2500,l.PASSWORD_CHUNK_SIZE=l.MAX_PASSWORD_LENGTH-100,le([a.memoize],l.prototype,"cliPath",null),l=le([x(1,R.IWindowsMainService),x(2,y.IDialogMainService),x(3,b.ILifecycleMainService),x(4,n.IEnvironmentMainService),x(5,g.ITelemetryService),x(6,m.ILogService),x(7,v.IProductService)],l),e.NativeHostMainService=l}),define(Q[216],J([0,1,2,4,78,11,6,32,42,87,30,17,25]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let h=class extends w.Disposable{constructor(S,v,a,c,l){super();this.logService=S,this.windowsMainService=v,this.nativeHostMainService=a,this.encryptionMainService=c,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const S=R.Event.fromNodeEventEmitter(b.app,"login",(v,a,c,l,s)=>({event:v,webContents:a,req:c,authInfo:l,callback:s}));this._register(S(this.onLogin,this))}async onLogin({event:S,authInfo:v,req:a,callback:c}){if(!!v.isProxy){if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}S.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(l==null?void 0:l.username,l==null?void 0:l.password)}}async resolveProxyCredentials(S){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(S);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(S){var v,a,c,l;this.logService.trace("auth#doResolveProxyCredentials - enter",S);const s=String((0,D.hash)({scheme:S.scheme,host:S.host,port:S.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s);if(f){const I=JSON.parse(await this.encryptionMainService.decrypt(f));t=I.username,r=I.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:S,username:(a=(v=this.sessionCredentials)===null||v===void 0?void 0:v.username)!==null&&a!==void 0?a:t,password:(l=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&l!==void 0?l:r,replyChannel:`vscode:proxyAuthResponse:${(0,L.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,u),this.state=p.LoginDialogShown;const d=await new Promise(f=>{var I;const A=async(F,C,H)=>{var X;if(C===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),(X=o.win)===null||X===void 0||X.webContents.off("ipc-message",A),H){const ne={username:H.username,password:H.password};try{if(H.remember){const oe=await this.encryptionMainService.encrypt(JSON.stringify(ne));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s,oe)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s)}catch(oe){this.logService.error(oe)}f({username:ne.username,password:ne.password})}else f(void 0)};(I=o.win)===null||I===void 0||I.webContents.on("ipc-message",A)});return this.sessionCredentials=d,d}};h=le([x(0,P.ILogService),x(1,n.IWindowsMainService),x(2,y.INativeHostMainService),x(3,i.IEncryptionMainService),x(4,g.IProductService)],h),e.ProxyAuthHandler=h}),define(Q[217],J([0,1,214,32,55,2,33,56,168,3,4,77,102,10,18,42]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function S(c){return c<21}let v=class{constructor(l,s,t,r,o){this.windowServer=l,this.options=s,this.windowsMainService=t,this.lifecycleMainService=r,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!(s==null?void 0:s.win))throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(s)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,s){await this.whenUnfrozen(l);const t=E.KeybindingParser.parseUserBinding(s);for(let r of t)await this._dispatchKeybinding(l,r)}async _dispatchKeybinding(l,s){if(s instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const r=t.win.webContents,o=new n.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),d=new y.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),f=[];s.ctrlKey&&f.push("ctrl"),s.metaKey&&f.push("meta"),s.shiftKey&&f.push("shift"),s.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:d,modifiers:f}),S(s.keyCode)||r.sendInputEvent({type:"char",keyCode:d,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:d,modifiers:f}),await(0,p.timeout)(100)}async click(l,s,t,r){await(await this.getWindowDriver(l)).click(s,t,r)}async doubleClick(l,s){await(await this.getWindowDriver(l)).doubleClick(s)}async setValue(l,s,t){await(await this.getWindowDriver(l)).setValue(s,t)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,s){return await(await this.getWindowDriver(l)).isActiveElement(s)}async getElements(l,s,t){return await(await this.getWindowDriver(l)).getElements(s,t)}async getElementXY(l,s,t,r){return await(await this.getWindowDriver(l)).getElementXY(s,t,r)}async typeInEditor(l,s,t){await(await this.getWindowDriver(l)).typeInEditor(s,t)}async getTerminalBuffer(l,s){return await(await this.getWindowDriver(l)).getTerminalBuffer(s)}async writeInTerminal(l,s,t){await(await this.getWindowDriver(l)).writeInTerminal(s,t)}async getWindowDriver(l){await this.whenUnfrozen(l);const s=`window:${l}`,t=new P.StaticRouter(o=>o===s),r=this.windowServer.getChannel("windowDriver",t);return new w.WindowDriverChannelClient(r)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await L.Event.toPromise(this.onDidReloadingChange.event)}};v=le([x(2,R.IWindowsMainService),x(3,h.ILifecycleMainService),x(4,m.INativeHostMainService)],v),e.Driver=v;async function a(c,l,s,t){const r=s.driverVerbose,o=t.createInstance(v,c,{verbose:r}),u=new w.WindowDriverRegistryChannel(o);c.registerChannel("windowDriverRegistry",u);const d=await(0,D.serve)(l),f=new w.DriverChannel(o);return d.registerChannel("driver",f),(0,b.combinedDisposable)(d,c)}e.serve=a}),define(Q[218],J([0,1,59,55]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,b,P,n){const y=L=>n(L,void 0),i=w.createConnection({host:D,port:b},()=>{i.removeListener("error",y);const L=Buffer.alloc(16);for(let h=0;h<16;h++)L[h]=Math.round(Math.random()*256);const g=L.toString("base64");let E=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${b}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];i.write(E.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",p),n(void 0,new R.NodeSocket(i)))};i.on("data",p)});i.once("error",y)}}}),define(Q[219],J([0,1,59,10,2,112,6,17,183,54,218,72]),function(j,e,w,R,D,b,P,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(S,v,a,c){return new p(S,v,a,c).waitForReady()}class p extends D.Disposable{constructor(v,a,c,l){super();this.suggestedLocalPort=l,this.public=!1,this._socketsDispose=new Map,this._options=v,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){var v;let a=await(0,b.findFreePortFaster)((v=this.suggestedLocalPort)!==null&&v!==void 0?v:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(a).address(),c||(a=0,c=this._server.listen(a).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(v){v.pause();const a=await(0,y.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=a.getSocket().socket,l=a.readEntireBuffer();a.dispose(),l.byteLength>0&&v.write(l.buffer),v.on("end",()=>{this._socketsDispose.delete(v.localAddress),c.end()}),v.on("close",()=>c.end()),v.on("error",()=>{this._socketsDispose.delete(v.localAddress),c.destroy()}),c.on("end",()=>v.end()),c.on("close",()=>v.end()),c.on("error",()=>{v.destroy()}),v.pipe(c),c.pipe(v),this._socketsDispose.set(v.localAddress,()=>{v.end(),c.end()})}}let h=class extends i.AbstractTunnelService{constructor(v,a,c,l){super(a);this.socketFactory=v,this.signService=c,this.productService=l}retainOrCreateTunnel(v,a,c,l,s,t){const r=this.getTunnelFromMap(a,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,c,l,s,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${c} on local port ${l}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},u=E(o,a,c,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,c,u),u}}};h=le([x(1,P.ILogService),x(2,g.ISignService),x(3,n.IProductService)],h),e.BaseTunnelService=h;let m=class extends h{constructor(v,a,c){super(L.nodeSocketFactory,v,a,c)}};m=le([x(0,P.ILogService),x(1,g.ISignService),x(2,n.IProductService)],m),e.TunnelService=m}),define(Q[220],J([0,1,213,185,2,13,19,184,24,6,21,47,69]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends D.Disposable{constructor(m,S,v){super();this.environmentService=S,this.logService=v,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,S){this.logService.trace("RequestService#request",m.url);const{proxyUrl:v,strictSSL:a}=this,c=m.agent?m.agent:await(0,n.getProxyAgent)(m.url||"",await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env),{proxyUrl:v,strictSSL:a});return m.agent=c,m.strictSSL=a,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,S)}async getNodeRequest(m){return((0,R.parse)(m.url).protocol==="https:"?await new Promise((a,c)=>{j(["https"],a,c)}):await new Promise((a,c)=>{j(["http"],a,c)})).request}_request(m,S){return new Promise(async(v,a)=>{let c;const l=(0,R.parse)(m.url),s=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,b.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),c=s(t,r=>{const o=(0,b.isNumber)(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this._request(Object.assign(Object.assign({},m),{url:r.headers.location,followRedirects:o-1}),S).then(v,a);else{let u=r;r.headers["content-encoding"]==="gzip"&&(u=r.pipe((0,w.createGunzip)())),v({res:r,stream:(0,L.streamToBufferReadableStream)(u)})}}),c.on("error",a),m.timeout&&c.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&c.write(m.data),c.end(),S.onCancellationRequested(()=>{c.abort(),a((0,P.canceled)())})})}async resolveProxy(m){}};p=le([x(0,y.IConfigurationService),x(1,g.INativeEnvironmentService),x(2,i.ILogService)],p),e.RequestService=p}),define(Q[221],J([0,1,220,11]),function(j,e,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return R.net.request}class b extends w.RequestService{request(n,y){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:D}),y)}}e.RequestMainService=b}),define(Q[222],J([0,1,11,26,10,6,18,73,9,3,2,83,13,4,69]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends L.Disposable{constructor(v,a,c,l,s,t){super();this.machineId=v,this.userEnv=a,this.environmentMainService=c,this.lifecycleMainService=l,this.logService=s,this.themeMainService=t,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new p.Emitter),this.onDidError=p.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),w.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,a)=>this.onWindowConnection(v,a))}async onWindowConnection(v,a){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(v.sender.isDestroyed())return c.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",a,[c])}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(a){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,h.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}});const v={machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel()};this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).with({query:`config=${encodeURIComponent(JSON.stringify(v))}`}).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{var a;this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),((a=this.window)===null||a===void 0?void 0:a.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,a)=>this._onDidError.fire({type:2,details:a})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(v,a,c)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${c}`})))}async connect(){await this.whenIpcReady;const v=(0,E.assertIsDefined)(this.window);return(0,g.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var v,a;return(a=(v=this.window)===null||v===void 0?void 0:v.isVisible())!==null&&a!==void 0?a:!1}};m=le([x(2,R.IEnvironmentMainService),x(3,P.ILifecycleMainService),x(4,b.ILogService),x(5,n.IThemeMainService)],m),e.SharedProcess=m}),define(Q[75],J([0,1,4,10,24,18,17,41,26,6,40,25]),function(j,e,w,R,D,b,P,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(h,m,S){return`${S.updateUrl}/api/update/${h}/${m}/${S.commit}`}e.createUpdateURL=E;let p=class{constructor(m,S,v,a,c,l){this.lifecycleMainService=m,this.configurationService=S,this.environmentMainService=v,this.requestService=a,this.logService=c,this.productService=l,this._state=n.State.Uninitialized,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),S=this.getProductQuality(m);if(!S){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(S),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=le([x(0,b.ILifecycleMainService),x(1,D.IConfigurationService),x(2,y.IEnvironmentMainService),x(3,L.IRequestService),x(4,i.ILogService),x(5,P.IProductService)],p),e.AbstractUpdateService=p}),define(Q[223],J([0,1,11,2,4,52,24,18,41,31,26,6,75,40,17]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends E.AbstractUpdateService{constructor(v,a,c,l,s,t,r){super(v,a,l,s,t,r);this.telemetryService=c,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"error",(v,a)=>a)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(v,a,c)=>({url:a,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(v,a,c,l)=>({releaseNotes:a,version:c,productVersion:c,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const c=(this.state.type==="checking for updates"?!!this.state.context:!0)?v:void 0;this.setState(y.State.Idle(1,c))}buildUpdateFeedUrl(v){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,E.createUpdateURL)(a,v,this.productService);try{w.autoUpdater.setFeedURL({url:c})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return c}doCheckForUpdates(v){this.setState(y.State.CheckingForUpdates(v)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(y.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};le([b.memoize],m.prototype,"onRawError",null),le([b.memoize],m.prototype,"onRawUpdateNotAvailable",null),le([b.memoize],m.prototype,"onRawUpdateAvailable",null),le([b.memoize],m.prototype,"onRawUpdateDownloaded",null),m=le([x(0,n.ILifecycleMainService),x(1,P.IConfigurationService),x(2,i.ITelemetryService),x(3,L.IEnvironmentMainService),x(4,p.IRequestService),x(5,g.ILogService),x(6,h.IProductService)],m),e.DarwinUpdateService=m}),define(Q[224],J([0,1,17,24,18,41,31,26,6,75,40,25,42]),function(j,e,w,R,D,b,P,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends i.AbstractUpdateService{constructor(m,S,v,a,c,l,s,t){super(m,S,a,c,l,t);this.telemetryService=v,this.nativeHostMainService=s}buildUpdateFeedUrl(m){return(0,i.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(b.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},g.CancellationToken.None).then(L.asJson).then(S=>{!S||!S.url||!S.version||!S.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(S))}).then(void 0,S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const v=m?S.message||S:void 0;this.setState(b.State.Idle(1,v))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(b.State.Idle(1))}};p=le([x(0,D.ILifecycleMainService),x(1,R.IConfigurationService),x(2,P.ITelemetryService),x(3,n.IEnvironmentMainService),x(4,L.IRequestService),x(5,y.ILogService),x(6,E.INativeHostMainService),x(7,w.IProductService)],p),e.LinuxUpdateService=p}),define(Q[225],J([0,1,4,10,18,41,26,6,8,22,46,31]),function(j,e,w,R,D,b,P,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(m,S,v){if(this.lifecycleMainService=m,this.logService=v,this._state=b.State.Uninitialized,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,S.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=le([x(0,D.ILifecycleMainService),x(1,P.IEnvironmentMainService),x(2,n.ILogService)],E);let p=class extends E{constructor(m,S,v,a,c,l){super(v,a,c);this.snap=m,this.snapRevision=S,this.telemetryService=l;const s=(0,i.watch)(y.dirname(this.snap)),t=w.Event.fromNodeEventEmitter(s,"change",(d,f)=>f),r=w.Event.filter(t,d=>d==="current"),u=w.Event.debounce(r,(d,f)=>f,2e3)(this.checkForUpdates,this);v.onWillShutdown(()=>{u.dispose(),s.close()})}doCheckForUpdates(m){this.setState(b.State.CheckingForUpdates(m)),this.isUpdateAvailable().then(S=>{S?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(b.State.Idle(2)))},S=>{this.logService.error(S),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(b.State.Idle(2,S.message||S))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,L.spawn)("sleep 3 && "+y.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((v,a)=>(0,i.realpath)(`${y.dirname(this.snap)}/current`,(c,l)=>c?a(c):v(l))),S=y.basename(m);return this.snapRevision!==S}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=le([x(2,D.ILifecycleMainService),x(3,P.IEnvironmentMainService),x(4,n.ILogService),x(5,g.ITelemetryService)],p),e.SnapUpdateService=p}),define(Q[226],J([0,1,22,8,23,52,24,18,17,41,31,26,6,75,40,108,27,46,25,10,16,7,42]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,I=1e3){for(;!f();)await(0,c.timeout)(I)}let o;function u(){return typeof o=="undefined"&&(o=w.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),o}let d=class extends p.AbstractUpdateService{constructor(I,A,F,C,H,X,ne,oe,V){super(I,A,C,H,X,V);this.telemetryService=F,this.fileService=ne,this.nativeHostMainService=oe}get cachePath(){const I=R.join((0,S.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return w.promises.mkdir(I,{recursive:!0}).then(()=>I)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(I){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),u()===1?A+="-archive":this.productService.target==="user"&&(A+="-user"),(0,p.createUpdateURL)(A,I,this.productService)}doCheckForUpdates(I){!this.url||(this.setState(i.State.CheckingForUpdates(I)),this.requestService.request({url:this.url},a.CancellationToken.None).then(h.asJson).then(A=>{const F=u();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I}),this.setState(i.State.Idle(F)),Promise.resolve(null)):F===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(C=>D.exists(C).then(H=>{if(H)return Promise.resolve(C);const X=A.url,ne=A.hash,oe=`${C}.tmp`;return this.requestService.request({url:X},a.CancellationToken.None).then(V=>this.fileService.writeFile(s.URI.file(oe),V.stream)).then(ne?()=>(0,m.checksum)(oe,A.hash):()=>{}).then(()=>w.promises.rename(oe,C)).then(()=>C)})).then(C=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:C},H&&A.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I});const F=I?A.message||A:void 0;this.setState(i.State.Idle(u(),F))}))}async doDownloadUpdate(I){I.update.url&&this.nativeHostMainService.openExternal(void 0,I.update.url),this.setState(i.State.Idle(u()))}async getUpdatePackagePath(I){const A=await this.cachePath;return R.join(A,`CodeSetup-${this.productService.quality}-${I}.exe`)}async cleanup(I=null){const A=I?X=>!new RegExp(`${this.productService.quality}-${I}\\.exe$`).test(X):()=>!0,F=await this.cachePath,H=(await D.readdir(F)).filter(A).map(async X=>{try{await w.promises.unlink(R.join(F,X))}catch(ne){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const I=this.state.update;this.setState(i.State.Updating(I));const A=await this.cachePath;this.availableUpdate.updateFilePath=R.join(A,`CodeSetup-${this.productService.quality}-${I.version}.flag`),await D.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(u()))});const C=`${this.productService.win32MutexName}-ready`,H=await new Promise((X,ne)=>{j(["windows-mutex"],X,ne)});r(()=>H.isActive(C)).then(()=>this.setState(i.State.Ready(I)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?w.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};le([b.memoize],d.prototype,"cachePath",null),d=le([x(0,n.ILifecycleMainService),x(1,P.IConfigurationService),x(2,L.ITelemetryService),x(3,g.IEnvironmentMainService),x(4,h.IRequestService),x(5,E.ILogService),x(6,l.IFileService),x(7,t.INativeHostMainService),x(8,y.IProductService)],d),e.Win32UpdateService=d}),define(Q[51],J([0,1,28,26,8,23,22,3,4,6,58,44,9,2,15,5,148,17,11,13,49,50,97]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let r=class extends p.Disposable{constructor(f,I,A,F,C){super();this.environmentMainService=f,this.logService=I,this.backupMainService=A,this.dialogMainService=F,this.productService=C,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new y.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new y.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==E.Schemas.file)return null;let I;try{I=(0,P.readFileSync)(f.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(f,I)}isWorkspacePath(f){return(0,w.isUntitledWorkspace)(f,this.environmentMainService)||(0,w.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,I){try{const A=this.doParseStoredWorkspace(f,I),F=o(f);return{id:F.id,configPath:F.configPath,folders:(0,w.toWorkspaceFolders)(A.folders,F.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(f,I){const A=(0,g.parse)(I);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(F=>(0,w.isStoredWorkspaceFolder)(F));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(f,I){const{workspace:A,storedWorkspace:F}=this.newUntitledWorkspace(f,I),C=A.configPath.fsPath;return await P.promises.mkdir((0,D.dirname)(C),{recursive:!0}),await(0,b.writeFile)(C,JSON.stringify(F,null,"	")),A}createUntitledWorkspaceSync(f,I){const{workspace:A,storedWorkspace:F}=this.newUntitledWorkspace(f,I),C=A.configPath.fsPath;return(0,P.mkdirSync)((0,D.dirname)(C),{recursive:!0}),(0,b.writeFileSync)(C,JSON.stringify(F,null,"	")),A}newUntitledWorkspace(f=[],I){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),F=(0,h.joinPath)(this.untitledWorkspacesHome,A),C=(0,h.joinPath)(F,w.UNTITLED_WORKSPACE_NAME),H=[];for(const X of f)H.push((0,w.getStoredWorkspaceFolder)(X.uri,!0,X.name,F,!n.isWindows,h.extUriBiasedIgnorePathCase));return{workspace:o(C),storedWorkspace:{folders:H,remoteAuthority:I}}}async getWorkspaceIdentifier(f){return o(f)}isUntitledWorkspace(f){return(0,w.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const I=(0,h.originalFSPath)(f.configPath);try{(0,b.rimrafSync)((0,D.dirname)(I));const A=(0,D.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,P.existsSync)(A)&&(0,b.writeFileSync)((0,D.join)(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${I} (${A}).`)}}getUntitledWorkspacesSync(){const f=[];try{const I=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(A=>(0,h.joinPath)(this.untitledWorkspacesHome,A,w.UNTITLED_WORKSPACE_NAME));for(const A of I){const F=o(A),C=this.resolveLocalWorkspaceSync(A);C?f.push({workspace:F,remoteAuthority:C.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(F)}}catch(I){I.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${I}).`)}return f}async enterWorkspace(f,I,A){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,I,A))return null;const C=this.doEnterWorkspace(f,o(A));return C?(this._onDidEnterWorkspace.fire({window:f,workspace:C.workspace}),C):null}async isValidTargetWorkspacePath(f,I,A){if(!A)return!0;if((0,w.isWorkspaceIdentifier)(f.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,A))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(I,A)){const F={title:this.productService.nameLong,type:"info",buttons:[(0,S.localize)(0,null)],message:(0,S.localize)(1,null,(0,h.basename)(A)),detail:(0,S.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(F,(0,c.withNullAsUndefined)(a.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,I){if(!f.config)return null;f.focus();let A;return f.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:I,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,w.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=I,f.config.backupPath=A,{workspace:I,backupPath:A}}};r=le([x(0,R.IEnvironmentMainService),x(1,i.ILogService),x(2,l.IBackupMainService),x(3,s.IDialogMainService),x(4,v.IProductService)],r),e.WorkspacesManagementMainService=r;function o(d){function f(){let I=d.scheme===E.Schemas.file?(0,h.originalFSPath)(d):d.toString();return n.isLinux||(I=I.toLowerCase()),(0,L.createHash)("md5").update(I).digest("hex")}return{id:f(),configPath:d}}e.getWorkspaceIdentifier=o;function u(d,f){function I(){if(d.scheme!==E.Schemas.file)return(0,L.createHash)("md5").update(d.toString()).digest("hex");if(!f)try{f=(0,P.statSync)(d.fsPath)}catch(C){return}let F;return n.isLinux?F=f.ino:n.isMacintosh?F=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?F=Math.floor(f.birthtimeMs):F=f.birthtime.getTime()),(0,L.createHash)("md5").update(d.fsPath).update(F?String(F):"").digest("hex")}const A=I();if(typeof A=="string")return{id:A,uri:d}}e.getSingleFolderWorkspaceIdentifier=u}),define(Q[98],J([0,1,6,95,3,5,32,23,51,24,7,11,34,53,25,28,13]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let v=class{constructor(c,l,s,t,r){this.logService=c,this.windowsMainService=l,this.urlService=s,this.workspacesManagementMainService=t,this.configurationService=r}async start(c,l){this.logService.trace("Received data from other instance: ",c,l),D.isMacintosh&&g.app.focus({steal:!0});const s=this.parseOpenUrl(c);if(s.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:o}of s)this.urlService.open(r,{originalUrl:o})})}else return this.startOpenWindow(c,l)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,E.coalesce)(c._urls.map(l=>{try{return{uri:L.URI.parse(l),url:l}}catch(s){return null}})):[]}async startOpenWindow(c,l){const s=(0,p.isLaunchedFromCli)(l)?0:4;let t=[];const r=c.wait&&c.waitMarkerFilePath?L.URI.file(c.waitMarkerFilePath):void 0,o=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:s,cli:c,userEnv:l,waitMarkerFileURI:r,remoteAuthority:o});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let u=!1;if(c["new-window"]||c["unity-launch"])u=!0;else if(c["reuse-window"])u=!1;else{const d=this.configurationService.getValue("window");switch((d==null?void 0:d.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!D.isMacintosh}}if(u)t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:o});else{const d=this.windowsMainService.getLastActiveWindow();d?(d.focus(),t=[d]):t=this.windowsMainService.open({context:s,cli:c,forceEmpty:!0,remoteAuthority:o})}}else t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:c.goto,remoteAuthority:o});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return g.BrowserWindow.getAllWindows().forEach(l=>{const s=this.windowsMainService.getWindowById(l.id);s?c.push(this.codeWindowToInfo(s)):c.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(r=>{const o=t.remoteAuthority;if(o){const u=`vscode:getDiagnosticInfoResponse${t.id}`,d={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",h.CancellationToken.None,{replyChannel:u,args:d}),g.ipcMain.once(u,(f,I)=>{I||r({hostName:o,errorMessage:`Unable to resolve connection to '${o}'.`}),r(I)}),setTimeout(()=>{r({hostName:o,errorMessage:`Fetching remote diagnostics for '${o}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const l=[],s=c.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(s))l.push(s.uri);else if((0,m.isWorkspaceIdentifier)(s)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(s.configPath);t&&t.folders.forEach(o=>{l.push(o.uri)})}return l}codeWindowToInfo(c){const l=this.getFolderURIs(c),s=(0,S.assertIsDefined)(c.win);return this.browserWindowToInfo(s,l,c.remoteAuthority)}browserWindowToInfo(c,l=[],s){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:l,remoteAuthority:s}}};v=le([x(0,w.ILogService),x(1,P.IWindowsMainService),x(2,R.IURLService),x(3,y.IWorkspacesManagementMainService),x(4,i.IConfigurationService)],v),e.LaunchMainService=v}),define(Q[227],J([0,1,139,27,17,60,11,98,68,26,3,6,81,50,5,61,9,42]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0;const a="#1E1E1E";e.IIssueMainService=(0,h.createDecorator)("issueMainService");let c=class{constructor(t,r,o,u,d,f,I,A,F){this.machineId=t,this.userEnv=r,this.environmentMainService=o,this.launchMainService=u,this.logService=d,this.diagnosticsService=f,this.dialogMainService=I,this.nativeHostMainService=A,this.productService=F,this._issueWindow=null,this._issueParentWindow=null,this._processExplorerWindow=null,this._processExplorerParentWindow=null,this.registerListeners()}registerListeners(){P.ipcMain.on("vscode:issueSystemInfoRequest",async t=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(r=>{const[o,u]=r;this.diagnosticsService.getSystemInfo(o,u).then(d=>{this.safeSend(t,"vscode:issueSystemInfoResponse",d)})})}),P.ipcMain.on("vscode:listProcesses",async t=>{const r=[];try{const o=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,E.listProcesses)(o)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,y.isRemoteDiagnosticError)(u)?r.push({name:u.hostName,rootProcess:u}):u.processes&&r.push({name:u.hostName,rootProcess:u.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(t,"vscode:listProcessesResponse",r)}),P.ipcMain.on("vscode:issueReporterClipboard",t=>{const r={message:(0,w.localize)(1,null),type:"warning",buttons:[(0,w.localize)(2,null),(0,w.localize)(3,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(r,this._issueWindow).then(o=>{this.safeSend(t,"vscode:issueReporterClipboardResponse",o.response===0)})}),P.ipcMain.on("vscode:issuePerformanceInfoRequest",t=>{this.getPerformanceInfo().then(r=>{this.safeSend(t,"vscode:issuePerformanceInfoResponse",r)})}),P.ipcMain.on("vscode:issueReporterConfirmClose",()=>{const t={message:(0,w.localize)(4,null),type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(t,this._issueWindow).then(r=>{r.response===0&&this._issueWindow&&(this._issueWindow.destroy(),this._issueWindow=null)})}),P.ipcMain.on("vscode:workbenchCommand",(t,r)=>{const{id:o,from:u,args:d}=r;let f;switch(u){case"issueReporter":f=this._issueParentWindow;break;case"processExplorer":f=this._processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${u}`)}f&&f.webContents.send("vscode:runAction",{id:o,from:u,args:d})}),P.ipcMain.on("vscode:openExternal",(t,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),P.ipcMain.on("vscode:closeIssueReporter",t=>{this._issueWindow&&this._issueWindow.close()}),P.ipcMain.on("vscode:closeProcessExplorer",t=>{this._processExplorerWindow&&this._processExplorerWindow.close()}),P.ipcMain.on("vscode:windowsInfoRequest",t=>{this.launchMainService.getMainProcessInfo().then(r=>{this.safeSend(t,"vscode:windowsInfoResponse",r.windows)})})}safeSend(t,r,...o){t.sender.isDestroyed()||t.sender.send(r,...o)}async openReporter(t){if(!this._issueWindow&&(this._issueParentWindow=P.BrowserWindow.getFocusedWindow(),this._issueParentWindow)){const r=this.getWindowPosition(this._issueParentWindow,700,800);this._issueWindow=new P.BrowserWindow({fullscreen:!1,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:(0,w.localize)(7,null),backgroundColor:t.styles.backgroundColor||a,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,m.zoomLevelToZoomFactor)(t.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._issueWindow.setMenuBarVisibility(!1);const o={};this.logService.trace("issueService#openReporter: opening issue reporter"),this._issueWindow.loadURL(this.getIssueReporterPath(t,o)),this._issueWindow.on("close",()=>this._issueWindow=null),this._issueParentWindow.on("closed",()=>{this._issueWindow&&(this._issueWindow.close(),this._issueWindow=null)})}this._issueWindow&&this._issueWindow.focus()}async openProcessExplorer(t){if(!this._processExplorerWindow&&(this._processExplorerParentWindow=P.BrowserWindow.getFocusedWindow(),this._processExplorerParentWindow)){const r=this.getWindowPosition(this._processExplorerParentWindow,800,500);this._processExplorerWindow=new P.BrowserWindow({skipTaskbar:!0,resizable:!0,fullscreen:!1,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,backgroundColor:t.styles.backgroundColor,title:(0,w.localize)(8,null),webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,m.zoomLevelToZoomFactor)(t.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._processExplorerWindow.setMenuBarVisibility(!1);const o={appRoot:this.environmentMainService.appRoot,windowId:this._processExplorerWindow.id,userEnv:this.userEnv,machineId:this.machineId,data:t};this._processExplorerWindow.loadURL(l("vs/code/electron-sandbox/processExplorer/processExplorer.html",o)),this._processExplorerWindow.on("close",()=>this._processExplorerWindow=null),this._processExplorerParentWindow.on("close",()=>{this._processExplorerWindow&&(this._processExplorerWindow.close(),this._processExplorerWindow=null)})}this._processExplorerWindow&&this._processExplorerWindow.focus()}async getSystemStatus(){return Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(t=>{const[r,o]=t;return this.diagnosticsService.getDiagnostics(r,o)})}getWindowPosition(t,r,o){let u;const d=P.screen.getAllDisplays();if(d.length===1)u=d[0];else{if(L.isMacintosh){const A=P.screen.getCursorScreenPoint();u=P.screen.getDisplayNearestPoint(A)}!u&&t&&(u=P.screen.getDisplayMatching(t.getBounds())),u||(u=P.screen.getPrimaryDisplay()||d[0])}const f={width:r,height:o},I=u.bounds;return f.x=I.x+I.width/2-f.width/2,f.y=I.y+I.height/2-f.height/2,I.width>0&&I.height>0&&(f.x<I.x&&(f.x=I.x),f.y<I.y&&(f.y=I.y),f.x>I.x+I.width&&(f.x=I.x),f.y>I.y+I.height&&(f.y=I.y),f.width>I.width&&(f.width=I.width),f.height>I.height&&(f.height=I.height)),f}getPerformanceInfo(){return new Promise(async(t,r)=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]).then(o=>{const[u,d]=o;this.diagnosticsService.getPerformanceInfo(u,d).then(f=>{t(f)}).catch(f=>{this.logService.warn("issueService#getPerformanceInfo ",f.message),r(f)})})})}getIssueReporterPath(t,r){if(!this._issueWindow)throw new Error("Issue window has been disposed");const o={appRoot:this.environmentMainService.appRoot,windowId:this._issueWindow.id,machineId:this.machineId,userEnv:this.userEnv,data:t,features:r,disableExtensions:this.environmentMainService.disableExtensions,os:{type:R.type(),arch:R.arch(),release:R.release()},product:{nameShort:this.productService.nameShort,version:this.productService.darwinUniversalAssetId?`${this.productService.version} (Universal)`:this.productService.version,commit:this.productService.commit,date:this.productService.date,reportIssueUrl:this.productService.reportIssueUrl,reportMarketplaceIssueUrl:this.productService.reportMarketplaceIssueUrl}};return l("vs/code/electron-sandbox/issue/issueReporter.html",o)}};c=le([x(2,i.IEnvironmentMainService),x(3,n.ILaunchMainService),x(4,g.ILogService),x(5,y.IDiagnosticsService),x(6,p.IDialogMainService),x(7,v.INativeHostMainService),x(8,D.IProductService)],c),e.IssueMainService=c;function l(s,t){const r=(0,b.parseArgs)(process.argv,b.OPTIONS),o=Object.assign(r,t);for(const u of Object.keys(o)){const d=u;(o[d]===void 0||o[d]===null||o[d]==="")&&delete o[d]}return S.FileAccess.asBrowserUri(s,j,!0).with({query:`config=${encodeURIComponent(JSON.stringify(o))}`}).toString(!0)}}),define(Q[228],J([0,1,27,8,144,172,4,7,11,26,6,24,60,17,61,2,3,32,28,51,49,192,73,31,50,39,196,18,96,16,9,53,25,42]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t,r,o,u,d,f,I,A,F,C,H,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ne;(function(V){V[V.NONE=0]="NONE",V[V.LOADING=1]="LOADING",V[V.NAVIGATING=2]="NAVIGATING",V[V.READY=3]="READY"})(ne||(ne={}));let oe=class dt extends m.Disposable{constructor(N,B,U,$,T,k,M,O,_,W,z,K,Y,Z){super();this.logService=B,this.environmentMainService=U,this.fileService=$,this.configurationService=k,this.themeMainService=M,this.workspacesManagementMainService=O,this.backupMainService=_,this.telemetryService=W,this.dialogMainService=z,this.lifecycleMainService=K,this.nativeHostMainService=Y,this.productService=Z,this._onWillLoad=this._register(new P.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new P.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new P.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new P.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.readyState=0;{const[G,ee]=this.restoreWindowState(N.state);this.windowState=G,this.logService.trace("window#ctor: using window state",G);const re=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:h.WindowMinimumSize.WIDTH,minHeight:h.WindowMinimumSize.HEIGHT,show:!re,title:this.productService.nameLong,webPreferences:Object.assign({preload:F.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,v8CacheOptions:S.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,h.zoomLevelToZoomFactor)(ie==null?void 0:ie.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};S.browserCodeLoadingCacheStrategy&&this.logService.info(`window#ctor: using vscode-file protocol and V8 cache options: ${S.browserCodeLoadingCacheStrategy}`),S.isLinux?ue.icon=(0,R.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(ue.icon=(0,R.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(ue.fullscreenable=!1),S.isMacintosh&&(ue.acceptFirstMouse=!0,(ie==null?void 0:ie.clickThroughInactive)===!1&&(ue.acceptFirstMouse=!1));const ve=S.isMacintosh&&(ie==null?void 0:ie.nativeTabs)===!0;ve&&(ue.tabbingIdentifier=this.productService.nameShort);const de=(0,h.getTitleBarStyle)(this.configurationService)==="custom";if(de&&(ue.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,S.isMacintosh||(ue.frame=!1)),this._win=new y.BrowserWindow(ue),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),S.isMacintosh&&de&&this._win.setSheetOffset(22),S.isMacintosh&&ee&&(!ve||y.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}re&&(this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show()),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:G=>T.globalStorage.get(G),store:(G,ee)=>T.globalStorage.set(G,ee)}),this.registerListeners()}get config(){return this.currentConfig}get id(){return this._id}get win(){return this._win}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var N;return!!((N=this.currentConfig)===null||N===void 0?void 0:N.extensionDevelopmentPath)}get isExtensionTestHost(){var N;return!!((N=this.currentConfig)===null||N===void 0?void 0:N.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var N;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((N=this.currentConfig)===null||N===void 0?void 0:N.debugId)}setRepresentedFilename(N){S.isMacintosh?this._win.setRepresentedFilename(N):this.representedFilename=N}getRepresentedFilename(){return S.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(N){S.isMacintosh&&this._win.setDocumentEdited(N),this.documentEdited=N}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(N){S.isMacintosh&&(N==null?void 0:N.force)&&y.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.backupPath}get openedWorkspace(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.workspace}get remoteAuthority(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.remoteAuthority}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.whenReadyCallbacks.push(N)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(N=>{function B(){U.dispose(),$.dispose(),N()}const U=this.onDidClose(()=>B()),$=this.onWillLoad(()=>B())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(U,$,T)=>this.onWindowError(3,T)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const N=new Set([F.Schemas.file,F.Schemas.vscodeFileResource,F.Schemas.vscodeRemoteResource,"devtools"]);this._win.webContents.session.webRequest.onBeforeRequest((U,$)=>{const T=n.URI.parse(U.url);return T.path.endsWith(".svg")&&!(N.has(T.scheme)||T.path.includes(F.Schemas.vscodeRemoteResource))?$({cancel:!0}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((U,$)=>{const T=U.responseHeaders,k=T["content-type"]||T["Content-Type"];if(k&&Array.isArray(k)){const M=n.URI.parse(U.url);if(M.path.endsWith(".svg")&&N.has(M.scheme))return T["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:T});if(!M.path.includes(F.Schemas.vscodeRemoteResource)&&k.some(O=>O.toLowerCase().includes("image/svg")))return $({cancel:!0})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),S.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!0),y.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!1),y.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",H.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",H.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const B=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:B},async(U,$)=>{const T=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,T)})})}async onWindowError(N,B){switch(N){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof B=="string"?B:B==null?void 0:B.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof B=="string"?B:B==null?void 0:B.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:N,reason:typeof B!="string"?B==null?void 0:B.reason:void 0}),N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,u.mnemonicButtonLabel)((0,D.localize)(0,null)),(0,u.mnemonicButtonLabel)((0,D.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,D.localize)(2,null))],message:(0,D.localize)(3,null),detail:(0,D.localize)(4,null),noLink:!0},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(N===2){let U;typeof B=="string"||!B?U=(0,D.localize)(5,null):U=(0,D.localize)(6,null,B.reason);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,u.mnemonicButtonLabel)((0,D.localize)(7,null)),(0,u.mnemonicButtonLabel)((0,D.localize)(8,null))],message:U,detail:(0,D.localize)(9,null),noLink:!0},this._win);if(!this._win)return;$.response===0?this.reload():$.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(N){var B;((B=this.openedWorkspace)===null||B===void 0?void 0:B.id)===N.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N));let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(B==null?void 0:B.endsWith("/"))&&(B=B.substr(0,B.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=U;const $=B||"",T=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${T}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:T,pacScript:""})}}addTabbedWindow(N){S.isMacintosh&&N.win&&this._win.addTabbedWindow(N.win)}load(N,{isReload:B,disableExtensions:U}=Object.create(null)){var $,T;const k=(T=($=this.currentConfig)!==null&&$!==void 0?$:this.pendingLoadConfig)===null||T===void 0?void 0:T.userEnv;k&&(0,C.isLaunchedFromCli)(k)&&!(0,C.isLaunchedFromCli)(N.userEnv)&&(N.userEnv=Object.assign(Object.assign({},k),N.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),this.readyState===0?this.currentConfig=N:(this.pendingLoadConfig=N,this.readyState=2);const M=Object.assign({},N);U!==void 0&&(M["disable-extensions"]=U),this.isDocumentEdited()&&(!B||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),B||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),(0,b.mark)("code/willOpenNewWindow"),this._win.loadURL(this.getUrl(M)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:M.workspace})}async reload(N){const B=Object.assign({},this.currentConfig);B.workspace=await this.validateWorkspace(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToWait,this.isExtensionDevelopmentHost&&N&&(B.verbose=N.verbose,B.debugId=N.debugId,B["inspect-extensions"]=N["inspect-extensions"],B["inspect-brk-extensions"]=N["inspect-brk-extensions"],B["extensions-dir"]=N["extensions-dir"]),B.isInitialStartup=!1,this.load(B,{isReload:!0,disableExtensions:N==null?void 0:N["disable-extensions"]})}async validateWorkspace(N){if((0,a.isWorkspaceIdentifier)(N.workspace)){const B=N.workspace.configPath;if(B.scheme===F.Schemas.file&&!await this.fileService.exists(B))return}else if((0,a.isSingleFolderWorkspaceIdentifier)(N.workspace)){const B=N.workspace.uri;if(B.scheme===F.Schemas.file&&!await this.fileService.exists(B))return}return N.workspace}getUrl(N){var B;N.windowId=this._win.id,N.sessionId=`window:${this._win.id}`,N.logLevel=this.logService.getLevel(),N.logsPath=this.environmentMainService.logsPath;const U=this.configurationService.getValue("window"),$=U==null?void 0:U.zoomLevel;typeof $=="number"&&(N.zoomLevel=$),N.fullscreen=this.isFullScreen,N.colorScheme={dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors},N.autoDetectHighContrast=(B=U==null?void 0:U.autoDetectHighContrast)!==null&&B!==void 0?B:!0,N.accessibilitySupport=y.app.accessibilitySupportEnabled,N.maximized=this._win.isMaximized(),N.perfMarks=(0,b.getMarks)(),N.partsSplashPath=(0,R.join)(this.environmentMainService.userDataPath,"rapid_render.json"),N.os={release:(0,w.release)()};const T=(0,E.parseArgs)(process.argv,E.OPTIONS),k=Object.assign(T,N);for(const O in k){const _=k[O];(_==null||_===""||_===!1)&&delete k[O]}let M=this.doGetUrl(k);return M.length>dt.MAX_URL_LENGTH&&(this.logService.warn("Application URL exceeds maximum of 2MB and was shortened."),M=this.doGetUrl(Object.assign(Object.assign({},k),{userEnv:void 0})),M.length>dt.MAX_URL_LENGTH&&this.logService.error("Application URL exceeds maximum of 2MB and cannot be loaded.")),M}doGetUrl(N){let B;return this.environmentMainService.sandbox?B="vs/code/electron-sandbox/workbench/workbench.html":B="vs/code/electron-browser/workbench/workbench.html",F.FileAccess.asBrowserUri(B,j).with({query:`config=${encodeURIComponent(JSON.stringify(N))}`}).toString(!0)}serializeWindowState(){if(!this._win)return(0,v.defaultWindowState)();if(this.isFullScreen){let U;try{U=y.screen.getDisplayMatching(this.getBounds())}catch(k){}const $=(0,v.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0}}const N=Object.create(null);let B;if(!S.isMacintosh&&this._win.isMaximized()?B=0:B=1,B===0?N.mode=0:N.mode=1,B===1||B===0){let U;B===1?U=this.getBounds():U=this._win.getNormalBounds(),N.x=U.x,N.y=U.y,N.width=U.width,N.height=U.height}return N}restoreWindowState(N){let B=!1;if(N)try{const U=y.screen.getAllDisplays();B=U.length>1,N=this.validateWindowState(N,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return[N||(0,v.defaultWindowState)(),B]}validateWindowState(N,B){var U,$;if(this.logService.trace(`window#validateWindowState: validating window state on ${B.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(B.length===1){const O=this.getWorkingArea(B[0]);if(O){this.logService.trace("window#validateWindowState: 1 monitor working area",O);function T(){!N||typeof N.x!="number"||typeof N.y!="number"||!O||(N.x<O.x&&(N.x=O.x),N.y<O.y&&(N.y=O.y))}T(),N.width>O.width&&(N.width=O.width),N.height>O.height&&(N.height=O.height),N.x>O.x+O.width-128&&(N.x=O.x+O.width-N.width),N.y>O.y+O.height-128&&(N.y=O.y+O.height-N.height),T()}return N}if(N.display&&N.mode===3){const O=B.find(_=>_.id===N.display);if(O&&typeof((U=O.bounds)===null||U===void 0?void 0:U.x)=="number"&&typeof(($=O.bounds)===null||$===void 0?void 0:$.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const _=(0,v.defaultWindowState)(3);return _.x=O.bounds.x,_.y=O.bounds.y,_}}let k,M;try{k=y.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),M=this.getWorkingArea(k)}catch(O){}if(k&&M&&N.x+N.width>M.x&&N.y+N.height>M.y&&N.x<M.x+M.width&&N.y<M.y+M.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",M),N}getWorkingArea(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,B]=this._win.getPosition(),[U,$]=this._win.getSize();return{x:N,y:B,width:U,height:$}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(N){this.useNativeFullScreen()?this.setNativeFullScreen(N):this.setSimpleFullScreen(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",H.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(N){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(N)}setSimpleFullScreen(N){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(N),this._win.webContents.focus()}useNativeFullScreen(){const N=this.configurationService.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let N=(0,h.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}setMenuBarVisibility(N,B=!0){S.isMacintosh||(N==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,D.localize)(10,null)),N==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(N)}):this.doSetMenuBarVisibility(N))}doSetMenuBarVisibility(N){const B=this.isFullScreen;switch(N){case"classic":this._win.setMenuBarVisibility(!B),this._win.autoHideMenuBar=B;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(S.isMacintosh)switch(y.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(N,B,...U){this.isReady?this.send(N,...U):this.ready().then(()=>{B.isCancellationRequested||this.send(N,...U)})}send(N,...B){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${N} for window that is destroyed`);return}this._win.webContents.send(N,...B)}}updateTouchBar(N){!S.isMacintosh||this.touchBarGroups.forEach((B,U)=>{const $=N[U];B.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(!!S.isMacintosh){for(let N=0;N<10;N++){const B=this.createTouchBarGroup();this.touchBarGroups.push(B)}this._win.setTouchBar(new y.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(N=[]){const B=this.createTouchBarGroupSegments(N),U=new y.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",H.CancellationToken.None,{id:U.segments[$].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(N=[]){return N.map(U=>{var $,T;let k;U.icon&&!d.ThemeIcon.isThemeIcon(U.icon)&&((T=($=U.icon)===null||$===void 0?void 0:$.dark)===null||T===void 0?void 0:T.scheme)===F.Schemas.file&&(k=y.nativeImage.createFromPath(n.URI.revive(U.icon.dark).fsPath),k.isEmpty()&&(k=void 0));let M;return typeof U.title=="string"?M=U.title:M=U.title.value,{id:U.id,label:k?void 0:M,icon:k}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};oe.MAX_URL_LENGTH=2*A.ByteSize.MB,oe=le([x(1,L.ILogService),x(2,i.IEnvironmentMainService),x(3,A.IFileService),x(4,I.IStorageMainService),x(5,g.IConfigurationService),x(6,t.IThemeMainService),x(7,c.IWorkspacesManagementMainService),x(8,l.IBackupMainService),x(9,r.ITelemetryService),x(10,o.IDialogMainService),x(11,f.ILifecycleMainService),x(12,X.INativeHostMainService),x(13,p.IProductService)],oe),e.CodeWindow=oe}),define(Q[62],J([0,1,147,34,38,11,6,39,4,3,28,51,10,15,7,9,23,18,5,2]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,a.createDecorator)("workspacesHistoryMainService");let l=class $e extends c.Disposable{constructor(f,I,A,F){super();this.stateService=f,this.logService=I,this.workspacesManagementMainService=A,this.lifecycleMainService=F,this._onDidChangeRecentlyOpened=this._register(new y.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const I=[],A=[];for(let F of f)if((0,L.isRecentWorkspace)(F))!this.workspacesManagementMainService.isUntitledWorkspace(F.workspace)&&r(I,F.workspace)===-1&&I.push(F);else if((0,L.isRecentFolder)(F))o(I,F.folderUri)===-1&&I.push(F);else{const C=u(A,F.fileUri)>=0,H=F.fileUri.scheme===m.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,p.basename)(F.fileUri))>=0;!C&&!H&&(A.push(F),i.isWindows&&F.fileUri.scheme===m.Schemas.file&&b.app.addRecentDocument(F.fileUri.fsPath))}this.addEntriesFromStorage(I,A),I.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(I.length=$e.MAX_TOTAL_RECENT_ENTRIES),A.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(A.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:I,files:A}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const I=H=>{const X=t(H);for(const ne of f)if(p.extUriBiasedIgnorePathCase.isEqual(ne,X))return!1;return!0},A=this.getRecentlyOpened(),F=A.workspaces.filter(I),C=A.files.filter(I);(F.length!==A.workspaces.length||C.length!==A.files.length)&&(this.saveRecentlyOpened({files:C,workspaces:F}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){b.app.clearRecentDocuments();const f=this.getRecentlyOpened(),I=[];let A=0;for(let C=0;C<f.workspaces.length&&A<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;C++){const H=t(f.workspaces[C]);if(H.scheme===m.Schemas.file){const X=(0,p.originalFSPath)(H);await(0,S.exists)(X)&&(I.push(X),A++)}}const F=[];for(let C=0;C<f.files.length&&A<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;C++){const H=t(f.files[C]);if(H.scheme===m.Schemas.file){const X=(0,p.originalFSPath)(H);if($e.COMMON_FILES_FILTER.includes((0,p.basename)(H))||I.includes(X))continue;await(0,S.exists)(X)&&(F.push(X),A++)}}F.reverse().forEach(C=>b.app.addRecentDocument(C)),I.reverse().forEach(C=>b.app.addRecentDocument(C))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var I,A;const F=[],C=[],H=(I=f==null?void 0:f.config)===null||I===void 0?void 0:I.workspace;(0,L.isWorkspaceIdentifier)(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?F.push({workspace:H}):(0,L.isSingleFolderWorkspaceIdentifier)(H)&&F.push({folderUri:H.uri});const X=(A=f==null?void 0:f.config)===null||A===void 0?void 0:A.filesToOpenOrCreate;if(X)for(let ne of X){const oe=ne.fileUri;oe&&u(C,oe)===-1&&C.push({fileUri:oe})}return this.addEntriesFromStorage(F,C),{workspaces:F,files:C}}addEntriesFromStorage(f,I){let A=this.getRecentlyOpenedFromStorage();for(let F of A.workspaces){let C=(0,L.isRecentFolder)(F)?o(f,F.folderUri):r(f,F.workspace);C>=0?f[C].label=f[C].label||F.label:f.push(F)}for(let F of A.files){let C=u(I,F.fileUri);C>=0?I[C].label=I[C].label||F.label:I.push(F)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem($e.recentlyOpenedStorageKey);return(0,L.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const I=(0,L.toStoreData)(f);this.stateService.setItem($e.recentlyOpenedStorageKey,I)}updateWindowsJumpList(){if(!!i.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let I=[];for(let C of b.app.getJumpListSettings().removedItems){const H=C.args;if(H){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);X&&I.push(h.URI.parse(X[2]))}}this.removeRecentlyOpened(I);let A=!1;const F=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(C=>{const H=(0,L.isRecentWorkspace)(C)?C.workspace:C.folderUri,{title:X,description:ne}=this.getWindowsJumpListLabel(H,C.label);let oe;return h.URI.isUri(H)?oe=`--folder-uri "${H.toString()}"`:(A=!0,oe=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:oe,iconPath:"explorer.exe",iconIndex:0}}));F.length>0&&f.push({type:"custom",name:A?(0,w.localize)(2,null):(0,w.localize)(3,null),items:F})}f.push({type:"recent"});try{b.app.setJumpList(f)}catch(I){this.logService.warn("updateWindowsJumpList#setJumpList",I)}}}getWindowsJumpListLabel(f,I){if(I)return{title:(0,n.splitName)(I).name,description:I};if(h.URI.isUri(f))return{title:(0,p.basename)(f),description:s(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,w.localize)(4,null),description:""};let A=(0,p.basename)(f.configPath);return A.endsWith(L.WORKSPACE_EXTENSION)&&(A=A.substr(0,A.length-L.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,A),description:s(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=le([x(0,D.IStateService),x(1,P.ILogService),x(2,g.IWorkspacesManagementMainService),x(3,v.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function s(d){return d.scheme==="file"?(0,n.normalizeDriveLetter)(d.fsPath):d.toString()}function t(d){return(0,L.isRecentFolder)(d)?d.folderUri:(0,L.isRecentFile)(d)?d.fileUri:d.workspace.configPath}function r(d,f){return d.findIndex(I=>(0,L.isRecentWorkspace)(I)&&I.workspace.id===f.id)}function o(d,f){return d.findIndex(I=>(0,L.isRecentFolder)(I)&&p.extUriBiasedIgnorePathCase.isEqual(I.folderUri,f))}function u(d,f){return d.findIndex(I=>p.extUriBiasedIgnorePathCase.isEqual(I.fileUri,f))}}),define(Q[229],J([0,1,140,3,26,11,61,24,31,41,17,10,6,39,32,62,177,7,38,18,42,25]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class ft{constructor(d,f,I,A,F,C,H,X,ne,oe,V){this.updateService=d,this.configurationService=f,this.windowsMainService=I,this.environmentMainService=A,this.telemetryService=F,this.workspacesHistoryMainService=C,this.stateService=H,this.lifecycleMainService=X,this.logService=ne,this.nativeHostMainService=oe,this.productService=V,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,P.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const d=this.stateService.getItem(ft.lastKnownMenubarStorageKey);d&&(d.menus&&(this.menubarMenus=d.menus),d.keybindings&&(this.keybindings=d.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(C,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(C,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(C,H,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(C,H,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const d=this.productService.twitterUrl;d&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(d,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const I=this.productService.reportIssueUrl;I&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(I,"openReportIssues"));const A=this.productService.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const C=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${C}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const F=this.productService.privacyStatementUrl;F&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const C=A.indexOf("?")>0?"&":"?";this.openUrl(`${F}${C}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(F,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(d=>this.onDidChangeWindowsCount(d)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let d=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof d!="boolean"&&(d=!0),d}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let d=this.configurationService.getValue("window.nativeTabs");return typeof d!="boolean"&&(d=!1),d}updateMenu(d,f){this.menubarMenus=d.menus,this.keybindings=d.keybindings,this.stateService.setItem(ft.lastKnownMenubarStorageKey,d),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(d){!R.isMacintosh||(d.oldCount===0&&d.newCount>0||d.oldCount>0&&d.newCount===0)&&(this.closedLastWindow=d.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const d=b.Menu.getApplicationMenu();if(d&&this.oldMenus.push(d),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(R.isMacintosh?new b.Menu:null);return}const f=new b.Menu;let I;if(R.isMacintosh){const W=new b.Menu;I=new b.MenuItem({label:this.productService.nameShort,submenu:W}),this.setMacApplicationMenu(W),f.append(I)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const W=new b.Menu;W.append(new b.MenuItem({label:this.mnemonicLabel(w.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(W)}const A=new b.Menu,F=new b.MenuItem({label:this.mnemonicLabel(w.localize(1,null)),submenu:A});this.setMenuById(A,"File"),f.append(F);const C=new b.Menu,H=new b.MenuItem({label:this.mnemonicLabel(w.localize(2,null)),submenu:C});this.setMenuById(C,"Edit"),f.append(H);const X=new b.Menu,ne=new b.MenuItem({label:this.mnemonicLabel(w.localize(3,null)),submenu:X});this.setMenuById(X,"Selection"),f.append(ne);const oe=new b.Menu,V=new b.MenuItem({label:this.mnemonicLabel(w.localize(4,null)),submenu:oe});this.setMenuById(oe,"View"),f.append(V);const N=new b.Menu,B=new b.MenuItem({label:this.mnemonicLabel(w.localize(5,null)),submenu:N});this.setMenuById(N,"Go"),f.append(B);const U=new b.Menu,$=new b.MenuItem({label:this.mnemonicLabel(w.localize(6,null)),submenu:U});this.setMenuById(U,"Run"),f.append($);const T=new b.Menu,k=new b.MenuItem({label:this.mnemonicLabel(w.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),f.append(k);let M;if(this.shouldDrawMenu("Window")){const W=new b.Menu;M=new b.MenuItem({label:this.mnemonicLabel(w.localize(8,null)),submenu:W,role:"window"}),this.setMacWindowMenu(W)}M&&f.append(M);const O=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(w.localize(9,null)),submenu:O,role:"help"});this.setMenuById(O,"Help"),f.append(_),f.items&&f.items.length>0?b.Menu.setApplicationMenu(f):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(d){const f=this.createMenuItem(w.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),I=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const N=new b.Menu;this.setMenuById(N,"Preferences"),A=new b.MenuItem({label:this.mnemonicLabel(w.localize(11,null)),submenu:N})}const F=new b.Menu,C=new b.MenuItem({label:w.localize(12,null),role:"services",submenu:F}),H=new b.MenuItem({label:w.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new b.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new b.MenuItem({label:w.localize(15,null),role:"unhide"}),oe=new b.MenuItem(this.likeAction("workbench.action.quit",{label:w.localize(16,null,this.productService.nameLong),click:()=>{const N=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||(N==null?void 0:N.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),V=[f];V.push(...I),A&&V.push(o(),A),V.push(o(),C,o(),H,X,ne,o(),oe),V.forEach(N=>d.append(N))}shouldDrawMenu(d){if(!R.isMacintosh&&(0,P.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(d){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[d];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[d]}}setMenu(d,f){f.forEach(I=>{if((0,S.isMenubarMenuItemSeparator)(I))d.append(o());else if((0,S.isMenubarMenuItemSubmenu)(I)){const A=new b.Menu,F=new b.MenuItem({label:this.mnemonicLabel(I.label),submenu:A});this.setMenu(A,I.submenu.items),d.append(F)}else(0,S.isMenubarMenuItemRecentAction)(I)?d.append(this.createOpenRecentMenuItem(I)):(0,S.isMenubarMenuItemAction)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(d),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[I.id]?d.append(new b.MenuItem(this.likeAction(I.id,{label:this.mnemonicLabel(I.label),click:this.fallbackMenuHandlers[I.id]}))):d.append(this.createMenuItem(I.label,I.id,!1,I.checked)):d.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)):d.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)))})}setMenuById(d,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(d,this.menubarMenus[f].items)}insertCheckForUpdatesItems(d){const f=this.getUpdateMenuItems();f.length&&(f.forEach(I=>d.append(I)),d.append(o()))}createOpenRecentMenuItem(d){const f=v.URI.revive(d.uri),I=d.id,A=I==="openRecentFile"?{fileUri:f}:I==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new b.MenuItem(this.likeAction(I,{label:d.label,click:(F,C,H)=>{const X=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:d.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(d){return!!(d&&(!R.isMacintosh&&(d.ctrlKey||d.shiftKey)||R.isMacintosh&&(d.metaKey||d.altKey)))}createRoleMenuItem(d,f,I){const A={label:this.mnemonicLabel(d),role:I,enabled:!0};return new b.MenuItem(this.withKeybinding(f,A))}setMacWindowMenu(d){const f=new b.MenuItem({label:w.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),I=new b.MenuItem({label:w.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new b.MenuItem({label:w.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),F=this.createMenuItem(w.localize(20,null),"workbench.action.switchWindow"),C=[];this.currentEnableNativeTabs&&(C.push(o()),C.push(this.createMenuItem(w.localize(21,null),"workbench.action.newWindowTab")),C.push(this.createRoleMenuItem(w.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.createRoleMenuItem(w.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.createRoleMenuItem(w.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.createRoleMenuItem(w.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,I,o(),F,...C,o(),A].forEach(H=>d.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(w.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const f=this.windowsMainService.getLastActiveWindow(),I=f&&`window:${f.id}`;this.updateService.checkForUpdates(I)},0)})];case"checking for updates":return[new b.MenuItem({label:w.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(w.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:w.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(w.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:w.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(w.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(d,f,I,A){const F=this.mnemonicLabel(d),C=typeof f=="function"?f:(V,N,B)=>{const U=V?V.userSettingsLabel:null;let $=f;Array.isArray(f)&&($=this.isOptionClick(B)?f[1]:f[0]),U&&B.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:U}):this.runActionInRenderer({type:"commandId",commandId:$})},H=typeof I=="boolean"?I:this.windowsMainService.getWindowCount()>0,X=typeof A=="boolean"?A:!1,ne={label:F,click:C,enabled:H};X&&(ne.type="checkbox",ne.checked=X);let oe;return typeof f=="string"?oe=f:Array.isArray(f)&&(oe=f[0]),R.isMacintosh&&(oe==="editor.action.clipboardCutAction"?ne.role="cut":oe==="editor.action.clipboardCopyAction"?ne.role="copy":oe==="editor.action.clipboardPasteAction"&&(ne.role="paste"),oe==="undo"?ne.click=this.makeContextAwareClickHandler(C,{inDevTools:V=>V.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?ne.click=this.makeContextAwareClickHandler(C,{inDevTools:V=>V.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(C,{inDevTools:V=>V.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(oe,ne))}makeContextAwareClickHandler(d,f){return(I,A,F)=>{const C=b.BrowserWindow.getFocusedWindow();if(!C)return f.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return f.inDevTools(C.webContents.devToolsWebContents);d(I,A||C,F)}}runActionInRenderer(d){let f=b.BrowserWindow.getFocusedWindow();if(!f){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(f=A.win)}const I=f?this.windowsMainService.getWindowById(f.id):void 0;if(I){if(this.logService.trace("menubar#runActionInRenderer",d),R.isMacintosh&&!this.environmentMainService.isBuilt&&!I.isReady&&(d.type==="commandId"&&d.commandId==="workbench.action.toggleDevTools"||d.type!=="commandId"&&d.userSettingsLabel==="alt+cmd+i"))return;if(d.type==="commandId"){const A={id:d.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:d.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",d)}withKeybinding(d,f){const I=typeof d=="string"?this.keybindings[d]:void 0;if(I==null?void 0:I.label){if(I.isNative!==!1)f.accelerator=I.label,f.userSettingsLabel=I.userSettingsLabel;else if(typeof f.label=="string"){const A=f.label.indexOf("[");A>=0?f.label=`${f.label.substr(0,A)} [${I.label}]`:f.label=`${f.label} [${I.label}]`}}else f.accelerator=void 0;return f}likeAction(d,f,I=!f.accelerator){I&&(f=this.withKeybinding(d,f));const A=f.click;return f.click=(F,C,H)=>{this.reportMenuActionTelemetry(d),A&&A(F,C,H)},f}openUrl(d,f){this.nativeHostMainService.openExternal(void 0,d),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(d){this.telemetryService.publicLog2("workbenchActionExecuted",{id:d,from:t})}mnemonicLabel(d){return(0,p.mnemonicMenuLabel)(d,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=le([x(0,i.IUpdateService),x(1,n.IConfigurationService),x(2,h.IWindowsMainService),x(3,D.IEnvironmentMainService),x(4,y.ITelemetryService),x(5,m.IWorkspacesHistoryMainService),x(6,a.IStateService),x(7,c.ILifecycleMainService),x(8,E.ILogService),x(9,l.INativeHostMainService),x(10,L.IProductService)],r),e.Menubar=r;function o(){return new b.MenuItem({type:"separator"})}}),define(Q[230],J([0,1,229,6,5,18]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,D.createDecorator)("menubarMainService");let P=class{constructor(y,i,L){this.instantiationService=y,this.lifecycleMainService=i,this.logService=L,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(w.Menubar)}async updateMenubar(y,i){this.logService.trace("menubarService#updateMenubar",y),(await this.menubar).updateMenu(i,y)}};P=le([x(0,D.IInstantiationService),x(1,b.ILifecycleMainService),x(2,R.ILogService)],P),e.MenubarMainService=P}),define(Q[231],J([0,1,22,8,145,34,49,26,38,228,11,18,24,6,61,97,4,17,62,3,28,5,9,7,15,71,212,51,43,2,50,13,29,39,25,16,35]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t,r,o,u,d,f,I,A,F,C,H,X,ne,oe,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N($){return(0,l.isWorkspaceIdentifier)($==null?void 0:$.workspace)}function B($){return(0,l.isSingleFolderWorkspaceIdentifier)($==null?void 0:$.workspace)}let U=class Je extends A.Disposable{constructor(T,k,M,O,_,W,z,K,Y,Z,G,ee,re,ie){super();this.machineId=T,this.initialUserEnv=k,this.logService=M,this.stateService=O,this.environmentMainService=_,this.lifecycleMainService=W,this.backupMainService=z,this.configurationService=K,this.workspacesHistoryMainService=Y,this.workspacesManagementMainService=Z,this.instantiationService=G,this.dialogMainService=ee,this.fileService=re,this.productService=ie,this._onDidOpenWindow=this._register(new S.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new S.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new S.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new S.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new d.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.lifecycleMainService.when(2).then(()=>this.registerListeners())}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window)))}openEmptyWindow(T,k){let M=this.environmentMainService.args;const O=(k==null?void 0:k.remoteAuthority)||void 0,_=!0,W=k==null?void 0:k.forceReuseWindow,z=!W;return this.open(Object.assign(Object.assign({},T),{cli:M,forceEmpty:_,forceNewWindow:z,forceReuseWindow:W,remoteAuthority:O}))}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const k=[],M=[],O=[],_=[],W=[];let z,K=0;const Y=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",Y);for(const ie of Y)B(ie)?T.addMode?k.push(ie):M.push(ie):N(ie)?O.push(ie):ie.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ie.remoteAuthority}),z.filesToOpenOrCreate.push(ie)):ie.backupPath?W.push({backupFolder:(0,R.basename)(ie.backupPath),remoteAuthority:ie.remoteAuthority}):K++;T.diffMode&&(z==null?void 0:z.filesToOpenOrCreate.length)===2&&(z.filesToDiff=z.filesToOpenOrCreate,z.filesToOpenOrCreate=[]),z&&T.waitMarkerFileURI&&(z.filesToWait={paths:[...z.filesToDiff,...z.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(_.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),O.push(..._),W.push(...this.backupMainService.getEmptyWindowBackupPaths())):W.length=0;const{windows:Z,filesOpenedInWindow:G}=this.doOpen(T,O,M,W,K,z,k);if(this.logService.trace(`windowsManager#open used window count ${Z.length} (workspacesToOpen: ${O.length}, foldersToOpen: ${M.length}, emptyToRestore: ${W.length}, emptyToOpen: ${K})`),Z.length>1)if(G)G.focus();else{const ie=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let ue=!0,ve=!0;if(ie){const de=Z.filter(he=>this.windowsStateHandler.state.lastActiveWindow&&he.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);de.length&&(de[0].focus(),ue=!1,ve=!1)}if(ue)for(let de=Z.length-1;de>=0;de--){const he=Z[de];if(!(he.openedWorkspace&&_.some(me=>he.openedWorkspace&&me.workspace.id===he.openedWorkspace.id)||he.backupPath&&W.some(me=>he.backupPath&&me.backupFolder===(0,R.basename)(he.backupPath)))){he.focus(),ve=!1;break}}ve&&Z[Z.length-1].focus()}const ee=z&&z.filesToDiff.length>0;if(!Z.some(ie=>ie.isExtensionDevelopmentHost)&&!ee&&!T.noRecentEntry){const ie=[];for(const ue of Y)N(ue)?ie.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):B(ue)?ie.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&ie.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ie)}const re=T.waitMarkerFileURI;return T.context===0&&re&&Z.length===1&&Z[0]&&Z[0].whenClosedOrLoaded.then(()=>this.fileService.del(re),()=>{}),Z}doOpen(T,k,M,O,_,W,z){const K=[];let Y;function Z(de,he){K.push(de),he&&(Y=de,W=void 0)}let{openFolderInNewWindow:G,openFilesInNewWindow:ee}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&z.length>0){const de=z[0].remoteAuthority,he=this.getLastActiveWindowForAuthority(de);he&&Z(this.doAddFoldersToExistingWindow(he,z.map(me=>me.workspace.uri)))}const re=M.length+k.length+O.length;if(W&&re===0){const de=W.filesToOpenOrCreate[0]||W.filesToDiff[0],he=this.getWindows().filter(ke=>W&&ke.remoteAuthority===W.remoteAuthority);let me;(de==null?void 0:de.fileUri)&&!ee&&((T.context===4||T.context===0||T.context===1)&&(me=(0,m.findWindowOnFile)(he,de.fileUri,ke=>ke.configPath.scheme===t.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):null)),me||(me=this.doGetLastActiveWindow(he))),me?(0,l.isWorkspaceIdentifier)(me.openedWorkspace)?k.push({workspace:me.openedWorkspace,remoteAuthority:me.remoteAuthority}):(0,l.isSingleFolderWorkspaceIdentifier)(me.openedWorkspace)?M.push({workspace:me.openedWorkspace,remoteAuthority:me.remoteAuthority}):Z(this.doOpenFilesInExistingWindow(T,me,W),!0):Z(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:W,forceNewWindow:!0,remoteAuthority:W.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const ie=(0,b.distinct)(k,de=>de.workspace.id);if(ie.length>0){const de=(0,b.coalesce)(ie.map(he=>(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.configPath)));if(de.length>0){const he=de[0],me=(W==null?void 0:W.remoteAuthority)===he.remoteAuthority?W:void 0;Z(this.doOpenFilesInExistingWindow(T,he,me),!!me),G=!0}ie.forEach(he=>{if(!de.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===he.workspace.id)){const me=he.remoteAuthority,ke=(W==null?void 0:W.remoteAuthority)===me?W:void 0;Z(this.doOpenFolderOrWorkspace(T,he,G,ke),!!ke),G=!0}})}const ue=(0,b.distinct)(M,de=>o.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(ue.length>0){const de=(0,b.coalesce)(ue.map(he=>(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.uri)));if(de.length>0){const he=de[0],me=(W==null?void 0:W.remoteAuthority)===he.remoteAuthority?W:void 0;Z(this.doOpenFilesInExistingWindow(T,he,me),!!me),G=!0}ue.forEach(he=>{if(!de.some(Le=>(0,l.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)&&o.extUriBiasedIgnorePathCase.isEqual(Le.openedWorkspace.uri,he.workspace.uri))){const me=he.remoteAuthority,ke=(W==null?void 0:W.remoteAuthority)===me?W:void 0;Z(this.doOpenFolderOrWorkspace(T,he,G,ke),!!ke),G=!0}})}const ve=(0,b.distinct)(O,de=>de.backupFolder);if(ve.length>0&&ve.forEach(de=>{const he=de.remoteAuthority,me=(W==null?void 0:W.remoteAuthority)===he?W:void 0;Z(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:me,remoteAuthority:he,forceNewWindow:!0,forceNewTabbedWindow:T.forceNewTabbedWindow,emptyWindowBackupInfo:de}),!!me),G=!0}),K.length===0||W){W&&!_&&_++;const de=W?W.remoteAuthority:T.remoteAuthority;for(let he=0;he<_;he++)Z(this.doOpenEmpty(T,G,de,W),!!W),G=!0}return{windows:(0,b.distinct)(K),filesOpenedInWindow:Y}}doOpenFilesInExistingWindow(T,k,M){var O;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),k.focus();const _={filesToOpenOrCreate:M==null?void 0:M.filesToOpenOrCreate,filesToDiff:M==null?void 0:M.filesToDiff,filesToWait:M==null?void 0:M.filesToWait,termProgram:(O=T==null?void 0:T.userEnv)===null||O===void 0?void 0:O.TERM_PROGRAM};return k.sendWhenReady("vscode:openFiles",ne.CancellationToken.None,_),k}doAddFoldersToExistingWindow(T,k){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),T.focus();const M={foldersToAdd:k};return T.sendWhenReady("vscode:addFolders",ne.CancellationToken.None,M),T}doOpenEmpty(T,k,M,O,_){return!k&&!_&&typeof T.contextWindowId=="number"&&(_=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:M,forceNewWindow:k,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:O,windowToUse:_})}doOpenFolderOrWorkspace(T,k,M,O,_){return!M&&!_&&typeof T.contextWindowId=="number"&&(_=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:k.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:k.remoteAuthority,forceNewWindow:M,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:O,windowToUse:_})}getPathsToOpen(T){var k;let M,O=!1,_=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(M=this.doExtractPathsFromAPI(T),O=!0):T.forceEmpty?M=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(M=this.doExtractPathsFromCLI(T.cli),M.length===0&&M.push(Object.create(null)),O=!0):(M=this.doGetPathsFromLastSession(),M.length===0&&M.push(Object.create(null)),_=!0),!T.addMode&&O){const W=M.filter(z=>B(z));if(W.length>1){const z=W[0].remoteAuthority;if(W.every(K=>K.remoteAuthority===z)){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(W.map(Y=>({uri:Y.workspace.uri})));M.push({workspace:K,remoteAuthority:z}),M=M.filter(Y=>!B(Y))}}}return T.initialStartup&&!_&&((k=this.configurationService.getValue("window"))===null||k===void 0?void 0:k.restoreWindows)==="preserve"&&M.unshift(...this.doGetPathsFromLastSession().filter(W=>N(W)||B(W)||W.backupPath)),M}doExtractPathsFromAPI(T){const k=[],M={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const O of(0,b.coalesce)(T.urisToOpen||[])){const _=this.resolveOpenable(O,M);if(_)_.label=O.label,k.push(_);else{const W=this.resourceFromOpenable(O),z={title:this.productService.nameLong,type:"info",buttons:[(0,D.localize)(0,null)],message:W.scheme===t.Schemas.file?(0,D.localize)(1,null):(0,D.localize)(2,null),detail:W.scheme===t.Schemas.file?(0,D.localize)(3,null,(0,X.getPathLabel)(W.fsPath,this.environmentMainService)):(0,D.localize)(4,null,W.toString()),noLink:!0};this.dialogMainService.showMessageBox(z,(0,C.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}}return k}doExtractPathsFromCLI(T){const k=[],M={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},O=T["folder-uri"];if(O)for(const z of O){const K=this.cliArgToUri(z);if(K){const Y=this.resolveOpenable({folderUri:K},M);Y&&k.push(Y)}}const _=T["file-uri"];if(_)for(const z of _){const K=this.cliArgToUri(z);if(K){const Y=this.resolveOpenable((0,l.hasWorkspaceFileExtension)(z)?{workspaceUri:K}:{fileUri:K},M);Y&&k.push(Y)}}const W=T._;for(const z of W){const K=T.remote?this.doResolvePathRemote(z,T.remote):this.doResolveFilePath(z,M);K&&k.push(K)}return k}cliArgToUri(T){try{const k=r.URI.parse(T);if(!k.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return k}catch(k){this.logService.error(`Invalid URI input string: ${T}, ${k.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":const k=[];T!=="one"&&k.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&k.push(this.windowsStateHandler.state.lastActiveWindow);const M=[];for(const O of k)if(O.workspace){const _=this.resolveOpenable({workspaceUri:O.workspace.configPath},{remoteAuthority:O.remoteAuthority});N(_)&&M.push(_)}else if(O.folderUri){const _=this.resolveOpenable({folderUri:O.folderUri},{remoteAuthority:O.remoteAuthority});B(_)&&M.push(_)}else T!=="folders"&&O.backupPath&&M.push({backupPath:O.backupPath,remoteAuthority:O.remoteAuthority});return M}}getRestoreWindowsSetting(){let T;if(this.lifecycleMainService.wasRestarted)T="all";else{const k=this.configurationService.getValue("window");T=(k==null?void 0:k.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")}return T}resolveOpenable(T,k={}){let M=this.resourceFromOpenable(T);return M.scheme===t.Schemas.file?((0,h.isFileToOpen)(T)&&(k=Object.assign(Object.assign({},k),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(M.fsPath,k)):this.doResolveRemoteOpenable(T,k)}doResolveRemoteOpenable(T,k){let M=this.resourceFromOpenable(T);const O=(0,u.getRemoteAuthority)(M)||k.remoteAuthority;if(M=(0,o.removeTrailingPathSeparator)((0,o.normalizePath)(M)),(0,h.isFileToOpen)(T)){if(k.gotoLineMode){const{path:_,line:W,column:z}=(0,H.parseLineAndColumnAware)(M.path);return{fileUri:M.with({path:_}),lineNumber:W,columnNumber:z,remoteAuthority:O}}return{fileUri:M,remoteAuthority:O}}else if((0,h.isWorkspaceToOpen)(T))return{workspace:(0,f.getWorkspaceIdentifier)(M),remoteAuthority:O};return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(M),remoteAuthority:O}}resourceFromOpenable(T){return(0,h.isWorkspaceToOpen)(T)?T.workspaceUri:(0,h.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,k){let M,O;if(k.gotoLineMode){const _=(0,H.parseLineAndColumnAware)(T);M=_.line,O=_.column,T=_.path}T=(0,H.sanitizeFilePath)((0,R.normalize)(T),(0,V.cwd)());try{const _=(0,w.statSync)(T);if(_.isFile()){if(!k.forceOpenWorkspaceAsFile){const W=this.workspacesManagementMainService.resolveLocalWorkspaceSync(r.URI.file(T));if(W)return{workspace:{id:W.id,configPath:W.configPath},remoteAuthority:W.remoteAuthority,exists:!0}}return{fileUri:r.URI.file(T),lineNumber:M,columnNumber:O,exists:!0}}else if(_.isDirectory())return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(r.URI.file(T),_),exists:!0}}catch(_){const W=r.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([W]),k.ignoreFileNotFound)return{fileUri:W,exists:!1}}}doResolvePathRemote(T,k,M){const O=T.charCodeAt(0);O!==47&&((0,H.isWindowsDriveLetter)(O)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,H.toSlashes)(T)),T=`/${T}`);const _=r.URI.from({scheme:t.Schemas.vscodeRemote,authority:k,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,l.hasWorkspaceFileExtension)(T))return M?{fileUri:_,remoteAuthority:k}:{workspace:(0,f.getWorkspaceIdentifier)(_),remoteAuthority:k};if(R.posix.basename(T).indexOf(".")!==-1)return{fileUri:_,remoteAuthority:k}}return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:k}}shouldOpenNewWindow(T){const k=this.configurationService.getValue("window"),M=(k==null?void 0:k.openFoldersInNewWindow)||"default",O=(k==null?void 0:k.openFilesInNewWindow)||"off";let _=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(M==="on"||M==="off")&&(_=M==="on");let W=!1;return T.forceNewWindow||T.forceReuseWindow?W=!!T.forceNewWindow&&!T.forceReuseWindow:(c.isMacintosh?T.context===1&&(W=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(W=!0),!T.cli.extensionDevelopmentPath&&(O==="on"||O==="off")&&(W=O==="on")),{openFolderInNewWindow:!!_,openFilesInNewWindow:W}}openExtensionDevelopmentHostWindow(T,k){const M=(0,m.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(M)return this.lifecycleMainService.reload(M,k.cli),M.focus(),[M];let O=k.cli["folder-uri"]||[],_=k.cli["file-uri"]||[],W=k.cli._;if(!W.length&&!O.length&&!_.length&&!k.cli.extensionTestsPath){const Z=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,G=Z&&(Z.workspace||Z.folderUri);G&&(r.URI.isUri(G)?G.scheme===t.Schemas.file?W=[G.fsPath]:O=[G.toString()]:G.configPath.scheme===t.Schemas.file?W=[(0,o.originalFSPath)(G.configPath)]:_=[G.configPath.toString()])}let z=k.remoteAuthority;for(const Z of T)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const G=r.URI.parse(Z),ee=(0,u.getRemoteAuthority)(G);ee&&(z?ee!==z&&this.logService.error("more than one extension development path authority"):z=ee)}W=W.filter(Z=>{const G=r.URI.file(Z);return(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),G)?!1:(0,u.getRemoteAuthority)(G)===z}),O=O.filter(Z=>{const G=this.cliArgToUri(Z);return G&&!!(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),G)?!1:G?(0,u.getRemoteAuthority)(G)===z:!1}),_=_.filter(Z=>{const G=this.cliArgToUri(Z);return G&&!!(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),G)?!1:G?(0,u.getRemoteAuthority)(G)===z:!1}),k.cli._=W,k.cli["folder-uri"]=O,k.cli["file-uri"]=_;const K=!W.length&&!O.length&&!_.length,Y={context:k.context,cli:k.cli,forceNewWindow:!0,forceEmpty:K,userEnv:k.userEnv,noRecentEntry:!0,waitMarkerFileURI:k.waitMarkerFileURI,remoteAuthority:z};return this.open(Y)}openInBrowserWindow(T){var k;const M=Object.assign({},T.cli);M.appRoot=this.environmentMainService.appRoot,M.machineId=this.machineId,M.nodeCachedDataDir=this.environmentMainService.nodeCachedDataDir,M.mainPid=process.pid,M.execPath=process.execPath,M.userEnv=Object.assign(Object.assign({},this.initialUserEnv),T.userEnv),M.isInitialStartup=T.initialStartup,M.workspace=T.workspace,M.remoteAuthority=T.remoteAuthority;const O=T.filesToOpen;O&&(M.filesToOpenOrCreate=O.filesToOpenOrCreate,M.filesToDiff=O.filesToDiff,M.filesToWait=O.filesToWait),T.emptyWindowBackupInfo&&(M.backupPath=(0,R.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder));let _;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(_=T.windowToUse||this.getLastActiveWindow(),_&&_.focus()),_){const W=_.config;!M.extensionDevelopmentPath&&W&&!!W.extensionDevelopmentPath&&(M.extensionDevelopmentPath=W.extensionDevelopmentPath,M.verbose=W.verbose,M["inspect-brk-extensions"]=W["inspect-brk-extensions"],M.debugId=W.debugId,M["inspect-extensions"]=W["inspect-extensions"],M["extensions-dir"]=W["extensions-dir"])}else{const W=this.windowsStateHandler.getNewWindowState(M),z=_=this.instantiationService.createInstance(i.CodeWindow,{state:W,extensionDevelopmentPath:M.extensionDevelopmentPath,isExtensionTestHost:!!M.extensionTestsPath});if(T.forceNewTabbedWindow){const Y=this.getLastActiveWindow();Y&&Y.addTabbedWindow(z)}Je.WINDOWS.push(z),this._onDidOpenWindow.fire(z),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,I.once)(z.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(z)),(0,I.once)(z.onDidClose)(()=>this.onWindowClosed(z)),(0,I.once)(z.onDidDestroy)(()=>this._onDidDestroyWindow.fire(z));const K=(0,C.assertIsDefined)((k=z.win)===null||k===void 0?void 0:k.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(z)),this.lifecycleMainService.registerWindow(z)}return _.isReady?this.lifecycleMainService.unload(_,4).then(W=>{W||this.doOpenInBrowserWindow(_,M,T)}):this.doOpenInBrowserWindow(_,M,T),_}doOpenInBrowserWindow(T,k,M){if(!k.extensionDevelopmentPath)if((0,l.isWorkspaceIdentifier)(k.workspace))k.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:k.workspace,remoteAuthority:k.remoteAuthority});else if((0,l.isSingleFolderWorkspaceIdentifier)(k.workspace))k.backupPath=this.backupMainService.registerFolderBackupSync(k.workspace.uri);else{const O=M.emptyWindowBackupInfo&&M.emptyWindowBackupInfo.backupFolder;k.backupPath=this.backupMainService.registerEmptyWindowBackupSync(O,k.remoteAuthority)}T.load(k)}onWindowClosed(T){const k=Je.WINDOWS.indexOf(T);Je.WINDOWS.splice(k,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=L.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(k=>k.remoteAuthority===T))}doGetLastActiveWindow(T){const k=Math.max.apply(Math,T.map(M=>M.lastFocusTime));return T.find(M=>M.lastFocusTime===k)}sendToFocused(T,...k){const M=this.getFocusedWindow()||this.getLastActiveWindow();M&&M.sendWhenReady(T,ne.CancellationToken.None,...k)}sendToAll(T,k,M){for(const O of this.getWindows())M&&M.indexOf(O.id)>=0||O.sendWhenReady(T,ne.CancellationToken.None,k)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(T){const k=this.getWindows().filter(M=>M.id===T);return(0,b.firstOrDefault)(k)}getWindowByWebContents(T){const k=L.BrowserWindow.fromWebContents(T);if(!!k)return this.getWindowById(k.id)}};U.WINDOWS=[],U=le([x(2,p.ILogService),x(3,y.IStateService),x(4,n.IEnvironmentMainService),x(5,g.ILifecycleMainService),x(6,P.IBackupMainService),x(7,E.IConfigurationService),x(8,a.IWorkspacesHistoryMainService),x(9,f.IWorkspacesManagementMainService),x(10,s.IInstantiationService),x(11,F.IDialogMainService),x(12,oe.IFileService),x(13,v.IProductService)],U),e.WindowsMainService=U}),define(Q[232],J([0,1,51,32,62,49]),function(j,e,w,R,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(y,i,L,g){this.workspacesManagementMainService=y,this.windowsMainService=i,this.workspacesHistoryMainService=L,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(y,i){const L=this.windowsMainService.getWindowById(y);return L?this.workspacesManagementMainService.enterWorkspace(L,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(y,i,L){return this.workspacesManagementMainService.createUntitledWorkspace(i,L)}deleteUntitledWorkspace(y,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(y,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(y){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(y))}async addRecentlyOpened(y,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(y,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(y){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=le([x(0,w.IWorkspacesManagementMainService),x(1,R.IWindowsMainService),x(2,D.IWorkspacesHistoryMainService),x(3,b.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Q[233],J([0,1,27,22,11,3,231,18,69,41,198,33,119,83,222,98,5,70,67,6,38,26,24,95,199,31,94,193,194,190,17,216,170,2,32,7,28,232,65,226,224,223,227,175,19,201,217,230,116,8,15,128,9,225,96,210,215,49,62,200,51,68,151,42,50,13,39,207,203,16,44,30,21,87,208,188,53,29,25,162,178,43,71,72]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t,r,o,u,d,f,I,A,F,C,H,X,ne,oe,V,N,B,U,$,T,k,M,O,_,W,z,K,Y,Z,G,ee,re,ie,ue,ve,de,he,me,ke,Le,je,Fe,He,Ze,Ye,nt,Ke,rt,Ce,st,q,te,se,ae,fe,pe,Ee,Re,Oe,We,Be,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ot=class extends X.Disposable{constructor(ge,we,Pe,ce,Se,ye,Ie,be,De,Me){super();this.mainProcessNodeIpcServer=ge,this.userEnv=we,this.mainInstantiationService=Pe,this.logService=ce,this.environmentMainService=Se,this.lifecycleMainService=ye,this.configurationService=Ie,this.stateService=be,this.fileService=De,this.productService=Me,this.registerListeners()}registerListeners(){(0,O.setUnexpectedErrorHandler)(ce=>this.onUnexpectedError(ce)),process.on("uncaughtException",ce=>this.onUnexpectedError(ce)),process.on("unhandledRejection",ce=>(0,O.onUnexpectedError)(ce)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,K.registerContextMenuListener)(),D.app.on("accessibility-support-changed",(ce,Se)=>{var ye;(ye=this.windowsMainService)===null||ye===void 0||ye.sendToAll("vscode:accessibilitySupportChanged",Se)}),D.app.on("activate",(ce,Se)=>{var ye;this.logService.trace("app#activate"),Se||(ye=this.windowsMainService)===null||ye===void 0||ye.openEmptyWindow({context:1})}),D.app.on("remote-require",(ce,Se,ye)=>{this.logService.trace("app#on(remote-require): prevented"),ce.preventDefault()}),D.app.on("remote-get-global",(ce,Se,ye)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${ye}`),ce.preventDefault()}),D.app.on("remote-get-builtin",(ce,Se,ye)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${ye}`),ye!=="clipboard"&&ce.preventDefault()}),D.app.on("remote-get-current-window",ce=>{this.logService.trace("app#on(remote-get-current-window): prevented"),ce.preventDefault()}),D.app.on("remote-get-current-web-contents",ce=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),ce.preventDefault())}),D.app.on("web-contents-created",(ce,Se)=>{Se.on("will-attach-webview",(Ie,be,De)=>{const Me=Te=>{if(!Te)return!1;const Ne=oe.URI.parse(Te);if(Ne.scheme===ee.Schemas.vscodeWebview)return Ne.path==="/index.html"||Ne.path==="/electron-browser/index.html";const qe=Ne.fsPath.toLowerCase(),Ve=oe.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return qe.startsWith(Ve+Y.sep)};delete be.preload,be.nodeIntegration=!1,!(Me(De.src)&&Me(be.preloadURL))&&(delete be.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ie.preventDefault())}),Se.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),Se.on("new-window",(Ie,be)=>{var De;Ie.preventDefault(),(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,be)});const ye="about:blank?webviewFrame";D.session.defaultSession.setPermissionRequestHandler((Ie,be,De,Me)=>Me.requestingUrl===ye?De(be==="clipboard-read"):De(!1)),D.session.defaultSession.setPermissionCheckHandler((Ie,be,De,Me)=>Me.requestingUrl===ye?be==="clipboard-read":!1)});let ge=[],we=null;D.app.on("open-file",(ce,Se)=>{this.logService.trace("app#open-file: ",Se),ce.preventDefault(),ge.push(this.getWindowOpenableFromPathSync(Se)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var ye;(ye=this.windowsMainService)===null||ye===void 0||ye.open({context:1,cli:this.environmentMainService.args,urisToOpen:ge,gotoLineMode:!1,preferNewWindow:!0}),ge=[],we=null},100)}),D.app.on("new-window-for-tab",()=>{var ce;(ce=this.windowsMainService)===null||ce===void 0||ce.openEmptyWindow({context:4})});let Pe=!1;D.ipcMain.on("vscode:fetchShellEnv",async ce=>{var Se;const ye=ce.sender;let Ie=!1;function be(ze){clearTimeout(Me),clearTimeout(Ne),Ie||(Ie=!0,ye.isDestroyed()||ye.send("vscode:acceptShellEnv",ze))}const De=new Ee.CancellationTokenSource,Me=setTimeout(()=>{var ze;Pe||((ze=this.windowsMainService)===null||ze===void 0||ze.sendToFocused("vscode:showShellEnvSlowWarning",De.token),Pe=!0)},3e3),Te=(Se=this.windowsMainService)===null||Se===void 0?void 0:Se.getWindowByWebContents(ce.sender),Ne=setTimeout(()=>{De.dispose(!0),Te==null||Te.sendWhenReady("vscode:showShellEnvTimeoutError",Ee.CancellationToken.None),be({})},1e4);let qe,Ve;(Te==null?void 0:Te.config)?(qe=Te.config,Ve=Object.assign(Object.assign({},process.env),Te.config.userEnv)):(qe=this.environmentMainService.args,Ve=process.env);const _e=await(0,y.resolveShellEnv)(this.logService,qe,Ve);be(_e)}),D.ipcMain.handle("vscode:writeNlsFile",async(ce,Se,ye)=>{const Ie=this.validateNlsPath([Se]);if(!Ie||typeof ye!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ie,q.VSBuffer.fromString(ye))}),D.ipcMain.handle("vscode:readNlsFile",async(ce,...Se)=>{const ye=this.validateNlsPath(Se);if(!ye)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ye)).value.toString()}),D.ipcMain.on("vscode:toggleDevTools",ce=>ce.sender.toggleDevTools()),D.ipcMain.on("vscode:openDevTools",ce=>ce.sender.openDevTools()),D.ipcMain.on("vscode:reloadWindow",ce=>ce.sender.reload())}validateNlsPath(ge){let we;for(const Pe of ge)typeof Pe=="string"&&(typeof we!="string"?we=Pe:we=(0,Y.join)(we,Pe));if(!(typeof we!="string"||!(0,Y.isAbsolute)(we)||!(0,pe.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return oe.URI.file(we)}onUnexpectedError(ge){var we;if(ge){const Pe={message:`[uncaught exception in main]: ${ge.message}`,stack:ge.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${ge}`),ge.stack&&this.logService.error(ge.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ge=this.productService.win32AppUserModelId;b.isWindows&&ge&&D.app.setAppUserModelId(ge);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!D.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&D.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Me){this.logService.error(Me)}const we=this._register(this.mainInstantiationService.createInstance(H.FileProtocolHandler)),Pe=new E.Server;this.logService.trace("Resolving machine identifier...");const ce=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ce}`);const{sharedProcess:Se,sharedProcessReady:ye,sharedProcessClient:Ie}=this.setupSharedProcess(ce),be=await this.initServices(ce,Se,ye);if(this.environmentMainService.driverHandle){const Me=await(0,W.serve)(Pe,this.environmentMainService.driverHandle,this.environmentMainService,be);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Me)}this._register(be.createInstance(C.ProxyAuthHandler)),be.invokeFunction(Me=>this.initChannels(Me,Pe,Ie));const De=be.invokeFunction(Me=>this.openFirstWindow(Me,Pe,we));be.invokeFunction(Me=>this.afterWindowOpen(Me,Se)),this.environmentMainService.args.trace&&be.invokeFunction(Me=>this.stopTracingEventually(Me,De))}async resolveMachineId(){let ge=this.stateService.getItem(u.machineIdKey);return(!ge||b.isMacintosh&&ge==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ge=await(0,B.getMachineId)(),this.stateService.setItem(u.machineIdKey,ge)),ge}setupSharedProcess(ge){const we=this._register(this.mainInstantiationService.createInstance(h.SharedProcess,ge,this.userEnv)),Pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Se=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Se,"main")})(),ce=(async()=>(await we.whenReady(),Pe))();return{sharedProcess:we,sharedProcessReady:ce,sharedProcessClient:Pe}}async initServices(ge,we,Pe){const ce=new v.ServiceCollection;switch(process.platform){case"win32":ce.set(i.IUpdateService,new a.SyncDescriptor(U.Win32UpdateService));break;case"linux":b.isLinuxSnap?ce.set(i.IUpdateService,new a.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ce.set(i.IUpdateService,new a.SyncDescriptor($.LinuxUpdateService));break;case"darwin":ce.set(i.IUpdateService,new a.SyncDescriptor(T.DarwinUpdateService));break}ce.set(ne.IWindowsMainService,new a.SyncDescriptor(P.WindowsMainService,[ge,this.userEnv])),ce.set(He.IDialogMainService,new a.SyncDescriptor(He.DialogMainService)),ce.set(m.ILaunchMainService,new a.SyncDescriptor(m.LaunchMainService)),ce.set(Le.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Pe.then(ye=>ye.getChannel("diagnostics"))))),ce.set(k.IIssueMainService,new a.SyncDescriptor(k.IssueMainService,[ge,this.userEnv])),ce.set(te.IEncryptionMainService,new a.SyncDescriptor(te.EncryptionMainService,[ge])),ce.set(ae.IKeyboardLayoutMainService,new a.SyncDescriptor(ae.KeyboardLayoutMainService)),ce.set(Fe.INativeHostMainService,new a.SyncDescriptor(Fe.NativeHostMainService,[we])),ce.set(Ke.IWebviewManagerService,new a.SyncDescriptor(nt.WebviewMainService)),ce.set(V.IWorkspacesService,new a.SyncDescriptor(N.WorkspacesMainService)),ce.set(ke.IWorkspacesManagementMainService,new a.SyncDescriptor(ke.WorkspacesManagementMainService)),ce.set(he.IWorkspacesHistoryMainService,new a.SyncDescriptor(he.WorkspacesHistoryMainService)),ce.set(z.IMenubarMainService,new a.SyncDescriptor(z.MenubarMainService)),ce.set(Re.IExtensionUrlTrustService,new a.SyncDescriptor(Oe.ExtensionUrlTrustService)),ce.set(ie.IStorageMainService,new a.SyncDescriptor(ie.StorageMainService));const Se=new ve.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ce.set(de.IBackupMainService,Se),ce.set(r.IURLService,new a.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const ye=(0,g.getDelayedChannel)(Pe.then(Te=>Te.getChannel("telemetryAppender"))),Ie=new f.TelemetryAppenderClient(ye),be=(0,A.resolveCommonProperties)(this.fileService,(0,w.release)(),process.arch,this.productService.commit,this.productService.version,ge,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),De=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Me={appender:Ie,commonProperties:be,piiPaths:De,sendErrorTelemetry:!0};ce.set(u.ITelemetryService,new a.SyncDescriptor(I.TelemetryService,[Me]))}else ce.set(u.ITelemetryService,d.NullTelemetryService);return await Se.initialize(),this.mainInstantiationService.createChild(ce)}initChannels(ge,we,Pe){const ce=g.ProxyChannel.fromService(ge.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ce);const Se=new L.UpdateChannel(ge.get(i.IUpdateService));we.registerChannel("update",Se);const ye=g.ProxyChannel.fromService(ge.get(k.IIssueMainService));we.registerChannel("issue",ye);const Ie=g.ProxyChannel.fromService(ge.get(te.IEncryptionMainService));we.registerChannel("encryption",Ie);const be=g.ProxyChannel.fromService(ge.get(St.ISignService));we.registerChannel("sign",be);const De=g.ProxyChannel.fromService(ge.get(ae.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",De),this.nativeHostMainService=ge.get(Fe.INativeHostMainService);const Me=g.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",Me),Pe.then(Ge=>Ge.registerChannel("nativeHost",Me));const Te=g.ProxyChannel.fromService(ge.get(V.IWorkspacesService));we.registerChannel("workspaces",Te);const Ne=g.ProxyChannel.fromService(ge.get(z.IMenubarMainService));we.registerChannel("menubar",Ne);const qe=g.ProxyChannel.fromService(ge.get(r.IURLService));we.registerChannel("url",qe);const Ve=g.ProxyChannel.fromService(ge.get(Re.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",Ve);const _e=g.ProxyChannel.fromService(ge.get(Ke.IWebviewManagerService));we.registerChannel("webview",_e);const ze=this._register(new ue.StorageDatabaseChannel(this.logService,ge.get(ie.IStorageMainService)));we.registerChannel("storage",ze),Pe.then(Ge=>Ge.registerChannel("storage",ze));const Qe=new M.LogLevelChannel(ge.get(c.ILogService));we.registerChannel("logLevel",Qe),Pe.then(Ge=>Ge.registerChannel("logLevel",Qe));const xe=new M.LoggerChannel(ge.get(c.ILoggerService));we.registerChannel("logger",xe);const tt=new je.ElectronExtensionHostDebugBroadcastChannel(ge.get(ne.IWindowsMainService));we.registerChannel("extensionhostdebugservice",tt)}openFirstWindow(ge,we,Pe){const ce=this.windowsMainService=ge.get(ne.IWindowsMainService),Se=ge.get(r.IURLService),ye=ge.get(Fe.INativeHostMainService);this.lifecycleMainService.phase=2,Pe.injectWindowsMainService(this.windowsMainService);const Ie=[],be=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ue=>{try{return{uri:oe.URI.parse(Ue),url:Ue}}catch(Xe){return null}}).filter(Ue=>{if(!Ue||this.shouldBlockURI(Ue.uri))return!1;const Xe=this.getWindowOpenableFromProtocolLink(Ue.uri);return Xe?(Ie.push(Xe),!1):!0}),De=this,Me=this.environmentMainService;Se.registerHandler({async handleURL(Ue,Xe){if(De.shouldBlockURI(Ue))return!0;const wt=De.getWindowOpenableFromProtocolLink(Ue);if(wt){const[ct]=ce.open({context:5,cli:Object.assign({},Me.args),urisToOpen:[wt],gotoLineMode:!0});return ct.focus(),!0}if(b.isMacintosh&&ce.getWindowCount()===0){const[ct]=ce.open({context:5,cli:Object.assign({},Me.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Be.getRemoteAuthority)(Ue)});return await ct.ready(),Se.open(Ue,Xe)}return!1}});const Te=this._register(new se.ActiveWindowManager({onDidOpenWindow:ye.onDidOpenWindow,onDidFocusWindow:ye.onDidFocusWindow,getActiveWindowId:()=>ye.getActiveWindowId(-1)})),Ne=new g.StaticRouter(Ue=>Te.getActiveClientId().then(Xe=>Ue===Xe)),qe=new o.URLHandlerRouter(Ne),Ve=we.getChannel("urlHandler",qe);Se.registerHandler(new o.URLHandlerChannelClient(Ve)),this._register(new _.ElectronURLListener(be,Se,ce,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,ze=global.macOpenFiles,Qe=(0,fe.isLaunchedFromCli)(process.env)?0:4,xe=_e._.length,tt=!!_e["folder-uri"],Ge=!!_e["file-uri"],at=_e["skip-add-to-recently-opened"]===!0,lt=_e.wait&&_e.waitMarkerFilePath?oe.URI.file(_e.waitMarkerFilePath):void 0,vt=_e.remote||void 0;return Ie.length>0?ce.open({context:Qe,cli:_e,urisToOpen:Ie,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!xe&&!tt&&!Ge?ce.open({context:Qe,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:at,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:vt}):ze.length&&!xe&&!tt&&!Ge?ce.open({context:1,cli:_e,urisToOpen:ze.map(Ue=>this.getWindowOpenableFromPathSync(Ue)),noRecentEntry:at,waitMarkerFileURI:lt,initialStartup:!0}):ce.open({context:Qe,cli:_e,forceNewWindow:_e["new-window"]||!xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:at,waitMarkerFileURI:lt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(ge){return!!(ge.authority===ee.Schemas.file&&b.isWindows&&D.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Ye.mnemonicButtonLabel)((0,G.localize)(0,null)),(0,Ye.mnemonicButtonLabel)((0,G.localize)(1,null))],cancelId:1,message:(0,G.localize)(2,null,(0,Ye.getPathLabel)(ge.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,G.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ge){if(!!ge.path){if(ge.authority===ee.Schemas.file)return{fileUri:oe.URI.file(ge.fsPath)};if(ge.authority===ee.Schemas.vscodeRemote){const we=ge.path.indexOf(Y.posix.sep,1);if(we!==-1){const Pe=ge.path.substring(1,we),ce=ge.path.substring(we),Se=oe.URI.from({scheme:ee.Schemas.vscodeRemote,authority:Pe,path:ce,query:ge.query,fragment:ge.fragment});return(0,V.hasWorkspaceFileExtension)(ce)?{workspaceUri:Se}:{folderUri:Se}}}}}getWindowOpenableFromPathSync(ge){try{if((0,R.statSync)(ge).isDirectory())return{folderUri:oe.URI.file(ge)};if((0,V.hasWorkspaceFileExtension)(ge))return{workspaceUri:oe.URI.file(ge)}}catch(we){}return{fileUri:oe.URI.file(ge)}}async afterWindowOpen(ge,we){var Pe;this.lifecycleMainService.phase=3;const ce=ge.get(u.ITelemetryService);this._register(we.onDidError(({type:Ie,details:be})=>{let De;typeof be=="string"?De=be:De=`SharedProcess: crashed (detail: ${be.reason})`,(0,O.onUnexpectedError)(new Error(De)),ce.publicLog2("sharedprocesserror",{type:Ie,reason:typeof be!="string"?be==null?void 0:be.reason:void 0,visible:we.isVisible()})}));const Se=this.productService.win32MutexName;if(b.isWindows&&Se)try{const Ie=j.__$__nodeRequire("windows-mutex").Mutex,be=new Ie(Se);(0,We.once)(this.lifecycleMainService.onWillShutdown)(()=>be.release())}catch(Ie){this.logService.error(Ie)}D.protocol.registerHttpProtocol(ee.Schemas.vscodeRemoteResource,(Ie,be)=>{be({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})});const ye=ge.get(i.IUpdateService);(ye instanceof U.Win32UpdateService||ye instanceof $.LinuxUpdateService||ye instanceof T.DarwinUpdateService)&&ye.initialize(),(0,y.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const be=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,Ce.stripComments)(be))["enable-crash-reporter"]===void 0){const Me=(Pe=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Pe!==void 0?Pe:!0,Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,st.generateUuid)()}"`,"}"],Ne=be.substring(0,be.length-2).concat(`,
`,Te.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,q.VSBuffer.fromString(Ne))}}catch(Ie){this.logService.error(Ie)}}stopTracingEventually(ge,we){this.logService.info("Tracing: waiting for windows to get ready...");const Pe=ge.get(He.IDialogMainService);let ce=!1;const Se=async Ie=>{if(!ce){ce=!0;const be=await D.contentTracing.stopRecording((0,Z.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ie?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${be}`):Pe.showMessageBox({type:"info",message:(0,G.localize)(4,null),detail:(0,G.localize)(5,null,be),buttons:[(0,G.localize)(6,null)]},(0,Ze.withNullAsUndefined)(D.BrowserWindow.getFocusedWindow()))}},ye=setTimeout(()=>Se(!0),3e4);Promise.all(we.map(Ie=>Ie.ready())).then(()=>{clearTimeout(ye),Se(!1)})}};ot=le([x(2,S.IInstantiationService),x(3,c.ILogService),x(4,s.IEnvironmentMainService),x(5,n.ILifecycleMainService),x(6,t.IConfigurationService),x(7,l.IStateService),x(8,rt.IFileService),x(9,F.IProductService)],ot),e.CodeApplication=ot}),define(Q[239],J([0,1,11,22,12,3,92,53,154,18,33,55,166,70,67,6,189,38,24,181,40,221,233,39,91,90,19,73,43,72,187,191,171,173,9,16,54,219,17,29,20,8,34,26,66,94,176,35,197]),function(j,e,w,R,D,b,P,n,y,i,L,g,E,p,h,m,S,v,a,c,l,s,t,r,o,u,d,f,I,A,F,C,H,X,ne,oe,V,N,B,U,$,T,k,M,O,_,W,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class K{main(){try{this.startup()}catch(G){console.error(G.message),w.app.exit(1)}}async startup(){(0,d.setUnexpectedErrorHandler)(me=>console.error(me));const G=this.resolveArgs(),[ee,re,ie,ue,ve,de,he]=this.createServices(G);try{try{await this.initServices(ie,ue,ve)}catch(me){throw this.handleStartupDataDirError(ie,he.nameLong,me),me}await ee.invokeFunction(async me=>{const ke=me.get(m.ILogService),Le=me.get(i.ILifecycleMainService),je=me.get(oe.IFileService),Fe=await this.doStartup(G,ke,ie,Le,ee,he,!0);return de.logger=new o.SpdLogLogger("main",(0,T.join)(ie.logsPath,"main.log"),!0,de.getLevel()),(0,I.once)(Le.onWillShutdown)(()=>{je.dispose(),ue.dispose()}),ee.createInstance(t.CodeApplication,Fe,re).startup()})}catch(me){ee.invokeFunction(this.quit,me)}}createServices(G){const ee=new p.ServiceCollection,re=Object.assign({_serviceBrand:void 0},P.default);ee.set(B.IProductService,re);const ie=new M.EnvironmentMainService(G,re),ue=this.patchEnvironment(ie);ee.set(M.IEnvironmentMainService,ie);const ve=new u.BufferLogService,de=new m.MultiplexLogService([new m.ConsoleMainLogger((0,m.getLogLevel)(ie)),ve]);process.once("exit",()=>de.dispose()),ee.set(m.ILogService,de);const he=new H.FileService(de);ee.set(oe.IFileService,he);const me=new X.DiskFileSystemProvider(de);he.registerProvider(ne.Schemas.file,me),ee.set(m.ILoggerService,new W.LoggerService(de,he));const ke=new c.ConfigurationService(ie.settingsResource,he);ee.set(a.IConfigurationService,ke),ee.set(i.ILifecycleMainService,new h.SyncDescriptor(i.LifecycleMainService));const Le=new S.StateService(ie,de);return ee.set(v.IStateService,Le),ee.set(l.IRequestService,new h.SyncDescriptor(s.RequestMainService)),ee.set(f.IThemeMainService,new h.SyncDescriptor(f.ThemeMainService)),ee.set(A.ISignService,new h.SyncDescriptor(F.SignService)),ee.set(V.ITunnelService,new h.SyncDescriptor(N.TunnelService)),[new E.InstantiationService(ee,!0),ue,ie,ke,Le,ve,re]}patchEnvironment(G){const ee={VSCODE_IPC_HOOK:G.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(re=>{const ie=process.env[re];typeof ie=="string"&&(ee[re]=ie)}),Object.assign(process.env,ee),ee}initServices(G,ee,re){const ie=Promise.all([G.extensionsPath,G.nodeCachedDataDir,G.logsPath,G.globalStorageHome.fsPath,G.workspaceStorageHome.fsPath,G.backupHome].map(de=>de?R.promises.mkdir(de,{recursive:!0}):void 0)),ue=ee.initialize(),ve=re.init();return Promise.all([ie,ue,ve])}async doStartup(G,ee,re,ie,ue,ve,de){let he;try{he=await(0,g.serve)(re.mainIPCHandle),(0,I.once)(ie.onWillShutdown)(()=>he.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(re,ve.nameLong,me),me;let ke;try{ke=await(0,g.connect)(re.mainIPCHandle,"main")}catch(Fe){if(!de||b.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,D.localize)(0,null,ve.nameShort),(0,D.localize)(1,null),ve.nameLong),Fe;try{(0,R.unlinkSync)(re.mainIPCHandle)}catch(He){throw ee.warn("Could not delete obsolete instance handle",He),He}return this.doStartup(G,ee,re,ie,ue,ve,!1)}if(re.extensionTestsLocationURI&&!re.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ee.error(Fe),ke.dispose(),new Error(Fe)}let Le;!G.wait&&!G.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,D.localize)(2,null,ve.nameShort),(0,D.localize)(3,null),ve.nameLong)},1e4));const je=L.ProxyChannel.toService(ke.getChannel("launch"),{disableMarshalling:!0});if(G.status)return ue.invokeFunction(async()=>{const Fe=new C.DiagnosticsService(_.NullTelemetryService,ve),He=await je.getMainProcessInfo(),Ze=await je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ye=await Fe.getDiagnostics(He,Ze);throw console.log(Ye),new d.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(je,ee),ee.trace("Sending env to running instance..."),await je.start(G,process.env),ke.dispose(),Le&&clearTimeout(Le),new d.ExpectedError("Sent env to running instance. Terminating...")}if(G.status)throw ee.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),he}handleStartupDataDirError(G,ee,re){if(re.code==="EACCES"||re.code==="EPERM"){const ie=(0,k.coalesce)([G.userDataPath,G.extensionsPath,g.XDG_RUNTIME_DIR]).map(ue=>(0,r.getPathLabel)(ue,G));this.showStartupWarningDialog((0,D.localize)(4,null),(0,D.localize)(5,null,(0,O.toErrorMessage)(re),ie.join(`
`)),ee)}}showStartupWarningDialog(G,ee,re){w.dialog.showMessageBoxSync({title:re,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,D.localize)(6,null))],message:G,detail:ee,noLink:!0})}async windowsAllowSetForegroundWindow(G,ee){if(b.isWindows){const re=await G.getMainProcessId();ee.trace("Sending some foreground love to the running instance:",re);try{(await new Promise((ie,ue)=>{j(["windows-foreground-love"],ie,ue)})).allowSetForegroundWindow(re)}catch(ie){ee.error(ie)}}}quit(G,ee){const re=G.get(m.ILogService),ie=G.get(i.ILifecycleMainService);let ue=0;ee&&(ee.isExpected?ee.message&&re.trace(ee.message):(ue=1,ee.stack?re.error(ee.stack):re.error(`Startup error: ${ee.toString()}`))),ie.kill(ue)}resolveArgs(){const G=this.validatePaths((0,n.parseMainProcessArgv)(process.argv));if(G.wait&&!G.waitMarkerFilePath){const ee=(0,y.createWaitMarkerFile)(G.verbose);ee&&((0,n.addArg)(process.argv,"--waitMarkerFilePath",ee),G.waitMarkerFilePath=ee)}return G}validatePaths(G){if(G["open-url"]&&(G._urls=G._,G._=[]),!G.remote){const ee=this.doValidatePaths(G._,G.goto);G._=ee}return G}doValidatePaths(G,ee){const re=(0,z.cwd)(),ie=G.map(de=>{let he=String(de),me;ee&&(me=(0,U.parseLineAndColumnAware)(he),he=me.path),he&&(he=this.preparePath(re,he));const ke=(0,U.sanitizeFilePath)(he,re),Le=(0,T.basename)(ke);return Le&&!(0,U.isValidBasename)(Le)?null:ee&&me?(me.path=ke,this.toPath(me)):ke}),ue=b.isWindows||b.isMacintosh,ve=(0,k.distinct)(ie,de=>de&&ue?de.toLowerCase():de||"");return(0,k.coalesce)(ve)}preparePath(G,ee){return b.isWindows&&(ee=(0,$.rtrim)(ee,'"')),ee=(0,$.trim)((0,$.trim)(ee," "),"	"),b.isWindows&&(ee=(0,T.resolve)(G,ee),ee=(0,$.rtrim)(ee,".")),ee}toPath(G){const ee=[G.path];return typeof G.line=="number"&&ee.push(String(G.line)),typeof G.column=="number"&&ee.push(String(G.column)),ee.join(":")}}new K().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d06d2f1d6245ce00b1c36a9cd81a9087d225173e/core/vs/code/electron-main/main.js.map
