/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/platform","fs","vs/base/common/buffer","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/process","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/request/common/request","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","path","vs/platform/environment/node/argvHelper","vs/base/common/performance","vs/base/common/iterator","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function(x){for(var t=[],m=0,C=x.length;m<C;m++)t[m]=Q[x[m]];return t};define(Q[56],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(C,b){if(!C)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=m}),define(Q[57],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function m(d){return(f,O,h)=>{let w=null,I=null;if(typeof h.value=="function"?(w="value",I=h.value):typeof h.get=="function"&&(w="get",I=h.get),!I)throw new Error("not supported");h[w]=d(I,O)}}t.createDecorator=m;let C=0;function b(){const d=`$memoize${C++}`;let f;const O=function(w,I,l){let v=null,y=null;if(typeof l.value=="function"?(v="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(v="get",y=l.get),!y)throw new Error("not supported");const p=`${d}:${I}`;l[v]=function(...L){return f=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:y.apply(this,L)}),this[p]}};return O.clear=()=>{typeof f!="undefined"&&Object.getOwnPropertyNames(f).forEach(h=>{h.indexOf(d)===0&&delete f[h]})},O}t.createMemoizer=b;function S(d,f,O){return b()(d,f,O)}t.memoize=S;function T(d,f,O){return m((h,w)=>{const I=`$debounce$${w}`,l=`$debounce$result$${w}`;return function(...v){this[l]||(this[l]=O?O():void 0),clearTimeout(this[I]),f&&(this[l]=f(this[l],...v),v=[this[l]]),this[I]=setTimeout(()=>{h.apply(this,v),this[l]=O?O():void 0},d)}})}t.debounce=T;function R(d,f,O){return m((h,w)=>{const I=`$throttle$timer$${w}`,l=`$throttle$result$${w}`,v=`$throttle$lastRun$${w}`,y=`$throttle$pending$${w}`;return function(...p){if(this[l]||(this[l]=O?O():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),f&&(this[l]=f(this[l],...p)),!this[y]){const L=this[v]+d;L<=Date.now()?(this[v]=Date.now(),h.apply(this,[this[l]]),this[l]=O?O():void 0):(this[y]=!0,this[I]=setTimeout(()=>{this[y]=!1,this[v]=Date.now(),h.apply(this,[this[l]]),this[l]=O?O():void 0},L-Date.now()))}}})}t.throttle=R}),define(Q[23],Z([0,1,14]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function C(W,G=0){return W[W.length-(1+G)]}t.tail=C;function b(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=b;function S(W,G,_=(c,u)=>c===u){if(W===G)return!0;if(!W||!G||W.length!==G.length)return!1;for(let c=0,u=W.length;c<u;c++)if(!_(W[c],G[c]))return!1;return!0}t.equals=S;function T(W,G,_){let c=0,u=W.length-1;for(;c<=u;){const P=(c+u)/2|0,D=_(W[P],G);if(D<0)c=P+1;else if(D>0)u=P-1;else return P}return-(c+1)}t.binarySearch=T;function R(W,G){let _=0,c=W.length;if(c===0)return 0;for(;_<c;){const u=Math.floor((_+c)/2);G(W[u])?c=u:_=u+1}return _}t.findFirstInSorted=R;function d(W,G,_){if(W=W|0,W>=G.length)throw new TypeError("invalid index");let c=G[Math.floor(G.length*Math.random())],u=[],P=[],D=[];for(let k of G){const M=_(k,c);M<0?u.push(k):M>0?P.push(k):D.push(k)}return W<u.length?d(W,u,_):W<u.length+D.length?D[0]:d(W-(u.length+D.length),P,_)}t.quickSelect=d;function f(W,G){const _=[];let c;for(const u of W.slice(0).sort(G))!c||G(c[0],u)!==0?(c=[u],_.push(c)):c.push(u);return _}t.groupBy=f;function O(W,G,_){const c=[];function u(k,M,U){if(!(M===0&&U.length===0)){const B=c[c.length-1];B&&B.start+B.deleteCount===k?(B.deleteCount+=M,B.toInsert.push(...U)):c.push({start:k,deleteCount:M,toInsert:U})}}let P=0,D=0;for(;;){if(P===W.length){u(P,0,G.slice(D));break}if(D===G.length){u(P,W.length-P,[]);break}const k=W[P],M=G[D],U=_(k,M);U===0?(P+=1,D+=1):U<0?(u(P,1,[]),P+=1):U>0&&(u(P,0,[M]),D+=1)}return c}t.sortedDiff=O;function h(W,G,_){const c=O(W,G,_),u=[],P=[];for(const D of c)u.push(...W.slice(D.start,D.start+D.deleteCount)),P.push(...D.toInsert);return{removed:u,added:P}}t.delta=h;function w(W,G,_){if(_===0)return[];const c=W.slice(0,_).sort(G);return l(W,G,c,_,W.length),c}t.top=w;function I(W,G,_,c,u){return _===0?Promise.resolve([]):new Promise((P,D)=>{(async()=>{const k=W.length,M=W.slice(0,_).sort(G);for(let U=_,B=Math.min(_+c,k);U<k;U=B,B=Math.min(B+c,k)){if(U>_&&await new Promise(q=>setTimeout(q)),u&&u.isCancellationRequested)throw(0,m.canceled)();l(W,G,M,U,B)}return M})().then(P,D)})}t.topAsync=I;function l(W,G,_,c,u){for(const P=_.length;c<u;c++){const D=W[c];if(G(D,_[P-1])<0){_.pop();const k=R(_,M=>G(D,M)<0);_.splice(k,0,D)}}}function v(W){return W.filter(G=>!!G)}t.coalesce=v;function y(W){let G=0;for(let _=0;_<W.length;_++)W[_]&&(W[G]=W[_],G+=1);W.length=G}t.coalesceInPlace=y;function p(W,G,_){W.splice(_,0,W.splice(G,1)[0])}t.move=p;function L(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=L;function E(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=E;function a(W,G){if(!G)return W.filter((c,u)=>W.indexOf(c)===u);const _=Object.create(null);return W.filter(c=>{const u=G(c);return _[u]?!1:(_[u]=!0,!0)})}t.distinct=a;function i(W){const G=new Set;return W.filter(_=>G.has(_)?!1:(G.add(_),!0))}t.distinctES6=i;function e(W){const G=Object.create(null);return _=>{const c=W(_);return G[c]?!1:(G[c]=!0,!0)}}t.uniqueFilter=e;function n(W,G){for(let _=W.length-1;_>=0;_--){const c=W[_];if(G(c))return _}return-1}t.lastIndex=n;function r(W,G){return W.length>0?W[0]:G}t.firstOrDefault=r;function o(W,G,_=(c,u)=>c===u){let c=0;for(let u=0,P=Math.min(W.length,G.length);u<P&&_(W[u],G[u]);u++)c++;return c}t.commonPrefixLength=o;function s(W){return[].concat(...W)}t.flatten=s;function g(W,G){let _=typeof G=="number"?W:0;typeof G=="number"?_=W:(_=0,G=W);const c=[];if(_<=G)for(let u=_;u<G;u++)c.push(u);else for(let u=_;u>G;u--)c.push(u);return c}t.range=g;function F(W,G,_){return W.reduce((c,u)=>(c[G(u)]=_?_(u):u,c),Object.create(null))}t.index=F;function V(W,G){return W.push(G),()=>N(W,G)}t.insert=V;function N(W,G){const _=W.indexOf(G);if(_>-1)return W.splice(_,1),G}t.remove=N;function A(W,G,_){const c=W.slice(0,G),u=W.slice(G);return c.concat(_,u)}t.arrayInsert=A;function j(W,G){let _;if(typeof G=="number"){let c=G;_=()=>{const u=Math.sin(c++)*179426549;return u-Math.floor(u)}}else _=Math.random;for(let c=W.length-1;c>0;c-=1){const u=Math.floor(_()*(c+1)),P=W[c];W[c]=W[u],W[u]=P}}t.shuffle=j;function $(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.unshift(G))}t.pushToStart=$;function X(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.push(G))}t.pushToEnd=X;function ne(W,G){return Array.isArray(W)?W.map(G):G(W)}t.mapArrayOrNot=ne;function ee(W){return Array.isArray(W)?W:[W]}t.asArray=ee;function te(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=te;function ae(W,G){for(const _ of W){const c=G(_);if(c!==void 0)return c}}t.mapFind=ae}),define(Q[58],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var S;(function(e){e.DEFAULT={allowTrailingComma:!0}})(S=t.ParseOptions||(t.ParseOptions={}));function T(e,n=!1){let r=0,o=e.length,s="",g=0,F=16,V=0;function N(te){let ae=0,W=0;for(;ae<te;){const G=e.charCodeAt(r);if(G>=48&&G<=57)W=W*16+G-48;else if(G>=65&&G<=70)W=W*16+G-65+10;else if(G>=97&&G<=102)W=W*16+G-97+10;else break;r++,ae++}return ae<te&&(W=-1),W}function A(te){r=te,s="",g=0,F=16,V=0}function j(){const te=r;if(e.charCodeAt(r)===48)r++;else for(r++;r<e.length&&f(e.charCodeAt(r));)r++;if(r<e.length&&e.charCodeAt(r)===46)if(r++,r<e.length&&f(e.charCodeAt(r)))for(r++;r<e.length&&f(e.charCodeAt(r));)r++;else return V=3,e.substring(te,r);let ae=r;if(r<e.length&&(e.charCodeAt(r)===69||e.charCodeAt(r)===101))if(r++,(r<e.length&&e.charCodeAt(r)===43||e.charCodeAt(r)===45)&&r++,r<e.length&&f(e.charCodeAt(r))){for(r++;r<e.length&&f(e.charCodeAt(r));)r++;ae=r}else V=3;return e.substring(te,ae)}function $(){let te="",ae=r;for(;;){if(r>=o){te+=e.substring(ae,r),V=2;break}const W=e.charCodeAt(r);if(W===34){te+=e.substring(ae,r),r++;break}if(W===92){if(te+=e.substring(ae,r),r++,r>=o){V=2;break}switch(e.charCodeAt(r++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const _=N(4);_>=0?te+=String.fromCharCode(_):V=4;break;default:V=5}ae=r;continue}if(W>=0&&W<=31)if(d(W)){te+=e.substring(ae,r),V=2;break}else V=6;r++}return te}function X(){if(s="",V=0,g=r,r>=o)return g=o,F=17;let te=e.charCodeAt(r);if(R(te)){do r++,s+=String.fromCharCode(te),te=e.charCodeAt(r);while(R(te));return F=15}if(d(te))return r++,s+=String.fromCharCode(te),te===13&&e.charCodeAt(r)===10&&(r++,s+=`
`),F=14;switch(te){case 123:return r++,F=1;case 125:return r++,F=2;case 91:return r++,F=3;case 93:return r++,F=4;case 58:return r++,F=6;case 44:return r++,F=5;case 34:return r++,s=$(),F=10;case 47:const ae=r-1;if(e.charCodeAt(r+1)===47){for(r+=2;r<o&&!d(e.charCodeAt(r));)r++;return s=e.substring(ae,r),F=12}if(e.charCodeAt(r+1)===42){r+=2;const W=o-1;let G=!1;for(;r<W;){if(e.charCodeAt(r)===42&&e.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,V=1),s=e.substring(ae,r),F=13}return s+=String.fromCharCode(te),r++,F=16;case 45:if(s+=String.fromCharCode(te),r++,r===o||!f(e.charCodeAt(r)))return F=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),F=11;default:for(;r<o&&ne(te);)r++,te=e.charCodeAt(r);if(g!==r){switch(s=e.substring(g,r),s){case"true":return F=8;case"false":return F=9;case"null":return F=7}return F=16}return s+=String.fromCharCode(te),r++,F=16}}function ne(te){if(R(te)||d(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let te;do te=X();while(te>=12&&te<=15);return te}return{setPosition:A,getPosition:()=>r,scan:n?ee:X,getToken:()=>F,getTokenValue:()=>s,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>V}}t.createScanner=T;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function d(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var O;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(O||(O={}));function h(e,n){const r=[],o=new Object;let s;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let F=!1;function V(N,A,j,$){g.value=N,g.offset=A,g.length=j,g.type=$,g.colonOffset=void 0,s=g}try{E(e,{onObjectBegin:(N,A)=>{if(n<=N)throw o;s=void 0,F=n>N,r.push("")},onObjectProperty:(N,A,j)=>{if(n<A||(V(N,A,j,"property"),r[r.length-1]=N,n<=A+j))throw o},onObjectEnd:(N,A)=>{if(n<=N)throw o;s=void 0,r.pop()},onArrayBegin:(N,A)=>{if(n<=N)throw o;s=void 0,r.push(0)},onArrayEnd:(N,A)=>{if(n<=N)throw o;s=void 0,r.pop()},onLiteralValue:(N,A,j)=>{if(n<A||(V(N,A,j,i(N)),n<=A+j))throw o},onSeparator:(N,A,j)=>{if(n<=A)throw o;if(N===":"&&s&&s.type==="property")s.colonOffset=A,F=!1,s=void 0;else if(N===","){const $=r[r.length-1];typeof $=="number"?r[r.length-1]=$+1:(F=!0,r[r.length-1]=""),s=void 0}}})}catch(N){if(N!==o)throw N}return{path:r,previousNode:s,isAtPropertyKey:F,matches:N=>{let A=0;for(let j=0;A<N.length&&j<r.length;j++)if(N[A]===r[j]||N[A]==="*")A++;else if(N[A]!=="**")return!1;return A===N.length}}}t.getLocation=h;function w(e,n=[],r=S.DEFAULT){let o=null,s=[];const g=[];function F(N){Array.isArray(s)?s.push(N):o!==null&&(s[o]=N)}return E(e,{onObjectBegin:()=>{const N={};F(N),g.push(s),s=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{s=g.pop()},onArrayBegin:()=>{const N=[];F(N),g.push(s),s=N,o=null},onArrayEnd:()=>{s=g.pop()},onLiteralValue:F,onError:(N,A,j)=>{n.push({error:N,offset:A,length:j})}},r),s[0]}t.parse=w;function I(e,n=[],r=S.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(N){o.type==="property"&&(o.length=N-o.offset,o=o.parent)}function g(N){return o.children.push(N),N}E(e,{onObjectBegin:N=>{o=g({type:"object",offset:N,length:-1,parent:o,children:[]})},onObjectProperty:(N,A,j)=>{o=g({type:"property",offset:A,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:N,offset:A,length:j,parent:o})},onObjectEnd:(N,A)=>{o.length=N+A-o.offset,o=o.parent,s(N+A)},onArrayBegin:(N,A)=>{o=g({type:"array",offset:N,length:-1,parent:o,children:[]})},onArrayEnd:(N,A)=>{o.length=N+A-o.offset,o=o.parent,s(N+A)},onLiteralValue:(N,A,j)=>{g({type:i(N),offset:A,length:j,parent:o,value:N}),s(A+j)},onSeparator:(N,A,j)=>{o.type==="property"&&(N===":"?o.colonOffset=A:N===","&&s(A))},onError:(N,A,j)=>{n.push({error:N,offset:A,length:j})}},r);const V=o.children[0];return V&&delete V.parent,V}t.parseTree=I;function l(e,n){if(!!e){let r=e;for(let o of n)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===o){r=g.children[1],s=!0;break}if(!s)return}else{const s=o;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}}t.findNodeAtLocation=l;function v(e){if(!e.parent||!e.parent.children)return[];const n=v(e.parent);if(e.parent.type==="property"){const r=e.parent.children[0].value;n.push(r)}else if(e.parent.type==="array"){const r=e.parent.children.indexOf(e);r!==-1&&n.push(r)}return n}t.getNodePath=v;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":const n=Object.create(null);for(let r of e.children){const o=r.children[1];o&&(n[r.children[0].value]=y(o))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=y;function p(e,n,r=!1){return n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}t.contains=p;function L(e,n,r=!1){if(p(e,n,r)){const o=e.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=n;s++){const g=L(o[s],n,r);if(g)return g}return e}}t.findNodeAtOffset=L;function E(e,n,r=S.DEFAULT){const o=T(e,!1);function s(M){return M?()=>M(o.getTokenOffset(),o.getTokenLength()):()=>!0}function g(M){return M?U=>M(U,o.getTokenOffset(),o.getTokenLength()):()=>!0}const F=s(n.onObjectBegin),V=g(n.onObjectProperty),N=s(n.onObjectEnd),A=s(n.onArrayBegin),j=s(n.onArrayEnd),$=g(n.onLiteralValue),X=g(n.onSeparator),ne=s(n.onComment),ee=g(n.onError),te=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function W(){for(;;){const M=o.scan();switch(o.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(M){case 12:case 13:te?G(10):ne();break;case 16:G(1);break;case 15:case 14:break;default:return M}}}function G(M,U=[],B=[]){if(ee(M),U.length+B.length>0){let q=o.getToken();for(;q!==17;){if(U.indexOf(q)!==-1){W();break}else if(B.indexOf(q)!==-1)break;q=W()}}}function _(M){const U=o.getTokenValue();return M?$(U):V(U),W(),!0}function c(){switch(o.getToken()){case 11:let M=0;try{M=JSON.parse(o.getTokenValue()),typeof M!="number"&&(G(2),M=0)}catch(U){G(2)}$(M);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return W(),!0}function u(){return o.getToken()!==10?(G(3,[],[2,5]),!1):(_(!1),o.getToken()===6?(X(":"),W(),k()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function P(){F(),W();let M=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(M||G(4,[],[]),X(","),W(),o.getToken()===2&&ae)break}else M&&G(6,[],[]);u()||G(4,[],[2,5]),M=!0}return N(),o.getToken()!==2?G(7,[2],[]):W(),!0}function D(){A(),W();let M=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(M||G(4,[],[]),X(","),W(),o.getToken()===4&&ae)break}else M&&G(6,[],[]);k()||G(4,[],[4,5]),M=!0}return j(),o.getToken()!==4?G(8,[4],[]):W(),!0}function k(){switch(o.getToken()){case 3:return D();case 1:return P();case 10:return _(!0);default:return c()}}return W(),o.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):k()?(o.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=E;function a(e,n){let r=T(e),o=[],s,g=0,F;do switch(F=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:g!==F&&o.push(e.substring(g,F)),n!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,n)),g=r.getPosition();break}while(s!==17);return o.join("")}t.stripComments=a;function i(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=i});"use strict";(function(){function x(b){const S=[];typeof b=="number"&&S.push("code/timeOrigin",b);function T(d){S.push(d,Date.now())}function R(){const d=[];for(let f=0;f<S.length;f+=2)d.push({name:S[f],startTime:S[f+1]});return d}return{mark:T,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))S.push({name:T.name,startTime:Math.round(b+T.startTime)});return S}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function m(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=m(C))})(),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var C in m)(typeof exports=="object"?exports:x)[C]=m[C]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function m(C){if(t[C])return t[C].exports;var b=t[C]={i:C,l:!1,exports:{}};return x[C].call(b.exports,b,b.exports,m),b.l=!0,b.exports}return m.m=x,m.c=t,m.d=function(C,b,S){m.o(C,b)||Object.defineProperty(C,b,{enumerable:!0,get:S})},m.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},m.t=function(C,b){if(1&b&&(C=m(C)),8&b||4&b&&typeof C=="object"&&C&&C.__esModule)return C;var S=Object.create(null);if(m.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:C}),2&b&&typeof C!="string")for(var T in C)m.d(S,T,function(R){return C[R]}.bind(null,T));return S},m.n=function(C){var b=C&&C.__esModule?function(){return C.default}:function(){return C};return m.d(b,"a",b),b},m.o=function(C,b){return Object.prototype.hasOwnProperty.call(C,b)},m.p="",m(m.s=0)}([function(x,t,m){(function(C){var b;t=x.exports=B,b=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var S=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],d=t.src=[],f=0,O=f++;d[O]="0|[1-9]\\d*";var h=f++;d[h]="[0-9]+";var w=f++;d[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=f++;d[I]="("+d[O]+")\\.("+d[O]+")\\.("+d[O]+")";var l=f++;d[l]="("+d[h]+")\\.("+d[h]+")\\.("+d[h]+")";var v=f++;d[v]="(?:"+d[O]+"|"+d[w]+")";var y=f++;d[y]="(?:"+d[h]+"|"+d[w]+")";var p=f++;d[p]="(?:-("+d[v]+"(?:\\."+d[v]+")*))";var L=f++;d[L]="(?:-?("+d[y]+"(?:\\."+d[y]+")*))";var E=f++;d[E]="[0-9A-Za-z-]+";var a=f++;d[a]="(?:\\+("+d[E]+"(?:\\."+d[E]+")*))";var i=f++,e="v?"+d[I]+d[p]+"?"+d[a]+"?";d[i]="^"+e+"$";var n="[v=\\s]*"+d[l]+d[L]+"?"+d[a]+"?",r=f++;d[r]="^"+n+"$";var o=f++;d[o]="((?:<|>)?=?)";var s=f++;d[s]=d[h]+"|x|X|\\*";var g=f++;d[g]=d[O]+"|x|X|\\*";var F=f++;d[F]="[v=\\s]*("+d[g]+")(?:\\.("+d[g]+")(?:\\.("+d[g]+")(?:"+d[p]+")?"+d[a]+"?)?)?";var V=f++;d[V]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[L]+")?"+d[a]+"?)?)?";var N=f++;d[N]="^"+d[o]+"\\s*"+d[F]+"$";var A=f++;d[A]="^"+d[o]+"\\s*"+d[V]+"$";var j=f++;d[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=f++;d[$]="(?:~>?)";var X=f++;d[X]="(\\s*)"+d[$]+"\\s+",R[X]=new RegExp(d[X],"g");var ne=f++;d[ne]="^"+d[$]+d[F]+"$";var ee=f++;d[ee]="^"+d[$]+d[V]+"$";var te=f++;d[te]="(?:\\^)";var ae=f++;d[ae]="(\\s*)"+d[te]+"\\s+",R[ae]=new RegExp(d[ae],"g");var W=f++;d[W]="^"+d[te]+d[F]+"$";var G=f++;d[G]="^"+d[te]+d[V]+"$";var _=f++;d[_]="^"+d[o]+"\\s*("+n+")$|^$";var c=f++;d[c]="^"+d[o]+"\\s*("+e+")$|^$";var u=f++;d[u]="(\\s*)"+d[o]+"\\s*("+n+"|"+d[F]+")",R[u]=new RegExp(d[u],"g");var P=f++;d[P]="^\\s*("+d[F]+")\\s+-\\s+("+d[F]+")\\s*$";var D=f++;d[D]="^\\s*("+d[V]+")\\s+-\\s+("+d[V]+")\\s*$";var k=f++;d[k]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)b(M,d[M]),R[M]||(R[M]=new RegExp(d[M]));function U(z,H){if(z instanceof B)return z;if(typeof z!="string"||z.length>S||!(H?R[r]:R[i]).test(z))return null;try{return new B(z,H)}catch(K){return null}}function B(z,H){if(z instanceof B){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof B))return new B(z,H);b("SemVer",z,H),this.loose=H;var K=z.trim().match(H?R[r]:R[i]);if(!K)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=U,t.valid=function(z,H){var K=U(z,H);return K?K.version:null},t.clean=function(z,H){var K=U(z.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(z){return b("SemVer.compare",this.version,this.loose,z),z instanceof B||(z=new B(z,this.loose)),this.compareMain(z)||this.comparePre(z)},B.prototype.compareMain=function(z){return z instanceof B||(z=new B(z,this.loose)),J(this.major,z.major)||J(this.minor,z.minor)||J(this.patch,z.patch)},B.prototype.comparePre=function(z){if(z instanceof B||(z=new B(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=z.prerelease[H];if(b("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++H)},B.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new B(z,K).inc(H,se).version}catch(oe){return null}},t.diff=function(z,H){if(he(z,H))return null;var K=U(z),se=U(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var q=/^[0-9]+$/;function J(z,H){var K=q.test(z),se=q.test(H);return K&&se&&(z=+z,H=+H),K&&!se?-1:se&&!K?1:z<H?-1:z>H?1:0}function Y(z,H,K){return new B(z,K).compare(new B(H,K))}function ie(z,H,K){return Y(z,H,K)>0}function re(z,H,K){return Y(z,H,K)<0}function he(z,H,K){return Y(z,H,K)===0}function ge(z,H,K){return Y(z,H,K)!==0}function De(z,H,K){return Y(z,H,K)>=0}function Oe(z,H,K){return Y(z,H,K)<=0}function Fe(z,H,K,se){var oe;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z===K;break;case"!==":typeof z=="object"&&(z=z.version),typeof K=="object"&&(K=K.version),oe=z!==K;break;case"":case"=":case"==":oe=he(z,K,se);break;case"!=":oe=ge(z,K,se);break;case">":oe=ie(z,K,se);break;case">=":oe=De(z,K,se);break;case"<":oe=re(z,K,se);break;case"<=":oe=Oe(z,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function Re(z,H){if(z instanceof Re){if(z.loose===H)return z;z=z.value}if(!(this instanceof Re))return new Re(z,H);b("comparator",z,H),this.loose=H,this.parse(z),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(z,H){return J(H,z)},t.major=function(z,H){return new B(z,H).major},t.minor=function(z,H){return new B(z,H).minor},t.patch=function(z,H){return new B(z,H).patch},t.compare=Y,t.compareLoose=function(z,H){return Y(z,H,!0)},t.rcompare=function(z,H,K){return Y(H,z,K)},t.sort=function(z,H){return z.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(z,H){return z.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ie,t.lt=re,t.eq=he,t.neq=ge,t.gte=De,t.lte=Oe,t.cmp=Fe,t.Comparator=Re;var Me={};function ve(z,H){if(z instanceof ve)return z.loose===H?z:new ve(z.raw,H);if(z instanceof Re)return new ve(z.value,H);if(!(this instanceof ve))return new ve(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Se(z){return!z||z.toLowerCase()==="x"||z==="*"}function xe(z,H,K,se,oe,be,de,Ce,Ee,Le,ke,we,Ie){return((H=Se(K)?"":Se(se)?">="+K+".0.0":Se(oe)?">="+K+"."+se+".0":">="+H)+" "+(Ce=Se(Ee)?"":Se(Le)?"<"+(+Ee+1)+".0.0":Se(ke)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+ke+"-"+we:"<="+Ce)).trim()}function $e(z,H){for(var K=0;K<z.length;K++)if(!z[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<z.length;K++)if(b(z[K].semver),z[K].semver!==Me&&z[K].semver.prerelease.length>0){var se=z[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ue(z,H,K){try{H=new ve(H,K)}catch(se){return!1}return H.test(z)}function ze(z,H,K,se){var oe,be,de,Ce,Ee;switch(z=new B(z,se),H=new ve(H,se),K){case">":oe=ie,be=Oe,de=re,Ce=">",Ee=">=";break;case"<":oe=re,be=De,de=ie,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,H,se))return!1;for(var Le=0;Le<H.set.length;++Le){var ke=H.set[Le],we=null,Ie=null;if(ke.forEach(function(Te){Te.semver===Me&&(Te=new Re(">=0.0.0")),we=we||Te,Ie=Ie||Te,oe(Te.semver,we.semver,se)?we=Te:de(Te.semver,Ie.semver,se)&&(Ie=Te)}),we.operator===Ce||we.operator===Ee||(!Ie.operator||Ie.operator===Ce)&&be(z,Ie.semver)||Ie.operator===Ee&&de(z,Ie.semver))return!1}return!0}Re.prototype.parse=function(z){var H=this.loose?R[_]:R[c],K=z.match(H);if(!K)throw new TypeError("Invalid comparator: "+z);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new B(K[2],this.loose):this.semver=Me},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(z){return b("Comparator.test",z,this.loose),this.semver===Me||(typeof z=="string"&&(z=new B(z,this.loose)),Fe(z,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(z,H){if(!(z instanceof Re))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(z.value,H),Ue(this.value,K,H);if(z.operator==="")return K=new ve(this.value,H),Ue(z.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Fe(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Ee=Fe(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||oe||be&&de||Ce||Ee},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),b("range",z,H);var K=H?R[D]:R[P];z=z.replace(K,xe),b("hyphen replace",z),z=z.replace(R[u],"$1$2$3"),b("comparator trim",z,R[u]),z=(z=(z=z.replace(R[X],"$1~")).replace(R[ae],"$1^")).split(/\s+/).join(" ");var se=H?R[_]:R[c],oe=z.split(" ").map(function(be){return function(de,Ce){return b("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){b("caret",we,Ie);var Te=Ie?R[G]:R[W];return we.replace(Te,function(Ae,le,fe,me,pe){var Pe;return b("caret",we,Ae,le,fe,me,pe),Se(le)?Pe="":Se(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Se(me)?Pe=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":pe?(b("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+pe+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+pe+" <"+(+le+1)+".0.0"):(b("no pr"),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+" <"+(+le+1)+".0.0"),b("caret return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),b("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){var Te=Ie?R[ee]:R[ne];return we.replace(Te,function(Ae,le,fe,me,pe){var Pe;return b("tilde",we,Ae,le,fe,me,pe),Se(le)?Pe="":Se(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Se(me)?Pe=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":pe?(b("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0"):Pe=">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0",b("tilde return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),b("tildes",de),de=function(Ee,Le){return b("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(ke){return function(we,Ie){we=we.trim();var Te=Ie?R[A]:R[N];return we.replace(Te,function(Ae,le,fe,me,pe,Pe){b("xRange",we,Ae,le,fe,me,pe,Pe);var Be=Se(fe),Ne=Be||Se(me),je=Ne||Se(pe);return le==="="&&je&&(le=""),Be?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Ne&&(me=0),je&&(pe=0),le===">"?(le=">=",Ne?(fe=+fe+1,me=0,pe=0):je&&(me=+me+1,pe=0)):le==="<="&&(le="<",Ne?fe=+fe+1:me=+me+1),Ae=le+fe+"."+me+"."+pe):Ne?Ae=">="+fe+".0.0 <"+(+fe+1)+".0.0":je&&(Ae=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0"),b("xRange return",Ae),Ae})}(ke,Le)}).join(" ")}(de,Ce),b("xrange",de),de=function(Ee,Le){return b("replaceStars",Ee,Le),Ee.trim().replace(R[k],"")}(de,Ce),b("stars",de),de}(be,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(be){return!!be.match(se)})),oe=oe.map(function(be){return new Re(be,H)})},ve.prototype.intersects=function(z,H){if(!(z instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return z.set.some(function(oe){return oe.every(function(be){return se.intersects(be,H)})})})})},t.toComparators=function(z,H){return new ve(z,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new B(z,this.loose));for(var H=0;H<this.set.length;H++)if($e(this.set[H],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,H,K){var se=null,oe=null;try{var be=new ve(H,K)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==-1||(oe=new B(se=de,K)))}),se},t.minSatisfying=function(z,H,K){var se=null,oe=null;try{var be=new ve(H,K)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==1||(oe=new B(se=de,K)))}),se},t.validRange=function(z,H){try{return new ve(z,H).range||"*"}catch(K){return null}},t.ltr=function(z,H,K){return ze(z,H,"<",K)},t.gtr=function(z,H,K){return ze(z,H,">",K)},t.outside=ze,t.prerelease=function(z,H){var K=U(z,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(z,H,K){return z=new ve(z,K),H=new ve(H,K),z.intersects(H)},t.coerce=function(z){if(z instanceof B)return z;if(typeof z!="string")return null;var H=z.match(R[j]);return H==null?null:U((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,m(1))},function(x,t){var m,C,b=x.exports={};function S(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(y){if(m===setTimeout)return setTimeout(y,0);if((m===S||!m)&&setTimeout)return m=setTimeout,setTimeout(y,0);try{return m(y,0)}catch(p){try{return m.call(null,y,0)}catch(L){return m.call(this,y,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:S}catch(y){m=S}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch(y){C=T}})();var d,f=[],O=!1,h=-1;function w(){O&&d&&(O=!1,d.length?f=d.concat(f):h=-1,f.length&&I())}function I(){if(!O){var y=R(w);O=!0;for(var p=f.length;p;){for(d=f,f=[];++h<p;)d&&d[h].run();h=-1,p=f.length}d=null,O=!1,function(L){if(C===clearTimeout)return clearTimeout(L);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(L);try{C(L)}catch(E){try{return C.call(null,L)}catch(a){return C.call(this,L)}}}(y)}}function l(y,p){this.fun=y,this.array=p}function v(){}b.nextTick=function(y){var p=new Array(arguments.length-1);if(arguments.length>1)for(var L=1;L<arguments.length;L++)p[L-1]=arguments[L];f.push(new l(y,p)),f.length!==1||O||R(I)},l.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=v,b.addListener=v,b.once=v,b.off=v,b.removeListener=v,b.removeAllListeners=v,b.emit=v,b.prependListener=v,b.prependOnceListener=v,b.listeners=function(y){return[]},b.binding=function(y){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(y){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Q[34],Z([0,1,14,2]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(y){const p=y;return p&&[p.on,p.pause,p.resume,p.destroy].every(L=>typeof L=="function")}t.isReadableStream=b;function S(y){const p=y;return p&&b(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}t.isReadableBufferedStream=S;function T(y,p){return new R(y,p)}t.newWriteableStream=T;class R{constructor(p,L){this.reducer=p,this.options=L,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var L;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((L=this.options)===null||L===void 0?void 0:L.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(E=>this.pendingWritePromises.push(E))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(L=>L(p))}emitError(p){this.listeners.error.length===0?(0,m.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(L=>L(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,L){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(L),this.resume();break;case"end":this.listeners.end.push(L),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(L),this.state.flowing&&this.flowErrors();break}}removeListener(p,L){if(!this.state.destroyed){let E;switch(p){case"data":E=this.listeners.data;break;case"end":E=this.listeners.end;break;case"error":E=this.listeners.error;break}if(E){const a=E.indexOf(L);a>=0&&E.splice(a,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const L=[...this.pendingWritePromises];this.pendingWritePromises.length=0,L.forEach(E=>E())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(y,p){const L=[];let E;for(;(E=y.read())!==null;)L.push(E);return p(L)}t.consumeReadable=d;function f(y,p,L){const E=[];let a;for(;(a=y.read())!==null&&E.length<L;)E.push(a);return a===null&&E.length>0?p(E):{read:()=>{if(E.length>0)return E.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return y.read()}}}t.peekReadable=f;function O(y,p){return new Promise((L,E)=>{const a=[];h(y,{onData:i=>{p&&a.push(i)},onError:i=>{p?E(i):L(void 0)},onEnd:()=>{L(p?p(a):void 0)}})})}t.consumeStream=O;function h(y,p){y.on("error",L=>p.onError(L)),y.on("end",()=>p.onEnd()),y.on("data",L=>p.onData(L))}t.listenStream=h;function w(y,p){return new Promise((L,E)=>{const a=new C.DisposableStore,i=[],e=o=>{if(i.push(o),i.length>p)return a.dispose(),y.pause(),L({stream:y,buffer:i,ended:!1})},n=o=>E(o),r=()=>L({stream:y,buffer:i,ended:!0});a.add((0,C.toDisposable)(()=>y.removeListener("error",n))),y.on("error",n),a.add((0,C.toDisposable)(()=>y.removeListener("end",r))),y.on("end",r),a.add((0,C.toDisposable)(()=>y.removeListener("data",e))),y.on("data",e)})}t.peekStream=w;function I(y,p){const L=T(p);return L.end(y),L}t.toStream=I;function l(y){let p=!1;return{read:()=>p?null:(p=!0,y)}}t.toReadable=l;function v(y,p,L){const E=T(L);return h(y,{onData:a=>E.write(p.data(a)),onError:a=>E.error(p.error?p.error(a):a),onEnd:()=>E.end()}),E}t.transform=v}),define(Q[17],Z([0,1,21,34]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let R,d;class f{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return b?new f(Buffer.allocUnsafe(s)):new f(new Uint8Array(s))}static wrap(s){return b&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new f(s)}static fromString(s,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&b?new f(Buffer.from(s)):S?(R||(R=new TextEncoder),new f(R.encode(s))):new f(m.encodeUTF8(s))}static concat(s,g){if(typeof g=="undefined"){g=0;for(let N=0,A=s.length;N<A;N++)g+=s[N].byteLength}const F=f.alloc(g);let V=0;for(let N=0,A=s.length;N<A;N++){const j=s[N];F.set(j,V),V+=j.byteLength}return F}toString(){return b?this.buffer.toString():T?(d||(d=new TextDecoder),d.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(s,g){return new f(this.buffer.subarray(s,g))}set(s,g){s instanceof f?this.buffer.set(s.buffer,g):this.buffer.set(s,g)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,g){I(this.buffer,s,g)}readUInt32LE(s){return l(this.buffer,s)}writeUInt32LE(s,g){v(this.buffer,s,g)}readUInt8(s){return y(this.buffer,s)}writeUInt8(s,g){p(this.buffer,s,g)}}t.VSBuffer=f;function O(o,s){return o[s+0]<<0>>>0|o[s+1]<<8>>>0}t.readUInt16LE=O;function h(o,s,g){o[g+0]=s&255,s=s>>>8,o[g+1]=s&255}t.writeUInt16LE=h;function w(o,s){return o[s]*2**24+o[s+1]*2**16+o[s+2]*2**8+o[s+3]}t.readUInt32BE=w;function I(o,s,g){o[g+3]=s,s=s>>>8,o[g+2]=s,s=s>>>8,o[g+1]=s,s=s>>>8,o[g]=s}t.writeUInt32BE=I;function l(o,s){return o[s+0]<<0>>>0|o[s+1]<<8>>>0|o[s+2]<<16>>>0|o[s+3]<<24>>>0}t.readUInt32LE=l;function v(o,s,g){o[g+0]=s&255,s=s>>>8,o[g+1]=s&255,s=s>>>8,o[g+2]=s&255,s=s>>>8,o[g+3]=s&255}t.writeUInt32LE=v;function y(o,s){return o[s]}t.readUInt8=y;function p(o,s,g){o[g]=s}t.writeUInt8=p;function L(o){return C.consumeReadable(o,s=>f.concat(s))}t.readableToBuffer=L;function E(o){return C.toReadable(o)}t.bufferToReadable=E;function a(o){return C.consumeStream(o,s=>f.concat(s))}t.streamToBuffer=a;async function i(o){return o.ended?f.concat(o.buffer):f.concat([...o.buffer,await a(o.stream)])}t.bufferedStreamToBuffer=i;function e(o){return C.toStream(o,s=>f.concat(s))}t.bufferToStream=e;function n(o){return C.transform(o,{data:s=>typeof s=="string"?f.fromString(s):f.wrap(s)},s=>f.concat(s))}t.streamToBufferReadableStream=n;function r(o){return C.newWriteableStream(s=>f.concat(s),o)}t.newWriteableBufferStream=r}),define(Q[22],Z([0,1,8]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.keys(l).forEach(y=>{l[y]&&typeof l[y]=="object"?v[y]=C(l[y]):v[y]=l[y]}),v}t.deepClone=C;function b(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const y=v.shift();Object.freeze(y);for(const p in y)if(S.call(y,p)){const L=y[p];typeof L=="object"&&!Object.isFrozen(L)&&v.push(L)}}return l}t.deepFreeze=b;const S=Object.prototype.hasOwnProperty;function T(l,v){return R(l,v,new Set)}t.cloneAndChange=T;function R(l,v,y){if((0,m.isUndefinedOrNull)(l))return l;const p=v(l);if(typeof p!="undefined")return p;if((0,m.isArray)(l)){const L=[];for(const E of l)L.push(R(E,v,y));return L}if((0,m.isObject)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const L={};for(let E in l)S.call(l,E)&&(L[E]=R(l[E],v,y));return y.delete(l),L}return l}function d(l,v,y=!0){return(0,m.isObject)(l)?((0,m.isObject)(v)&&Object.keys(v).forEach(p=>{p in l?y&&((0,m.isObject)(l[p])&&(0,m.isObject)(v[p])?d(l[p],v[p],y):l[p]=v[p]):l[p]=v[p]}),l):v}t.mixin=d;function f(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let y,p;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(y=0;y<l.length;y++)if(!f(l[y],v[y]))return!1}else{const L=[];for(p in l)L.push(p);L.sort();const E=[];for(p in v)E.push(p);if(E.sort(),!f(L,E))return!1;for(y=0;y<L.length;y++)if(!f(l[L[y]],v[L[y]]))return!1}return!0}t.equals=f;function O(l){const v=new Set;return JSON.stringify(l,(y,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(v.has(p))return"[Circular]";v.add(p)}return p})}t.safeStringify=O;function h(l,v,y){const p=v(l);return typeof p=="undefined"?y:p}t.getOrDefault=h;function w(l,v){const y=Object.create(null);return!l||!v||Object.keys(v).forEach(L=>{const E=l[L],a=v[L];f(E,a)||(y[L]=a)}),y}t.distinct=w;function I(l,v){const y=v.toLowerCase(),p=Object.keys(l).find(L=>L.toLowerCase()===y);return p?l[p]:l[v]}t.getCaseInsensitive=I}),define(Q[59],Z([0,1,9]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(f){const O=f;return O&&typeof O.type=="string"&&typeof O.severity=="string"}t.isRemoteConsoleLog=C;function b(f){const O=[];let h;try{const w=JSON.parse(f.arguments),I=w[w.length-1];I&&I.__$stack&&(w.pop(),h=I.__$stack),O.push(...w)}catch(w){O.push("Unable to log remote console arguments",f.arguments)}return{args:O,stack:h}}t.parse=b;function S(f){if(typeof f!="string")return S(b(f).stack);const O=f;if(O){const h=T(O),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(w&&w.length===4)return{uri:m.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=S;function T(f){if(!f)return f;const O=f.indexOf(`
`);return O===-1?f:f.substring(0,O)}function R(f,O){const{args:h,stack:w}=b(f),I=typeof h[0]=="string"&&h.length===1;let l=T(w);l&&(l=`(${l.trim()})`);let v=[];if(typeof h[0]=="string"?l&&I?v=[`%c[${O}] %c${h[0]} %c${l}`,d("blue"),d(""),d("grey")]:v=[`%c[${O}] %c${h[0]}`,d("blue"),d(""),...h.slice(1)]:v=[`%c[${O}]%`,d("blue"),...h],l&&!I&&v.push(l),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,v)}t.log=R;function d(f){return`color: ${f}`}}),define(Q[60],Z([0,1,17,21,9]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function S(f){return JSON.stringify(f,R)}t.stringify=S;function T(f){let O=JSON.parse(f);return O=d(O),O}t.parse=T;function R(f,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function d(f,O=0){if(!f||O>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return b.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof m.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let h=0;h<f.length;++h)f[h]=d(f[h],O+1);else for(const h in f)Object.hasOwnProperty.call(f,h)&&(f[h]=d(f[h],O+1))}return f}t.revive=d}),define(Q[61],Z([0,1,21,35,3,43,4]),function(x,t,m,C,b,S,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const d="**",f="/",O="[/\\\\]",h="[^/\\\\]",w=/\//g;function I(u){switch(u){case 0:return"";case 1:return`${h}*?`;default:return`(?:${O}|${h}+${O}|${O}${h}+)*?`}}function l(u,P){if(!u)return[];const D=[];let k=!1,M=!1,U="";for(const B of u){switch(B){case P:if(!k&&!M){D.push(U),U="";continue}break;case"{":k=!0;break;case"}":k=!1;break;case"[":M=!0;break;case"]":M=!1;break}U+=B}return U&&D.push(U),D}t.splitGlobAware=l;function v(u){if(!u)return"";let P="";const D=l(u,f);if(D.every(k=>k===d))P=".*";else{let k=!1;D.forEach((M,U)=>{if(M===d){k||(P+=I(2),k=!0);return}let B=!1,q="",J=!1,Y="";for(const ie of M){if(ie!=="}"&&B){q+=ie;continue}if(J&&(ie!=="]"||!Y)){let re;ie==="-"?re=ie:(ie==="^"||ie==="!")&&!Y?re="^":ie===f?re="":re=m.escapeRegExpCharacters(ie),Y+=re;continue}switch(ie){case"{":B=!0;continue;case"[":J=!0;continue;case"}":P+=`(?:${l(q,",").map(ge=>v(ge)).join("|")})`,B=!1,q="";break;case"]":P+="["+Y+"]",J=!1,Y="";break;case"?":P+=h;continue;case"*":P+=I(1);continue;default:P+=m.escapeRegExpCharacters(ie)}}U<D.length-1&&(D[U+1]!==d||U+2<D.length)&&(P+=O),k=!1})}return P}const y=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,L=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,E=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),n=function(){return!1},r=function(){return null};function o(u,P){if(!u)return r;let D;typeof u!="string"?D=u.pattern:D=u,D=D.trim();const k=`${D}_${!!P.trimForExclusions}`;let M=e.get(k);if(M)return s(M,u);let U;if(y.test(D)){const B=D.substr(4);M=function(q,J){return typeof q=="string"&&q.endsWith(B)?D:null}}else(U=p.exec(g(D,P)))?M=F(U[1],D):(P.trimForExclusions?E:L).test(D)?M=V(D,P):(U=a.exec(g(D,P)))?M=N(U[1].substr(1),D,!0):(U=i.exec(g(D,P)))?M=N(U[1],D,!1):M=A(D);return e.set(k,M),s(M,u)}function s(u,P){return typeof P=="string"?u:function(D,k){return C.isEqualOrParent(D,P.base)?u(b.relative(P.base,D),k):null}}function g(u,P){return P.trimForExclusions&&u.endsWith("/**")?u.substr(0,u.length-2):u}function F(u,P){const D=`/${u}`,k=`\\${u}`,M=function(B,q){return typeof B!="string"?null:q?q===u?P:null:B===u||B.endsWith(D)||B.endsWith(k)?P:null},U=[u];return M.basenames=U,M.patterns=[P],M.allBasenames=U,M}function V(u,P){const D=c(u.slice(1,-1).split(",").map(q=>o(q,P)).filter(q=>q!==r),u),k=D.length;if(!k)return r;if(k===1)return D[0];const M=function(q,J){for(let Y=0,ie=D.length;Y<ie;Y++)if(D[Y](q,J))return u;return null},U=D.find(q=>!!q.allBasenames);U&&(M.allBasenames=U.allBasenames);const B=D.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function N(u,P,D){const k=b.sep===b.posix.sep,M=k?u:u.replace(w,b.sep),U=b.sep+M,B=b.posix.sep+u,q=D?function(J,Y){return typeof J=="string"&&(J===M||J.endsWith(U)||!k&&(J===u||J.endsWith(B)))?P:null}:function(J,Y){return typeof J=="string"&&(J===M||!k&&J===u)?P:null};return q.allPaths=[(D?"*/":"./")+u],q}function A(u){try{const P=new RegExp(`^${v(u)}$`);return function(D){return P.lastIndex=0,typeof D=="string"&&P.test(D)?u:null}}catch(P){return r}}function j(u,P,D){return!u||typeof P!="string"?!1:$(u)(P,void 0,D)}t.match=j;function $(u,P={}){if(!u)return n;if(typeof u=="string"||te(u)){const D=o(u,P);if(D===r)return n;const k=function(M,U){return!!D(M,U)};return D.allBasenames&&(k.allBasenames=D.allBasenames),D.allPaths&&(k.allPaths=D.allPaths),k}return G(u,P)}t.parse=$;function X(u){if(!!u){let P;return D=>(P||(P=(u()||Promise.resolve([])).then(k=>k?ee(k):{})),P.then(k=>!!k[D]))}}t.hasSiblingPromiseFn=X;function ne(u){if(!!u){let P;return D=>{if(!P){const k=u();P=k?ee(k):{}}return!!P[D]}}}t.hasSiblingFn=ne;function ee(u){const P={};for(const D of u)P[D]=!0;return P}function te(u){const P=u;return P&&typeof P.base=="string"&&typeof P.pattern=="string"}t.isRelativePattern=te;function ae(u){return u.allBasenames||[]}t.getBasenameTerms=ae;function W(u){return u.allPaths||[]}t.getPathTerms=W;function G(u,P){const D=c(Object.getOwnPropertyNames(u).map(q=>_(q,u[q],P)).filter(q=>q!==r)),k=D.length;if(!k)return r;if(!D.some(q=>!!q.requiresSiblings)){if(k===1)return D[0];const q=function(ie,re){for(let he=0,ge=D.length;he<ge;he++){const De=D[he](ie,re);if(De)return De}return null},J=D.find(ie=>!!ie.allBasenames);J&&(q.allBasenames=J.allBasenames);const Y=D.reduce((ie,re)=>re.allPaths?ie.concat(re.allPaths):ie,[]);return Y.length&&(q.allPaths=Y),q}const M=function(q,J,Y){let ie;for(let re=0,he=D.length;re<he;re++){const ge=D[re];ge.requiresSiblings&&Y&&(J||(J=b.basename(q)),ie||(ie=J.substr(0,J.length-b.extname(q).length)));const De=ge(q,J,ie,Y);if(De)return De}return null},U=D.find(q=>!!q.allBasenames);U&&(M.allBasenames=U.allBasenames);const B=D.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function _(u,P,D){if(P===!1)return r;const k=o(u,D);if(k===r)return r;if(typeof P=="boolean")return k;if(P){const M=P.when;if(typeof M=="string"){const U=(B,q,J,Y)=>{if(!Y||!k(B,q))return null;const ie=M.replace("$(basename)",J),re=Y(ie);return(0,T.isThenable)(re)?re.then(he=>he?u:null):re?u:null};return U.requiresSiblings=!0,U}}return k}function c(u,P){const D=u.filter(q=>!!q.basenames);if(D.length<2)return u;const k=D.reduce((q,J)=>{const Y=J.basenames;return Y?q.concat(Y):q},[]);let M;if(P){M=[];for(let q=0,J=k.length;q<J;q++)M.push(P)}else M=D.reduce((q,J)=>{const Y=J.patterns;return Y?q.concat(Y):q},[]);const U=function(q,J){if(typeof q!="string")return null;if(!J){let ie;for(ie=q.length;ie>0;ie--){const re=q.charCodeAt(ie-1);if(re===47||re===92)break}J=q.substr(ie)}const Y=k.indexOf(J);return Y!==-1?M[Y]:null};U.basenames=k,U.patterns=M,U.allBasenames=k;const B=u.filter(q=>!q.basenames);return B.push(U),B}}),define(Q[62],Z([0,1,9,3,21,10,15,18,35]),function(x,t,m,C,b,S,T,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(o,s,g){if(typeof o=="string"&&(o=m.URI.file(o)),g){const V=g.getWorkspaceFolder(o);if(V){const N=g.getWorkspace().folders.length>1;let A;if((0,R.isEqual)(V.uri,o)?A="":A=(0,R.relativePath)(V.uri,o),N){const j=V.name?V.name:(0,R.basename)(V.uri);A=A?j+" \u2022 "+A:j}return A}}if(o.scheme!==S.Schemas.file&&o.scheme!==S.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(o.fsPath))return(0,C.normalize)(h(o.fsPath));let F=(0,C.normalize)(o.fsPath);return!T.isWindows&&(s==null?void 0:s.userHome)&&(F=I(F,s.userHome.fsPath)),F}t.getPathLabel=f;function O(o){if(!!o){typeof o=="string"&&(o=m.URI.file(o));const s=(0,R.basename)(o)||(o.scheme===S.Schemas.file?o.fsPath:o.path);return T.isWindows&&(0,d.isRootOrDriveLetter)(s)?h(s):s}}t.getBaseLabel=O;function h(o){return(0,d.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=h;let w=Object.create(null);function I(o,s){if(T.isWindows||!o||!s)return o;let g=w.original===s?w.normalized:void 0;return g||(g=`${(0,b.rtrim)(s,C.posix.sep)}${C.posix.sep}`,w={original:s,normalized:g}),(T.isLinux?o.startsWith(g):(0,b.startsWithIgnoreCase)(o,g))&&(o=`~/${o.substr(g.length)}`),o}t.tildify=I;function l(o,s){return o.replace(/^~($|\/|\\)/,`${s}$1`)}t.untildify=l;const v="\u2026",y="\\\\",p="~";function L(o,s=C.sep){const g=new Array(o.length);let F=!1;for(let V=0;V<o.length;V++){let N=o[V];if(N===""){g[V]=`.${s}`;continue}if(!N){g[V]=N;continue}F=!0;let A="";N.indexOf(y)===0?(A=N.substr(0,N.indexOf(y)+y.length),N=N.substr(N.indexOf(y)+y.length)):N.indexOf(s)===0?(A=N.substr(0,N.indexOf(s)+s.length),N=N.substr(N.indexOf(s)+s.length)):N.indexOf(p)===0&&(A=N.substr(0,N.indexOf(p)+p.length),N=N.substr(N.indexOf(p)+p.length));const j=N.split(s);for(let $=1;F&&$<=j.length;$++)for(let X=j.length-$;F&&X>=0;X--){F=!1;let ne=j.slice(X,X+$).join(s);for(let ee=0;!F&&ee<o.length;ee++)if(ee!==V&&o[ee]&&o[ee].indexOf(ne)>-1){const te=X+$===j.length,ae=X>0&&o[ee].indexOf(s)>-1?s+ne:ne,W=o[ee].endsWith(ae);F=!te||W}if(!F){let ee="";(j[0].endsWith(":")||A!=="")&&(X===1&&(X=0,$++,ne=j[0]+s+ne),X>0&&(ee=j[0]+s),ee=A+ee),X>0&&(ee=ee+v+s),ee=ee+ne,X+$<j.length&&(ee=ee+s+v),g[V]=ee}}F&&(g[V]=N)}return g}t.shorten=L;var E;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function a(o,s=Object.create(null)){const g=[];let F=!1,V="";for(const N of o)if(N==="$"||F&&N==="{")V&&g.push({value:V,type:E.TEXT}),V="",F=!0;else if(N==="}"&&F){const A=s[V];if(typeof A=="string")A.length&&g.push({value:A,type:E.VARIABLE});else if(A){const j=g[g.length-1];(!j||j.type!==E.SEPARATOR)&&g.push({value:A.label,type:E.SEPARATOR})}V="",F=!1}else V+=N;return V&&!F&&g.push({value:V,type:E.TEXT}),g.filter((N,A)=>{if(N.type===E.SEPARATOR){const j=g[A-1],$=g[A+1];return[j,$].every(X=>X&&(X.type===E.VARIABLE||X.type===E.TEXT)&&X.value.length>0)}return!0}).map(N=>N.value).join("")}t.template=a;function i(o,s){return T.isMacintosh||s?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=i;function e(o,s){return T.isMacintosh||s?o.replace(/\(&&\w\)|&&/g,""):T.isWindows?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=n;function r(o){const s=o.indexOf("/")!==-1?C.posix:C.win32,g=s.basename(o),F=s.dirname(o);return g.length?{name:g,parentPath:F}:{name:F,parentPath:""}}t.splitName=r}),define(Q[44],Z([0,1,126]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class C{constructor(S="utf8"){this.stringDecoder=new m.StringDecoder(S),this.remaining=null}write(S){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(R.length<1)return T;let d=0,f,O=d;for(;O<R.length;)if(f=R.charCodeAt(O),f===13||f===10){if(T.push(R.substring(d,O)),O++,O<R.length){const h=f;f=R.charCodeAt(O),(h===13&&f===10||h===10&&f===13)&&O++}d=O}else O++;return this.remaining=d<R.length?R.substr(d):null,T}end(){return this.remaining}}t.LineDecoder=C}),define(Q[63],Z([0,1,16,64,21,3,12]),function(x,t,m,C,b,S,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(h){const w=(0,S.dirname)(h);if(h===w)return h;const I=((0,S.basename)(h)||h).toLowerCase();try{const v=(0,T.readdirSync)(w).filter(y=>y.toLowerCase()===I);if(v.length===1){const y=R(w);if(y)return(0,S.join)(y,v[0])}else if(v.length>1){const y=v.indexOf(I);if(y>=0){const p=R(w);if(p)return(0,S.join)(p,v[y])}}}catch(l){}return null}t.realcaseSync=R;async function d(h){try{return await(0,C.promisify)(m.realpath)(h)}catch(w){const I=O(h);return await m.promises.access(I,m.constants.R_OK),I}}t.realpath=d;function f(h){try{return m.realpathSync(h)}catch(w){const I=O(h);return m.accessSync(I,m.constants.R_OK),I}}t.realpathSync=f;function O(h){return(0,b.rtrim)((0,S.normalize)(h),S.sep)}});var ye=this&&this.__await||function(x){return this instanceof ye?(this.v=x,this):new ye(x)},Ve=this&&this.__asyncGenerator||function(x,t,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var C=m.apply(x,t||[]),b,S=[];return b={},T("next"),T("throw"),T("return"),b[Symbol.asyncIterator]=function(){return this},b;function T(w){C[w]&&(b[w]=function(I){return new Promise(function(l,v){S.push([w,I,l,v])>1||R(w,I)})})}function R(w,I){try{d(C[w](I))}catch(l){h(S[0][3],l)}}function d(w){w.value instanceof ye?Promise.resolve(w.value.v).then(f,O):h(S[0][2],w)}function f(w){R("next",w)}function O(w){R("throw",w)}function h(w,I){w(I),S.shift(),S.length&&R(S[0][0],S[0][1])}},_e=this&&this.__asyncValues||function(x){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=x[Symbol.asyncIterator],m;return t?t.call(x):(x=typeof __values=="function"?__values(x):x[Symbol.iterator](),m={},C("next"),C("throw"),C("return"),m[Symbol.asyncIterator]=function(){return this},m);function C(S){m[S]=x[S]&&function(T){return new Promise(function(R,d){T=x[S](T),b(R,d,T.done,T.value)})}}function b(S,T,R,d){Promise.resolve(d).then(function(f){S({value:f,done:R})},T)}};define(Q[65],Z([0,1,12,32,3]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let O;process.env.PROCESSOR_ARCHITEW6432?O=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?O=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?O=1:O=0;class h{constructor(i,e,n){this.exePath=i,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:O===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:a=!1,findPreview:i=!1}={}){const e=w({useAlternateBitness:a});if(!e)return null;const n=b.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(n))return null;let r=-1,o=null;for(const F of await m.readdir(n)){let V=-1;if(i){const A=F.indexOf("-");if(A<0)continue;const j=F.substring(0,A);if(!S.test(j)||F.substring(A+1)!=="preview")continue;V=parseInt(j,10)}else{if(!S.test(F))continue;V=parseInt(F,10)}if(!(V<=r)){const N=b.join(n,F,"pwsh.exe");!await m.SymlinkSupport.existsFile(N)||(o=N,r=V)}}if(!o)return null;const s=e.includes("x86")?" (x86)":"",g=i?" Preview":"";return new h(o,`PowerShell${g}${s}`,!0)}async function l({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const i=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=a?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const r of await m.readdir(i))if(e.test(r)){const o=b.join(i,r,"pwsh.exe");return new h(o,n)}return null}function v(){const a=b.join(C.homedir(),".dotnet","tools","pwsh.exe");return new h(a,".NET Core PowerShell Global Tool")}function y(){const a=b.join(process.env.windir,f===1&&O!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(a,"Windows PowerShell",!0)}function p(){return Ve(this,arguments,function*(){let i=yield ye(I());i&&(yield yield ye(i)),i=yield ye(I({useAlternateBitness:!0})),i&&(yield yield ye(i)),i=yield ye(l()),i&&(yield yield ye(i)),i=v(),i&&(yield yield ye(i)),i=yield ye(I({findPreview:!0})),i&&(yield yield ye(i)),i=yield ye(l({findPreview:!0})),i&&(yield yield ye(i)),i=yield ye(I({useAlternateBitness:!0,findPreview:!0})),i&&(yield yield ye(i)),i=y(),i&&(yield yield ye(i))})}function L(){return Ve(this,arguments,function*(){var i,e;try{for(var n=_e(p()),r;r=yield ye(n.next()),!r.done;){const o=r.value;(yield ye(o.exists()))&&(yield yield ye(o))}}catch(o){i={error:o}}finally{try{r&&!r.done&&(e=n.return)&&(yield ye(e.call(n)))}finally{if(i)throw i.error}}})}t.enumeratePowerShellInstallations=L;async function E(){var a,i;try{for(var e=_e(L()),n;n=await e.next(),!n.done;)return n.value}catch(r){a={error:r}}finally{try{n&&!n.done&&(i=e.return)&&await i.call(e)}finally{if(a)throw a.error}}return null}t.getFirstAvailablePowerShellInstallation=E}),define(Q[66],Z([0,1,3,16,15,127,2,12]),function(x,t,m,C,b,S,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function d(h,w,I){return O({path:h,isDirectory:!1},w,I)}t.watchFile=d;function f(h,w,I){return O({path:h,isDirectory:!0},w,I)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function O(h,w,I){const l=(0,m.basename)(h.path),v=new Map;let y=!1,p=[(0,T.toDisposable)(()=>{v.forEach(L=>(0,T.dispose)(L)),v.clear()})];try{const L=(0,C.watch)(h.path);p.push((0,T.toDisposable)(()=>{L.removeAllListeners(),L.close()}));const E=new Set;h.isDirectory&&(0,R.readdir)(h.path).then(a=>a.forEach(i=>E.add(i))),L.on("error",(a,i)=>{y||I(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${i})`)}),L.on("change",(a,i)=>{if(!y){let e="";if(i&&(e=i.toString(),b.isMacintosh&&(e=(0,S.normalizeNFC)(e))),!(!e||a!=="change"&&a!=="rename")){const n=h.isDirectory?(0,m.join)(h.path,e):h.path;if(h.isDirectory)if(a==="rename"){const r=v.get(n);r&&(0,T.dispose)(r);const o=setTimeout(async()=>{v.delete(n);const s=await(0,R.exists)(n);if(!y){let g;s?E.has(e)?g="changed":(g="added",E.add(e)):(E.delete(e),g="deleted"),w(g,n)}},t.CHANGE_BUFFER_DELAY);v.set(n,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let r;E.has(e)?r="changed":(r="added",E.add(e)),w(r,n)}else if(a==="rename"||e!==l){const r=setTimeout(async()=>{const o=await(0,R.exists)(n);y||(o?(w("changed",n),p=[O(h,w,I)]):w("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(p),p=[(0,T.toDisposable)(()=>clearTimeout(r))]}else w("changed",n)}}})}catch(L){(0,R.exists)(h.path).then(E=>{E&&!y&&I(`Failed to watch ${h.path} for changes using fs.watch() (${L.toString()})`)})}return(0,T.toDisposable)(()=>{y=!0,p=(0,T.dispose)(p)})}}),define(Q[36],Z([0,1,11,2,4,28,14,17,23,8,60,21]),function(x,t,m,C,b,S,T,R,d,f,O,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var w;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(w=t.RequestType||(t.RequestType={}));function I(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function v(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(y||(y={}));class p{constructor(c){this.buffer=c,this.pos=0}read(c){const u=this.buffer.slice(this.pos,this.pos+c);return this.pos+=u.byteLength,u}}class L{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(c){this.buffers.push(c)}}var E;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(E||(E={}));function a(_){const c=R.VSBuffer.alloc(4);return c.writeUInt32BE(_,0),c}function i(_){return _.read(4).readUInt32BE(0)}function e(_){const c=R.VSBuffer.alloc(1);return c.writeUInt8(_,0),c}const n={Undefined:e(E.Undefined),String:e(E.String),Buffer:e(E.Buffer),VSBuffer:e(E.VSBuffer),Array:e(E.Array),Object:e(E.Object)},r=typeof Buffer!="undefined";function o(_,c){if(typeof c=="undefined")_.write(n.Undefined);else if(typeof c=="string"){const u=R.VSBuffer.fromString(c);_.write(n.String),_.write(a(u.byteLength)),_.write(u)}else if(r&&Buffer.isBuffer(c)){const u=R.VSBuffer.wrap(c);_.write(n.Buffer),_.write(a(u.byteLength)),_.write(u)}else if(c instanceof R.VSBuffer)_.write(n.VSBuffer),_.write(a(c.byteLength)),_.write(c);else if(Array.isArray(c)){_.write(n.Array),_.write(a(c.length));for(const u of c)o(_,u)}else{const u=R.VSBuffer.fromString(JSON.stringify(c));_.write(n.Object),_.write(a(u.byteLength)),_.write(u)}}function s(_){switch(_.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return _.read(i(_)).toString();case E.Buffer:return _.read(i(_)).buffer;case E.VSBuffer:return _.read(i(_));case E.Array:{const u=i(_),P=[];for(let D=0;D<u;D++)P.push(s(_));return P}case E.Object:return JSON.parse(_.read(i(_)).toString())}}class g{constructor(c,u,P=null,D=1e3){this.protocol=c,this.ctx=u,this.logger=P,this.timeoutDelay=D,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(k=>this.onRawMessage(k)),this.sendResponse({type:200})}registerChannel(c,u){this.channels.set(c,u),setTimeout(()=>this.flushPendingRequests(c),0)}sendResponse(c){switch(c.type){case 200:{const u=this.send([c.type]);this.logger&&this.logger.logOutgoing(u,0,1,v(c.type));return}case 201:case 202:case 204:case 203:{const u=this.send([c.type,c.id],c.data);this.logger&&this.logger.logOutgoing(u,c.id,1,v(c.type),c.data);return}}}send(c,u=void 0){const P=new L;return o(P,c),o(P,u),this.sendBuffer(P.buffer)}sendBuffer(c){try{return this.protocol.send(c),c.byteLength}catch(u){return 0}}onRawMessage(c){const u=new p(c),P=s(u),D=s(u),k=P[0];switch(k){case 100:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${I(k)}: ${P[2]}.${P[3]}`,D),this.onPromise({type:k,id:P[1],channelName:P[2],name:P[3],arg:D});case 102:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${I(k)}: ${P[2]}.${P[3]}`,D),this.onEventListen({type:k,id:P[1],channelName:P[2],name:P[3],arg:D});case 101:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${I(k)}`),this.disposeActiveRequest({type:k,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],1,`${I(k)}`),this.disposeActiveRequest({type:k,id:P[1]})}}onPromise(c){const u=this.channels.get(c.channelName);if(!u){this.collectPendingRequest(c);return}const P=new S.CancellationTokenSource;let D;try{D=u.call(this.ctx,c.name,c.arg,P.token)}catch(U){D=Promise.reject(U)}const k=c.id;D.then(U=>{this.sendResponse({id:k,data:U,type:201}),this.activeRequests.delete(c.id)},U=>{U instanceof Error?this.sendResponse({id:k,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:k,data:U,type:203}),this.activeRequests.delete(c.id)});const M=(0,C.toDisposable)(()=>P.cancel());this.activeRequests.set(c.id,M)}onEventListen(c){const u=this.channels.get(c.channelName);if(!u){this.collectPendingRequest(c);return}const P=c.id,k=u.listen(this.ctx,c.name,c.arg)(M=>this.sendResponse({id:P,data:M,type:204}));this.activeRequests.set(c.id,k)}disposeActiveRequest(c){const u=this.activeRequests.get(c.id);u&&(u.dispose(),this.activeRequests.delete(c.id))}collectPendingRequest(c){let u=this.pendingRequests.get(c.channelName);u||(u=[],this.pendingRequests.set(c.channelName,u));const P=setTimeout(()=>{console.error(`Unknown channel: ${c.channelName}`),c.type===100&&this.sendResponse({id:c.id,data:{name:"Unknown channel",message:`Channel name '${c.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);u.push({request:c,timeoutTimer:P})}flushPendingRequests(c){const u=this.pendingRequests.get(c);if(u){for(const P of u)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(c)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(c=>c.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var F;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class V{constructor(c,u=null){this.protocol=c,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=u}getChannel(c){const u=this;return{call(P,D,k){return u.isDisposed?Promise.reject(T.canceled()):u.requestPromise(c,P,D,k)},listen(P,D){return u.isDisposed?Promise.reject(T.canceled()):u.requestEvent(c,P,D)}}}requestPromise(c,u,P,D=S.CancellationToken.None){const k=this.lastRequestId++,U={id:k,type:100,channelName:c,name:u,arg:P};if(D.isCancellationRequested)return Promise.reject(T.canceled());let B;return new Promise((J,Y)=>{if(D.isCancellationRequested)return Y(T.canceled());const ie=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(k),J(Oe.data);break;case 202:this.handlers.delete(k);const Fe=new Error(Oe.data.message);Fe.stack=Oe.data.stack,Fe.name=Oe.data.name,Y(Fe);break;case 203:this.handlers.delete(k),Y(Oe.data);break}};this.handlers.set(k,De),this.sendRequest(U)};let re=null;this.state===y.Idle?ie():(re=(0,b.createCancelablePromise)(De=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const he=()=>{re?(re.cancel(),re=null):this.sendRequest({id:k,type:101}),Y(T.canceled())},ge=D.onCancellationRequested(he);B=(0,C.combinedDisposable)((0,C.toDisposable)(he),ge),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(c,u,P){const D=this.lastRequestId++,M={id:D,type:102,channelName:c,name:u,arg:P};let U=null;const B=new m.Emitter({onFirstListenerAdd:()=>{U=(0,b.createCancelablePromise)(J=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(B),this.sendRequest(M)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(B),this.sendRequest({id:D,type:103}))}}),q=J=>B.fire(J.data);return this.handlers.set(D,q),B.event}sendRequest(c){switch(c.type){case 100:case 102:{const u=this.send([c.type,c.id,c.channelName,c.name],c.arg);this.logger&&this.logger.logOutgoing(u,c.id,0,`${I(c.type)}: ${c.channelName}.${c.name}`,c.arg);return}case 101:case 103:{const u=this.send([c.type,c.id]);this.logger&&this.logger.logOutgoing(u,c.id,0,I(c.type));return}}}send(c,u=void 0){const P=new L;return o(P,c),o(P,u),this.sendBuffer(P.buffer)}sendBuffer(c){try{return this.protocol.send(c),c.byteLength}catch(u){return 0}}onBuffer(c){const u=new p(c),P=s(u),D=s(u),k=P[0];switch(k){case 200:return this.logger&&this.logger.logIncoming(c.byteLength,0,0,v(k)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(c.byteLength,P[1],0,v(k),D),this.onResponse({type:P[0],id:P[1],data:D})}}onResponse(c){if(c.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const u=this.handlers.get(c.id);u&&u(c)}whenInitialized(){return this.state===y.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(c=>c.dispose()),this.activeRequests.clear()}}t.ChannelClient=V;class N{constructor(c){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,c(({protocol:u,onDidClientDisconnect:P})=>{m.Event.once(u.onMessage)(k=>{const M=new p(k),U=s(M),B=new g(u,U),q=new V(u);this.channels.forEach((Y,ie)=>B.registerChannel(ie,Y));const J={channelServer:B,channelClient:q,ctx:U};this._connections.add(J),this._onDidAddConnection.fire(J),P(()=>{B.dispose(),q.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const c=[];return this._connections.forEach(u=>c.push(u)),c}getChannel(c,u){const P=this;return{call(D,k,M){let U;if((0,f.isFunction)(u)){let q=(0,d.getRandomElement)(P.connections.filter(u));U=q?Promise.resolve(q):m.Event.toPromise(m.Event.filter(P.onDidAddConnection,u))}else U=u.routeCall(P,D,k);const B=U.then(q=>q.channelClient.getChannel(c));return j(B).call(D,k,M)},listen(D,k){if((0,f.isFunction)(u))return P.getMulticastEvent(c,u,D,k);const M=u.routeEvent(P,D,k).then(U=>U.channelClient.getChannel(c));return j(M).listen(D,k)}}}getMulticastEvent(c,u,P,D){const k=this;let M=new C.DisposableStore;const U=new m.Emitter({onFirstListenerAdd:()=>{M=new C.DisposableStore;const B=new m.EventMultiplexer,q=new Map,J=ie=>{const he=ie.channelClient.getChannel(c).listen(P,D),ge=B.add(he);q.set(ie,ge)},Y=ie=>{const re=q.get(ie);!re||(re.dispose(),q.delete(ie))};k.connections.filter(u).forEach(J),m.Event.filter(k.onDidAddConnection,u)(J,void 0,M),k.onDidRemoveConnection(Y,void 0,M),B.event(U.fire,U,M),M.add(B)},onLastListenerRemove:()=>{M.dispose()}});return U.event}registerChannel(c,u){this.channels.set(c,u),this._connections.forEach(P=>{P.channelServer.registerChannel(c,u)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class A{constructor(c,u,P=null){const D=new L;o(D,u),c.send(D.buffer),this.channelClient=new V(c,P),this.channelServer=new g(c,u,P)}getChannel(c){return this.channelClient.getChannel(c)}registerChannel(c,u){this.channelServer.registerChannel(c,u)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function j(_){return{call(c,u,P){return _.then(D=>D.call(c,u,P))},listen(c,u){const P=new m.Relay;return _.then(D=>P.input=D.listen(c,u)),P.event}}}t.getDelayedChannel=j;function $(_){let c=!1;return{call(u,P,D){return c?_.call(u,P,D):(0,b.timeout)(0).then(()=>c=!0).then(()=>_.call(u,P,D))},listen(u,P){if(c)return _.listen(u,P);const D=new m.Relay;return(0,b.timeout)(0).then(()=>c=!0).then(()=>D.input=_.listen(u,P)),D.event}}}t.getNextTickChannel=$;class X{constructor(c){this.fn=c}routeCall(c){return this.route(c)}routeEvent(c){return this.route(c)}async route(c){for(const u of c.connections)if(await Promise.resolve(this.fn(u.ctx)))return Promise.resolve(u);return await m.Event.toPromise(c.onDidAddConnection),await this.route(c)}}t.StaticRouter=X;var ne;(function(_){function c(D,k){const M=D,U=k&&k.disableMarshalling,B=new Map;for(const q in M)P(q)&&B.set(q,m.Event.buffer(M[q],!0));return new class{listen(q,J){const Y=B.get(J);if(Y)return Y;throw new Error(`Event not found: ${J}`)}call(q,J,Y){const ie=M[J];if(typeof ie=="function"){if(!U&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,O.revive)(Y[re]);return ie.apply(M,Y)}throw new Error(`Method not found: ${J}`)}}}_.fromService=c;function u(D,k){const M=k&&k.disableMarshalling;return new Proxy({},{get(U,B){var q;if(typeof B=="string")return((q=k==null?void 0:k.properties)===null||q===void 0?void 0:q.has(B))?k.properties.get(B):P(B)?D.listen(B):async function(...J){let Y;k&&!(0,f.isUndefinedOrNull)(k.context)?Y=[k.context,...J]:Y=J;const ie=await D.call(B,Y);return M?ie:(0,O.revive)(ie)};throw new Error(`Property not found: ${String(B)}`)}})}_.toService=u;function P(D){return D[0]==="o"&&D[1]==="n"&&h.isUpperAsciiLetter(D.charCodeAt(2))}})(ne=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let c=_.toString();if(c!=="[object Object]")return c}return _}function ae(_){return Array.isArray(_)?_.map(te):te(_)}function W(_,c,u,P,D,k,M){M=ae(M);const U=ee[D],B=U[P%U.length];let q=[`%c[${_}]%c[${String(c).padStart(7," ")}]%c[len: ${String(u).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${k}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(k)?(q=q.concat(M),q.push(")")):q.push(M),console.log.apply(console,q)}t.logWithColors=W;class G{constructor(c,u){this._outgoingPrefix=c,this._incomingPrefix=u,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(c,u,P,D,k){this._totalOutgoing+=c,W(this._outgoingPrefix,this._totalOutgoing,c,u,P,D,k)}logIncoming(c,u,P,D,k){this._totalIncoming+=c,W(this._incomingPrefix,this._totalIncoming,c,u,P,D,k)}}t.IPCLogger=G}),define(Q[67],Z([0,1,2,11,4,8]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var R;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(R||(R={}));class d extends m.Disposable{constructor(h,w=Object.create(null)){super();this.database=h,this.options=w,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){var w,I;(w=h.changed)===null||w===void 0||w.forEach((l,v)=>this.accept(v,l)),(I=h.deleted)===null||I===void 0||I.forEach(l=>this.accept(l,void 0))}accept(h,w){if(this.state!==R.Closed){let I=!1;(0,S.isUndefinedOrNull)(w)?I=this.cache.delete(h):this.cache.get(h)!==w&&(this.cache.set(h,w),I=!0),I&&this._onDidChangeStorage.fire(h)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,w){const I=this.cache.get(h);return(0,S.isUndefinedOrNull)(I)?w:I}getBoolean(h,w){const I=this.get(h);return(0,S.isUndefinedOrNull)(I)?w:I==="true"}getNumber(h,w){const I=this.get(h);return(0,S.isUndefinedOrNull)(I)?w:parseInt(I,10)}async set(h,w){if(this.state!==R.Closed){if((0,S.isUndefinedOrNull)(w))return this.delete(h);const I=String(w);if(this.cache.get(h)!==I)return this.cache.set(h,I),this.pendingInserts.set(h,I),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(h){if(this.state!==R.Closed&&!!this.cache.delete(h))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{var w;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(w=this.whenFlushedCallbacks.pop())===null||w===void 0||w()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((w,I)=>this.items.set(I,w)),h.delete&&h.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=f}),define(Q[68],Z([5,6]),function(x,t){return x.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,b=C*60,S=b*24,T=S*7,R=S*30,d=S*365;function f(h,w){typeof h!="number"&&(h=h.getTime());const I=Math.round((new Date().getTime()-h)/1e3);if(I<-30)return(0,m.localize)(0,null,f(new Date().getTime()+I*1e3,!1));if(I<30)return(0,m.localize)(1,null);let l;return I<C?(l=I,w?l===1?(0,m.localize)(2,null,l):(0,m.localize)(3,null,l):l===1?(0,m.localize)(4,null,l):(0,m.localize)(5,null,l)):I<b?(l=Math.floor(I/C),w?l===1?(0,m.localize)(6,null,l):(0,m.localize)(7,null,l):l===1?(0,m.localize)(8,null,l):(0,m.localize)(9,null,l)):I<S?(l=Math.floor(I/b),w?l===1?(0,m.localize)(10,null,l):(0,m.localize)(11,null,l):l===1?(0,m.localize)(12,null,l):(0,m.localize)(13,null,l)):I<T?(l=Math.floor(I/S),w?l===1?(0,m.localize)(14,null,l):(0,m.localize)(15,null,l):l===1?(0,m.localize)(16,null,l):(0,m.localize)(17,null,l)):I<R?(l=Math.floor(I/T),w?l===1?(0,m.localize)(18,null,l):(0,m.localize)(19,null,l):l===1?(0,m.localize)(20,null,l):(0,m.localize)(21,null,l)):I<d?(l=Math.floor(I/R),w?l===1?(0,m.localize)(22,null,l):(0,m.localize)(23,null,l):l===1?(0,m.localize)(24,null,l):(0,m.localize)(25,null,l)):(l=Math.floor(I/d),w?l===1?(0,m.localize)(26,null,l):(0,m.localize)(27,null,l):l===1?(0,m.localize)(28,null,l):(0,m.localize)(29,null,l))}t.fromNow=f;function O(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=O}),define(Q[70],Z([5,6]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,8,23]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function S(f,O){return O&&(f.stack||f.stacktrace)?m.localize(0,null,R(f),T(f.stack)||T(f.stacktrace)):R(f)}function T(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?m.localize(1,null,f.message):f.message||m.localize(2,null)}function d(f=null,O=!1){if(!f)return m.localize(3,null);if(Array.isArray(f)){const h=b.coalesce(f),w=d(h[0],O);return h.length>1?m.localize(4,null,w,h.length):w}if(C.isString(f))return f;if(f.detail){const h=f.detail;if(h.error)return S(h.error,O);if(h.exception)return S(h.exception,O)}return f.stack?S(f,O):f.message?f.message:m.localize(5,null)}t.toErrorMessage=d}),define(Q[71],Z([5,6]),function(x,t){return x.create("vs/base/node/processes",t)}),define(Q[45],Z([0,1,3,16,12,33,71,37,8,22,35,15,44,10]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function l(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(i,e){if(h.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};e&&(n.cwd=e);const r=S.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],n);return new Promise(o=>{r.once("error",s=>{o({success:!1,error:s})}),r.once("exit",(s,g)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?l(n.status):1})}else if(h.isLinux||h.isMacintosh)try{const n=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(r=>{S.execFile(n,[i.pid.toString()],{encoding:"utf8",shell:!0},(o,s,g)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function y(i=R.env){return i.comspec||"cmd.exe"}t.getWindowsShell=y;class p{constructor(e,n,r,o){if(n!==void 0&&r!==void 0&&o!==void 0)this.cmd=e,this.args=n,this.shell=r,this.options=o;else{const s=e;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(R.env).forEach(g=>{s[g]=R.env[g]}),Object.keys(this.options.env).forEach(g=>{s[g]=this.options.env[g]}),this.options.env=s}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const n=e.lastIndexOf(m.sep);return n!==-1&&(e=e.substring(n+1)),p.WellKnowCommands[e]?e:"other"}start(e){return h.isWindows&&(this.options&&this.options.cwd&&O.isUNC(this.options.cwd)||!this.options&&O.isUNC(R.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(n=>{let r,o;const s=new Promise((g,F)=>{r=g,o=F});if(n){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=S.exec(g,this.options,(F,V,N)=>{this.childProcess=null;const A=F;A&&A.killed?o({killed:this.terminateRequested,stdout:V.toString(),stderr:N.toString()}):this.handleExec(r,e,F,V,N)})}else{let g=null;const F=V=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(V,r,e,o);const N={terminated:this.terminateRequested};d.isNumber(V)&&(N.cmdCode=V),r(N)};if(this.shell&&h.isWindows){const V=f.deepClone(this.options);V.windowsVerbatimArguments=!0,V.detached=!1;let N=!1,A=!1;const j=[];let $=this.ensureQuotes(this.cmd);j.push($.value),N=$.quoted,this.args&&this.args.forEach(ne=>{$=this.ensureQuotes(ne),j.push($.value),A=A&&$.quoted});const X=["/s","/c"];N?A?X.push('"'+j.join(" ")+'"'):j.length>1?X.push('"'+j[0]+'" '+j.slice(1).join(" ")):X.push('"'+j[0]+'"'):X.push(j.join(" ")),g=S.spawn(y(),X,V)}else this.cmd&&(g=S.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(d.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",V=>{this.childProcess=null,o({terminated:this.terminateRequested,error:V})}),g.pid&&(this.childProcess.on("close",F),this.handleSpawn(g,r,e,o,!0)))}return s})}handleClose(e,n,r,o){}ensureQuotes(e){return p.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,v(e,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!h.isWindows)return e(!1);const n=S.spawn(y(),["/s","/c"]);n.on("error",r=>e(!0)),n.on("exit",r=>e(!1))})}}t.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class L extends p{constructor(e,n,r,o){super(e,n,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,n,r,o,s){[o,s].forEach((g,F)=>{const V=new w.LineDecoder;V.write(g).forEach(j=>{n({line:j,source:F===0?0:1})});const A=V.end();A&&n({line:A,source:F===0?0:1})}),e({terminated:this.terminateRequested,error:r})}handleSpawn(e,n,r,o,s){const g=new w.LineDecoder,F=new w.LineDecoder;e.stdout.on("data",V=>{g.write(V).forEach(A=>r({line:A,source:0}))}),e.stderr.on("data",V=>{F.write(V).forEach(A=>r({line:A,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=F}handleClose(e,n,r,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&r({line:g,source:1})}}t.LineProcess=L;function E(i){let e=[],n=!1;const r=function(o){if(n){e.push(o);return}(!i.send(o,g=>{if(g&&console.error(g),n=!1,e.length>0){const F=e.slice(0);e=[],F.forEach(V=>r(V))}})||h.isWindows)&&(n=!0)};return{send:r}}t.createQueuedSender=E;var a;(function(i){async function e(n,r,o){if(m.isAbsolute(n))return n;if(r===void 0&&(r=R.cwd()),m.dirname(n)!=="."||(o===void 0&&d.isString(R.env.PATH)&&(o=R.env.PATH.split(m.delimiter)),o===void 0||o.length===0))return m.join(r,n);async function g(F){return await b.exists(F)?!(await C.promises.stat(F)).isDirectory():!1}for(let F of o){let V;if(m.isAbsolute(F)?V=m.join(F,n):V=m.join(r,F,n),await g(V))return V;let N=V+".com";if(await g(N)||(N=V+".exe",await g(N)))return N}return m.join(r,n)}i.findExecutable=e})(a=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,15,65,45]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(I,l){return I===3?C.isWindows?h():S.getWindowsShell(l):f(I,l)}t.getSystemShell=T;function R(I,l){return I===3?C.isWindows?w(l):S.getWindowsShell(l):f(I,l)}t.getSystemShellSync=R;let d=null;function f(I,l){if(C.isLinux&&I===1||C.isMacintosh&&I===2)return"/bin/bash";if(!d){let v;if(C.isWindows)v="/bin/bash";else{if(v=l.SHELL,!v)try{v=m.userInfo().shell}catch(y){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}d=v}return d}let O=null;async function h(){return O||(O=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),O}function w(I){if(O)return O;const l=C.isWindows&&parseFloat(m.release())>=10,v=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${I.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?y:S.getWindowsShell(I)}}),define(Q[46],Z([0,1,33,2,4,22,11,45,36,59,28,14,17,15]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends d.ChannelServer{constructor(p){super({send:L=>{try{process.send&&process.send(L.buffer.toString("base64"))}catch(E){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",L=>w.VSBuffer.wrap(Buffer.from(L,"base64")))},p);process.once("disconnect",()=>this.dispose())}}t.Server=l;class v{constructor(p,L){this.modulePath=p,this.options=L,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=L&&L.timeout?L.timeout:6e4;this.disposeDelayer=new b.Delayer(E),this.child=null,this._client=null}getChannel(p){const L=this;return{call(E,a,i){return L.requestPromise(p,E,a,i)},listen(E,a){return L.requestEvent(p,E,a)}}}requestPromise(p,L,E,a=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(p),e=(0,b.createCancelablePromise)(o=>i.call(L,E,o)),n=a.onCancellationRequested(()=>e.cancel()),r=(0,C.toDisposable)(()=>e.cancel());return this.activeRequests.add(r),e.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(p,L,E){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let a;const i=new T.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(p).listen(L,E)(i.fire,i),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],L=Object.create(null);L.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(L.env=Object.assign(Object.assign({},L.env),this.options.env)),this.options&&this.options.freshExecArgv&&(L.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(L.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(L.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),L.execArgv===void 0&&(L.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),I.isMacintosh&&L.env&&delete L.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,p,L);const E=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,f.isRemoteConsoleLog)(s)){(0,f.log)(s,`IPC Library: ${this.options.serverName}`);return}E.fire(w.VSBuffer.wrap(Buffer.from(s,"base64")))});const i=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,e=s=>this.child&&this.child.connected&&i.send(s.buffer.toString("base64")),n=E.event,r={send:e,onMessage:n};this._client=new d.ChannelClient(r);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,g)=>{process.removeListener("exit",o),this.activeRequests.forEach(F=>(0,C.dispose)(F)),this.activeRequests.clear(),s!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:g})})}return this._client}getCachedChannel(p){let L=this.channels.get(p);return L||(L=this.client.getChannel(p),this.channels.set(p,L)),L}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=v}),define(Q[73],Z([5,6]),function(x,t){return x.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)});var ce=this&&this.__decorate||function(x,t,m,C){var b=arguments.length,S=b<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,m):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(x,t,m,C);else for(var R=x.length-1;R>=0;R--)(T=x[R])&&(S=(b<3?T(S):b>3?T(t,m,S):T(t,m))||S);return b>3&&S&&Object.defineProperty(t,m,S),S};define(Q[86],Z([0,1,3,18,57,69,10,9,37]),function(x,t,m,C,b,S,T,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(l,v,y){this._args=l,this.paths=v,this.productService=y}get appRoot(){return(0,m.dirname)(T.FileAccess.asFileUri("",x).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(R.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=d.env.VSCODE_PORTABLE;return l?R.URI.file((0,m.join)(l,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,m.resolve)(l):(0,m.normalize)((0,m.join)(T.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,m.resolve)(l):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,m.resolve)(l);const v=d.env.VSCODE_EXTENSIONS;if(v)return v;const y=d.env.VSCODE_PORTABLE;return y?(0,m.join)(y,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(v=>/^[^:/?#]+?:\/\//.test(v)?R.URI.parse(v):R.URI.file((0,m.normalize)(v)))}get extensionDevelopmentKind(){var l;return(l=this.args.extensionDevelopmentKind)===null||l===void 0?void 0:l.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?R.URI.parse(l):R.URI.file((0,m.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!d.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([b.memoize],f.prototype,"appRoot",null),ce([b.memoize],f.prototype,"userHome",null),ce([b.memoize],f.prototype,"userDataPath",null),ce([b.memoize],f.prototype,"appSettingsHome",null),ce([b.memoize],f.prototype,"tmpDir",null),ce([b.memoize],f.prototype,"userRoamingDataHome",null),ce([b.memoize],f.prototype,"settingsResource",null),ce([b.memoize],f.prototype,"userDataSyncHome",null),ce([b.memoize],f.prototype,"userDataSyncLogResource",null),ce([b.memoize],f.prototype,"sync",null),ce([b.memoize],f.prototype,"machineSettingsResource",null),ce([b.memoize],f.prototype,"globalStorageHome",null),ce([b.memoize],f.prototype,"workspaceStorageHome",null),ce([b.memoize],f.prototype,"keybindingsResource",null),ce([b.memoize],f.prototype,"keyboardLayoutResource",null),ce([b.memoize],f.prototype,"argvResource",null),ce([b.memoize],f.prototype,"snippetsHome",null),ce([b.memoize],f.prototype,"isExtensionDevelopment",null),ce([b.memoize],f.prototype,"untitledWorkspacesHome",null),ce([b.memoize],f.prototype,"installSourcePath",null),ce([b.memoize],f.prototype,"builtinExtensionsPath",null),ce([b.memoize],f.prototype,"extensionsPath",null),ce([b.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ce([b.memoize],f.prototype,"extensionDevelopmentKind",null),ce([b.memoize],f.prototype,"extensionTestsLocationURI",null),ce([b.memoize],f.prototype,"debugExtensionHost",null),ce([b.memoize],f.prototype,"serviceMachineIdResource",null),ce([b.memoize],f.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=f;function O(I,l){return w(I["inspect-extensions"],I["inspect-brk-extensions"],5870,l,I.debugId)}t.parseExtensionHostPort=O;function h(I,l){return w(I["inspect-search"],I["inspect-brk-search"],5876,l)}t.parseSearchPort=h;function w(I,l,v,y,p){const E=Number(l||I)||(y?null:v),a=E?Boolean(!!l):!1;return{port:E,break:a,debugId:p}}}),function(){"use strict";function x(t,m,C){function b(T){return t.resolve(S(T))}function S(T){const R=process.env.VSCODE_PORTABLE;if(R)return t.join(R,"user-data");const d=T["user-data-dir"];if(d)return d;let f=process.env.VSCODE_APPDATA;if(!f)switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=t.join(O,"AppData","Roaming")}break;case"darwin":f=t.join(m.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(f,C)}return{getUserDataPath:b}}if(typeof define=="function")define(Q[87],Z([0,128,32,10,18]),function(t,m,C,b,S){const T=S.dirname(b.FileAccess.asFileUri("",t)),R=t.__$__nodeRequire(S.joinPath(T,"package.json").fsPath);return x(m,C,R.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),C=require("os");module.exports=x(m,C,t.name)}else throw new Error("Unknown context")}(),define(Q[88],Z([0,1,32,87,86]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class S extends b.AbstractNativeEnvironmentService{constructor(R,d){super(R,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,C.getUserDataPath)(R)},d)}}t.NativeEnvironmentService=S}),define(Q[89],Z([0,1,22]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const C=/^%([\w\d.-]+)%$/i;function b(S,T){const R=d=>{if(typeof d=="string"){const f=C.exec(d);if(!!f)return T[f[1]]||d}};return(0,m.cloneAndChange)(S,R)}t.localizeManifest=b}),define(Q[47],Z([0,1,80]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function b(h){return h=h.trim(),h==="*"||C.test(h)}t.isValidVersionStr=b;function S(h){if(!b(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=h.match(C);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}t.parseVersion=S;function T(h){if(!h)return null;let w=h.majorBase,I=h.majorMustEqual,l=h.minorBase,v=h.minorMustEqual,y=h.patchBase,p=h.patchMustEqual;return h.hasCaret&&(w===0||(v=!1),p=!1),{majorBase:w,majorMustEqual:I,minorBase:l,minorMustEqual:v,patchBase:y,patchMustEqual:p,isMinimum:h.hasGreaterEquals}}t.normalizeVersion=T;function R(h,w){let I;typeof h=="string"?I=T(S(h)):I=h;let l;if(typeof w=="string"?l=T(S(w)):l=w,!I||!l)return!1;let v=I.majorBase,y=I.minorBase,p=I.patchBase,L=l.majorBase,E=l.minorBase,a=l.patchBase,i=l.majorMustEqual,e=l.minorMustEqual,n=l.patchMustEqual;return l.isMinimum?v>L?!0:v<L?!1:y>E?!0:y<E?!1:p>=a:(v===1&&L===0&&(!i||!e||!n)&&(L=1,E=0,a=0,i=!0,e=!1,n=!1),v<L?!1:v>L?!i:y<E?!1:y>E?!e:p<a?!1:p>a?!n:!0)}t.isValidVersion=R;function d(h,w,I){return w.isBuiltin||typeof w.main=="undefined"?!0:O(h,w.engines.vscode,I)}t.isValidExtensionVersion=d;function f(h,w){return h==="*"||O(w,h)}t.isEngineValid=f;function O(h,w,I=[]){let l=T(S(w));if(!l)return I.push(m.localize(0,null,w)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return I.push(m.localize(1,null,w)),!1}else if(!l.majorMustEqual)return I.push(m.localize(2,null,w)),!1;return R(h,l)?!0:(I.push(m.localize(3,null,h,w)),!1)}t.isVersionValid=O}),define(Q[90],Z([0,1,36,46,2,10]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends b.Disposable{constructor(d,f,O,h){super();this.folders=d,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new C.Client(S.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(d){this.verboseLogging=d,!this.isDisposed&&this.service&&this.service.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[91],Z([0,1,36,46,2,10]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends b.Disposable{constructor(d,f,O,h,w={}){super();this.folders=d,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=h,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new C.Client(S.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(d.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${d}`})}setVerboseLogging(d){this.verboseLogging=d,this.service&&this.service.setVerboseLogging(d)}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[92],Z([0,1,33,44,61,10]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(d,f,O,h,w){this.watchedFolder=d,this.eventCallback=O,this.logCallback=h,this.verboseLogging=w,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(I=>b.parse(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${d}`),this.startWatcher()}startWatcher(){const d=[this.watchedFolder];this.verboseLogging&&d.push("-verbose"),this.handle=m.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,d);const f=new C.LineDecoder;this.handle.stdout.on("data",O=>{const h=[];f.write(O).forEach(w=>{const I=w.split("|");if(I.length===2){const l=Number(I[0]),v=I[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(y=>y(v))){this.verboseLogging&&this.log(v);return}h.push({type:T.changeTypeMap[l],path:v})}else this.log(I[1])}}),h.length>0&&this.eventCallback(h)}),this.handle.on("error",O=>this.onError(O)),this.handle.stderr.on("data",O=>this.onError(O)),this.handle.on("exit",(O,h)=>this.onExit(O,h))}onError(d){this.error("process error: "+d.toString())}onExit(d,f){this.handle&&(this.error(`terminated unexpectedly (code: ${d}, signal: ${f})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(d){this.logCallback({type:"error",message:`[File Watcher (C#)] ${d}`})}log(d){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${d}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Q[93],Z([0,1,92,3,21]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class S{constructor(R,d,f,O){this.onDidFilesChange=d,this.onLogMessage=f,this.verboseLogging=O,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=S}),define(Q[48],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class m{constructor(S,T=[],R=!1){this.ctor=S,this.staticArguments=T,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=m;const C=(b,...S)=>new m(b,S);t.createSyncDescriptor=C}),define(Q[94],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}t.Node=m;class C{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let T of this._nodes.values())T.outgoing.size===0&&S.push(T);return S}insertEdge(S,T){const R=this.lookupOrInsertNode(S),d=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),d),d.incoming.set(this._hashFn(S),R)}removeNode(S){const T=this._hashFn(S);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(S){const T=this._hashFn(S);let R=this._nodes.get(T);return R||(R=new m(S),this._nodes.set(T,R)),R}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[T,R]of this._nodes)S.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return S.join(`
`)}}t.Graph=C}),define(Q[95],Z([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,m.createDecorator)("downloadService")}),define(Q[19],Z([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,m.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,m.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,7,10]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function S(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=S;var T;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=5]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var R;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(R=t.SortOrder||(t.SortOrder={}));var d;(function(h){h.Uninstall="uninstall"})(d=t.StatisticType||(t.StatisticType={}));var f;(function(h){h[h.None=0]="None",h[h.Install=1]="Install",h[h.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class O extends Error{constructor(w,I){super(w);this.code=I}}t.ExtensionManagementError=O,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=b.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,m.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,m.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,21,7]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=b,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(S=t.ExtensionType||(t.ExtensionType={}));class T{constructor(O){this.value=O,this._lower=O.toLowerCase()}static equals(O,h){if(typeof O=="undefined"||O===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof O=="string"||typeof h=="string"){let w=typeof O=="string"?O:O.value,I=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(w,I)}return O._lower===h._lower}static toKey(O){return typeof O=="string"?O.toLowerCase():O._lower}}t.ExtensionIdentifier=T;function R(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=R;function d(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,21,38]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(I,l){return I.uuid&&l.uuid?I.uuid===l.uuid:I.id===l.id?!0:(0,m.compareIgnoreCase)(I.id,l.id)===0}t.areSameExtensions=b;class S{constructor(l,v){this.version=v,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof S?b(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=S;function T(I,l){return`${I}.${l}`}t.getExtensionId=T;function R(I){return I.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function d(I,l){return R(T(I,l))}t.getGalleryExtensionId=d;function f(I,l){const v=[],y=p=>{for(const L of v)if(L.some(E=>b(l(E),l(p))))return L;return null};for(const p of I){const L=y(p);L?L.push(p):v.push([p])}return v}t.groupByExtension=f;function O(I){return{id:I.identifier.id,name:I.manifest.name,galleryId:null,publisherId:I.publisherId,publisherName:I.manifest.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:I.manifest.extensionDependencies&&I.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=O;function h(I){return Object.assign({id:I.identifier.id,name:I.name,galleryId:I.identifier.uuid,publisherId:I.publisherId,publisherName:I.publisher,publisherDisplayName:I.publisherDisplayName,dependencies:!!(I.properties.dependencies&&I.properties.dependencies.length>0)},I.telemetryData)}t.getGalleryExtensionTelemetryData=h,t.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function w(I){const l=new Set;for(const v of I)v.malicious&&l.add(v.id.id);return l}t.getMaliciousExtensionsSet=w});var ue=this&&this.__param||function(x,t){return function(m,C){t(m,C,x)}};define(Q[96],Z([0,1,76,14,9,39,24,25,38,62,28,10]),function(x,t,m,C,b,S,T,R,d,f,O,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=L=>(0,m.localize)(0,null,L),I=(0,m.localize)(1,null,"ms-dotnettools.csharp");function l(L,E){return E?`${L.publisher}.${L.name}@${L.version}`:`${L.publisher}.${L.name}`}const v=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function y(L){const E=v.exec(L);return E&&E[1]?[(0,R.adoptToGalleryExtensionId)(E[1]),E[2]]:[(0,R.adoptToGalleryExtensionId)(L),void 0]}t.getIdAndVersion=y;let p=class{constructor(E,a){this.extensionManagementService=E,this.extensionGalleryService=a}get location(){}async listExtensions(E,a,i=console){let e=await this.extensionManagementService.getInstalled(1);const n=d.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(a&&a!==""){if(n.indexOf(a.toLowerCase())<0){i.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(g=>g.toLowerCase()).indexOf(a.toLowerCase())>-1:!1)}else if(a===""){i.log("Possible Categories: "),n.forEach(o=>{i.log(o)});return}this.location&&i.log((0,m.localize)(2,null,this.location)),e=e.sort((o,s)=>o.identifier.id.localeCompare(s.identifier.id));let r;for(let o of e)r!==o.identifier.id&&(r=o.identifier.id,i.log(l(o.manifest,E)))}async installExtensions(E,a,i,e,n=console){const r=[],o=[];E.length&&n.log(this.location?(0,m.localize)(3,null,this.location):(0,m.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),g=(N,A)=>{const j=s.find($=>(0,R.areSameExtensions)($.identifier,{id:N}));if(j){if(!A&&!e)return n.log((0,m.localize)(5,null,N,j.manifest.version,N)),!1;if(A&&j.manifest.version===A)return n.log((0,m.localize)(6,null,`${N}@${A}`)),!1}return!0},F=[],V=[];for(const N of E)if(N instanceof b.URI)F.push(N);else{const[A,j]=y(N);g(A,j)&&V.push({id:A,version:j,installOptions:{isBuiltin:!1,isMachineScoped:i}})}for(const N of a){const[A,j]=y(N);g(A,j)&&V.push({id:A,version:j,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(F.length&&await Promise.all(F.map(async N=>{try{const A=await this.installVSIX(N,e,n);A&&o.push(A)}catch(A){n.error(A.message||A.stack||A),r.push(N.toString())}})),V.length){const N=await this.getGalleryExtensions(V);await Promise.all(V.map(async A=>{const j=N.get(A.id.toLowerCase());if(j)try{const $=await this.installFromGallery(A,j,s,e,n);$&&o.push($)}catch($){n.error($.message||$.stack||$),r.push(A.id)}else n.error(`${w(A.version?`${A.id}@${A.version}`:A.id)}
${I}`),r.push(A.id)}))}if(r.length)throw new Error((0,m.localize)(7,null,r.join(", ")))}async installVSIX(E,a,i){const e=await this.extensionManagementService.getManifest(E);if(!e)throw new Error("Invalid vsix");if(await this.validateVSIX(e,a,i))try{return await this.extensionManagementService.install(E),i.log((0,m.localize)(8,null,(0,f.getBaseLabel)(E))),e}catch(r){if((0,C.isPromiseCanceledError)(r))return i.log((0,m.localize)(9,null,(0,f.getBaseLabel)(E))),null;throw r}return null}async getGalleryExtensions(E){const a=E.filter(({version:n})=>n===void 0).map(({id:n})=>n),i=E.filter(({version:n})=>n!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(a,O.CancellationToken.None)).forEach(r=>e.set(r.identifier.id.toLowerCase(),r))})(),Promise.all(i.map(async({id:n,version:r})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:n},r);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:E,version:a,installOptions:i},e,n,r,o){const s=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(s&&!this.validateExtensionKind(s,o))return null;const g=n.find(F=>(0,R.areSameExtensions)(F.identifier,e.identifier));if(g){if(e.version===g.manifest.version)return o.log((0,m.localize)(10,null,a?`${E}@${a}`:E)),null;o.log((0,m.localize)(11,null,E,e.version))}try{return i.isBuiltin?o.log((0,m.localize)(12,null,E,e.version)):o.log((0,m.localize)(13,null,E,e.version)),await this.extensionManagementService.installFromGallery(e,i),o.log((0,m.localize)(14,null,E,e.version)),s}catch(F){if((0,C.isPromiseCanceledError)(F))return o.log((0,m.localize)(15,null,E)),null;throw F}}validateExtensionKind(E,a){return!0}async validateVSIX(E,a,i){const e={id:(0,R.getGalleryExtensionId)(E.publisher,E.name)},r=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,R.areSameExtensions)(e,o.identifier)&&(0,S.gt)(o.manifest.version,E.version));return r&&!a?(i.log((0,m.localize)(16,null,r.identifier.id,r.manifest.version,E.version)),!1):this.validateExtensionKind(E,i)}async uninstallExtensions(E,a,i=console){const e=async r=>{if(r instanceof b.URI){const o=await this.extensionManagementService.getManifest(r);return l(o)}return r},n=[];for(const r of E){const o=await e(r),g=(await this.extensionManagementService.getInstalled()).filter(F=>(0,R.areSameExtensions)(F.identifier,{id:o}));if(!g.length)throw new Error(`${this.notInstalled(o)}
${I}`);if(g.some(F=>F.type===0)){i.log((0,m.localize)(17,null,o));return}if(!a&&g.some(F=>F.isBuiltin)){i.log((0,m.localize)(18,null,o));return}i.log((0,m.localize)(19,null,o));for(const F of g)await this.extensionManagementService.uninstall(F),n.push(F);this.location?i.log((0,m.localize)(20,null,o,this.location)):i.log((0,m.localize)(21,null,o))}}async locateExtension(E,a=console){const i=await this.extensionManagementService.getInstalled();E.forEach(e=>{i.forEach(n=>{if(n.identifier.id===e&&n.location.scheme===h.Schemas.file){a.log(n.location.fsPath);return}})})}notInstalled(E){return this.location?(0,m.localize)(22,null,E,this.location):(0,m.localize)(23,null,E)}};p=ce([ue(0,T.IExtensionManagementService),ue(1,T.IExtensionGalleryService)],p),t.ExtensionManagementCLIService=p}),define(Q[97],Z([0,1,2,3,38,12]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends m.Disposable{constructor(d,f){super();this.environmentService=d,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,b.MANIFEST_CACHE_FOLDER,b.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(O=>this.onDidInstallExtension(O))),this._register(f.onDidUninstallExtension(O=>this.onDidUnInstallExtension(O)))}onDidInstallExtension(d){d.error||this.invalidate()}onDidUnInstallExtension(d){d.error||this.invalidate()}invalidate(){S.rimraf(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Q[98],Z([0,1,33,30,15,129,29,72]),function(x,t,m,C,b,S,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function d(h,w,I){return w["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(I)&&!w["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(I)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=O(h)),f)}t.resolveShellEnv=d;let f;async function O(h){const w=new Promise(async(I,l)=>{const v=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",v);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",y);const p=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),L=new RegExp(p+"(.*)"+p),E=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),a=`'${process.execPath}' -p '"${p}" + JSON.stringify(process.env) + "${p}"'`;h.trace("getUnixShellEnvironment#env",E),h.trace("getUnixShellEnvironment#spawn",a);const i=await(0,R.getSystemShell)(b.platform,E);h.trace("getUnixShellEnvironment#shell",i);const e=(0,m.spawn)(i,["-ilc",a],{detached:!0,stdio:["ignore","pipe",process.stderr],env:E}),n=[];e.on("error",()=>I({})),e.stdout.on("data",r=>n.push(r)),e.on("close",r=>{if(r!==0)return l(new Error("Failed to get environment"));const o=Buffer.concat(n).toString("utf8");h.trace("getUnixShellEnvironment#raw",o);const s=L.exec(o),g=s?s[1]:"{}";try{const F=JSON.parse(g);v?F.ELECTRON_RUN_AS_NODE=v:delete F.ELECTRON_RUN_AS_NODE,y?F.ELECTRON_NO_ATTACH_CONSOLE=y:delete F.ELECTRON_NO_ATTACH_CONSOLE,delete F.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",F),I(F)}catch(F){h.error("getUnixShellEnvironment#error",F),l(F)}})});try{return await w}catch(I){return h.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(I)),{}}}}),define(Q[49],Z([0,1,82,17,20,14]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(O,h,w,I,l,v){let y;try{await R(O,h,w,I,l,v)}catch(p){y=p}finally{y&&l.errorTransformer&&(y=l.errorTransformer(y)),typeof y!="undefined"&&w.error(y),w.end()}}t.readFileIntoStream=T;async function R(O,h,w,I,l,v){d(v);const y=await O.open(h,{create:!1});try{d(v);let p=0,L=0,E=l&&typeof l.length=="number"?l.length:void 0,a=C.VSBuffer.alloc(Math.min(l.bufferSize,typeof E=="number"?E:l.bufferSize)),i=l&&typeof l.position=="number"?l.position:0,e=0;do L=await O.read(y,i,a.buffer,e,a.byteLength-e),i+=L,e+=L,p+=L,typeof E=="number"&&(E-=L),e===a.byteLength&&(await w.write(I(a)),a=C.VSBuffer.alloc(Math.min(l.bufferSize,typeof E=="number"?E:l.bufferSize)),e=0);while(L>0&&(typeof E!="number"||E>0)&&d(v)&&f(p,l));if(e>0){let n=e;typeof E=="number"&&(n=Math.min(e,E)),w.write(I(a.slice(0,n)))}}catch(p){throw(0,b.ensureFileSystemProviderError)(p)}finally{await O.close(y)}}function d(O){if(O.isCancellationRequested)throw(0,S.canceled)();return!0}function f(O,h){if(h==null?void 0:h.limits){if(typeof h.limits.memory=="number"&&O>h.limits.memory)throw(0,b.createFileSystemProviderError)((0,m.localize)(0,null),b.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&O>h.limits.size)throw(0,b.createFileSystemProviderError)((0,m.localize)(1,null),b.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[50],Z([0,1,9,20,15]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function S(d){return d.map(f=>({type:f.type,resource:m.URI.file(f.path)}))}t.toFileChanges=S;function T(d){const f=new R;for(const O of d)f.processEvent(O);return f.normalize()}t.normalizeFileChanges=T;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const O=this.mapPathToChange.get(f.path);if(O){const h=O.type,w=f.type;h===1&&w===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(O),1)):h===2&&w===1?O.type=0:h===1&&w===0||(O.type=w)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],O=[];return this.normalized.filter(h=>h.type!==2?(f.push(h),!1):!0).sort((h,w)=>h.path.length-w.path.length).filter(h=>O.some(w=>(0,C.isParent)(h.path,w,!b.isLinux))?!1:(O.push(h.path),!0)).concat(f)}}}),define(Q[99],Z([0,1,50,2,12,63,66,4,3]),function(x,t,m,C,b,S,T,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends C.Disposable{constructor(h,w,I,l){super();this.path=h,this.onDidFilesChange=w,this.onLogMessage=I,this.verboseLogging=l,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(h){this.verboseLogging=h}async startWatching(){try{const{stat:h,symbolicLink:w}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(w)try{I=await(0,S.realpath)(I)}catch(l){if(this.onError(l),w.dangling)return}h.isDirectory()?this._register((0,T.watchFolder)(I,(l,v)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,d.join)(this.path,(0,d.basename)(v))})},l=>this.onError(l))):this._register((0,T.watchFile)(I,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(h){h.code!=="ENOENT"&&this.onError(h)}}onFileChange(h){this.fileChangesBuffer.push(h),this.verboseLogging&&this.onVerbose(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,m.normalizeFileChanges)(w);this.verboseLogging&&I.forEach(l=>{this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`)}),I.length>0&&this.onDidFilesChange(I)})}onError(h){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${h}`})}onVerbose(h){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(Q[51],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...b){this._entries=new Map;for(let[S,T]of b)this.set(S,T)}set(b,S){const T=this._entries.get(b);return this._entries.set(b,S),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=m}),define(Q[100],Z([0,1,14,94,48,7,51,4]),function(x,t,m,C,b,S,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const d=!1;class f extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class O{constructor(l=new T.ServiceCollection,v=!1,y){this._activeInstantiations=new Set,this._services=l,this._strict=v,this._parent=y,this._services.set(S.IInstantiationService,this)}createChild(l){return new O(l,this._strict,this)}invokeFunction(l,...v){let y=w.traceInvocation(l),p=!1;try{return l({get:(E,a)=>{if(p)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(E,y);if(!i&&a!==S.optional)throw new Error(`[invokeFunction] unknown service '${E}'`);return i}},...v)}finally{p=!0,y.stop()}}createInstance(l,...v){let y,p;return l instanceof b.SyncDescriptor?(y=w.traceCreation(l.ctor),p=this._createInstance(l.ctor,l.staticArguments.concat(v),y)):(y=w.traceCreation(l),p=this._createInstance(l,v,y)),y.stop(),p}_createInstance(l,v=[],y){let p=S._util.getServiceDependencies(l).sort((a,i)=>a.index-i.index),L=[];for(const a of p){let i=this._getOrCreateServiceInstance(a.id,y);if(!i&&this._strict&&!a.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${a.id}.`);L.push(i)}let E=p.length>0?p[0].index:v.length;if(v.length!==E){console.warn(`[createInstance] First service dependency of ${l.name} at position ${E+1} conflicts with ${v.length} static arguments`);let a=E-v.length;a>0?v=v.concat(new Array(a)):v=v.slice(0,E)}return new l(...[...v,...L])}_setServiceInstance(l,v){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,v);else if(this._parent)this._parent._setServiceInstance(l,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let v=this._services.get(l);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):v}_getOrCreateServiceInstance(l,v){let y=this._getServiceInstanceOrDescriptor(l);return y instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,y,v.branch(l,!0)):(v.branch(l,!1),y)}_safeCreateAndCacheServiceInstance(l,v,y){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,v,y)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,v,y){const p=new C.Graph(a=>a.id.toString());let L=0;const E=[{id:l,desc:v,_trace:y}];for(;E.length;){const a=E.pop();if(p.lookupOrInsertNode(a),L++>1e3)throw new f(p);for(let i of S._util.getServiceDependencies(a.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(i.id);if(!e&&!i.optional&&console.warn(`[createInstance] ${l} depends on ${i.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const n={id:i.id,desc:e,_trace:a._trace.branch(i.id,!0)};p.insertEdge(a,n),E.push(n)}}}for(;;){const a=p.roots();if(a.length===0){if(!p.isEmpty())throw new f(p);break}for(const{data:i}of a){if(this._getServiceInstanceOrDescriptor(i.id)instanceof b.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}p.removeNode(i)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,v,y=[],p,L){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(v,y,p,L);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,v,y,p,L);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(l,v=[],y,p){if(y){const L=new R.IdleValue(()=>this._createInstance(l,v,p));return new Proxy(Object.create(null),{get(E,a){if(a in E)return E[a];let i=L.value,e=i[a];return typeof e!="function"||(e=e.bind(i),E[a]=e),e},set(E,a,i){return L.value[a]=i,!0}})}else return this._createInstance(l,v,p)}}t.InstantiationService=O;var h;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(h||(h={}));class w{constructor(l,v){this.type=l,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return d?new w(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(l){return d?new w(0,l.name):w._None}branch(l,v){let y=new w(2,l.toString());return this._dep.push([l,v,y]),y}stop(){let l=Date.now()-this._start;w._totals+=l;let v=!1;function y(L,E){let a=[],i=new Array(L+1).join("	");for(const[e,n,r]of E._dep)if(n&&r){v=!0,a.push(`${i}CREATES -> ${e}`);let o=y(L+1,r);o&&a.push(o)}else a.push(`${i}uses -> ${e}`);return a.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(l>2||v)&&console.log(p.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Q[52],Z([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,m.createDecorator)("localizationsService");function C(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const S of b.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=C}),define(Q[13],Z([0,1,7,2,15,11,29]),function(x,t,m,C,b,S,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,m.createDecorator)("logService"),t.ILoggerService=(0,m.createDecorator)("loggerService");function R(){return new Date().toISOString()}var d;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(d=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=d.Info;class f extends C.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class O extends f{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...e){this.checkLogLevel(d.Trace)&&this.log(d.Trace,this.format([i,...e]))}debug(i,...e){this.checkLogLevel(d.Debug)&&this.log(d.Debug,this.format([i,...e]))}info(i,...e){this.checkLogLevel(d.Info)&&this.log(d.Info,this.format([i,...e]))}warn(i,...e){this.checkLogLevel(d.Warning)&&this.log(d.Warning,this.format([i,...e]))}error(i,...e){if(this.checkLogLevel(d.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(d.Error,this.format(n))}else this.log(d.Error,this.format([i,...e]))}critical(i,...e){this.checkLogLevel(d.Critical)&&this.log(d.Critical,this.format([i,...e]))}flush(){}format(i){let e="";for(let n=0;n<i.length;n++){let r=i[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}e+=(n>0?" ":"")+r}return e}}t.AbstractMessageLogger=O;class h extends f{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!b.isWindows}trace(i,...e){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}debug(i,...e){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}info(i,...e){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}warn(i,...e){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...e):console.warn(`[main ${R()}]`,i,...e))}error(i,...e){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...e):console.error(`[main ${R()}]`,i,...e))}critical(i,...e){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...e):console.error(`[main ${R()}]`,i,...e))}dispose(){}flush(){}}t.ConsoleMainLogger=h;class w extends f{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...e){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",i,...e)}debug(i,...e){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...e)}info(i,...e){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",i,...e)}warn(i,...e){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",i,...e)}error(i,...e){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",i,...e)}critical(i,...e){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...e)}dispose(){}flush(){}}t.ConsoleLogger=w;class I extends f{constructor(i,e=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(e)}trace(i,...e){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(i),...e])}debug(i,...e){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(i),...e])}info(i,...e){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(i),...e])}warn(i,...e){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(i),...e])}error(i,...e){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(i),...e])}critical(i,...e){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(i),...e])}extractMessage(i){return typeof i=="string"?i:(0,T.toErrorMessage)(i,this.getLevel()<=d.Trace)}dispose(){}flush(){}}t.AdapterLogger=I;class l extends f{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const e of this.logServices)e.setLevel(i);super.setLevel(i)}trace(i,...e){for(const n of this.logServices)n.trace(i,...e)}debug(i,...e){for(const n of this.logServices)n.debug(i,...e)}info(i,...e){for(const n of this.logServices)n.info(i,...e)}warn(i,...e){for(const n of this.logServices)n.warn(i,...e)}error(i,...e){for(const n of this.logServices)n.error(i,...e)}critical(i,...e){for(const n of this.logServices)n.critical(i,...e)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=l;class v extends C.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...e){this.logger.trace(i,...e)}debug(i,...e){this.logger.debug(i,...e)}info(i,...e){this.logger.info(i,...e)}warn(i,...e){this.logger.warn(i,...e)}error(i,...e){this.logger.error(i,...e)}critical(i,...e){this.logger.critical(i,...e)}flush(){this.logger.flush()}}t.LogService=v;class y{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(i){}getLevel(){return d.Info}trace(i,...e){}debug(i,...e){}info(i,...e){}warn(i,...e){}error(i,...e){}critical(i,...e){}dispose(){}flush(){}}t.NullLogService=y;function p(a){if(a.verbose)return d.Trace;if(typeof a.logLevel=="string"){const i=L(a.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=p;function L(a){switch(a){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}t.parseLogLevel=L;function E(a){switch(a){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}t.LogLevelToString=E}),define(Q[101],Z([0,1,16,2,20,24,19,9,18,25,13,30,39,15,4,14]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends C.Disposable{constructor(E,a,i,e){super();this.fileService=a,this.extensionGalleryService=i,this.logService=e,this.extensionsDownloadDir=R.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,a){await this.cleanUpPromise;const i=this.getName(E),e=(0,d.joinPath)(this.extensionsDownloadDir,i);if(!await this.fileService.exists(e)){const n=(0,d.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(n)||await this.extensionGalleryService.download(E,n,a);try{await this.rename(n,e,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch(o){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",E.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,v.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,n.path),r}}return e}async delete(E){}async rename(E,a,i){try{await m.promises.rename(E.fsPath,a.fsPath)}catch(e){if(I.isWindows&&e&&e.code==="EPERM"&&Date.now()<i)return this.logService.info(`Failed renaming ${E} to ${a} with 'EPERM' error. Trying again...`),this.rename(E,a,i);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const a=[],i=[];for(const r of E.children){const o=this.parse(r.name);o&&i.push([o,r])}const e=(0,f.groupByExtension)(i,([r])=>r),n=[];for(const r of e)r.sort((o,s)=>w.rcompare(o[0].version,s[0].version)),a.push(...r.slice(1).map(o=>o[1].resource)),n.push(r[0][1]);n.sort((r,o)=>r.mtime-o.mtime),a.push(...n.slice(0,Math.max(0,n.length-this.cache)).map(r=>r.resource)),await l.Promises.settled(a.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?new f.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase():(0,h.generateUuid)()}parse(E){const a=y.exec(E);return a&&a[1]&&a[2]?new f.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};p=ce([ue(0,T.INativeEnvironmentService),ue(1,b.IFileService),ue(2,S.IExtensionGalleryService),ue(3,O.ILogService)],p),t.ExtensionsDownloader=p}),define(Q[102],Z([0,1,2,13,33,29,3,4,11,10,12,19]),function(x,t,m,C,b,S,T,R,d,f,O,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends m.Disposable{constructor(l,v){super();this.environmentService=l,this.logService=v,this.processesLimiter=new R.Limiter(5)}async postUninstall(l){const v=this.parseScript(l,"uninstall");return v&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${y}`)))),(0,O.rimraf)(this.getExtensionStoragePath(l)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(l,v){const y=`vscode:${v}`;if(l.location.scheme===f.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[y]=="string"){const p=l.manifest.scripts[y].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${y} should be a node script`),null):{script:(0,T.join)(l.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(l,v,y,p,L){return new Promise((E,a)=>{const i=this.start(l,v,y,L);let e;const n=r=>{e&&(clearTimeout(e),e=null),r?a(r):E(void 0)};i.on("error",r=>{n((0,S.toErrorMessage)(r)||"Unknown")}),i.on("exit",(r,o)=>{n(r?`post-${v} process exited with code ${r}`:void 0)}),p&&(e=setTimeout(()=>{e=null,i.kill(),a("timed out")},5e3))})}start(l,v,y,p){const L={silent:!0,execArgv:void 0},E=(0,b.fork)(l,[`--type=extension-post-${v}`,...y],L);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const a=d.Event.fromNodeEventEmitter(E.stdout,"data"),i=d.Event.fromNodeEventEmitter(E.stderr,"data");a(r=>this.logService.info(p.identifier.id,p.manifest.version,`post-${v}`,r)),i(r=>this.logService.error(p.identifier.id,p.manifest.version,`post-${v}`,r));const e=d.Event.any(d.Event.map(a,r=>({data:`%c${r}`,format:[""]})),d.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]})));return d.Event.debounce(e,(r,o)=>r?{data:r.data+o.data,format:[...r.format,...o.format]}:{data:o.data,format:o.format},100)(r=>{console.group(p.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),E}getExtensionStoragePath(l){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};w=ce([ue(0,h.IEnvironmentService),ue(1,C.ILogService)],w),t.ExtensionsLifecycle=w}),define(Q[103],Z([0,1,2,19,11,20,9,25,18,13]),function(x,t,m,C,b,S,T,R,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let O=class extends m.Disposable{constructor(w,I,l,v){super();this.extensionsManagementService=w,this.logService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(L=>{this.installedExtensions=L.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(L=>this.onInstallExtension(L))),this._register(w.onDidInstallExtension(L=>this.onDidInstallExtension(L))),this._register(w.onDidUninstallExtension(L=>this.onDidUninstallExtension(L)));const y=T.URI.file(l.extensionsPath),p=new d.ExtUri(L=>!I.hasCapability(L,1024));this._register(I.watch(y)),this._register(b.Event.filter(I.onDidFilesChange,L=>L.changes.some(E=>this.doesChangeAffects(E,y,p)))(()=>this.onDidChange()))}doesChangeAffects(w,I,l){return l.isEqual(l.dirname(w.resource),I)?l.isEqual(w.resource,l.joinPath(I,".obsolete"))?!0:!(w.type!==1&&w.type!==2||l.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtension(w){this.removeInstallingExtension(w.identifier),w.error||this.addInstalledExtension(w.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(I=>!(0,R.areSameExtensions)(I,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,R.areSameExtensions)(I,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),I=w.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,R.areSameExtensions)(y,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),l=this.installedExtensions.filter(v=>w.every(y=>!(0,R.areSameExtensions)(y.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=w.map(v=>v.identifier),(I.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:l})}}};O=ce([ue(1,S.IFileService),ue(2,C.INativeEnvironmentService),ue(3,f.ILogService)],O),t.ExtensionsWatcher=O}),define(Q[104],Z([0,1,81,130,2,20,11,18,43,23,13,17,34,4,28,10,49,131]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v,y,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let L=class extends b.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(a,i){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:i});const e=new b.DisposableStore;return e.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new S.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),e.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:a}))),typeof i.onDidErrorOccur=="function"&&e.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:i}),this.provider.delete(a),(0,b.dispose)(e)})}async activateProvider(a){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(e){i.push(e)}}),!this.provider.has(a)&&await I.Promises.settled(i)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,i){const e=this.provider.get(a.scheme);return!!(e&&e.capabilities&i)}listCapabilities(){return p.Iterable.map(this.provider,([a,i])=>({scheme:a,capabilities:i.capabilities}))}async withProvider(a){if(!(0,R.isAbsolutePath)(a))throw new S.FileOperationError((0,m.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const i=this.provider.get(a.scheme);if(!i){const e=new Error;throw e.name="ENOPRO",e.message=(0,m.localize)(1,null,a.toString()),e}return i}async withReadProvider(a){const i=await this.withProvider(a);if((0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)||(0,S.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const i=await this.withProvider(a);if((0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,i){try{return await this.doResolveFile(a,i)}catch(e){throw(0,S.toFileSystemProviderErrorCode)(e)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,m.localize)(2,null,this.resourceForError(a)),1):(0,S.ensureFileSystemProviderError)(e)}}async doResolveFile(a,i){const e=await this.withProvider(a),n=this.isPathCaseSensitive(e),r=i==null?void 0:i.resolveTo,o=i==null?void 0:i.resolveSingleChildDescendants,s=i==null?void 0:i.resolveMetadata,g=await e.stat(a);let F;return this.toFileStat(e,a,g,void 0,!!s,(V,N)=>(F||(F=d.TernarySearchTree.forUris(()=>!n),F.set(a,!0),(0,f.isNonEmptyArray)(r)&&r.forEach(A=>F.set(A,!0))),Boolean(F.findSuperstr(V.resource)||F.get(V.resource))?!0:V.isDirectory&&o?N===1:!1))}async toFileStat(a,i,e,n,r,o){const{providerExtUri:s}=this.getExtUri(a),g={resource:i,name:s.basename(i),isFile:(e.type&S.FileType.File)!=0,isDirectory:(e.type&S.FileType.Directory)!=0,isSymbolicLink:(e.type&S.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,S.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&o(g,n)){try{const F=await a.readdir(i),V=await I.Promises.settled(F.map(async([N,A])=>{try{const j=s.joinPath(i,N),$=r?await a.stat(j):{type:A};return await this.toFileStat(a,j,$,F.length,r,o)}catch(j){return this.logService.trace(j),null}}));g.children=(0,f.coalesce)(V)}catch(F){this.logService.trace(F),g.children=[]}return g}return g}async resolveAll(a){return I.Promises.settled(a.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(a){const i=await this.withProvider(a);try{return!!await i.stat(a)}catch(e){return!1}}async canCreateFile(a,i){try{await this.doValidateCreateFile(a,i)}catch(e){return e}return!0}async doValidateCreateFile(a,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(a))throw new S.FileOperationError((0,m.localize)(3,null,this.resourceForError(a)),3,i)}async createFile(a,i=h.VSBuffer.fromString(""),e){await this.doValidateCreateFile(a,e);const n=await this.writeFile(a,i);return this._onDidRunOperation.fire(new S.FileOperationEvent(a,0,n)),n}async writeFile(a,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,a,e)||await this.mkdirp(n,r.dirname(a));let s;if((0,S.hasReadWriteCapability)(n)&&!(i instanceof h.VSBuffer))if((0,w.isReadableStream)(i)){const g=await(0,w.peekStream)(i,3);g.ended?s=h.VSBuffer.concat(g.buffer):s=g}else s=(0,w.peekReadable)(i,g=>h.VSBuffer.concat(g),3);else s=i;!(0,S.hasOpenReadWriteCloseCapability)(n)||(0,S.hasReadWriteCapability)(n)&&s instanceof h.VSBuffer?await this.doWriteUnbuffered(n,a,e,s):await this.doWriteBuffered(n,a,e,s instanceof h.VSBuffer?(0,h.bufferToReadable)(s):s)}catch(o){throw new S.FileOperationError((0,m.localize)(4,null,this.resourceForError(a),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),e)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,i,e){if(!!(e==null?void 0:e.unlock)&&!(a.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(i)));let r;try{r=await a.stat(i)}catch(o){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,m.localize)(6,null,this.resourceForError(i)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&e.mtime<r.mtime&&e.etag!==(0,S.etag)({mtime:e.mtime,size:r.size}))throw new S.FileOperationError((0,m.localize)(7,null),3,e);return r}async readFile(a,i){const e=await this.withReadProvider(a);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(e,a,i):this.doReadFile(e,a,i)}async doReadFileAtomic(a,i,e){return new Promise((n,r)=>{this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,i,e);n(o)}catch(o){r(o)}})})}async doReadFile(a,i,e){const n=await this.doReadFileStream(a,i,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,h.streamToBuffer)(n.value)})}async readFileStream(a,i){const e=await this.withReadProvider(a);return this.doReadFileStream(e,a,i)}async doReadFileStream(a,i,e){const n=new l.CancellationTokenSource,r=this.validateReadFile(i,e).then(s=>s,s=>{throw n.cancel(),s});let o;try{e&&typeof e.etag=="string"&&e.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(a)||(0,S.hasFileReadStreamCapability)(a))||(0,S.hasReadWriteCapability)(a)&&(e==null?void 0:e.preferUnbuffered)?o=this.readFileUnbuffered(a,i,e):(0,S.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,i,n.token,e):o=this.readFileBuffered(a,i,n.token,e);const s=await r;return Object.assign(Object.assign({},s),{value:o})}catch(s){throw o&&await(0,w.consumeStream)(o),new S.FileOperationError((0,m.localize)(8,null,this.resourceForError(i),(0,S.ensureFileSystemProviderError)(s).toString()),(0,S.toFileOperationResult)(s),e)}}readFileStreamed(a,i,e,n=Object.create(null)){const r=a.readFileStream(i,n,e);return(0,w.transform)(r,{data:o=>o instanceof h.VSBuffer?o:h.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,m.localize)(9,null,this.resourceForError(i),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),n)},o=>h.VSBuffer.concat(o))}readFileBuffered(a,i,e,n=Object.create(null)){const r=(0,h.newWriteableBufferStream)();return(0,y.readFileIntoStream)(a,i,r,o=>o,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,m.localize)(10,null,this.resourceForError(i),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),n)}),e),r}readFileUnbuffered(a,i,e){const n=(0,w.newWriteableStream)(r=>h.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(i);e&&typeof e.position=="number"&&(r=r.slice(e.position)),e&&typeof e.length=="number"&&(r=r.slice(0,e.length)),this.validateReadFileLimits(i,r.byteLength,e),n.end(h.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(a,i){const e=await this.resolve(a,{resolveMetadata:!0});if(e.isDirectory)throw new S.FileOperationError((0,m.localize)(11,null,this.resourceForError(a)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==S.ETAG_DISABLED&&i.etag===e.etag)throw new S.FileOperationError((0,m.localize)(12,null),2,i);return this.validateReadFileLimits(a,e.size,i),e}validateReadFileLimits(a,i,e){if(e==null?void 0:e.limits){let n;if(typeof e.limits.memory=="number"&&i>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&i>e.limits.size&&(n=7),typeof n=="number")throw new S.FileOperationError((0,m.localize)(13,null,this.resourceForError(a)),n)}}async canMove(a,i,e){return this.doCanMoveCopy(a,i,"move",e)}async canCopy(a,i,e){return this.doCanMoveCopy(a,i,"copy",e)}async doCanMoveCopy(a,i,e,n){if(a.toString()!==i.toString())try{const r=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,a,o,i,e,n)}catch(r){return r}return!0}async move(a,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(n,a,r,i,"move",!!e),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,o==="move"?2:3,s)),s}async copy(a,i,e){const n=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(n,a,r,i,"copy",!!e),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,o==="copy"?3:2,s)),s}async doMoveCopy(a,i,e,n,r,o){if(i.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(a,i,e,n,r,o);if(s&&!g&&o&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),r==="copy"){if(a===e&&(0,S.hasFileFolderCopyCapability)(a))await a.copy(i,n,{overwrite:o});else{const F=await this.resolve(i);F.isDirectory?await this.doCopyFolder(a,F,e,n):await this.doCopyFile(a,i,e,n)}return r}else return a===e?(await a.rename(i,n,{overwrite:o}),r):(await this.doMoveCopy(a,i,e,n,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(a,i,e,n){if((0,S.hasOpenReadWriteCloseCapability)(a)&&(0,S.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(a,i,e,n);if((0,S.hasOpenReadWriteCloseCapability)(a)&&(0,S.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(a,i,e,n);if((0,S.hasReadWriteCapability)(a)&&(0,S.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(a,i,e,n);if((0,S.hasReadWriteCapability)(a)&&(0,S.hasReadWriteCapability)(e))return this.doPipeUnbuffered(a,i,e,n)}async doCopyFolder(a,i,e,n){await e.mkdir(n),Array.isArray(i.children)&&await I.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(e).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),e,o):this.doCopyFile(a,r.resource,e,o)}))}async doValidateMoveCopy(a,i,e,n,r,o){let s=!1;if(a===e){const{providerExtUri:F,isPathCaseSensitive:V}=this.getExtUri(a);if(V||(s=F.isEqual(i,n)),s&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!s&&F.isEqualOrParent(n,i))throw new Error((0,m.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const g=await this.exists(n);if(g&&!s){if(!o)throw new S.FileOperationError((0,m.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(a===e){const{providerExtUri:F}=this.getExtUri(a);if(F.isEqualOrParent(i,n))throw new Error((0,m.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:g,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const i=this.isPathCaseSensitive(a);return{providerExtUri:i?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(i,a);const e=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(a,0,e)),e}async mkdirp(a,i){const e=[],{providerExtUri:n}=this.getExtUri(a);for(;!n.isEqual(i,n.dirname(i));)try{if(((await a.stat(i)).type&S.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(n.basename(i)),i=n.dirname(i)}for(let r=e.length-1;r>=0;r--){i=n.joinPath(i,e[r]);try{await a.mkdir(i)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,i){try{await this.doValidateDelete(a,i)}catch(e){return e}return!0}async doValidateDelete(a,i){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(i==null?void 0:i.useTrash)&&!(e.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(a)));const r=await this.exists(a);if(!r)throw new S.FileOperationError((0,m.localize)(20,null,this.resourceForError(a)),1);if(!!!(i==null?void 0:i.recursive)&&r){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(a)))}return e}async del(a,i){const e=await this.doValidateDelete(a,i),n=!!(i==null?void 0:i.useTrash),r=!!(i==null?void 0:i.recursive);await e.delete(a,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new S.FileOperationEvent(a,1))}watch(a,i={recursive:!1,excludes:[]}){let e=!1,n=()=>{e=!0};return this.doWatch(a,i).then(r=>{e?(0,b.dispose)(r):n=()=>(0,b.dispose)(r)},r=>this.logService.error(r)),(0,b.toDisposable)(()=>n())}async doWatch(a,i){const e=await this.withProvider(a),n=this.toWatchKey(e,a,i),r=this.activeWatchers.get(n)||{count:0,disposable:e.watch(a,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,b.toDisposable)(()=>{r.count--,r.count===0&&((0,b.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(a,i,e){const{providerExtUri:n}=this.getExtUri(a);return[n.getComparisonKey(i),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,b.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,i,e,n){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{var r;const o=await a.open(i,{create:!0,unlock:(r=e==null?void 0:e.unlock)!==null&&r!==void 0?r:!1});try{(0,w.isReadableStream)(n)||(0,w.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(a,o,n):await this.doWriteReadableBufferedQueued(a,o,n)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await a.close(o)}})}async doWriteStreamBufferedQueued(a,i,e){let n=0,r;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=h.VSBuffer.concat(e.buffer);await this.doWriteBuffer(a,i,o,o.byteLength,n,0),n+=o.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise(async(o,s)=>{(0,w.listenStream)(r,{onData:async g=>{r.pause();try{await this.doWriteBuffer(a,i,g,g.byteLength,n,0)}catch(F){return s(F)}n+=g.byteLength,setTimeout(()=>r.resume())},onError:g=>s(g),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,i,e){let n=0,r;for(;(r=e.read())!==null;)await this.doWriteBuffer(a,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(a,i,e,n,r,o){let s=0;for(;s<n;)s+=await a.write(i,r+s,e.buffer,o+s,n-s)}async doWriteUnbuffered(a,i,e,n){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,i,e,n))}async doWriteUnbufferedQueued(a,i,e,n){var r;let o;n instanceof h.VSBuffer?o=n:(0,w.isReadableStream)(n)?o=await(0,h.streamToBuffer)(n):(0,w.isReadableBufferedStream)(n)?o=await(0,h.bufferedStreamToBuffer)(n):o=(0,h.readableToBuffer)(n),await a.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:(r=e==null?void 0:e.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(a,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,i,e,n))}async doPipeBufferedQueued(a,i,e,n){let r,o;try{r=await a.open(i,{create:!1}),o=await e.open(n,{create:!0,unlock:!1});const s=h.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,F=0,V=0;do V=await a.read(r,g,s.buffer,F,s.byteLength-F),await this.doWriteBuffer(e,o,s,V,g,F),g+=V,F+=V,F===s.byteLength&&(F=0);while(V>0)}catch(s){throw(0,S.ensureFileSystemProviderError)(s)}finally{await I.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,i,e,n))}async doPipeUnbufferedQueued(a,i,e,n){return e.writeFile(n,await a.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,i,e,n))}async doPipeUnbufferedToBufferedQueued(a,i,e,n){const r=await e.open(n,{create:!0,unlock:!1});try{const o=await a.readFile(i);await this.doWriteBuffer(e,r,h.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await e.close(r)}}async doPipeBufferedToUnbuffered(a,i,e,n){const r=await(0,h.streamToBuffer)(this.readFileBuffered(a,i,l.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,r)}throwIfFileSystemIsReadonly(a,i){if(a.capabilities&2048)throw new S.FileOperationError((0,m.localize)(22,null,this.resourceForError(i)),6);return a}resourceForError(a){return a.scheme===v.Schemas.file?a.fsPath:a.toString(!0)}};L=ce([ue(0,O.ILogService)],L),t.FileService=L}),define(Q[105],Z([0,1,16,64,2,20,11,15,12,3,18,35,4,13,83,50,91,93,90,99,34,49,23,17]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v,y,p,L,E,a,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class r extends b.Disposable{constructor(s,g){var F;super();this.logService=s,this.options=g,this.BUFFER_SIZE=((F=this.options)===null||F===void 0?void 0:F.bufferSize)||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new w.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:g,symbolicLink:F}=await d.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(g,F),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(s){try{const g=await(0,d.readdir)(this.toFilePath(s),{withFileTypes:!0}),F=[];return await Promise.all(g.map(async V=>{try{let N;V.isSymbolicLink()?N=(await this.stat((0,O.joinPath)(s,V.name))).type:N=this.toType(V),F.push([V.name,N])}catch(N){this.logService.trace(N)}})),F}catch(g){throw this.toFileSystemProviderError(g)}}toType(s,g){let F;return(g==null?void 0:g.dangling)?F=S.FileType.Unknown:s.isFile()?F=S.FileType.File:s.isDirectory()?F=S.FileType.Directory:F=S.FileType.Unknown,g&&(F|=S.FileType.SymbolicLink),F}async readFile(s){try{const g=this.toFilePath(s);return await m.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(s,g,F){const V=(0,a.newWriteableStream)(N=>n.VSBuffer.concat(N.map(A=>n.VSBuffer.wrap(A))).buffer);return(0,i.readFileIntoStream)(this,s,V,N=>N.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),F),V}async writeFile(s,g,F){let V;try{const N=this.toFilePath(s);if(!F.create||!F.overwrite){if(await(0,d.exists)(N)){if(!F.overwrite)throw(0,S.createFileSystemProviderError)((0,l.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!F.create)throw(0,S.createFileSystemProviderError)((0,l.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}V=await this.open(s,{create:!0,unlock:F.unlock}),await this.write(V,0,g,0,g.byteLength)}catch(N){throw await this.toFileSystemProviderWriteError(s,N)}finally{typeof V=="number"&&await this.close(V)}}async open(s,g){try{const F=this.toFilePath(s);if((0,S.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:A}=await d.SymlinkSupport.stat(F);A.mode&128||await m.promises.chmod(F,A.mode|128)}catch(A){this.logService.trace(A)}let V;if((0,S.isFileOpenForWriteOptions)(g)){if(R.isWindows)try{await m.promises.truncate(F,0),V="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}V||(V="w")}else V="r";const N=await(0,C.promisify)(m.open)(F,V);return this.mapHandleToPos.set(N,0),(0,S.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(N,s),N}catch(F){throw(0,S.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(s,F):this.toFileSystemProviderError(F)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await(0,C.promisify)(m.fdatasync)(s)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,C.promisify)(m.close)(s)}catch(g){throw this.toFileSystemProviderError(g)}}async read(s,g,F,V,N){const A=this.normalizePos(s,g);let j=null;try{const $=await(0,C.promisify)(m.read)(s,F,V,N,A);return typeof $=="number"?j=$:j=$.bytesRead,j}catch($){throw this.toFileSystemProviderError($)}finally{this.updatePos(s,A,j)}}normalizePos(s,g){return g===this.mapHandleToPos.get(s)?null:g}updatePos(s,g,F){const V=this.mapHandleToPos.get(s);typeof V=="number"&&(typeof g=="number"||(typeof F=="number"?this.mapHandleToPos.set(s,V+F):this.mapHandleToPos.delete(s)))}async write(s,g,F,V,N){return(0,w.retry)(()=>this.doWrite(s,g,F,V,N),100,3)}async doWrite(s,g,F,V,N){const A=this.normalizePos(s,g);let j=null;try{const $=await(0,C.promisify)(m.write)(s,F,V,N,A);return typeof $=="number"?j=$:j=$.bytesWritten,j}catch($){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),$)}finally{this.updatePos(s,A,j)}}async mkdir(s){try{await m.promises.mkdir(this.toFilePath(s))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(s,g){try{const F=this.toFilePath(s);await this.doDelete(F,g)}catch(F){throw this.toFileSystemProviderError(F)}}async doDelete(s,g){g.recursive?await(0,d.rimraf)(s,d.RimRafMode.MOVE):await m.promises.unlink(s)}async rename(s,g,F){const V=this.toFilePath(s),N=this.toFilePath(g);if(V!==N)try{await this.validateTargetDeleted(s,g,"move",F.overwrite),await(0,d.move)(V,N)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(2,null,(0,f.basename)(V),(0,f.basename)((0,f.dirname)(N)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(s,g,F){const V=this.toFilePath(s),N=this.toFilePath(g);if(V!==N)try{await this.validateTargetDeleted(s,g,"copy",F.overwrite),await(0,d.copy)(V,N,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(3,null,(0,f.basename)(V),(0,f.basename)((0,f.dirname)(N)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(s,g,F,V){const N=this.toFilePath(s),A=this.toFilePath(g);let j=!1;if(!!(this.capabilities&1024)||(j=(0,h.isEqual)(N,A,!0)),j&&F==="copy")throw(0,S.createFileSystemProviderError)((0,l.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!j&&await(0,d.exists)(A)){if(!V)throw(0,S.createFileSystemProviderError)((0,l.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(s,g){return g.recursive?this.watchRecursive(s,g.excludes):this.watchNonRecursive(s)}watchRecursive(s,g){const F={path:this.toFilePath(s),excludes:g},V=(0,e.insert)(this.recursiveFoldersToWatch,F);return this.refreshRecursiveWatchers(),(0,b.toDisposable)(()=>{V(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,g,F;if(this.recursiveWatcher instanceof L.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let V,N;((g=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||g===void 0?void 0:g.usePolling)?(V=y.FileWatcher,N=(F=this.options)===null||F===void 0?void 0:F.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?V=p.FileWatcher:V=y.FileWatcher:V=L.FileWatcher,this.recursiveWatcher=new V(this.recursiveFoldersToWatch,A=>this._onDidChangeFile.fire((0,v.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===I.LogLevel.Trace,N),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const g=new E.FileWatcher(this.toFilePath(s),V=>this._onDidChangeFile.fire((0,v.toFileChanges)(V)),V=>{V.type==="error"&&this._onDidWatchErrorOccur.fire(V.message),this.logService[V.type](V.message)},this.logService.getLevel()===I.LogLevel.Trace),F=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,b.combinedDisposable)(g,F)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof S.FileSystemProviderError)return s;let g;switch(s.code){case"ENOENT":g=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=S.FileSystemProviderErrorCode.NoPermissions;break;default:g=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(s,g)}async toFileSystemProviderWriteError(s,g){let F=this.toFileSystemProviderError(g);if(s&&F.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:V}=await d.SymlinkSupport.stat(this.toFilePath(s));V.mode&128||(F=(0,S.createFileSystemProviderError)(g,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(V){this.logService.trace(V)}return F}dispose(){super.dispose(),(0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,b.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=r}),define(Q[106],Z([0,1,12,16,132,24,2,19,4,25,13,52,23,11,10,3]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let y=class extends T.Disposable{constructor(E,a,i){super();this.extensionManagementService=E,this.logService=i,this._onDidLanguagesChange=this._register(new I.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new p(a,i)),this._register(E.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(E.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(E=>{const a=["en",...Object.keys(E)];return(0,w.distinct)(a)})}onDidInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",E.identifier.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(E){this.cache.getLanguagePacks().then(a=>{Object.keys(a).some(i=>a[i]&&a[i].extensions.some(e=>(0,f.areSameExtensions)(e.extensionIdentifier,E)))&&(this.logService.debug("Removing language packs from the extension",E.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[E,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(a);return!(0,w.equals)(Object.keys(E),Object.keys(i))}};y=ce([ue(0,S.IExtensionManagementService),ue(1,R.INativeEnvironmentService),ue(2,O.ILogService)],y),t.LocalizationsService=y;let p=class extends T.Disposable{constructor(E,a){super();this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new d.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(a=>{Object.keys(a).forEach(i=>delete a[i]),this.createLanguagePacksFromExtensions(a,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...a){for(const i of a)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,i);Object.keys(E).forEach(i=>this.updateHash(E[i]))}createLanguagePacksFromExtension(E,a){const i=a.identifier,e=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const n of e)if(a.location.scheme===l.Schemas.file&&(0,h.isValidLocalization)(n)){let r=E[n.languageId];r||(r={hash:"",extensions:[],translations:{}},E[n.languageId]=r);let o=r.extensions.filter(s=>(0,f.areSameExtensions)(s.extensionIdentifier,i))[0];o?o.version=a.manifest.version:r.extensions.push({extensionIdentifier:i,version:a.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,v.join)(a.location.fsPath,s.path)}}updateHash(E){if(E){const a=(0,b.createHash)("md5");for(const i of E.extensions)a.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);E.hash=a.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return C.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(e){return{}}}).then(i=>(a=E(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,m.writeFile)(this.languagePacksFilePath,e)}).then(()=>a,i=>this.logService.error(i))})}};p=ce([ue(0,R.INativeEnvironmentService),ue(1,O.ILogService)],p)}),define(Q[107],Z([0,1,13,20]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(d,f,O,h){try{const w=await new Promise((I,l)=>{x(["spdlog"],I,l)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(d,f,O,h)}catch(w){console.error(w)}return null}function S(d,f,O,h){return x.__$__nodeRequire("spdlog").createRotatingLogger(d,f,O,h)}t.createRotatingLogger=S;function T(d,f,O){switch(f){case m.LogLevel.Trace:d.trace(O);break;case m.LogLevel.Debug:d.debug(O);break;case m.LogLevel.Info:d.info(O);break;case m.LogLevel.Warning:d.warn(O);break;case m.LogLevel.Error:d.error(O);break;case m.LogLevel.Critical:d.critical(O);break;default:throw new Error("Invalid log level")}}class R extends m.AbstractMessageLogger{constructor(f,O,h,w){super();this.name=f,this.filepath=O,this.rotating=h,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}_createSpdLogLogger(){const f=this.rotating?6:1,O=30/f*C.ByteSize.MB;return b(this.name,this.filepath,O,f).then(h=>{if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:w,message:I}of this.buffer)T(this._logger,w,I);this.buffer=[]}})}log(f,O){this._logger?T(this._logger,f,O):this.getLevel()<=f&&this.buffer.push({level:f,message:O})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(Q[40],Z([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,m.createDecorator)("productService")}),define(Q[26],Z([0,1,8,56]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,R){C.ok(m.isString(T)),C.ok(m.isObject(R)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(Q[108],Z([0,1,26,11]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class S{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[b(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new S;m.Registry.add(t.Extensions.JSONContribution,T)}),define(Q[31],Z([0,1,74,11,26,8,108]),function(x,t,m,C,b,S,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var R;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=b.Registry.as(T.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,L=!0){this.registerConfigurations([p],L)}registerConfigurations(p,L=!0){const E=[];p.forEach(a=>{E.push(...this.validateAndRegisterProperties(a,L)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterConfigurations(p){const L=[],E=a=>{if(a.properties)for(const i in a.properties)L.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,a.properties[i]);a.allOf&&a.allOf.forEach(i=>E(i))};for(const a of p){E(a);const i=this.configurationContributors.indexOf(a);i!==-1&&this.configurationContributors.splice(i,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(L)}registerDefaultConfigurations(p){const L=[],E=[];for(const a of p)for(const i in a)if(L.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),a[i]);const e={type:"object",default:this.defaultValues[i],description:m.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};E.push(h(i)),this.configurationProperties[i]=e,this.defaultLanguageConfigurationOverridesNode.properties[i]=e}else{this.defaultValues[i]=a[i];const e=this.configurationProperties[i];e&&(this.updatePropertyDefaultValue(i,e),this.updateSchema(i,e))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(L)}deregisterDefaultConfigurations(p){const L=[];for(const E of p)for(const a in E)if(L.push(a),delete this.defaultValues[a],t.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const i=this.configurationProperties[a];i&&(this.updatePropertyDefaultValue(a,i),this.updateSchema(a,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(L)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const L of p)this.overrideIdentifiers.add(L);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,L=!0,E=3){E=S.isUndefinedOrNull(p.scope)?E:p.scope;let a=[],i=p.properties;if(i)for(let n in i){if(L&&l(n)){delete i[n];continue}const r=i[n];if(this.updatePropertyDefaultValue(n,r),t.OVERRIDE_PROPERTY_PATTERN.test(n)?r.scope=void 0:r.scope=S.isUndefinedOrNull(r.scope)?E:r.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),a.push(n)}let e=p.allOf;if(e)for(let n of e)a.push(...this.validateAndRegisterProperties(n,L,E));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const L=E=>{let a=E.properties;if(a)for(const e in a)this.updateSchema(e,a[e]);let i=E.allOf;i&&i.forEach(L)};L(p)}updateSchema(p,L){switch(t.allSettings.properties[p]=L,L.scope){case 1:t.applicationSettings.properties[p]=L;break;case 2:t.machineSettings.properties[p]=L;break;case 6:t.machineOverridableSettings.properties[p]=L;break;case 3:t.windowSettings.properties[p]=L;break;case 4:t.resourceSettings.properties[p]=L;break;case 5:t.resourceSettings.properties[p]=L,this.resourceLanguageSettingsSchema.properties[p]=L;break}}removeFromSchema(p,L){switch(delete t.allSettings.properties[p],L.scope){case 1:delete t.applicationSettings.properties[p];break;case 2:delete t.machineSettings.properties[p];break;case 6:delete t.machineOverridableSettings.properties[p];break;case 3:delete t.windowSettings.properties[p];break;case 4:case 5:delete t.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const L=`[${p}]`,E={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(L,E),t.allSettings.properties[L]=E,t.applicationSettings.properties[L]=E,t.machineSettings.properties[L]=E,t.machineOverridableSettings.properties[L]=E,t.windowSettings.properties[L]=E,t.resourceSettings.properties[L]=E}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,L){let E=this.defaultValues[p];S.isUndefined(E)&&(E=L.default),S.isUndefined(E)&&(E=w(L.type)),L.default=E}}const O="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(O);function h(y){return y.substring(1,y.length-1)}t.overrideIdentifierFromKey=h;function w(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=w;const I=new f;b.Registry.add(t.Extensions.Configuration,I);function l(y){return y.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(y)?m.localize(5,null,y):I.getConfigurationProperties()[y]!==void 0?m.localize(6,null,y):null:m.localize(4,null)}t.validateProperty=l;function v(){const y=[],p=I.getConfigurationProperties();for(const L of Object.keys(p))y.push([L,p[L].scope]);return y.push(["launch",4]),y.push(["task",4]),y}t.getScopes=v}),define(Q[27],Z([0,1,22,8,9,26,7,31]),function(x,t,m,C,b,S,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function d(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof b.URI)}t.isConfigurationOverrides=d;var f;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function O(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=O;function h(n,r){const o=r?n?r.keys.filter(j=>n.keys.indexOf(j)===-1):[...r.keys]:[],s=n?r?n.keys.filter(j=>r.keys.indexOf(j)===-1):[...n.keys]:[],g=[];if(r&&n){for(const j of n.keys)if(r.keys.indexOf(j)!==-1){const $=p(n.contents,j),X=p(r.contents,j);m.equals($,X)||g.push(j)}}const F=[],V=j=>{const $={};for(const X of j)for(const ne of X.identifiers)$[i(ne)]=X;return $},N=r?V(r.overrides):{},A=n?V(n.overrides):{};if(Object.keys(N).length)for(const j of o){const $=N[j];$&&F.push([(0,R.overrideIdentifierFromKey)(j),$.keys])}if(Object.keys(A).length)for(const j of s){const $=A[j];$&&F.push([(0,R.overrideIdentifierFromKey)(j),$.keys])}if(Object.keys(N).length&&Object.keys(A).length)for(const j of g){const $=A[j],X=N[j];if($&&X){const ne=h({contents:$.contents,keys:$.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});F.push([(0,R.overrideIdentifierFromKey)(j),[...ne.added,...ne.removed,...ne.updated]])}}return{added:o,removed:s,updated:g,overrides:F}}t.compare=h;function w(n,r){const o=[];for(const s of Object.keys(n))if(R.OVERRIDE_PROPERTY_PATTERN.test(s)){const g={};for(const F in n[s])g[F]=n[s][F];o.push({identifiers:[(0,R.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(g),contents:I(g,r)})}return o}t.toOverrides=w;function I(n,r){const o=Object.create(null);for(let s in n)l(o,s,n[s],r);return o}t.toValuesTree=I;function l(n,r,o,s){const g=r.split("."),F=g.pop();let V=n;for(let N=0;N<g.length;N++){let A=g[N],j=V[A];switch(typeof j){case"undefined":j=V[A]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${g.slice(0,N+1).join(".")} is ${JSON.stringify(j)}`);return}V=j}if(typeof V=="object"&&V!==null)try{V[F]=o}catch(N){s(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(V)}`)}else s(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(V)}`)}t.addToValueTree=l;function v(n,r){const o=r.split(".");y(n,o)}t.removeFromValueTree=v;function y(n,r){const o=r.shift();if(r.length===0){delete n[o];return}if(Object.keys(n).indexOf(o)!==-1){const s=n[o];typeof s=="object"&&!Array.isArray(s)&&(y(s,r),Object.keys(s).length===0&&delete n[o])}}function p(n,r,o){function s(V,N){let A=V;for(const j of N){if(typeof A!="object"||A===null)return;A=A[j]}return A}const g=r.split("."),F=s(n,g);return typeof F=="undefined"?o:F}t.getConfigurationValue=p;function L(n,r,o){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in n?C.isObject(n[s])&&C.isObject(r[s])?L(n[s],r[s],o):o&&(n[s]=r[s]):n[s]=r[s])})}t.merge=L;function E(){const n=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=E;function a(){const n=Object.create(null),r=S.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let o in r){let s=r[o].default;l(n,o,s,g=>console.error(`Conflict in default settings: ${g}`))}return n}t.getDefaultValues=a;function i(n){return`[${n}]`}t.keyFromOverrideIdentifier=i;function e(n,r,o){const s=n.inspect(r),g=n.inspect(o);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:s.defaultValue}t.getMigratedSettingValue=e}),define(Q[109],Z([0,1,58,43,23,8,22,9,31,27,26,2,11]),function(x,t,m,C,b,S,T,R,d,f,O,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class I{constructor(e={},n=[],r=[]){this._contents=e,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const r=this.getContentsForOverrideIdentifer(n);return r?e?(0,f.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const o of b.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[o],g=n[o];g&&(typeof s=="object"&&typeof g=="object"?(s=T.deepClone(s),this.mergeContents(s,g)):s=g),r[o]=s}return new I(r,this.keys,this.overrides)}merge(...e){const n=T.deepClone(this.contents),r=T.deepClone(this.overrides),o=[...this.keys];for(const s of e){this.mergeContents(n,s.contents);for(const g of s.overrides){const[F]=r.filter(V=>b.equals(V.identifiers,g.identifiers));F?this.mergeContents(F.contents,g.contents):r.push(T.deepClone(g))}for(const g of s.keys)o.indexOf(g)===-1&&o.push(g)}return new I(n,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const r of Object.keys(n)){if(r in e&&S.isObject(e[r])&&S.isObject(n[r])){this.mergeContents(e[r],n[r]);continue}e[r]=T.deepClone(n[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,f.addToValueTree)(this.contents,e,n,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let r=0;r<n;r++)e.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=I;class l extends I{constructor(){const e=(0,f.getDefaultValues)(),n=(0,f.getConfigurationKeys)(),r=[];for(const o of Object.keys(e))d.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,d.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,f.toValuesTree)(e[o],s=>console.error(`Conflict in default settings file: ${s}`))});super(e,n,r)}}t.DefaultConfigurationModel=l;class v{constructor(e,n){this._name=e,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get errors(){return this._parseErrors}parseContent(e){if(!S.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n)}}parseRaw(e){this._raw=e;const n=this.doParseRaw(e);this._configurationModel=new I(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let n={},r=null,o=[],s=[],g=[];function F(N){Array.isArray(o)?o.push(N):r&&(o[r]=N)}let V={onObjectBegin:()=>{let N={};F(N),s.push(o),o=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{let N=[];F(N),s.push(o),o=N,r=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:F,onError:(N,A,j)=>{g.push({error:N,offset:A,length:j})}};if(e)try{m.visit(e,V),n=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e){if(this._scopes){const s=O.Registry.as(d.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,s,!0,this._scopes)}const n=(0,f.toValuesTree)(e,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),r=Object.keys(e),o=(0,f.toOverrides)(e,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:n,keys:r,overrides:o}}filterByScope(e,n,r,o){const s={};for(let g in e)if(d.OVERRIDE_PROPERTY_PATTERN.test(g)&&r)s[g]=this.filterByScope(e[g],n,!1,o);else{const F=this.getScope(g,n);(F===void 0||o.indexOf(F)!==-1)&&(s[g]=e[g])}return s}getScope(e,n){const r=n[e];return r?typeof r.scope!="undefined"?r.scope:3:void 0}}t.ConfigurationModelParser=v;class y extends h.Disposable{constructor(e,n,r,o){super();this.userSettingsResource=e,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new I}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=y;class p{constructor(e,n,r=new I,o=new I,s=new C.ResourceMap,g=new I,F=new C.ResourceMap,V=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=s,this._memoryConfiguration=g,this._memoryConfigurationByResource=F,this._freeze=V,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(e)}updateValue(e,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new I,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(e):o.setValue(e,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,r){const o=this.getConsolidateConfigurationModel(n,r),s=this.getFolderConfigurationModelForResource(n.resource,r),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,F=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),V=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),A=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),j=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,X=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(e):g.getValue(e),ne=o.getValue(e),ee=b.distinct(b.flatten(o.overrides.map(te=>te.identifiers))).filter(te=>o.getOverrideValue(e,te)!==void 0);return{defaultValue:F,userValue:V,userLocalValue:N,userRemoteValue:A,workspaceValue:j,workspaceFolderValue:$,memoryValue:X,value:ne,default:F!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:V!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:s==null?void 0:s.freeze().getValue(e),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:g.getValue(e),override:n.overrideIdentifier?g.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const r=n.filter(o=>d.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const s=(0,d.overrideIdentifierFromKey)(o),g=this._defaultConfiguration.getKeysForOverrideIdentifier(s),F=e.getKeysForOverrideIdentifier(s),V=[...F.filter(N=>g.indexOf(N)===-1),...g.filter(N=>F.indexOf(N)===-1),...g.filter(N=>!T.equals(this._defaultConfiguration.override(s).getValue(N),e.override(s).getValue(N)))];return[s,V]});return this.updateDefaultConfiguration(e),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:r,removed:o,overrides:s}=(0,f.compare)(this.localUserConfiguration,e),g=[...n,...r,...o];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:s}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:r,removed:o,overrides:s}=(0,f.compare)(this.remoteUserConfiguration,e);let g=[...n,...r,...o];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:s}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:r,removed:o,overrides:s}=(0,f.compare)(this.workspaceConfiguration,e);let g=[...n,...r,...o];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:s}}compareAndUpdateFolderConfiguration(e,n){const r=this.folderConfigurations.get(e),{added:o,updated:s,removed:g,overrides:F}=(0,f.compare)(r,n);let V=[...o,...s,...g];return(V.length||!r)&&this.updateFolderConfiguration(e,n),{keys:V,overrides:F}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:o,removed:s,overrides:g}=(0,f.compare)(n,void 0);return{keys:[...r,...o,...s],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let r=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const o=n.getFolder(e);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const s=this._memoryConfigurationByResource.get(e);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(n=r.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=r}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const r=n.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:r,overrides:o,keys:s}=this._folderConfigurations.get(n);return e.push([n,{contents:r,overrides:o,keys:s}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((g,F)=>(g.set(R.URI.revive(F[0]),this.parseConfigurationModel(F[1])),g),new C.ResourceMap);return new p(n,r,new I,o,s,new I,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new I(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=p;function L(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const e=new Set,n=new Map;for(const o of i)o.keys.forEach(s=>e.add(s)),o.overrides.forEach(([s,g])=>{const F=(0,C.getOrSet)(n,s,new Set);g.forEach(V=>F.add(V))});const r=[];return n.forEach((o,s)=>r.push([s,[...o.values()]])),{keys:[...e.values()],overrides:r}}t.mergeChanges=L;class E{constructor(e,n,r,o){this.change=e,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const s=new Set;e.keys.forEach(F=>s.add(F)),e.overrides.forEach(([,F])=>F.forEach(V=>s.add(V))),this.affectedKeys=[...s.values()];const g=new I;this.affectedKeys.forEach(F=>g.setValue(F,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,s=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!T.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let r=(0,f.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(e=e[o],!e)return!1;r=r[o]}return!0}}t.ConfigurationChangeEvent=E;class a extends E{constructor(e,n,r,o){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=r,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=a}),define(Q[110],Z([0,1,26,31,2,27,109,11,4,18]),function(x,t,m,C,b,S,T,R,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class O extends b.Disposable{constructor(w,I){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,I)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new d.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,I){const l=typeof w=="string"?w:void 0,v=(0,S.isConfigurationOverrides)(w)?w:(0,S.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(l,v,void 0)}updateValue(w,I,l,v){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const I=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(l,I,1)}onDidDefaultConfigurationChange(w){const I=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,w);this.trigger(l,I,6)}trigger(w,I,l){const v=new T.ConfigurationChangeEvent(w,{data:I},this.configuration);v.source=l,v.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=O}),define(Q[53],Z([0,1,84,7,31,26,17]),function(x,t,m,C,b,S,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}t.isSuccess=R;function d(h){return h.res.statusCode===204}async function f(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return d(h)?null:(await(0,T.streamToBuffer)(h.stream)).toString()}t.asText=f;async function O(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(d(h))return null;const I=(await(0,T.streamToBuffer)(h.stream)).toString();try{return JSON.parse(I)}catch(l){throw l.message+=`:
`+I,l}}t.asJson=O,S.Registry.as(b.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,m.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null)],default:"override",description:(0,m.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(8,null)}}})}),define(Q[111],Z([0,1,112,8]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,R){return T.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:T.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function S(T,R,d={}){const f=(0,m.parse)(T),O=d.proxyUrl||b(f,R);if(!O)return null;const h=(0,m.parse)(O);if(!/^https?:$/.test(h.protocol||""))return null;const w={host:h.hostname||"",port:h.port||(h.protocol==="https"?"443":"80"),auth:h.auth,rejectUnauthorized:(0,C.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((I,l)=>{x(["http-proxy-agent"],I,l)}))(w):new(await new Promise((I,l)=>{x(["https-proxy-agent"],I,l)}))(w)}t.getProxyAgent=S}),define(Q[113],Z([0,1,30,17]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(S,T,R){let d=R&&R.get("storage.serviceMachineId",0)||null;if(d)return d;try{const O=(await T.readFile(S.serviceMachineIdResource)).value.toString();d=(0,m.isUUID)(O)?O:null}catch(f){d=null}if(!d){d=(0,m.generateUuid)();try{await T.writeFile(S.serviceMachineIdResource,C.VSBuffer.fromString(d))}catch(f){}}return R&&R.store("storage.serviceMachineId",d,0,1),d}t.getServiceMachineId=b}),define(Q[114],Z([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,m.createDecorator)("stateService")}),define(Q[115],Z([0,1,3,16,19,12,8,13]),function(x,t,m,C,b,S,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class d{constructor(h,w){this.dbPath=h,this.onError=w,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const h=await this.loadAsync();this._database||(this._database=h)}}loadSync(){try{return this.lastFlushedSerializedDatabase=C.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(h){return h.code!=="ENOENT"&&this.onError(h),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await C.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(h){return h.code!=="ENOENT"&&this.onError(h),{}}}getItem(h,w){const I=this.database[h];return(0,T.isUndefinedOrNull)(I)?w:I}setItem(h,w){if((0,T.isUndefinedOrNull)(w))return this.removeItem(h);(typeof w=="string"||typeof w=="number"||typeof w=="boolean")&&this.database[h]===w||(this.database[h]=w,this.saveSync())}removeItem(h){(0,T.isUndefined)(this.database[h])||(this.database[h]=void 0,this.saveSync())}saveSync(){const h=JSON.stringify(this.database,null,4);if(h!==this.lastFlushedSerializedDatabase)try{(0,S.writeFileSync)(this.dbPath,h),this.lastFlushedSerializedDatabase=h}catch(w){this.onError(w)}}}t.FileStorage=d;let f=class We{constructor(h,w){this.fileStorage=new d(m.join(h.userDataPath,We.STATE_FILE),I=>w.error(I))}init(){return this.fileStorage.init()}getItem(h,w){return this.fileStorage.getItem(h,w)}setItem(h,w){this.fileStorage.setItem(h,w)}removeItem(h){this.fileStorage.removeItem(h)}};f.STATE_FILE="storage.json",f=ce([ue(0,b.INativeEnvironmentService),ue(1,R.ILogService)],f),t.StateService=f}),define(Q[116],Z([0,1,7,11,2,8,67,4]),function(x,t,m,C,b,S,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";t.IStorageService=(0,m.createDecorator)("storageService");var f;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var h;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(h=t.StorageTarget||(t.StorageTarget={}));class w extends b.Disposable{constructor(y={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,p){p===d?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:p,target:this.getKeyTargets(y)[p]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,p,L){var E;return(E=this.getStorage(p))===null||E===void 0?void 0:E.get(y,L)}getBoolean(y,p,L){var E;return(E=this.getStorage(p))===null||E===void 0?void 0:E.getBoolean(y,L)}getNumber(y,p,L){var E;return(E=this.getStorage(p))===null||E===void 0?void 0:E.getNumber(y,L)}store(y,p,L,E){if((0,S.isUndefinedOrNull)(p)){this.remove(y,L);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(y,L,E),(a=this.getStorage(L))===null||a===void 0||a.set(y,p)})}remove(y,p){this.withPausedEmitters(()=>{var L;this.updateKeyTarget(y,p,void 0),(L=this.getStorage(p))===null||L===void 0||L.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,p){const L=[],E=this.getKeyTargets(y);for(const a of Object.keys(E))E[a]===p&&L.push(a);return L}updateKeyTarget(y,p,L){var E,a;const i=this.getKeyTargets(p);typeof L=="number"?i[y]!==L&&(i[y]=L,(E=this.getStorage(p))===null||E===void 0||E.set(d,JSON.stringify(i))):typeof i[y]=="number"&&(delete i[y],(a=this.getStorage(p))===null||a===void 0||a.set(d,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const p=this.get(d,y);if(p)try{return JSON.parse(p)}catch(L){}return Object.create(null)}isNew(y){return this.getBoolean(t.IS_NEW_KEY,y)===!0}async flush(){var y,p,L,E;this._onWillSaveState.fire({reason:f.NONE}),await R.Promises.settled([(p=(y=this.getStorage(0))===null||y===void 0?void 0:y.whenFlushed())!==null&&p!==void 0?p:Promise.resolve(),(E=(L=this.getStorage(1))===null||L===void 0?void 0:L.whenFlushed())!==null&&E!==void 0?E:Promise.resolve()])}async logStorage(){var y,p,L,E,a,i;const e=(p=(y=this.getStorage(0))===null||y===void 0?void 0:y.items)!==null&&p!==void 0?p:new Map,n=(E=(L=this.getStorage(1))===null||L===void 0?void 0:L.items)!==null&&E!==void 0?E:new Map;return l(e,n,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends w{constructor(){super();this.globalStorage=new T.Storage(new T.InMemoryStorageDatabase),this.workspaceStorage=new T.Storage(new T.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}t.InMemoryStorageService=I;async function l(v,y,p,L){const E=s=>{try{return JSON.parse(s)}catch(g){return s}},a=new Map,i=new Map;v.forEach((s,g)=>{a.set(g,s),i.set(g,E(s))});const e=new Map,n=new Map;y.forEach((s,g)=>{e.set(g,s),n.set(g,E(s))}),console.group(`Storage: Global (path: ${p})`);let r=[];a.forEach((s,g)=>{r.push({key:g,value:s})}),console.table(r),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${L})`);let o=[];e.forEach((s,g)=>{o.push({key:g,value:s})}),console.table(o),console.groupEnd(),console.log(n)}t.logStorage=l}),define(Q[117],Z([0,1,15,37,30,9]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function T(d,f,O,h,w,I,l,v,y){const p=Object.create(null);p["common.machineId"]=I,p.sessionID=(0,b.generateUuid)()+Date.now(),p.commitHash=h,p.version=w,p["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,m.PlatformToString)(m.platform),p["common.nodePlatform"]=C.platform,p["common.nodeArch"]=O,p["common.product"]=y||"desktop";const L=R(l||[]);L&&(p["common.msftInternal"]=L);let E=0;const a=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),m.isLinuxSnap&&(p["common.snap"]="true");try{const i=await d.readFile(S.URI.file(v));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}t.resolveCommonProperties=T;function R(d){const f=C.env.USERDNSDOMAIN;if(!f)return!1;const O=f.toLowerCase();return d.some(h=>O===h)}}),define(Q[41],Z([0,1,7]),function(x,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,m.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[118],Z([0,1,14,24,25,22,41,53,47,19,28,13,20,9,40,116,113,7,18]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v,y,p,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var E;(function(c){c[c.None=0]="None",c[c.IncludeVersions=1]="IncludeVersions",c[c.IncludeFiles=2]="IncludeFiles",c[c.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",c[c.IncludeSharedAccounts=8]="IncludeSharedAccounts",c[c.IncludeVersionProperties=16]="IncludeVersionProperties",c[c.ExcludeNonValidated=32]="ExcludeNonValidated",c[c.IncludeInstallationTargets=64]="IncludeInstallationTargets",c[c.IncludeAssetUri=128]="IncludeAssetUri",c[c.IncludeStatistics=256]="IncludeStatistics",c[c.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",c[c.Unpublished=4096]="Unpublished"})(E||(E={}));function a(...c){return String(c.reduce((u,P)=>u|P,0))}var i;(function(c){c[c.Tag=1]="Tag",c[c.ExtensionId=4]="ExtensionId",c[c.Category=5]="Category",c[c.ExtensionName=7]="ExtensionName",c[c.Target=8]="Target",c[c.Featured=9]="Featured",c[c.SearchText=10]="SearchText",c[c.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:E.None,criteria:[],assetTypes:[]};class s{constructor(u=o){this.state=u}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(u,P=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:u,pageSize:P}))}withFilter(u,...P){const D=[...this.state.criteria,...P.length?P.map(k=>({filterType:u,value:k})):[{filterType:u}]];return new s(Object.assign(Object.assign({},this.state),{criteria:D}))}withSortBy(u){return new s(Object.assign(Object.assign({},this.state),{sortBy:u}))}withSortOrder(u){return new s(Object.assign(Object.assign({},this.state),{sortOrder:u}))}withFlags(...u){return new s(Object.assign(Object.assign({},this.state),{flags:u.reduce((P,D)=>P|D,0)}))}withAssetTypes(...u){return new s(Object.assign(Object.assign({},this.state),{assetTypes:u}))}get raw(){const{criteria:u,pageNumber:P,pageSize:D,sortBy:k,sortOrder:M,flags:U,assetTypes:B}=this.state;return{filters:[{criteria:u,pageNumber:P,pageSize:D,sortBy:k,sortOrder:M}],assetTypes:B,flags:U}}get searchText(){const u=this.state.criteria.filter(P=>P.filterType===i.SearchText)[0];return u&&u.value?u.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(u=>String(u.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(c,u){const P=(c||[]).filter(D=>D.statisticName===u)[0];return P?P.value:0}function F(c){const u="Microsoft.VisualStudio.Code.Translation.";return c.files.filter(D=>D.assetType.indexOf(u)===0).reduce((D,k)=>{const M=j(c,k.assetType);return M&&D.push([k.assetType.substring(u.length),M]),D},[])}function V(c){if(c.properties){const u=c.properties.filter(k=>k.key===e.Repository),P=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),D=u.filter(k=>P.test(k.value))[0];return D?{uri:D.value,fallbackUri:D.value}:null}return j(c,e.Repository)}function N(c){return{uri:`${c.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${c.fallbackAssetUri}/${e.VSIX}`}}function A(c){const u=j(c,e.Icon);if(u)return u;const P=C.DefaultIconPath;return{uri:P,fallbackUri:P}}function j(c,u){return c.files.filter(D=>D.assetType===u)[0]?{uri:`${c.assetUri}/${u}`,fallbackUri:`${c.fallbackAssetUri}/${u}`}:null}function $(c,u){const P=c.properties?c.properties.filter(k=>k.key===u):[],D=P.length>0&&P[0].value;return D?D.split(",").map(k=>(0,b.adoptToGalleryExtensionId)(k)):[]}function X(c){const u=c.properties?c.properties.filter(P=>P.key===n.Engine):[];return u.length>0&&u[0].value||""}function ne(c){const u=c.properties?c.properties.filter(D=>D.key===n.LocalizedLanguages):[],P=u.length>0&&u[0].value||"";return P?P.split(","):[]}function ee(c){return c.indexOf("preview")!==-1}function te(c){const u=c.properties?c.properties.find(P=>P.key===n.WebExtension):void 0;return!!u&&u.value==="true"}function ae(c){return c.files.some(u=>u.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,L.joinPath)(I.URI.parse(c.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(c,u,P,D,k){const M={manifest:j(u,e.Manifest),readme:j(u,e.Details),changelog:j(u,e.Changelog),license:j(u,e.License),repository:V(u),download:N(u),icon:A(u),coreTranslations:F(u)};return{identifier:{id:(0,b.getGalleryExtensionId)(c.publisher.publisherName,c.extensionName),uuid:c.extensionId},name:c.extensionName,version:u.version,date:u.lastUpdated,displayName:c.displayName,publisherId:c.publisher.publisherId,publisher:c.publisher.publisherName,publisherDisplayName:c.publisher.displayName,description:c.shortDescription||"",installCount:g(c.statistics,"install"),rating:g(c.statistics,"averagerating"),ratingCount:g(c.statistics,"ratingcount"),assetUri:I.URI.parse(u.assetUri),webResource:ae(u),assetTypes:u.files.map(({assetType:U})=>U),assets:M,properties:{dependencies:$(u,n.Dependency),extensionPack:$(u,n.ExtensionPack),engine:X(u),localizedLanguages:ne(u),webExtension:te(u)},telemetryData:{index:(D.pageNumber-1)*D.pageSize+P,searchText:D.searchText,querySource:k},preview:ee(c.flags)}}let G=class{constructor(u,P,D,k,M,U,B){this.requestService=u,this.logService=P,this.environmentService=D,this.telemetryService=k,this.fileService=M,this.productService=U;const q=U.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=_(U.version,this.environmentService,this.fileService,B)}api(u=""){return`${this.extensionsGalleryUrl}${u}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(u,P){const D=[];let{total:k,firstPage:M,getPage:U}=await this.query({names:u,pageSize:u.length},P);D.push(...M);for(let B=1;D.length<k&&(M=await U(B,P),M.length);B++)D.push(...M);return D}async getCompatibleExtension(u,P){const D=await this.getCompatibleExtensionByEngine(u,P);return(D==null?void 0:D.properties.webExtension)?D.webResource?D:null:D}async getCompatibleExtensionByEngine(u,P){const D=(0,C.isIExtensionIdentifier)(u)?null:u;if(D&&D.properties.engine&&(0,d.isEngineValid)(D.properties.engine,this.productService.version))return D;const{id:k,uuid:M}=D?D.identifier:u;let U=new s().withFlags(E.IncludeAssetUri,E.IncludeStatistics,E.IncludeFiles,E.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");M?U=U.withFilter(i.ExtensionId,M):U=U.withFilter(i.ExtensionName,k);const{galleryExtensions:B}=await this.queryGallery(U,O.CancellationToken.None),[q]=B;if(!q||!q.versions.length)return null;if(P){const Y=q.versions.filter(ie=>ie.version===P)[0];if(Y){const ie=W(q,Y,0,U);if(ie.properties.engine&&(0,d.isEngineValid)(ie.properties.engine,this.productService.version))return ie}return null}const J=await this.getLastValidExtensionVersion(q,q.versions);return J?W(q,J,0,U):null}async query(u,P){const D=O.CancellationToken.isCancellationToken(u)?{}:u,k=O.CancellationToken.isCancellationToken(u)?u:P;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=D.text||"";const U=(0,S.getOrDefault)(D,re=>re.pageSize,50);let B=new s().withFlags(E.IncludeLatestVersionOnly,E.IncludeAssetUri,E.IncludeStatistics,E.IncludeFiles,E.IncludeVersionProperties).withPage(1,U).withFilter(i.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(i.Category,ge||he),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(i.Tag,ge||he),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(i.SearchText,M)),B=B.withSortBy(0)):D.ids?B=B.withFilter(i.ExtensionId,...D.ids):D.names?B=B.withFilter(i.ExtensionName,...D.names):B=B.withSortBy(4),typeof D.sortBy=="number"&&(B=B.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(B=B.withSortOrder(D.sortOrder));const{galleryExtensions:q,total:J}=await this.queryGallery(B,k),Y=q.map((re,he)=>W(re,re.versions[0],he,B,D.source)),ie=async(re,he)=>{if(he.isCancellationRequested)throw(0,m.canceled)();const ge=B.withPage(re+1),{galleryExtensions:De}=await this.queryGallery(ge,he);return De.map((Oe,Fe)=>W(Oe,Oe.versions[0],Fe,ge,D.source))};return{firstPage:Y,total:J,pageSize:B.pageSize,getPage:ie}}async queryGallery(u,P){if(!this.isEnabled())throw new Error("No extension gallery service configured.");u=u.withFlags(u.flags,E.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,a(E.Unpublished));const D=await this.commonHeadersPromise,k=JSON.stringify(u.raw),M=Object.assign(Object.assign({},D),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(k.length)}),U=new Date().getTime();let B,q,J=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:k,headers:M},P),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:J};const Y=await(0,R.asJson)(B);if(Y){const ie=Y.results[0],re=ie.extensions,he=ie.resultMetadata&&ie.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return J=he&&he.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:J}}return{galleryExtensions:[],total:J}}catch(Y){throw q=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},u.telemetryData),{requestBodySize:String(k.length),duration:new Date().getTime()-U,success:!!B&&(0,R.isSuccess)(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:q?(0,m.isPromiseCanceledError)(q)?"canceled":(0,m.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(u,P,D,k){if(!!this.isEnabled()){const M=await this.commonHeadersPromise,U=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${u}/extensions/${P}/${D}/stats?statType=${k}`),headers:U},O.CancellationToken.None)}catch(B){}}}async download(u,P,D){this.logService.trace("ExtensionGalleryService#download",u.identifier.id);const k=(0,b.getGalleryExtensionTelemetryData)(u),M=new Date().getTime(),U=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},k),{duration:Y})),B=D===1?"install":D===2?"update":"",q=B?{uri:`${u.assets.download.uri}&${B}=true`,fallbackUri:`${u.assets.download.fallbackUri}?${B}=true`}:u.assets.download,J=await this.getAsset(q);await this.fileService.writeFile(P,J.stream),U(new Date().getTime()-M)}async getReadme(u,P){if(u.assets.readme){const D=await this.getAsset(u.assets.readme,{},P);return await(0,R.asText)(D)||""}return""}async getManifest(u,P){if(u.assets.manifest){const D=await this.getAsset(u.assets.manifest,{},P),k=await(0,R.asText)(D);return k?JSON.parse(k):null}return null}async getCoreTranslation(u,P){const D=u.assets.coreTranslations.filter(k=>k[0]===P.toUpperCase())[0];if(D){const k=await this.getAsset(D[1]),M=await(0,R.asText)(k);return M?JSON.parse(M):null}return null}async getChangelog(u,P){if(u.assets.changelog){const D=await this.getAsset(u.assets.changelog,{},P);return await(0,R.asText)(D)||""}return""}async getAllVersions(u,P){let D=new s().withFlags(E.IncludeVersions,E.IncludeFiles,E.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");u.identifier.uuid?D=D.withFilter(i.ExtensionId,u.identifier.uuid):D=D.withFilter(i.ExtensionName,u.identifier.id);const k=[],{galleryExtensions:M}=await this.queryGallery(D,O.CancellationToken.None);return M.length&&(P?await Promise.all(M[0].versions.map(async U=>{let B;try{B=await this.getEngine(U)}catch(q){}B&&(0,d.isEngineValid)(B,this.productService.version)&&k.push({version:U.version,date:U.lastUpdated})})):k.push(...M[0].versions.map(U=>({version:U.version,date:U.lastUpdated})))),k}async getAsset(u,P={},D=O.CancellationToken.None){const k=await this.commonHeadersPromise,M={type:"GET"},U=Object.assign(Object.assign({},k),P.headers||{});P=Object.assign(Object.assign(Object.assign({},P),M),{headers:U});const B=u.uri,q=u.fallbackUri,J=Object.assign(Object.assign({},P),{url:B});try{const Y=await this.requestService.request(J,D);if(Y.res.statusCode===200)return Y;const ie=await(0,R.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ie}`)}catch(Y){if((0,m.isPromiseCanceledError)(Y))throw Y;const ie=(0,m.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ie});const re=Object.assign(Object.assign({},P),{url:q});return this.requestService.request(re,D)}}async getLastValidExtensionVersion(u,P){const D=this.getLastValidExtensionVersionFromProperties(u,P);return D||this.getLastValidExtensionVersionRecursively(u,P)}getLastValidExtensionVersionFromProperties(u,P){for(const D of P){const k=X(D);if(!k)return null;if((0,d.isEngineValid)(k,this.productService.version))return D}return null}async getEngine(u){const P=X(u);if(P)return P;const D=j(u,e.Manifest);if(!D)throw new Error("Manifest was not found");const k={"Accept-Encoding":"gzip"},M=await this.getAsset(D,{headers:k}),U=await(0,R.asJson)(M);if(U)return U.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(u,P){if(!P.length)return null;const D=P[0],k=await this.getEngine(D);return(0,d.isEngineValid)(k,this.productService.version)?(D.properties=D.properties||[],D.properties.push({key:n.Engine,value:k}),D):this.getLastValidExtensionVersionRecursively(u,P.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const u=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const P=await(0,R.asJson)(u),D=new Map;if(P)for(const k of P.malicious){const M=D.get(k)||{id:{id:k},malicious:!0,slow:!1};M.malicious=!0,D.set(k,M)}return[...D.values()]}};G=ce([ue(0,R.IRequestService),ue(1,h.ILogService),ue(2,f.IEnvironmentService),ue(3,T.ITelemetryService),ue(4,w.IFileService),ue(5,l.IProductService),ue(6,(0,p.optional)(v.IStorageService))],G),t.ExtensionGalleryService=G;async function _(c,u,P,D){const k={"X-Market-Client-Id":`VSCode ${c}`,"User-Agent":`VSCode ${c}`},M=await(0,y.getServiceMachineId)(u,P,D);return k["X-Market-User-Id"]=M,k}t.resolveMarketplaceHeaders=_}),define(Q[119],Z([0,1,54,85,21,7,27,31,2,22,26]),function(x,t,m,C,b,S,T,R,d,f,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let h=class{constructor(l,v){this._configurationService=v,this._experimentProperties={},this._disposables=new d.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(y),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(y=>{const p=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(l,v){this._experimentProperties[l]=v}setEnabled(l){this._enabled=l}_updateUserOptIn(){var l;const v=(l=this._configurationService)===null||l===void 0?void 0:l.getValue(w);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let v=l.sessionID,y=l["common.instanceId"],p=l["common.machineId"],L=l["common.firstSessionDate"],E=l["common.msftInternal"];return{sessionId:v,instanceId:y,machineId:p,firstSessionDate:L,msftInternal:E}}dispose(){this._disposables.dispose()}publicLog(l,v,y){return this.isOptedIn?this._commonProperties.then(p=>{v=(0,f.mixin)(v,p),v=(0,f.mixin)(v,this._experimentProperties),v=(0,f.cloneAndChange)(v,L=>{if(typeof L=="string")return this._cleanupInfo(L,y)}),this._appender.log(l,v)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(l,v,y){return this.publicLog(l,v,y)}publicLogError(l,v){return this.sendErrorTelemetry?this.publicLog(l,v,!0):Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}_cleanupInfo(l,v){let y=l;if(v){const p=[];for(let i of this._cleanupPatterns)for(;;){const e=i.exec(l);if(!e)break;p.push([e.index,i.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(y="";;){const i=E.exec(l);if(!i)break;!L.test(i[0])&&p.every(([e,n])=>i.index<e||i.index>=n)&&(y+=l.substring(a,i.index)+"<REDACTED: user-file-path>",a=E.lastIndex)}a<l.length&&(y+=l.substr(a))}for(let p of this._cleanupPatterns)y=y.replace(p,"");return y}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=ce([ue(1,(0,S.optional)(T.IConfigurationService))],h),t.TelemetryService=h;const w="telemetry";O.Registry.as(R.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,C.localize)(2,null,m.default.privacyStatementUrl):(0,C.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[55],Z([0,1,27,22,8,4]),function(x,t,m,C,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(l,v){return Promise.resolve(void 0)}publicLog2(l,v){return this.publicLog(l,v)}publicLogError(l,v){return Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(v,y,p){}async publicLogError(v,y,p){}}t.NullEndpointTelemetryService=T;function R(...l){return{log:(v,y)=>l.forEach(p=>p.log(v,y)),flush:()=>S.Promises.settled(l.map(v=>v.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(l,v){return v.onDidChangeConfiguration(y=>{y.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(y.source),configurationKeys:w(y.sourceConfig)})})}t.configurationTelemetry=d;function f(l){const v=Object.create(null),y=Object.create(null),p=Object.create(null);h(l,p);for(let L in p){L=L.length>150?L.substr(L.length-149):L;const E=p[L];typeof E=="number"?y[L]=E:typeof E=="boolean"?y[L]=E?1:0:typeof E=="string"?v[L]=E.substring(0,1023):typeof E!="undefined"&&E!==null&&(v[L]=E)}return{properties:v,measurements:y}}t.validateTelemetryData=f;function O(l){if(!l)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{l.indexOf(`${p}+`)===0&&(v=p)}),v}t.cleanRemoteAuthority=O;function h(l,v,y=0,p){if(!!l)for(let L of Object.getOwnPropertyNames(l)){const E=l[L],a=p?p+L:L;Array.isArray(E)?v[a]=(0,C.safeStringify)(E):E instanceof Date?v[a]=E.toISOString():(0,b.isObject)(E)?y<2?h(E,v,y+1,a+"."):v[a]=(0,C.safeStringify)(E):v[a]=E}}function w(l){if(!l)return[];const v=[];return I(v,"",l),v}function I(l,v,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(p=>I(l,v?`${v}.${p}`:p,y[p])):l.push(v)}}),define(Q[120],Z([0,1,14,22,55]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function S(R){const d=await new Promise((O,h)=>{x(["applicationinsights"],O,h)});let f;return d.defaultClient?(f=new d.TelemetryClient(R),f.channel.setUseDiskRetryCaching(!0)):(d.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=d.defaultClient),R.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class T{constructor(d,f,O){this._eventPrefix=d,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof O=="function"?this._aiClient=O():this._aiClient=O,this._asyncAIClient=null}_withAIClient(d){if(!!this._aiClient){if(typeof this._aiClient!="string"){d(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=S(this._aiClient)),this._asyncAIClient.then(f=>{d(f)},f=>{(0,m.onUnexpectedError)(f),console.error(f)})}}log(d,f){!this._aiClient||(f=(0,C.mixin)(f,this._defaultData),f=(0,b.validateTelemetryData)(f),this._withAIClient(O=>O.trackEvent({name:this._eventPrefix+"/"+d,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(d=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,d(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Q[121],Z([0,1,12,16,3]),function(x,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function S(T,R){const d=Object.create(null),f=(h,w)=>{const I=JSON.parse(h);d[w]=I};if(R){const h=(0,m.readdirSync)(R).filter(I=>{try{return(0,C.statSync)((0,b.join)(R,I)).isDirectory()}catch(l){return!1}}),w=[];h.forEach(I=>{(0,m.readdirSync)((0,b.join)(R,I)).filter(v=>v==="telemetry.json").length===1&&w.push(I)}),w.forEach(I=>{const l=(0,C.readFileSync)((0,b.join)(R,I,"telemetry.json")).toString();f(l,I)})}let O=(0,C.readFileSync)((0,b.join)(T,"telemetry-core.json")).toString();return f(O,"vscode-core"),O=(0,C.readFileSync)((0,b.join)(T,"telemetry-extensions.json")).toString(),f(O,"vscode-extensions"),JSON.stringify(d,null,4)}t.buildTelemetryMessage=S}),define(Q[42],Z([0,1,73,3,16,4,12,133,134,8]),function(x,t,m,C,b,S,T,R,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class O extends Error{constructor(e,n){let r=n.message;switch(e){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=e,this.cause=n}}t.ExtractError=O;function h(i){const e=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,r)=>n+r,e&61440)}function w(i){if(i instanceof O)return i;let e;return/end of central directory record signature not found/.test(i.message)&&(e="CorruptZip"),new O(e,i)}function I(i,e,n,r,o,s){const g=C.dirname(e),F=C.join(r,g);if(!F.startsWith(r))return Promise.reject(new Error(m.localize(0,null,e)));const V=C.join(r,e);let N;return s.onCancellationRequested(()=>{N&&N.destroy()}),Promise.resolve(b.promises.mkdir(F,{recursive:!0})).then(()=>new Promise((A,j)=>{if(!s.isCancellationRequested)try{N=(0,b.createWriteStream)(V,{mode:n}),N.once("close",()=>A()),N.once("error",j),i.once("error",j),i.pipe(N)}catch($){j($)}}))}function l(i,e,n,r){let o=(0,S.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{o.cancel(),i.close()}),new Promise((g,F)=>{const V=new S.Sequencer,N=A=>{A.isCancellationRequested||(s++,i.readEntry())};i.once("error",F),i.once("close",()=>o.then(()=>{r.isCancellationRequested||i.entryCount===s?g():F(new O("Incomplete",new Error(m.localize(1,null,s,i.entryCount))))},F)),i.readEntry(),i.on("entry",A=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(A.fileName)){N(r);return}const j=A.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(j)){const ne=C.join(e,j);o=(0,S.createCancelablePromise)(ee=>b.promises.mkdir(ne,{recursive:!0}).then(()=>N(ee)).then(void 0,F));return}const $=y(i,A),X=h(A);o=(0,S.createCancelablePromise)(ne=>V.queue(()=>$.then(ee=>I(ee,j,X,e,n,ne).then(()=>N(ne)))).then(null,F))}})})}function v(i,e=!1){return new Promise((n,r)=>{(0,R.open)(i,e?{lazyEntries:!0}:void 0,(o,s)=>{o?r(w(o)):n((0,f.assertIsDefined)(s))})})}function y(i,e){return new Promise((n,r)=>{i.openReadStream(e,(o,s)=>{o?r(w(o)):n((0,f.assertIsDefined)(s))})})}function p(i,e){return new Promise((n,r)=>{const o=new d.ZipFile;e.forEach(g=>{g.contents?o.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&o.addFile(g.localPath,g.path)}),o.end();const s=(0,b.createWriteStream)(i);o.outputStream.pipe(s),o.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(i))})}t.zip=p;function L(i,e,n={},r){const o=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=v(i,!0);return n.overwrite&&(s=s.then(g=>(0,T.rimraf)(e).then(()=>g))),s.then(g=>l(g,e,{sourcePathRegex:o},r))}t.extract=L;function E(i,e){return v(i).then(n=>new Promise((r,o)=>{n.on("entry",s=>{s.fileName===e&&y(n,s).then(g=>r(g),g=>o(g))}),n.once("close",()=>o(new Error(m.localize(2,null,e))))}))}function a(i,e){return E(i,e).then(n=>new Promise((r,o)=>{const s=[];n.once("error",o),n.on("data",g=>s.push(g)),n.on("end",()=>r(Buffer.concat(s)))}))}t.buffer=a}),define(Q[122],Z([0,1,42,78]),function(x,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(S){return(0,m.buffer)(S,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(R){throw new Error((0,C.localize)(0,null))}})}t.getManifest=b}),define(Q[123],Z([0,1,16,39,2,12,3,13,24,25,4,9,19,89,79,40,42,15,23,10,20,18,30,14]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v,y,p,L,E,a,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const r="scanningSystem",o="scanningUser",s="extracting",g="deleting",F="renaming";let V=class extends b.Disposable{constructor(A,j,$,X,ne){super();this.beforeRemovingExtension=A,this.fileService=j,this.logService=$,this.environmentService=X,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=X.builtinExtensionsPath,this.extensionsPath=X.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(A){const j=[];(A===null||A===0)&&j.push(this.scanSystemExtensions().then(null,$=>Promise.reject(new d.ExtensionManagementError(this.joinErrors($).message,r)))),(A===null||A===1)&&j.push(this.scanUserExtensions(!0).then(null,$=>Promise.reject(new d.ExtensionManagementError(this.joinErrors($).message,o))));try{const $=await Promise.all(j);return(0,L.flatten)($)}catch($){throw this.joinErrors($)}}async scanUserExtensions(A){this.logService.trace("Started scanning user extensions");let[j,$]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return $=$.filter(X=>!j[new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]),A&&($=(0,f.groupByExtension)($,ne=>ne.identifier).map(ne=>ne.sort((ee,te)=>C.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",$.length),$}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(A,j,$){const X=A.key(),ne=T.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=T.join(this.extensionsPath,X);try{await S.rimraf(ee)}catch(ae){try{await S.rimraf(ee)}catch(W){}throw new d.ExtensionManagementError((0,l.localize)(0,null,ee,A.id),g)}await this.extractAtLocation(A,j,ne,$);let te=await this.scanExtension(h.URI.file(ne),1);if(!te)throw new Error((0,l.localize)(1,null,ne));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(A,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await S.rimraf(ne)}catch(W){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(ae)}. Deleted from extracted location`,ne),ae}try{te=await this.scanExtension(h.URI.file(ee),1)}catch(ae){}if(te)return te;throw new Error((0,l.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(A,j){return this.setMetadata(A,j),await this.storeMetadata(A,Object.assign(Object.assign({},j),{installedTimestamp:A.installedTimestamp})),A}async storeMetadata(A,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const $=T.join(A.location.fsPath,"package.json"),X=await m.promises.readFile($,"utf8"),{manifest:ne}=await this.parseManifest(X);return ne.__metadata=j,await S.writeFile($,JSON.stringify(ne,null,"	")),A}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const j=A.map($=>new f.ExtensionIdentifierWithVersion($.identifier,$.manifest.version));await this.withUninstalledExtensions($=>{j.forEach(X=>$[X.key()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(X=>delete X[A.key()]);const $=(await this.scanExtensions(1)).find(X=>new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).equals(A))||null;return $?(await this.storeMetadata($,{installedTimestamp:Date.now()}),this.scanExtension($.location,1)):null}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await m.promises.readFile(this.uninstalledPath,"utf8")}catch(X){if(X.code!=="ENOENT")throw X}let $={};if(j)try{$=JSON.parse(j)}catch(X){}return A&&(A($),Object.keys($).length?await S.writeFile(this.uninstalledPath,JSON.stringify($)):await S.rimraf(this.uninstalledPath)),$})}async removeExtension(A,j){this.logService.trace(`Deleting ${j} extension from disk`,A.identifier.id,A.location.fsPath),await S.rimraf(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).key()])}async extractAtLocation(A,j,$,X){this.logService.trace(`Started extracting the extension from ${j} to ${$}`);try{await S.rimraf($)}catch(ne){throw new d.ExtensionManagementError(this.joinErrors(ne).message,g)}try{await(0,y.extract)(j,$,{sourcePath:"extension",overwrite:!0},X),this.logService.info(`Extracted extension to ${$}:`,A.id)}catch(ne){try{await S.rimraf($)}catch(ee){}throw new d.ExtensionManagementError(ne.message,ne instanceof y.ExtractError&&ne.type?ne.type:s)}}async rename(A,j,$,X){try{await m.promises.rename(j,$)}catch(ne){if(p.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<X)return this.logService.info(`Failed renaming ${j} to ${$} with 'EPERM' error. Trying again...`,A.id),this.rename(A,j,$,X);throw new d.ExtensionManagementError(ne.message||(0,l.localize)(3,null,j,$),ne.code||F)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const A=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return A;const j=this.scanDevSystemExtensions(),[$,X]=await Promise.all([A,j]);return[...$,...X]}async scanExtensionsInDir(A,j){const $=new O.Limiter(10),X=await this.fileService.resolve(h.URI.file(A));return X.children?(await Promise.all(X.children.filter(ee=>ee.isDirectory).map(ee=>$.queue(async()=>j===1&&(0,i.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,j))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(A,j){var $,X;try{const ne=await this.fileService.resolve(A);if(ne.children){const{manifest:ee,metadata:te}=await this.readManifest(A.fsPath),ae=($=ne.children.find(({name:c})=>/^readme(\.txt|\.md|)$/i.test(c)))===null||$===void 0?void 0:$.resource,W=(X=ne.children.find(({name:c})=>/^changelog(\.txt|\.md|)$/i.test(c)))===null||X===void 0?void 0:X.resource,G={id:(0,f.getGalleryExtensionId)(ee.publisher,ee.name)},_={type:j,identifier:G,manifest:ee,location:A,readmeUrl:ae,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return te&&(this.setMetadata(_,te),_.installedTimestamp=te.installedTimestamp),_}}catch(ne){j!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const A=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(){const A=this.getDevSystemExtensionsList();if(A.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter($=>A.some(X=>(0,f.areSameExtensions)($.identifier,{id:X})))}else return[]}setMetadata(A,j){A.publisherDisplayName=j.publisherDisplayName||null,A.publisherId=j.publisherId||null,A.identifier.uuid=j.id,A.isMachineScoped=!!j.isMachineScoped,A.isBuiltin=A.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),$=new Set;for(const ee of j)A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||$.add(ee.identifier.id.toLowerCase());const X=(0,f.groupByExtension)(j,ee=>ee.identifier);await O.Promises.settled(X.map(async ee=>{const te=ee.sort((ae,W)=>C.rcompare(ae.manifest.version,W.manifest.version))[0];$.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const ne=j.filter(ee=>A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await O.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const A=await this.scanAllUserExtensions(),j=[],$=(0,f.groupByExtension)(A,X=>X.identifier);j.push(...(0,L.flatten)($.map(X=>X.sort((ne,ee)=>C.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await O.Promises.settled(j.map(X=>this.removeExtension(X,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(A=>A.name)}joinErrors(A){const j=Array.isArray(A)?A:[A];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce(($,X)=>new Error(`${$.message}${$.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(E.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(A){const j=[m.promises.readFile(T.join(A,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),m.promises.readFile(T.join(A,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:$,metadata:X},ne]=await Promise.all(j);return{manifest:(0,I.localizeManifest)($,ne),metadata:X}}parseManifest(A){return new Promise((j,$)=>{try{const X=JSON.parse(A),ne=X.__metadata||null;j({manifest:X,metadata:ne})}catch(X){$(new Error((0,l.localize)(4,null)))}})}};V=ce([ue(1,a.IFileService),ue(2,R.ILogService),ue(3,w.INativeEnvironmentService),ue(4,v.IProductService)],V),t.ExtensionsScanner=V}),define(Q[124],Z([0,1,16,77,3,12,2,23,42,24,25,19,4,11,39,9,54,15,13,97,29,41,47,18,30,95,7,10,28,122,101,123,102,103,20]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v,y,p,L,E,a,i,e,n,r,o,s,g,F,V,N,A,j,$,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",te="validating",ae="local",W="unknown";let G=class extends T.Disposable{constructor(c,u,P,D,k,M,U){super();this.environmentService=c,this.galleryService=u,this.logService=P,this.downloadService=D,this.telemetryService=k,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new I.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new I.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new I.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new I.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const B=this._register(M.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(A.ExtensionsScanner,J=>B.postUninstall(J))),this.manifestCache=this._register(new E.ExtensionsManifestCache(c,this)),this.extensionsDownloader=this._register(M.createInstance(N.ExtensionsDownloader));const q=this._register(new $.ExtensionsWatcher(this,U,c,P));this._register(q.onDidChangeExtensionsByAnotherSource(({added:J,removed:Y})=>{J.forEach(ie=>this._onDidInstallExtension.fire({identifier:ie.identifier,operation:0,local:ie})),Y.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))})),this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(J=>J.cancel()),this.uninstallingExtensions.forEach(J=>J.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(c){this.logService.trace("ExtensionManagementService#zip",c.identifier.id);const u=await this.collectFiles(c),P=await(0,d.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,u);return v.URI.file(P)}async unzip(c){return this.logService.trace("ExtensionManagementService#unzip",c.toString()),(await this.install(c)).identifier}async getManifest(c){const u=await this.downloadVsix(c),P=b.resolve(u.fsPath);return(0,V.getManifest)(P)}async collectFiles(c){const u=async D=>{let k=await S.readdir(D);k=k.map(B=>b.join(D,B));const M=await Promise.all(k.map(B=>m.promises.stat(B)));let U=Promise.resolve([]);return M.forEach((B,q)=>{const J=k[q];B.isFile()&&(U=U.then(Y=>[...Y,J])),B.isDirectory()&&(U=U.then(Y=>u(J).then(ie=>[...Y,...ie])))}),U};return(await u(c.location.fsPath)).map(D=>({path:`extension/${b.relative(c.location.fsPath,D)}`,localPath:D}))}async install(c,u={}){return this.logService.trace("ExtensionManagementService#install",c.toString()),(0,w.createCancelablePromise)(async P=>{const D=await this.downloadVsix(c),k=b.resolve(D.fsPath),M=await(0,V.getManifest)(k),U={id:(0,O.getGalleryExtensionId)(M.publisher,M.name)};let B=1;if(M.engines&&M.engines.vscode&&!(0,e.isEngineValid)(M.engines.vscode,y.default.version))throw new Error(C.localize(0,null,U.id,y.default.version));const q=new O.ExtensionIdentifierWithVersion(U,M.version),Y=(await this.getInstalled(1)).find(re=>(0,O.areSameExtensions)(U,re.identifier));if(Y)if(u.isMachineScoped=u.isMachineScoped||Y.isMachineScoped,u.isBuiltin=u.isBuiltin||Y.isBuiltin,B=2,q.equals(new O.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(C.localize(1,null,M.displayName||M.name))}else l.gt(Y.manifest.version,M.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal(q);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(he){throw new Error(C.localize(2,null,M.displayName||M.name))}}this.logService.info("Installing the extension:",U.id),this._onInstallExtension.fire({identifier:U,zipPath:k});let ie;try{ie=await this.getGalleryMetadata((0,O.getGalleryExtensionId)(M.publisher,M.name))}catch(re){}try{const re=await this.installFromZipPath(q,k,Object.assign(Object.assign({},ie||{}),u),u,B,P);return this.logService.info("Successfully installed the extension:",U.id),re}catch(re){throw this.logService.error("Failed to install the extension:",U.id,re.message),re}})}async downloadVsix(c){if(c.scheme===g.Schemas.file)return c;if(!this.downloadService)throw new Error("Download service is not available");const u=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(c,u),u}async installFromZipPath(c,u,P,D,k,M){try{const U=await this.installExtension({zipPath:u,identifierWithVersion:c,metadata:P},M);try{await this.installDependenciesAndPackExtensions(U,void 0,D)}catch(B){(0,R.isNonEmptyArray)(U.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",U.identifier.id,B.message),(0,R.isNonEmptyArray)(U.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",U.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:c,zipPath:u,local:U,operation:k}),U}catch(U){throw this._onDidInstallExtension.fire({identifier:c,zipPath:u,operation:k,error:U}),U}}async canInstall(c){return!0}async installFromGallery(c,u={}){if(!this.galleryService.isEnabled())throw new Error(C.localize(3,null));try{c=await this.checkAndGetCompatibleVersion(c)}catch(k){const M=k&&k.code?k.code:W;throw this.logService.error("Failed to install extension:",c.identifier.id,k?k.message:M),this.reportTelemetry(this.getTelemetryEvent(1),(0,O.getGalleryExtensionTelemetryData)(c),void 0,k),k instanceof Error&&(k.name=M),k}const P=new O.ExtensionIdentifierWithVersion(c.identifier,c.version).key();let D=this.installingExtensions.get(P);return D||(D=(0,w.createCancelablePromise)(k=>this.doInstallFromGallery(c,u,k)),this.installingExtensions.set(P,D),D.finally(()=>this.installingExtensions.delete(P))),D}async doInstallFromGallery(c,u,P){const D=new Date().getTime();let k=1;this.logService.info("Installing extension:",c.identifier.id),this._onInstallExtension.fire({identifier:c.identifier,gallery:c});try{const U=(await this.getInstalled(1)).find(J=>(0,O.areSameExtensions)(J.identifier,c.identifier));U&&(k=2);const B=await this.downloadInstallableExtension(c,k);B.metadata.isMachineScoped=u.isMachineScoped||(U==null?void 0:U.isMachineScoped),B.metadata.isBuiltin=u.isBuiltin||(U==null?void 0:U.isBuiltin);const q=await this.installExtension(B,P);try{await this.extensionsDownloader.delete(v.URI.file(B.zipPath))}catch(J){}if(!u.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(q,U,u)}catch(J){try{await this.uninstall(q)}catch(Y){}throw J}return U&&l.neq(U.manifest.version,c.version)&&await this.extensionsScanner.setUninstalled(U),this.logService.info("Extensions installed successfully:",c.identifier.id),this._onDidInstallExtension.fire({identifier:c.identifier,gallery:c,local:q,operation:k}),this.reportTelemetry(this.getTelemetryEvent(k),(0,O.getGalleryExtensionTelemetryData)(c),new Date().getTime()-D,void 0),q}catch(M){const U=M&&M.code?M.code:W;throw this.logService.error("Failed to install extension:",c.identifier.id,M?M.message:U),this._onDidInstallExtension.fire({identifier:c.identifier,gallery:c,operation:k,error:U}),this.reportTelemetry(this.getTelemetryEvent(k),(0,O.getGalleryExtensionTelemetryData)(c),new Date().getTime()-D,M),M instanceof Error&&(M.name=U),M}}async checkAndGetCompatibleVersion(c){if(await this.isMalicious(c))throw new f.ExtensionManagementError(C.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const u=await this.galleryService.getCompatibleExtension(c);if(!u)throw new f.ExtensionManagementError(C.localize(5,null,c.identifier.id,y.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return u}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(6,null));const u=await this.findGalleryExtension(c);if(!u)throw new Error(C.localize(7,null));await this.extensionsScanner.setUninstalled(c);try{await this.extensionsScanner.removeUninstalledExtension(c)}catch(P){throw new Error(C.localize(8,null,(0,a.toErrorMessage)(P)))}await this.installFromGallery(u)}getTelemetryEvent(c){return c===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(c){const u=await this.getExtensionsReport();return(0,O.getMaliciousExtensionsSet)(u).has(c.identifier.id)}async downloadInstallableExtension(c,u){const P={id:c.identifier.uuid,publisherId:c.publisherId,publisherDisplayName:c.publisherDisplayName};let D;try{this.logService.trace("Started downloading extension:",c.identifier.id);const k=await this.extensionsDownloader.downloadExtension(c,u);this.logService.info("Downloaded extension:",c.identifier.id,D),D=k.fsPath}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,ee)}try{const k=await(0,V.getManifest)(D);return{zipPath:D,identifierWithVersion:new O.ExtensionIdentifierWithVersion(c.identifier,k.version),metadata:P}}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,te)}}async installExtension(c,u){try{const P=await this.unsetUninstalledAndGetLocal(c.identifierWithVersion);if(P)return c.metadata?this.extensionsScanner.saveMetadataForLocalExtension(P,c.metadata):P}catch(P){throw p.isMacintosh?new f.ExtensionManagementError(C.localize(9,null),ne):new f.ExtensionManagementError(C.localize(10,null),ne)}return this.extractAndInstall(c,u)}async unsetUninstalledAndGetLocal(c){if(!await this.isUninstalled(c))return null;this.logService.trace("Removing the extension from uninstalled list:",c.id);const P=await this.extensionsScanner.setInstalled(c);return this.logService.info("Removed the extension from uninstalled list:",c.id),P}async extractAndInstall({zipPath:c,identifierWithVersion:u,metadata:P},D){let k=await this.extensionsScanner.extractUserExtension(u,c,D);return this.logService.info("Installation completed.",u.id),P&&(k=await this.extensionsScanner.saveMetadataForLocalExtension(k,P)),k}async installDependenciesAndPackExtensions(c,u,P){if(!!this.galleryService.isEnabled()){const D=c.manifest.extensionDependencies||[];if(c.manifest.extensionPack)for(const k of c.manifest.extensionPack)u&&u.manifest.extensionPack&&u.manifest.extensionPack.some(M=>(0,O.areSameExtensions)({id:M},{id:k}))||D.every(M=>!(0,O.areSameExtensions)({id:M},{id:k}))&&D.push(k);if(D.length){const k=await this.getInstalled(),M=D.filter(U=>k.every(({identifier:B})=>!(0,O.areSameExtensions)(B,{id:U})));if(M.length){const B=(await this.galleryService.query({names:M,pageSize:D.length},F.CancellationToken.None)).firstPage;try{await w.Promises.settled(B.map(q=>this.installFromGallery(q,P)))}catch(q){try{await this.rollback(B)}catch(J){}throw q}}}}}async rollback(c){const P=(await this.getInstalled(1)).filter(D=>c.some(k=>new O.ExtensionIdentifierWithVersion(D.identifier,D.manifest.version).equals(new O.ExtensionIdentifierWithVersion(k.identifier,k.version))));await w.Promises.settled(P.map(D=>this.uninstall(D)))}async uninstall(c,u={}){this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id);const P=await this.getInstalled(1),D=P.find(k=>(0,O.areSameExtensions)(k.identifier,c.identifier));if(!D)throw new Error(C.localize(11,null,c.manifest.displayName||c.manifest.name));try{await this.checkForDependenciesAndUninstall(D,P,u)}catch(k){throw this.joinErrors(k)}}async updateMetadata(c,u){return this.logService.trace("ExtensionManagementService#updateMetadata",c.identifier.id),c=await this.extensionsScanner.saveMetadataForLocalExtension(c,Object.assign(Object.assign({},c.manifest.__metadata||{}),u)),this.manifestCache.invalidate(),c}async updateExtensionScope(c,u){return this.logService.trace("ExtensionManagementService#updateExtensionScope",c.identifier.id),c=await this.extensionsScanner.saveMetadataForLocalExtension(c,Object.assign(Object.assign({},c.manifest.__metadata||{}),{isMachineScoped:u})),this.manifestCache.invalidate(),c}async getGalleryMetadata(c){const u=await this.findGalleryExtensionByName(c);return u?{id:u.identifier.uuid,publisherDisplayName:u.publisherDisplayName,publisherId:u.publisherId}:void 0}async findGalleryExtension(c){if(c.identifier.uuid){const u=await this.findGalleryExtensionById(c.identifier.uuid);return u||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},F.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},F.CancellationToken.None)).firstPage[0]}joinErrors(c){const u=Array.isArray(c)?c:[c];return u.length===1?u[0]instanceof Error?u[0]:new Error(u[0]):u.reduce((P,D)=>new Error(`${P.message}${P.message?",":""}${D instanceof Error?D.message:D}`),new Error(""))}async checkForDependenciesAndUninstall(c,u,P){try{await this.preUninstallExtension(c);const D=P.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(c,u);await this.uninstallExtensions(c,D,u,P)}catch(D){throw await this.postUninstallExtension(c,new f.ExtensionManagementError(D instanceof Error?D.message:D,ae)),D}await this.postUninstallExtension(c)}async uninstallExtensions(c,u,P,D){const k=[c,...u];if(!D.donotCheckDependents)for(const M of k)this.checkForDependents(M,k,P,c);await w.Promises.settled([this.uninstallExtension(c),...u.map(M=>this.doUninstall(M))])}checkForDependents(c,u,P,D){const k=this.getDependents(c,P);if(k.length){const M=k.filter(U=>u.indexOf(U)===-1);if(M.length)throw new Error(this.getDependentsErrorMessage(c,M,D))}}getDependentsErrorMessage(c,u,P){return P===c?u.length===1?C.localize(12,null,P.manifest.displayName||P.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?C.localize(13,null,P.manifest.displayName||P.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):C.localize(14,null,P.manifest.displayName||P.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?C.localize(15,null,P.manifest.displayName||P.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?C.localize(16,null,P.manifest.displayName||P.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):C.localize(17,null,P.manifest.displayName||P.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}getAllPackExtensionsToUninstall(c,u,P=[]){if(P.indexOf(c)!==-1)return[];P.push(c);const D=c.manifest.extensionPack?c.manifest.extensionPack:[];if(D.length){const k=u.filter(U=>!U.isBuiltin&&D.some(B=>(0,O.areSameExtensions)({id:B},U.identifier))),M=[];for(const U of k)M.push(...this.getAllPackExtensionsToUninstall(U,u,P));return[...k,...M]}return[]}getDependents(c,u){return u.filter(P=>P.manifest.extensionDependencies&&P.manifest.extensionDependencies.some(D=>(0,O.areSameExtensions)({id:D},c.identifier)))}async doUninstall(c){try{await this.preUninstallExtension(c),await this.uninstallExtension(c)}catch(u){throw await this.postUninstallExtension(c,new f.ExtensionManagementError(u instanceof Error?u.message:u,ae)),u}await this.postUninstallExtension(c)}async preUninstallExtension(c){if(!await S.exists(c.location.fsPath))throw new Error(C.localize(18,null));this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier)}async uninstallExtension(c){let u=this.uninstallingExtensions.get(c.identifier.id);return u||(u=(0,w.createCancelablePromise)(async()=>{const P=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...P.filter(D=>(0,O.areSameExtensions)(D.identifier,c.identifier)))}),this.uninstallingExtensions.set(c.identifier.id,u),u.finally(()=>this.uninstallingExtensions.delete(c.identifier.id))),u}async postUninstallExtension(c,u){if(u)this.logService.error("Failed to uninstall extension:",c.identifier.id,u.message);else if(this.logService.info("Successfully uninstalled extension:",c.identifier.id),c.identifier.uuid)try{await this.galleryService.reportStatistic(c.manifest.publisher,c.manifest.name,c.manifest.version,"uninstall")}catch(D){}this.reportTelemetry("extensionGallery:uninstall",(0,O.getLocalExtensionTelemetryData)(c),void 0,u);const P=u?u instanceof f.ExtensionManagementError?u.code:W:void 0;this._onDidUninstallExtension.fire({identifier:c.identifier,error:P})}getInstalled(c=null){return this.extensionsScanner.scanExtensions(c)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(c){return(await this.filterUninstalled(c)).length===1}async filterUninstalled(...c){const u=[],P=await this.extensionsScanner.getUninstalledExtensions();for(const D of c)P[D.key()]&&u.push(D.key());return u}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(c,u,P,D){const k=D?D instanceof f.ExtensionManagementError?D.code:W:void 0;this.telemetryService.publicLogError(c,Object.assign(Object.assign({},u),{success:!D,duration:P,errorcode:k}))}};G=ce([ue(0,h.INativeEnvironmentService),ue(1,f.IExtensionGalleryService),ue(2,L.ILogService),ue(3,(0,s.optional)(o.IDownloadService)),ue(4,i.ITelemetryService),ue(5,s.IInstantiationService),ue(6,X.IFileService)],G),t.ExtensionManagementService=G}),define(Q[125],Z([0,1,135,112,2,8,14,111,27,13,17,19,98]),function(x,t,m,C,b,S,T,R,d,f,O,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let I=class extends b.Disposable{constructor(v,y,p){super();this.environmentService=y,this.logService=p,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,y){this.logService.trace("RequestService#request",v.url);const{proxyUrl:p,strictSSL:L}=this,E=v.agent?v.agent:await(0,R.getProxyAgent)(v.url||"",await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env),{proxyUrl:p,strictSSL:L});return v.agent=E,v.strictSSL=L,this.authorization&&(v.headers=Object.assign(Object.assign({},v.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(v,y)}async getNodeRequest(v){return((0,C.parse)(v.url).protocol==="https:"?await new Promise((L,E)=>{x(["https"],L,E)}):await new Promise((L,E)=>{x(["http"],L,E)})).request}_request(v,y){return new Promise(async(p,L)=>{let E;const a=(0,C.parse)(v.url),i=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),e={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,S.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(e.auth=v.user+":"+v.password),E=i(e,n=>{const r=(0,S.isNumber)(v.followRedirects)?v.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request(Object.assign(Object.assign({},v),{url:n.headers.location,followRedirects:r-1}),y).then(p,L);else{let o=n;n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,m.createGunzip)())),p({res:n,stream:(0,O.streamToBufferReadableStream)(o)})}}),E.on("error",L),v.timeout&&E.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&E.write(v.data),E.end(),y.onCancellationRequested(()=>{E.abort(),L((0,T.canceled)())})})}async resolveProxy(v){}};I=ce([ue(0,d.IConfigurationService),ue(1,h.INativeEnvironmentService),ue(2,f.ILogService)],I),t.RequestService=I}),define(Q[136],Z([0,1,32,16,137,3,4,54,51,48,100,19,88,24,124,118,41,55,119,117,53,125,27,110,120,114,115,13,10,107,121,104,20,105,2,40,96,9,106,52,14,29,17,37]),function(x,t,m,C,b,S,T,R,d,f,O,h,w,I,l,v,y,p,L,E,a,i,e,n,r,o,s,g,F,V,N,A,j,$,X,ne,ee,te,ae,W,G,_,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class P extends X.Disposable{constructor(M){super();this.argv=M,(0,b.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[M,U]=await this.initServices();return M.invokeFunction(async B=>{const q=B.get(g.ILogService),J=B.get(j.IFileService),Y=B.get(h.INativeEnvironmentService),ie=B.get(I.IExtensionManagementCLIService);return q.info("CLI main",this.argv),this.registerErrorHandler(q),await this.doRun(Y,ie,J),(0,T.raceTimeout)((0,p.combinedAppender)(...U).flush(),1e3)})}async initServices(){const M=new d.ServiceCollection,U=Object.assign({_serviceBrand:void 0},R.default);M.set(ne.IProductService,U);const B=new w.NativeEnvironmentService(this.argv,U);M.set(h.INativeEnvironmentService,B),await Promise.all([B.appSettingsHome.fsPath,B.extensionsPath].map(Se=>Se?C.promises.mkdir(Se,{recursive:!0}):void 0));const q=(0,g.getLogLevel)(B),J=[];J.push(new V.SpdLogLogger("cli",(0,S.join)(B.logsPath,"cli.log"),!0,q)),q===g.LogLevel.Trace&&J.push(new g.ConsoleLogger(q));const Y=this._register(new g.MultiplexLogService(J));M.set(g.ILogService,Y);const ie=this._register(new A.FileService(Y));M.set(j.IFileService,ie);const re=this._register(new $.DiskFileSystemProvider(Y));ie.registerProvider(F.Schemas.file,re);const he=this._register(new n.ConfigurationService(B.settingsResource,ie));M.set(e.IConfigurationService,he),await he.initialize();const ge=new s.StateService(B,Y);M.set(o.IStateService,ge);const{appRoot:De,extensionsPath:Oe,extensionDevelopmentLocationURI:Fe,isBuilt:Re,installSourcePath:Me}=B;M.set(a.IRequestService,new f.SyncDescriptor(i.RequestService)),M.set(I.IExtensionManagementService,new f.SyncDescriptor(l.ExtensionManagementService)),M.set(I.IExtensionGalleryService,new f.SyncDescriptor(v.ExtensionGalleryService)),M.set(I.IExtensionManagementCLIService,new f.SyncDescriptor(ee.ExtensionManagementCLIService)),M.set(W.ILocalizationsService,new f.SyncDescriptor(ae.LocalizationsService));const ve=[];if(Re&&!Fe&&!B.disableTelemetry&&U.enableTelemetry){U.aiConfig&&U.aiConfig.asimovKey&&ve.push(new r.AppInsightsAppender("monacoworkbench",null,U.aiConfig.asimovKey));const Se={appender:(0,p.combinedAppender)(...ve),sendErrorTelemetry:!1,commonProperties:(0,E.resolveCommonProperties)(ie,(0,m.release)(),process.arch,U.commit,U.version,ge.getItem("telemetry.machineId"),U.msftInternalDomains,Me),piiPaths:[De,Oe]};M.set(y.ITelemetryService,new f.SyncDescriptor(L.TelemetryService,[Se]))}else M.set(y.ITelemetryService,p.NullTelemetryService);return[new O.InstantiationService(M),ve]}registerErrorHandler(M){(0,G.setUnexpectedErrorHandler)(U=>{const B=(0,_.toErrorMessage)(U,!0);!B||M.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(M,U,B){if(this.argv["install-source"])return this.setInstallSource(M,B,this.argv["install-source"]);if(this.argv["list-extensions"])return U.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return U.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return U.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return U.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,N.buildTelemetryMessage)(M.appRoot,M.extensionsPath))}asExtensionIdOrVSIX(M){return M.map(U=>/\.vsix$/i.test(U)?te.URI.file((0,S.isAbsolute)(U)?U:(0,S.join)((0,u.cwd)(),U)):U)}async setInstallSource(M,U,B){await U.writeFile(te.URI.file(M.installSourcePath),c.VSBuffer.fromString(B.slice(0,30)))}}async function D(k){const M=new P(k);try{await M.run()}finally{M.dispose()}}t.main=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d06d2f1d6245ce00b1c36a9cd81a9087d225173e/core/vs/code/node/cliProcessMain.js.map
